/* A Bison parser, made by GNU Bison 3.7.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2020 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30704

/* Bison version string.  */
#define YYBISON_VERSION "3.7.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         nft_parse
#define yylex           nft_lex
#define yyerror         nft_error
#define yydebug         nft_debug
#define yynerrs         nft_nerrs

/* First part of user prologue.  */
#line 11 "parser_bison.y"


#include <ctype.h>
#include <stddef.h>
#include <stdio.h>
#include <inttypes.h>
#include <syslog.h>
#include <netinet/ip.h>
#include <netinet/tcp.h>
#include <netinet/if_ether.h>
#include <linux/netfilter.h>
#include <linux/netfilter/nf_tables.h>
#include <linux/netfilter/nf_conntrack_tuple_common.h>
#include <linux/netfilter/nf_nat.h>
#include <linux/netfilter/nf_log.h>
#include <linux/netfilter/nfnetlink_osf.h>
#include <linux/netfilter/nf_synproxy.h>
#include <linux/xfrm.h>
#include <netinet/ip_icmp.h>
#include <netinet/icmp6.h>
#include <libnftnl/common.h>
#include <libnftnl/set.h>
#include <libnftnl/udata.h>

#include <rule.h>
#include <statement.h>
#include <expression.h>
#include <headers.h>
#include <utils.h>
#include <parser.h>
#include <erec.h>
#include <sctp_chunk.h>

#include "parser_bison.h"

void parser_init(struct nft_ctx *nft, struct parser_state *state,
		 struct list_head *msgs, struct list_head *cmds,
		 struct scope *top_scope)
{
	memset(state, 0, sizeof(*state));
	state->msgs = msgs;
	state->cmds = cmds;
	state->scopes[0] = scope_init(top_scope, NULL);
	init_list_head(&state->indesc_list);
}

static void yyerror(struct location *loc, struct nft_ctx *nft, void *scanner,
		    struct parser_state *state, const char *s)
{
	erec_queue(error(loc, "%s", s), state->msgs);
}

static struct scope *current_scope(const struct parser_state *state)
{
	return state->scopes[state->scope];
}

static void open_scope(struct parser_state *state, struct scope *scope)
{
	assert(state->scope < array_size(state->scopes) - 1);
	scope_init(scope, current_scope(state));
	state->scopes[++state->scope] = scope;
}

static void close_scope(struct parser_state *state)
{
	assert(state->scope > 0);
	state->scope--;
}

static void location_init(void *scanner, struct parser_state *state,
			  struct location *loc)
{
	memset(loc, 0, sizeof(*loc));
	loc->indesc = state->indesc;
}

static void location_update(struct location *loc, struct location *rhs, int n)
{
	if (n) {
		loc->indesc       = rhs[n].indesc;
		loc->token_offset = rhs[1].token_offset;
		loc->line_offset  = rhs[1].line_offset;
		loc->first_line   = rhs[1].first_line;
		loc->first_column = rhs[1].first_column;
		loc->last_line    = rhs[n].last_line;
		loc->last_column  = rhs[n].last_column;
	} else {
		loc->indesc       = rhs[0].indesc;
		loc->token_offset = rhs[0].token_offset;
		loc->line_offset  = rhs[0].line_offset;
		loc->first_line   = loc->last_line   = rhs[0].last_line;
		loc->first_column = loc->last_column = rhs[0].last_column;
	}
}

static struct expr *handle_concat_expr(const struct location *loc,
					 struct expr *expr,
					 struct expr *expr_l, struct expr *expr_r,
					 struct location loc_rhs[3])
{
	if (expr->etype != EXPR_CONCAT) {
		expr = concat_expr_alloc(loc);
		compound_expr_add(expr, expr_l);
	} else {
		location_update(&expr_r->location, loc_rhs, 2);

		expr = expr_l;
		expr->location = *loc;
	}

	compound_expr_add(expr, expr_r);
	return expr;
}

static bool already_set(const void *attr, const struct location *loc,
			struct parser_state *state)
{
	if (!attr)
		return false;

	erec_queue(error(loc, "You can only specify this once. This statement is duplicated."),
		   state->msgs);
	return true;
}

#define YYLLOC_DEFAULT(Current, Rhs, N)	location_update(&Current, Rhs, N)

#define symbol_value(loc, str) \
	symbol_expr_alloc(loc, SYMBOL_VALUE, current_scope(state), str)

/* Declare those here to avoid compiler warnings */
void nft_set_debug(int, void *);
int nft_lex(void *, void *, void *);

#line 212 "parser_bison.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

/* Use api.header.include to #include this header
   instead of duplicating it here.  */
#ifndef YY_NFT_PARSER_BISON_H_INCLUDED
# define YY_NFT_PARSER_BISON_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif
#if YYDEBUG
extern int nft_debug;
#endif

/* Token kinds.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    YYEMPTY = -2,
    TOKEN_EOF = 0,                 /* "end of file"  */
    YYerror = 256,                 /* error  */
    YYUNDEF = 257,                 /* "invalid token"  */
    JUNK = 258,                    /* "junk"  */
    NEWLINE = 259,                 /* "newline"  */
    COLON = 260,                   /* "colon"  */
    SEMICOLON = 261,               /* "semicolon"  */
    COMMA = 262,                   /* "comma"  */
    DOT = 263,                     /* "."  */
    EQ = 264,                      /* "=="  */
    NEQ = 265,                     /* "!="  */
    LT = 266,                      /* "<"  */
    GT = 267,                      /* ">"  */
    GTE = 268,                     /* ">="  */
    LTE = 269,                     /* "<="  */
    LSHIFT = 270,                  /* "<<"  */
    RSHIFT = 271,                  /* ">>"  */
    AMPERSAND = 272,               /* "&"  */
    CARET = 273,                   /* "^"  */
    NOT = 274,                     /* "!"  */
    SLASH = 275,                   /* "/"  */
    ASTERISK = 276,                /* "*"  */
    DASH = 277,                    /* "-"  */
    AT = 278,                      /* "@"  */
    VMAP = 279,                    /* "vmap"  */
    PLUS = 280,                    /* "+"  */
    INCLUDE = 281,                 /* "include"  */
    DEFINE = 282,                  /* "define"  */
    REDEFINE = 283,                /* "redefine"  */
    UNDEFINE = 284,                /* "undefine"  */
    FIB = 285,                     /* "fib"  */
    SOCKET = 286,                  /* "socket"  */
    TRANSPARENT = 287,             /* "transparent"  */
    WILDCARD = 288,                /* "wildcard"  */
    TPROXY = 289,                  /* "tproxy"  */
    OSF = 290,                     /* "osf"  */
    SYNPROXY = 291,                /* "synproxy"  */
    MSS = 292,                     /* "mss"  */
    WSCALE = 293,                  /* "wscale"  */
    TYPEOF = 294,                  /* "typeof"  */
    HOOK = 295,                    /* "hook"  */
    DEVICE = 296,                  /* "device"  */
    DEVICES = 297,                 /* "devices"  */
    TABLE = 298,                   /* "table"  */
    TABLES = 299,                  /* "tables"  */
    CHAIN = 300,                   /* "chain"  */
    CHAINS = 301,                  /* "chains"  */
    RULE = 302,                    /* "rule"  */
    RULES = 303,                   /* "rules"  */
    SETS = 304,                    /* "sets"  */
    SET = 305,                     /* "set"  */
    ELEMENT = 306,                 /* "element"  */
    MAP = 307,                     /* "map"  */
    MAPS = 308,                    /* "maps"  */
    FLOWTABLE = 309,               /* "flowtable"  */
    HANDLE = 310,                  /* "handle"  */
    RULESET = 311,                 /* "ruleset"  */
    TRACE = 312,                   /* "trace"  */
    INET = 313,                    /* "inet"  */
    NETDEV = 314,                  /* "netdev"  */
    ADD = 315,                     /* "add"  */
    UPDATE = 316,                  /* "update"  */
    REPLACE = 317,                 /* "replace"  */
    CREATE = 318,                  /* "create"  */
    INSERT = 319,                  /* "insert"  */
    DELETE = 320,                  /* "delete"  */
    GET = 321,                     /* "get"  */
    LIST = 322,                    /* "list"  */
    RESET = 323,                   /* "reset"  */
    FLUSH = 324,                   /* "flush"  */
    RENAME = 325,                  /* "rename"  */
    DESCRIBE = 326,                /* "describe"  */
    IMPORT = 327,                  /* "import"  */
    EXPORT = 328,                  /* "export"  */
    MONITOR = 329,                 /* "monitor"  */
    ALL = 330,                     /* "all"  */
    ACCEPT = 331,                  /* "accept"  */
    DROP = 332,                    /* "drop"  */
    CONTINUE = 333,                /* "continue"  */
    JUMP = 334,                    /* "jump"  */
    GOTO = 335,                    /* "goto"  */
    RETURN = 336,                  /* "return"  */
    TO = 337,                      /* "to"  */
    CONSTANT = 338,                /* "constant"  */
    INTERVAL = 339,                /* "interval"  */
    DYNAMIC = 340,                 /* "dynamic"  */
    AUTOMERGE = 341,               /* "auto-merge"  */
    TIMEOUT = 342,                 /* "timeout"  */
    GC_INTERVAL = 343,             /* "gc-interval"  */
    ELEMENTS = 344,                /* "elements"  */
    EXPIRES = 345,                 /* "expires"  */
    POLICY = 346,                  /* "policy"  */
    MEMORY = 347,                  /* "memory"  */
    PERFORMANCE = 348,             /* "performance"  */
    SIZE = 349,                    /* "size"  */
    FLOW = 350,                    /* "flow"  */
    OFFLOAD = 351,                 /* "offload"  */
    METER = 352,                   /* "meter"  */
    METERS = 353,                  /* "meters"  */
    FLOWTABLES = 354,              /* "flowtables"  */
    NUM = 355,                     /* "number"  */
    STRING = 356,                  /* "string"  */
    QUOTED_STRING = 357,           /* "quoted string"  */
    ASTERISK_STRING = 358,         /* "string with a trailing asterisk"  */
    LL_HDR = 359,                  /* "ll"  */
    NETWORK_HDR = 360,             /* "nh"  */
    TRANSPORT_HDR = 361,           /* "th"  */
    BRIDGE = 362,                  /* "bridge"  */
    ETHER = 363,                   /* "ether"  */
    SADDR = 364,                   /* "saddr"  */
    DADDR = 365,                   /* "daddr"  */
    TYPE = 366,                    /* "type"  */
    VLAN = 367,                    /* "vlan"  */
    ID = 368,                      /* "id"  */
    CFI = 369,                     /* "cfi"  */
    PCP = 370,                     /* "pcp"  */
    ARP = 371,                     /* "arp"  */
    HTYPE = 372,                   /* "htype"  */
    PTYPE = 373,                   /* "ptype"  */
    HLEN = 374,                    /* "hlen"  */
    PLEN = 375,                    /* "plen"  */
    OPERATION = 376,               /* "operation"  */
    IP = 377,                      /* "ip"  */
    HDRVERSION = 378,              /* "version"  */
    HDRLENGTH = 379,               /* "hdrlength"  */
    DSCP = 380,                    /* "dscp"  */
    ECN = 381,                     /* "ecn"  */
    LENGTH = 382,                  /* "length"  */
    FRAG_OFF = 383,                /* "frag-off"  */
    TTL = 384,                     /* "ttl"  */
    PROTOCOL = 385,                /* "protocol"  */
    CHECKSUM = 386,                /* "checksum"  */
    PTR = 387,                     /* "ptr"  */
    VALUE = 388,                   /* "value"  */
    LSRR = 389,                    /* "lsrr"  */
    RR = 390,                      /* "rr"  */
    SSRR = 391,                    /* "ssrr"  */
    RA = 392,                      /* "ra"  */
    ICMP = 393,                    /* "icmp"  */
    CODE = 394,                    /* "code"  */
    SEQUENCE = 395,                /* "seq"  */
    GATEWAY = 396,                 /* "gateway"  */
    MTU = 397,                     /* "mtu"  */
    IGMP = 398,                    /* "igmp"  */
    MRT = 399,                     /* "mrt"  */
    OPTIONS = 400,                 /* "options"  */
    IP6 = 401,                     /* "ip6"  */
    PRIORITY = 402,                /* "priority"  */
    FLOWLABEL = 403,               /* "flowlabel"  */
    NEXTHDR = 404,                 /* "nexthdr"  */
    HOPLIMIT = 405,                /* "hoplimit"  */
    ICMP6 = 406,                   /* "icmpv6"  */
    PPTR = 407,                    /* "param-problem"  */
    MAXDELAY = 408,                /* "max-delay"  */
    AH = 409,                      /* "ah"  */
    RESERVED = 410,                /* "reserved"  */
    SPI = 411,                     /* "spi"  */
    ESP = 412,                     /* "esp"  */
    COMP = 413,                    /* "comp"  */
    FLAGS = 414,                   /* "flags"  */
    CPI = 415,                     /* "cpi"  */
    PORT = 416,                    /* "port"  */
    UDP = 417,                     /* "udp"  */
    SPORT = 418,                   /* "sport"  */
    DPORT = 419,                   /* "dport"  */
    UDPLITE = 420,                 /* "udplite"  */
    CSUMCOV = 421,                 /* "csumcov"  */
    TCP = 422,                     /* "tcp"  */
    ACKSEQ = 423,                  /* "ackseq"  */
    DOFF = 424,                    /* "doff"  */
    WINDOW = 425,                  /* "window"  */
    URGPTR = 426,                  /* "urgptr"  */
    OPTION = 427,                  /* "option"  */
    ECHO = 428,                    /* "echo"  */
    EOL = 429,                     /* "eol"  */
    NOP = 430,                     /* "nop"  */
    SACK = 431,                    /* "sack"  */
    SACK0 = 432,                   /* "sack0"  */
    SACK1 = 433,                   /* "sack1"  */
    SACK2 = 434,                   /* "sack2"  */
    SACK3 = 435,                   /* "sack3"  */
    SACK_PERM = 436,               /* "sack-permitted"  */
    TIMESTAMP = 437,               /* "timestamp"  */
    KIND = 438,                    /* "kind"  */
    COUNT = 439,                   /* "count"  */
    LEFT = 440,                    /* "left"  */
    RIGHT = 441,                   /* "right"  */
    TSVAL = 442,                   /* "tsval"  */
    TSECR = 443,                   /* "tsecr"  */
    DCCP = 444,                    /* "dccp"  */
    SCTP = 445,                    /* "sctp"  */
    CHUNK = 446,                   /* "chunk"  */
    DATA = 447,                    /* "data"  */
    INIT = 448,                    /* "init"  */
    INIT_ACK = 449,                /* "init-ack"  */
    HEARTBEAT = 450,               /* "heartbeat"  */
    HEARTBEAT_ACK = 451,           /* "heartbeat-ack"  */
    ABORT = 452,                   /* "abort"  */
    SHUTDOWN = 453,                /* "shutdown"  */
    SHUTDOWN_ACK = 454,            /* "shutdown-ack"  */
    ERROR = 455,                   /* "error"  */
    COOKIE_ECHO = 456,             /* "cookie-echo"  */
    COOKIE_ACK = 457,              /* "cookie-ack"  */
    ECNE = 458,                    /* "ecne"  */
    CWR = 459,                     /* "cwr"  */
    SHUTDOWN_COMPLETE = 460,       /* "shutdown-complete"  */
    ASCONF_ACK = 461,              /* "asconf-ack"  */
    FORWARD_TSN = 462,             /* "forward-tsn"  */
    ASCONF = 463,                  /* "asconf"  */
    TSN = 464,                     /* "tsn"  */
    STREAM = 465,                  /* "stream"  */
    SSN = 466,                     /* "ssn"  */
    PPID = 467,                    /* "ppid"  */
    INIT_TAG = 468,                /* "init-tag"  */
    A_RWND = 469,                  /* "a-rwnd"  */
    NUM_OSTREAMS = 470,            /* "num-outbound-streams"  */
    NUM_ISTREAMS = 471,            /* "num-inbound-streams"  */
    INIT_TSN = 472,                /* "initial-tsn"  */
    CUM_TSN_ACK = 473,             /* "cum-tsn-ack"  */
    NUM_GACK_BLOCKS = 474,         /* "num-gap-ack-blocks"  */
    NUM_DUP_TSNS = 475,            /* "num-dup-tsns"  */
    LOWEST_TSN = 476,              /* "lowest-tsn"  */
    SEQNO = 477,                   /* "seqno"  */
    NEW_CUM_TSN = 478,             /* "new-cum-tsn"  */
    VTAG = 479,                    /* "vtag"  */
    RT = 480,                      /* "rt"  */
    RT0 = 481,                     /* "rt0"  */
    RT2 = 482,                     /* "rt2"  */
    RT4 = 483,                     /* "srh"  */
    SEG_LEFT = 484,                /* "seg-left"  */
    ADDR = 485,                    /* "addr"  */
    LAST_ENT = 486,                /* "last-entry"  */
    TAG = 487,                     /* "tag"  */
    SID = 488,                     /* "sid"  */
    HBH = 489,                     /* "hbh"  */
    FRAG = 490,                    /* "frag"  */
    RESERVED2 = 491,               /* "reserved2"  */
    MORE_FRAGMENTS = 492,          /* "more-fragments"  */
    DST = 493,                     /* "dst"  */
    MH = 494,                      /* "mh"  */
    META = 495,                    /* "meta"  */
    MARK = 496,                    /* "mark"  */
    IIF = 497,                     /* "iif"  */
    IIFNAME = 498,                 /* "iifname"  */
    IIFTYPE = 499,                 /* "iiftype"  */
    OIF = 500,                     /* "oif"  */
    OIFNAME = 501,                 /* "oifname"  */
    OIFTYPE = 502,                 /* "oiftype"  */
    SKUID = 503,                   /* "skuid"  */
    SKGID = 504,                   /* "skgid"  */
    NFTRACE = 505,                 /* "nftrace"  */
    RTCLASSID = 506,               /* "rtclassid"  */
    IBRIPORT = 507,                /* "ibriport"  */
    OBRIPORT = 508,                /* "obriport"  */
    IBRIDGENAME = 509,             /* "ibrname"  */
    OBRIDGENAME = 510,             /* "obrname"  */
    PKTTYPE = 511,                 /* "pkttype"  */
    CPU = 512,                     /* "cpu"  */
    IIFGROUP = 513,                /* "iifgroup"  */
    OIFGROUP = 514,                /* "oifgroup"  */
    CGROUP = 515,                  /* "cgroup"  */
    TIME = 516,                    /* "time"  */
    CLASSID = 517,                 /* "classid"  */
    NEXTHOP = 518,                 /* "nexthop"  */
    CT = 519,                      /* "ct"  */
    L3PROTOCOL = 520,              /* "l3proto"  */
    PROTO_SRC = 521,               /* "proto-src"  */
    PROTO_DST = 522,               /* "proto-dst"  */
    ZONE = 523,                    /* "zone"  */
    DIRECTION = 524,               /* "direction"  */
    EVENT = 525,                   /* "event"  */
    EXPECTATION = 526,             /* "expectation"  */
    EXPIRATION = 527,              /* "expiration"  */
    HELPER = 528,                  /* "helper"  */
    LABEL = 529,                   /* "label"  */
    STATE = 530,                   /* "state"  */
    STATUS = 531,                  /* "status"  */
    ORIGINAL = 532,                /* "original"  */
    REPLY = 533,                   /* "reply"  */
    COUNTER = 534,                 /* "counter"  */
    NAME = 535,                    /* "name"  */
    PACKETS = 536,                 /* "packets"  */
    BYTES = 537,                   /* "bytes"  */
    AVGPKT = 538,                  /* "avgpkt"  */
    COUNTERS = 539,                /* "counters"  */
    QUOTAS = 540,                  /* "quotas"  */
    LIMITS = 541,                  /* "limits"  */
    SYNPROXYS = 542,               /* "synproxys"  */
    HELPERS = 543,                 /* "helpers"  */
    LOG = 544,                     /* "log"  */
    PREFIX = 545,                  /* "prefix"  */
    GROUP = 546,                   /* "group"  */
    SNAPLEN = 547,                 /* "snaplen"  */
    QUEUE_THRESHOLD = 548,         /* "queue-threshold"  */
    LEVEL = 549,                   /* "level"  */
    LIMIT = 550,                   /* "limit"  */
    RATE = 551,                    /* "rate"  */
    BURST = 552,                   /* "burst"  */
    OVER = 553,                    /* "over"  */
    UNTIL = 554,                   /* "until"  */
    QUOTA = 555,                   /* "quota"  */
    USED = 556,                    /* "used"  */
    SECMARK = 557,                 /* "secmark"  */
    SECMARKS = 558,                /* "secmarks"  */
    NANOSECOND = 559,              /* "nanosecond"  */
    MICROSECOND = 560,             /* "microsecond"  */
    MILLISECOND = 561,             /* "millisecond"  */
    SECOND = 562,                  /* "second"  */
    MINUTE = 563,                  /* "minute"  */
    HOUR = 564,                    /* "hour"  */
    DAY = 565,                     /* "day"  */
    WEEK = 566,                    /* "week"  */
    _REJECT = 567,                 /* "reject"  */
    WITH = 568,                    /* "with"  */
    ICMPX = 569,                   /* "icmpx"  */
    SNAT = 570,                    /* "snat"  */
    DNAT = 571,                    /* "dnat"  */
    MASQUERADE = 572,              /* "masquerade"  */
    REDIRECT = 573,                /* "redirect"  */
    RANDOM = 574,                  /* "random"  */
    FULLY_RANDOM = 575,            /* "fully-random"  */
    PERSISTENT = 576,              /* "persistent"  */
    QUEUE = 577,                   /* "queue"  */
    QUEUENUM = 578,                /* "num"  */
    BYPASS = 579,                  /* "bypass"  */
    FANOUT = 580,                  /* "fanout"  */
    DUP = 581,                     /* "dup"  */
    FWD = 582,                     /* "fwd"  */
    NUMGEN = 583,                  /* "numgen"  */
    INC = 584,                     /* "inc"  */
    MOD = 585,                     /* "mod"  */
    OFFSET = 586,                  /* "offset"  */
    JHASH = 587,                   /* "jhash"  */
    SYMHASH = 588,                 /* "symhash"  */
    SEED = 589,                    /* "seed"  */
    POSITION = 590,                /* "position"  */
    INDEX = 591,                   /* "index"  */
    COMMENT = 592,                 /* "comment"  */
    XML = 593,                     /* "xml"  */
    JSON = 594,                    /* "json"  */
    VM = 595,                      /* "vm"  */
    NOTRACK = 596,                 /* "notrack"  */
    EXISTS = 597,                  /* "exists"  */
    MISSING = 598,                 /* "missing"  */
    EXTHDR = 599,                  /* "exthdr"  */
    IPSEC = 600,                   /* "ipsec"  */
    MODE = 601,                    /* "mode"  */
    REQID = 602,                   /* "reqid"  */
    SPNUM = 603,                   /* "spnum"  */
    TRANSPORT = 604,               /* "transport"  */
    TUNNEL = 605,                  /* "tunnel"  */
    IN = 606,                      /* "in"  */
    OUT = 607                      /* "out"  */
  };
  typedef enum yytokentype yytoken_kind_t;
#endif
/* Token kinds.  */
#define YYEMPTY -2
#define TOKEN_EOF 0
#define YYerror 256
#define YYUNDEF 257
#define JUNK 258
#define NEWLINE 259
#define COLON 260
#define SEMICOLON 261
#define COMMA 262
#define DOT 263
#define EQ 264
#define NEQ 265
#define LT 266
#define GT 267
#define GTE 268
#define LTE 269
#define LSHIFT 270
#define RSHIFT 271
#define AMPERSAND 272
#define CARET 273
#define NOT 274
#define SLASH 275
#define ASTERISK 276
#define DASH 277
#define AT 278
#define VMAP 279
#define PLUS 280
#define INCLUDE 281
#define DEFINE 282
#define REDEFINE 283
#define UNDEFINE 284
#define FIB 285
#define SOCKET 286
#define TRANSPARENT 287
#define WILDCARD 288
#define TPROXY 289
#define OSF 290
#define SYNPROXY 291
#define MSS 292
#define WSCALE 293
#define TYPEOF 294
#define HOOK 295
#define DEVICE 296
#define DEVICES 297
#define TABLE 298
#define TABLES 299
#define CHAIN 300
#define CHAINS 301
#define RULE 302
#define RULES 303
#define SETS 304
#define SET 305
#define ELEMENT 306
#define MAP 307
#define MAPS 308
#define FLOWTABLE 309
#define HANDLE 310
#define RULESET 311
#define TRACE 312
#define INET 313
#define NETDEV 314
#define ADD 315
#define UPDATE 316
#define REPLACE 317
#define CREATE 318
#define INSERT 319
#define DELETE 320
#define GET 321
#define LIST 322
#define RESET 323
#define FLUSH 324
#define RENAME 325
#define DESCRIBE 326
#define IMPORT 327
#define EXPORT 328
#define MONITOR 329
#define ALL 330
#define ACCEPT 331
#define DROP 332
#define CONTINUE 333
#define JUMP 334
#define GOTO 335
#define RETURN 336
#define TO 337
#define CONSTANT 338
#define INTERVAL 339
#define DYNAMIC 340
#define AUTOMERGE 341
#define TIMEOUT 342
#define GC_INTERVAL 343
#define ELEMENTS 344
#define EXPIRES 345
#define POLICY 346
#define MEMORY 347
#define PERFORMANCE 348
#define SIZE 349
#define FLOW 350
#define OFFLOAD 351
#define METER 352
#define METERS 353
#define FLOWTABLES 354
#define NUM 355
#define STRING 356
#define QUOTED_STRING 357
#define ASTERISK_STRING 358
#define LL_HDR 359
#define NETWORK_HDR 360
#define TRANSPORT_HDR 361
#define BRIDGE 362
#define ETHER 363
#define SADDR 364
#define DADDR 365
#define TYPE 366
#define VLAN 367
#define ID 368
#define CFI 369
#define PCP 370
#define ARP 371
#define HTYPE 372
#define PTYPE 373
#define HLEN 374
#define PLEN 375
#define OPERATION 376
#define IP 377
#define HDRVERSION 378
#define HDRLENGTH 379
#define DSCP 380
#define ECN 381
#define LENGTH 382
#define FRAG_OFF 383
#define TTL 384
#define PROTOCOL 385
#define CHECKSUM 386
#define PTR 387
#define VALUE 388
#define LSRR 389
#define RR 390
#define SSRR 391
#define RA 392
#define ICMP 393
#define CODE 394
#define SEQUENCE 395
#define GATEWAY 396
#define MTU 397
#define IGMP 398
#define MRT 399
#define OPTIONS 400
#define IP6 401
#define PRIORITY 402
#define FLOWLABEL 403
#define NEXTHDR 404
#define HOPLIMIT 405
#define ICMP6 406
#define PPTR 407
#define MAXDELAY 408
#define AH 409
#define RESERVED 410
#define SPI 411
#define ESP 412
#define COMP 413
#define FLAGS 414
#define CPI 415
#define PORT 416
#define UDP 417
#define SPORT 418
#define DPORT 419
#define UDPLITE 420
#define CSUMCOV 421
#define TCP 422
#define ACKSEQ 423
#define DOFF 424
#define WINDOW 425
#define URGPTR 426
#define OPTION 427
#define ECHO 428
#define EOL 429
#define NOP 430
#define SACK 431
#define SACK0 432
#define SACK1 433
#define SACK2 434
#define SACK3 435
#define SACK_PERM 436
#define TIMESTAMP 437
#define KIND 438
#define COUNT 439
#define LEFT 440
#define RIGHT 441
#define TSVAL 442
#define TSECR 443
#define DCCP 444
#define SCTP 445
#define CHUNK 446
#define DATA 447
#define INIT 448
#define INIT_ACK 449
#define HEARTBEAT 450
#define HEARTBEAT_ACK 451
#define ABORT 452
#define SHUTDOWN 453
#define SHUTDOWN_ACK 454
#define ERROR 455
#define COOKIE_ECHO 456
#define COOKIE_ACK 457
#define ECNE 458
#define CWR 459
#define SHUTDOWN_COMPLETE 460
#define ASCONF_ACK 461
#define FORWARD_TSN 462
#define ASCONF 463
#define TSN 464
#define STREAM 465
#define SSN 466
#define PPID 467
#define INIT_TAG 468
#define A_RWND 469
#define NUM_OSTREAMS 470
#define NUM_ISTREAMS 471
#define INIT_TSN 472
#define CUM_TSN_ACK 473
#define NUM_GACK_BLOCKS 474
#define NUM_DUP_TSNS 475
#define LOWEST_TSN 476
#define SEQNO 477
#define NEW_CUM_TSN 478
#define VTAG 479
#define RT 480
#define RT0 481
#define RT2 482
#define RT4 483
#define SEG_LEFT 484
#define ADDR 485
#define LAST_ENT 486
#define TAG 487
#define SID 488
#define HBH 489
#define FRAG 490
#define RESERVED2 491
#define MORE_FRAGMENTS 492
#define DST 493
#define MH 494
#define META 495
#define MARK 496
#define IIF 497
#define IIFNAME 498
#define IIFTYPE 499
#define OIF 500
#define OIFNAME 501
#define OIFTYPE 502
#define SKUID 503
#define SKGID 504
#define NFTRACE 505
#define RTCLASSID 506
#define IBRIPORT 507
#define OBRIPORT 508
#define IBRIDGENAME 509
#define OBRIDGENAME 510
#define PKTTYPE 511
#define CPU 512
#define IIFGROUP 513
#define OIFGROUP 514
#define CGROUP 515
#define TIME 516
#define CLASSID 517
#define NEXTHOP 518
#define CT 519
#define L3PROTOCOL 520
#define PROTO_SRC 521
#define PROTO_DST 522
#define ZONE 523
#define DIRECTION 524
#define EVENT 525
#define EXPECTATION 526
#define EXPIRATION 527
#define HELPER 528
#define LABEL 529
#define STATE 530
#define STATUS 531
#define ORIGINAL 532
#define REPLY 533
#define COUNTER 534
#define NAME 535
#define PACKETS 536
#define BYTES 537
#define AVGPKT 538
#define COUNTERS 539
#define QUOTAS 540
#define LIMITS 541
#define SYNPROXYS 542
#define HELPERS 543
#define LOG 544
#define PREFIX 545
#define GROUP 546
#define SNAPLEN 547
#define QUEUE_THRESHOLD 548
#define LEVEL 549
#define LIMIT 550
#define RATE 551
#define BURST 552
#define OVER 553
#define UNTIL 554
#define QUOTA 555
#define USED 556
#define SECMARK 557
#define SECMARKS 558
#define NANOSECOND 559
#define MICROSECOND 560
#define MILLISECOND 561
#define SECOND 562
#define MINUTE 563
#define HOUR 564
#define DAY 565
#define WEEK 566
#define _REJECT 567
#define WITH 568
#define ICMPX 569
#define SNAT 570
#define DNAT 571
#define MASQUERADE 572
#define REDIRECT 573
#define RANDOM 574
#define FULLY_RANDOM 575
#define PERSISTENT 576
#define QUEUE 577
#define QUEUENUM 578
#define BYPASS 579
#define FANOUT 580
#define DUP 581
#define FWD 582
#define NUMGEN 583
#define INC 584
#define MOD 585
#define OFFSET 586
#define JHASH 587
#define SYMHASH 588
#define SEED 589
#define POSITION 590
#define INDEX 591
#define COMMENT 592
#define XML 593
#define JSON 594
#define VM 595
#define NOTRACK 596
#define EXISTS 597
#define MISSING 598
#define EXTHDR 599
#define IPSEC 600
#define MODE 601
#define REQID 602
#define SPNUM 603
#define TRANSPORT 604
#define TUNNEL 605
#define IN 606
#define OUT 607

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
union YYSTYPE
{
#line 167 "parser_bison.y"

	uint64_t		val;
	uint32_t		val32;
	uint8_t			val8;
	const char *		string;

	struct list_head	*list;
	struct cmd		*cmd;
	struct handle		handle;
	struct table		*table;
	struct chain		*chain;
	struct rule		*rule;
	struct stmt		*stmt;
	struct expr		*expr;
	struct set		*set;
	struct obj		*obj;
	struct flowtable	*flowtable;
	struct ct		*ct;
	const struct datatype	*datatype;
	struct handle_spec	handle_spec;
	struct position_spec	position_spec;
	struct prio_spec	prio_spec;

#line 993 "parser_bison.c"

};
typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif

/* Location type.  */
#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE YYLTYPE;
struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
};
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif



int nft_parse (struct nft_ctx *nft, void *scanner, struct parser_state *state);

#endif /* !YY_NFT_PARSER_BISON_H_INCLUDED  */
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_JUNK = 3,                       /* "junk"  */
  YYSYMBOL_NEWLINE = 4,                    /* "newline"  */
  YYSYMBOL_COLON = 5,                      /* "colon"  */
  YYSYMBOL_SEMICOLON = 6,                  /* "semicolon"  */
  YYSYMBOL_COMMA = 7,                      /* "comma"  */
  YYSYMBOL_DOT = 8,                        /* "."  */
  YYSYMBOL_EQ = 9,                         /* "=="  */
  YYSYMBOL_NEQ = 10,                       /* "!="  */
  YYSYMBOL_LT = 11,                        /* "<"  */
  YYSYMBOL_GT = 12,                        /* ">"  */
  YYSYMBOL_GTE = 13,                       /* ">="  */
  YYSYMBOL_LTE = 14,                       /* "<="  */
  YYSYMBOL_LSHIFT = 15,                    /* "<<"  */
  YYSYMBOL_RSHIFT = 16,                    /* ">>"  */
  YYSYMBOL_AMPERSAND = 17,                 /* "&"  */
  YYSYMBOL_CARET = 18,                     /* "^"  */
  YYSYMBOL_NOT = 19,                       /* "!"  */
  YYSYMBOL_SLASH = 20,                     /* "/"  */
  YYSYMBOL_ASTERISK = 21,                  /* "*"  */
  YYSYMBOL_DASH = 22,                      /* "-"  */
  YYSYMBOL_AT = 23,                        /* "@"  */
  YYSYMBOL_VMAP = 24,                      /* "vmap"  */
  YYSYMBOL_PLUS = 25,                      /* "+"  */
  YYSYMBOL_INCLUDE = 26,                   /* "include"  */
  YYSYMBOL_DEFINE = 27,                    /* "define"  */
  YYSYMBOL_REDEFINE = 28,                  /* "redefine"  */
  YYSYMBOL_UNDEFINE = 29,                  /* "undefine"  */
  YYSYMBOL_FIB = 30,                       /* "fib"  */
  YYSYMBOL_SOCKET = 31,                    /* "socket"  */
  YYSYMBOL_TRANSPARENT = 32,               /* "transparent"  */
  YYSYMBOL_WILDCARD = 33,                  /* "wildcard"  */
  YYSYMBOL_TPROXY = 34,                    /* "tproxy"  */
  YYSYMBOL_OSF = 35,                       /* "osf"  */
  YYSYMBOL_SYNPROXY = 36,                  /* "synproxy"  */
  YYSYMBOL_MSS = 37,                       /* "mss"  */
  YYSYMBOL_WSCALE = 38,                    /* "wscale"  */
  YYSYMBOL_TYPEOF = 39,                    /* "typeof"  */
  YYSYMBOL_HOOK = 40,                      /* "hook"  */
  YYSYMBOL_DEVICE = 41,                    /* "device"  */
  YYSYMBOL_DEVICES = 42,                   /* "devices"  */
  YYSYMBOL_TABLE = 43,                     /* "table"  */
  YYSYMBOL_TABLES = 44,                    /* "tables"  */
  YYSYMBOL_CHAIN = 45,                     /* "chain"  */
  YYSYMBOL_CHAINS = 46,                    /* "chains"  */
  YYSYMBOL_RULE = 47,                      /* "rule"  */
  YYSYMBOL_RULES = 48,                     /* "rules"  */
  YYSYMBOL_SETS = 49,                      /* "sets"  */
  YYSYMBOL_SET = 50,                       /* "set"  */
  YYSYMBOL_ELEMENT = 51,                   /* "element"  */
  YYSYMBOL_MAP = 52,                       /* "map"  */
  YYSYMBOL_MAPS = 53,                      /* "maps"  */
  YYSYMBOL_FLOWTABLE = 54,                 /* "flowtable"  */
  YYSYMBOL_HANDLE = 55,                    /* "handle"  */
  YYSYMBOL_RULESET = 56,                   /* "ruleset"  */
  YYSYMBOL_TRACE = 57,                     /* "trace"  */
  YYSYMBOL_INET = 58,                      /* "inet"  */
  YYSYMBOL_NETDEV = 59,                    /* "netdev"  */
  YYSYMBOL_ADD = 60,                       /* "add"  */
  YYSYMBOL_UPDATE = 61,                    /* "update"  */
  YYSYMBOL_REPLACE = 62,                   /* "replace"  */
  YYSYMBOL_CREATE = 63,                    /* "create"  */
  YYSYMBOL_INSERT = 64,                    /* "insert"  */
  YYSYMBOL_DELETE = 65,                    /* "delete"  */
  YYSYMBOL_GET = 66,                       /* "get"  */
  YYSYMBOL_LIST = 67,                      /* "list"  */
  YYSYMBOL_RESET = 68,                     /* "reset"  */
  YYSYMBOL_FLUSH = 69,                     /* "flush"  */
  YYSYMBOL_RENAME = 70,                    /* "rename"  */
  YYSYMBOL_DESCRIBE = 71,                  /* "describe"  */
  YYSYMBOL_IMPORT = 72,                    /* "import"  */
  YYSYMBOL_EXPORT = 73,                    /* "export"  */
  YYSYMBOL_MONITOR = 74,                   /* "monitor"  */
  YYSYMBOL_ALL = 75,                       /* "all"  */
  YYSYMBOL_ACCEPT = 76,                    /* "accept"  */
  YYSYMBOL_DROP = 77,                      /* "drop"  */
  YYSYMBOL_CONTINUE = 78,                  /* "continue"  */
  YYSYMBOL_JUMP = 79,                      /* "jump"  */
  YYSYMBOL_GOTO = 80,                      /* "goto"  */
  YYSYMBOL_RETURN = 81,                    /* "return"  */
  YYSYMBOL_TO = 82,                        /* "to"  */
  YYSYMBOL_CONSTANT = 83,                  /* "constant"  */
  YYSYMBOL_INTERVAL = 84,                  /* "interval"  */
  YYSYMBOL_DYNAMIC = 85,                   /* "dynamic"  */
  YYSYMBOL_AUTOMERGE = 86,                 /* "auto-merge"  */
  YYSYMBOL_TIMEOUT = 87,                   /* "timeout"  */
  YYSYMBOL_GC_INTERVAL = 88,               /* "gc-interval"  */
  YYSYMBOL_ELEMENTS = 89,                  /* "elements"  */
  YYSYMBOL_EXPIRES = 90,                   /* "expires"  */
  YYSYMBOL_POLICY = 91,                    /* "policy"  */
  YYSYMBOL_MEMORY = 92,                    /* "memory"  */
  YYSYMBOL_PERFORMANCE = 93,               /* "performance"  */
  YYSYMBOL_SIZE = 94,                      /* "size"  */
  YYSYMBOL_FLOW = 95,                      /* "flow"  */
  YYSYMBOL_OFFLOAD = 96,                   /* "offload"  */
  YYSYMBOL_METER = 97,                     /* "meter"  */
  YYSYMBOL_METERS = 98,                    /* "meters"  */
  YYSYMBOL_FLOWTABLES = 99,                /* "flowtables"  */
  YYSYMBOL_NUM = 100,                      /* "number"  */
  YYSYMBOL_STRING = 101,                   /* "string"  */
  YYSYMBOL_QUOTED_STRING = 102,            /* "quoted string"  */
  YYSYMBOL_ASTERISK_STRING = 103,          /* "string with a trailing asterisk"  */
  YYSYMBOL_LL_HDR = 104,                   /* "ll"  */
  YYSYMBOL_NETWORK_HDR = 105,              /* "nh"  */
  YYSYMBOL_TRANSPORT_HDR = 106,            /* "th"  */
  YYSYMBOL_BRIDGE = 107,                   /* "bridge"  */
  YYSYMBOL_ETHER = 108,                    /* "ether"  */
  YYSYMBOL_SADDR = 109,                    /* "saddr"  */
  YYSYMBOL_DADDR = 110,                    /* "daddr"  */
  YYSYMBOL_TYPE = 111,                     /* "type"  */
  YYSYMBOL_VLAN = 112,                     /* "vlan"  */
  YYSYMBOL_ID = 113,                       /* "id"  */
  YYSYMBOL_CFI = 114,                      /* "cfi"  */
  YYSYMBOL_PCP = 115,                      /* "pcp"  */
  YYSYMBOL_ARP = 116,                      /* "arp"  */
  YYSYMBOL_HTYPE = 117,                    /* "htype"  */
  YYSYMBOL_PTYPE = 118,                    /* "ptype"  */
  YYSYMBOL_HLEN = 119,                     /* "hlen"  */
  YYSYMBOL_PLEN = 120,                     /* "plen"  */
  YYSYMBOL_OPERATION = 121,                /* "operation"  */
  YYSYMBOL_IP = 122,                       /* "ip"  */
  YYSYMBOL_HDRVERSION = 123,               /* "version"  */
  YYSYMBOL_HDRLENGTH = 124,                /* "hdrlength"  */
  YYSYMBOL_DSCP = 125,                     /* "dscp"  */
  YYSYMBOL_ECN = 126,                      /* "ecn"  */
  YYSYMBOL_LENGTH = 127,                   /* "length"  */
  YYSYMBOL_FRAG_OFF = 128,                 /* "frag-off"  */
  YYSYMBOL_TTL = 129,                      /* "ttl"  */
  YYSYMBOL_PROTOCOL = 130,                 /* "protocol"  */
  YYSYMBOL_CHECKSUM = 131,                 /* "checksum"  */
  YYSYMBOL_PTR = 132,                      /* "ptr"  */
  YYSYMBOL_VALUE = 133,                    /* "value"  */
  YYSYMBOL_LSRR = 134,                     /* "lsrr"  */
  YYSYMBOL_RR = 135,                       /* "rr"  */
  YYSYMBOL_SSRR = 136,                     /* "ssrr"  */
  YYSYMBOL_RA = 137,                       /* "ra"  */
  YYSYMBOL_ICMP = 138,                     /* "icmp"  */
  YYSYMBOL_CODE = 139,                     /* "code"  */
  YYSYMBOL_SEQUENCE = 140,                 /* "seq"  */
  YYSYMBOL_GATEWAY = 141,                  /* "gateway"  */
  YYSYMBOL_MTU = 142,                      /* "mtu"  */
  YYSYMBOL_IGMP = 143,                     /* "igmp"  */
  YYSYMBOL_MRT = 144,                      /* "mrt"  */
  YYSYMBOL_OPTIONS = 145,                  /* "options"  */
  YYSYMBOL_IP6 = 146,                      /* "ip6"  */
  YYSYMBOL_PRIORITY = 147,                 /* "priority"  */
  YYSYMBOL_FLOWLABEL = 148,                /* "flowlabel"  */
  YYSYMBOL_NEXTHDR = 149,                  /* "nexthdr"  */
  YYSYMBOL_HOPLIMIT = 150,                 /* "hoplimit"  */
  YYSYMBOL_ICMP6 = 151,                    /* "icmpv6"  */
  YYSYMBOL_PPTR = 152,                     /* "param-problem"  */
  YYSYMBOL_MAXDELAY = 153,                 /* "max-delay"  */
  YYSYMBOL_AH = 154,                       /* "ah"  */
  YYSYMBOL_RESERVED = 155,                 /* "reserved"  */
  YYSYMBOL_SPI = 156,                      /* "spi"  */
  YYSYMBOL_ESP = 157,                      /* "esp"  */
  YYSYMBOL_COMP = 158,                     /* "comp"  */
  YYSYMBOL_FLAGS = 159,                    /* "flags"  */
  YYSYMBOL_CPI = 160,                      /* "cpi"  */
  YYSYMBOL_PORT = 161,                     /* "port"  */
  YYSYMBOL_UDP = 162,                      /* "udp"  */
  YYSYMBOL_SPORT = 163,                    /* "sport"  */
  YYSYMBOL_DPORT = 164,                    /* "dport"  */
  YYSYMBOL_UDPLITE = 165,                  /* "udplite"  */
  YYSYMBOL_CSUMCOV = 166,                  /* "csumcov"  */
  YYSYMBOL_TCP = 167,                      /* "tcp"  */
  YYSYMBOL_ACKSEQ = 168,                   /* "ackseq"  */
  YYSYMBOL_DOFF = 169,                     /* "doff"  */
  YYSYMBOL_WINDOW = 170,                   /* "window"  */
  YYSYMBOL_URGPTR = 171,                   /* "urgptr"  */
  YYSYMBOL_OPTION = 172,                   /* "option"  */
  YYSYMBOL_ECHO = 173,                     /* "echo"  */
  YYSYMBOL_EOL = 174,                      /* "eol"  */
  YYSYMBOL_NOP = 175,                      /* "nop"  */
  YYSYMBOL_SACK = 176,                     /* "sack"  */
  YYSYMBOL_SACK0 = 177,                    /* "sack0"  */
  YYSYMBOL_SACK1 = 178,                    /* "sack1"  */
  YYSYMBOL_SACK2 = 179,                    /* "sack2"  */
  YYSYMBOL_SACK3 = 180,                    /* "sack3"  */
  YYSYMBOL_SACK_PERM = 181,                /* "sack-permitted"  */
  YYSYMBOL_TIMESTAMP = 182,                /* "timestamp"  */
  YYSYMBOL_KIND = 183,                     /* "kind"  */
  YYSYMBOL_COUNT = 184,                    /* "count"  */
  YYSYMBOL_LEFT = 185,                     /* "left"  */
  YYSYMBOL_RIGHT = 186,                    /* "right"  */
  YYSYMBOL_TSVAL = 187,                    /* "tsval"  */
  YYSYMBOL_TSECR = 188,                    /* "tsecr"  */
  YYSYMBOL_DCCP = 189,                     /* "dccp"  */
  YYSYMBOL_SCTP = 190,                     /* "sctp"  */
  YYSYMBOL_CHUNK = 191,                    /* "chunk"  */
  YYSYMBOL_DATA = 192,                     /* "data"  */
  YYSYMBOL_INIT = 193,                     /* "init"  */
  YYSYMBOL_INIT_ACK = 194,                 /* "init-ack"  */
  YYSYMBOL_HEARTBEAT = 195,                /* "heartbeat"  */
  YYSYMBOL_HEARTBEAT_ACK = 196,            /* "heartbeat-ack"  */
  YYSYMBOL_ABORT = 197,                    /* "abort"  */
  YYSYMBOL_SHUTDOWN = 198,                 /* "shutdown"  */
  YYSYMBOL_SHUTDOWN_ACK = 199,             /* "shutdown-ack"  */
  YYSYMBOL_ERROR = 200,                    /* "error"  */
  YYSYMBOL_COOKIE_ECHO = 201,              /* "cookie-echo"  */
  YYSYMBOL_COOKIE_ACK = 202,               /* "cookie-ack"  */
  YYSYMBOL_ECNE = 203,                     /* "ecne"  */
  YYSYMBOL_CWR = 204,                      /* "cwr"  */
  YYSYMBOL_SHUTDOWN_COMPLETE = 205,        /* "shutdown-complete"  */
  YYSYMBOL_ASCONF_ACK = 206,               /* "asconf-ack"  */
  YYSYMBOL_FORWARD_TSN = 207,              /* "forward-tsn"  */
  YYSYMBOL_ASCONF = 208,                   /* "asconf"  */
  YYSYMBOL_TSN = 209,                      /* "tsn"  */
  YYSYMBOL_STREAM = 210,                   /* "stream"  */
  YYSYMBOL_SSN = 211,                      /* "ssn"  */
  YYSYMBOL_PPID = 212,                     /* "ppid"  */
  YYSYMBOL_INIT_TAG = 213,                 /* "init-tag"  */
  YYSYMBOL_A_RWND = 214,                   /* "a-rwnd"  */
  YYSYMBOL_NUM_OSTREAMS = 215,             /* "num-outbound-streams"  */
  YYSYMBOL_NUM_ISTREAMS = 216,             /* "num-inbound-streams"  */
  YYSYMBOL_INIT_TSN = 217,                 /* "initial-tsn"  */
  YYSYMBOL_CUM_TSN_ACK = 218,              /* "cum-tsn-ack"  */
  YYSYMBOL_NUM_GACK_BLOCKS = 219,          /* "num-gap-ack-blocks"  */
  YYSYMBOL_NUM_DUP_TSNS = 220,             /* "num-dup-tsns"  */
  YYSYMBOL_LOWEST_TSN = 221,               /* "lowest-tsn"  */
  YYSYMBOL_SEQNO = 222,                    /* "seqno"  */
  YYSYMBOL_NEW_CUM_TSN = 223,              /* "new-cum-tsn"  */
  YYSYMBOL_VTAG = 224,                     /* "vtag"  */
  YYSYMBOL_RT = 225,                       /* "rt"  */
  YYSYMBOL_RT0 = 226,                      /* "rt0"  */
  YYSYMBOL_RT2 = 227,                      /* "rt2"  */
  YYSYMBOL_RT4 = 228,                      /* "srh"  */
  YYSYMBOL_SEG_LEFT = 229,                 /* "seg-left"  */
  YYSYMBOL_ADDR = 230,                     /* "addr"  */
  YYSYMBOL_LAST_ENT = 231,                 /* "last-entry"  */
  YYSYMBOL_TAG = 232,                      /* "tag"  */
  YYSYMBOL_SID = 233,                      /* "sid"  */
  YYSYMBOL_HBH = 234,                      /* "hbh"  */
  YYSYMBOL_FRAG = 235,                     /* "frag"  */
  YYSYMBOL_RESERVED2 = 236,                /* "reserved2"  */
  YYSYMBOL_MORE_FRAGMENTS = 237,           /* "more-fragments"  */
  YYSYMBOL_DST = 238,                      /* "dst"  */
  YYSYMBOL_MH = 239,                       /* "mh"  */
  YYSYMBOL_META = 240,                     /* "meta"  */
  YYSYMBOL_MARK = 241,                     /* "mark"  */
  YYSYMBOL_IIF = 242,                      /* "iif"  */
  YYSYMBOL_IIFNAME = 243,                  /* "iifname"  */
  YYSYMBOL_IIFTYPE = 244,                  /* "iiftype"  */
  YYSYMBOL_OIF = 245,                      /* "oif"  */
  YYSYMBOL_OIFNAME = 246,                  /* "oifname"  */
  YYSYMBOL_OIFTYPE = 247,                  /* "oiftype"  */
  YYSYMBOL_SKUID = 248,                    /* "skuid"  */
  YYSYMBOL_SKGID = 249,                    /* "skgid"  */
  YYSYMBOL_NFTRACE = 250,                  /* "nftrace"  */
  YYSYMBOL_RTCLASSID = 251,                /* "rtclassid"  */
  YYSYMBOL_IBRIPORT = 252,                 /* "ibriport"  */
  YYSYMBOL_OBRIPORT = 253,                 /* "obriport"  */
  YYSYMBOL_IBRIDGENAME = 254,              /* "ibrname"  */
  YYSYMBOL_OBRIDGENAME = 255,              /* "obrname"  */
  YYSYMBOL_PKTTYPE = 256,                  /* "pkttype"  */
  YYSYMBOL_CPU = 257,                      /* "cpu"  */
  YYSYMBOL_IIFGROUP = 258,                 /* "iifgroup"  */
  YYSYMBOL_OIFGROUP = 259,                 /* "oifgroup"  */
  YYSYMBOL_CGROUP = 260,                   /* "cgroup"  */
  YYSYMBOL_TIME = 261,                     /* "time"  */
  YYSYMBOL_CLASSID = 262,                  /* "classid"  */
  YYSYMBOL_NEXTHOP = 263,                  /* "nexthop"  */
  YYSYMBOL_CT = 264,                       /* "ct"  */
  YYSYMBOL_L3PROTOCOL = 265,               /* "l3proto"  */
  YYSYMBOL_PROTO_SRC = 266,                /* "proto-src"  */
  YYSYMBOL_PROTO_DST = 267,                /* "proto-dst"  */
  YYSYMBOL_ZONE = 268,                     /* "zone"  */
  YYSYMBOL_DIRECTION = 269,                /* "direction"  */
  YYSYMBOL_EVENT = 270,                    /* "event"  */
  YYSYMBOL_EXPECTATION = 271,              /* "expectation"  */
  YYSYMBOL_EXPIRATION = 272,               /* "expiration"  */
  YYSYMBOL_HELPER = 273,                   /* "helper"  */
  YYSYMBOL_LABEL = 274,                    /* "label"  */
  YYSYMBOL_STATE = 275,                    /* "state"  */
  YYSYMBOL_STATUS = 276,                   /* "status"  */
  YYSYMBOL_ORIGINAL = 277,                 /* "original"  */
  YYSYMBOL_REPLY = 278,                    /* "reply"  */
  YYSYMBOL_COUNTER = 279,                  /* "counter"  */
  YYSYMBOL_NAME = 280,                     /* "name"  */
  YYSYMBOL_PACKETS = 281,                  /* "packets"  */
  YYSYMBOL_BYTES = 282,                    /* "bytes"  */
  YYSYMBOL_AVGPKT = 283,                   /* "avgpkt"  */
  YYSYMBOL_COUNTERS = 284,                 /* "counters"  */
  YYSYMBOL_QUOTAS = 285,                   /* "quotas"  */
  YYSYMBOL_LIMITS = 286,                   /* "limits"  */
  YYSYMBOL_SYNPROXYS = 287,                /* "synproxys"  */
  YYSYMBOL_HELPERS = 288,                  /* "helpers"  */
  YYSYMBOL_LOG = 289,                      /* "log"  */
  YYSYMBOL_PREFIX = 290,                   /* "prefix"  */
  YYSYMBOL_GROUP = 291,                    /* "group"  */
  YYSYMBOL_SNAPLEN = 292,                  /* "snaplen"  */
  YYSYMBOL_QUEUE_THRESHOLD = 293,          /* "queue-threshold"  */
  YYSYMBOL_LEVEL = 294,                    /* "level"  */
  YYSYMBOL_LIMIT = 295,                    /* "limit"  */
  YYSYMBOL_RATE = 296,                     /* "rate"  */
  YYSYMBOL_BURST = 297,                    /* "burst"  */
  YYSYMBOL_OVER = 298,                     /* "over"  */
  YYSYMBOL_UNTIL = 299,                    /* "until"  */
  YYSYMBOL_QUOTA = 300,                    /* "quota"  */
  YYSYMBOL_USED = 301,                     /* "used"  */
  YYSYMBOL_SECMARK = 302,                  /* "secmark"  */
  YYSYMBOL_SECMARKS = 303,                 /* "secmarks"  */
  YYSYMBOL_NANOSECOND = 304,               /* "nanosecond"  */
  YYSYMBOL_MICROSECOND = 305,              /* "microsecond"  */
  YYSYMBOL_MILLISECOND = 306,              /* "millisecond"  */
  YYSYMBOL_SECOND = 307,                   /* "second"  */
  YYSYMBOL_MINUTE = 308,                   /* "minute"  */
  YYSYMBOL_HOUR = 309,                     /* "hour"  */
  YYSYMBOL_DAY = 310,                      /* "day"  */
  YYSYMBOL_WEEK = 311,                     /* "week"  */
  YYSYMBOL__REJECT = 312,                  /* "reject"  */
  YYSYMBOL_WITH = 313,                     /* "with"  */
  YYSYMBOL_ICMPX = 314,                    /* "icmpx"  */
  YYSYMBOL_SNAT = 315,                     /* "snat"  */
  YYSYMBOL_DNAT = 316,                     /* "dnat"  */
  YYSYMBOL_MASQUERADE = 317,               /* "masquerade"  */
  YYSYMBOL_REDIRECT = 318,                 /* "redirect"  */
  YYSYMBOL_RANDOM = 319,                   /* "random"  */
  YYSYMBOL_FULLY_RANDOM = 320,             /* "fully-random"  */
  YYSYMBOL_PERSISTENT = 321,               /* "persistent"  */
  YYSYMBOL_QUEUE = 322,                    /* "queue"  */
  YYSYMBOL_QUEUENUM = 323,                 /* "num"  */
  YYSYMBOL_BYPASS = 324,                   /* "bypass"  */
  YYSYMBOL_FANOUT = 325,                   /* "fanout"  */
  YYSYMBOL_DUP = 326,                      /* "dup"  */
  YYSYMBOL_FWD = 327,                      /* "fwd"  */
  YYSYMBOL_NUMGEN = 328,                   /* "numgen"  */
  YYSYMBOL_INC = 329,                      /* "inc"  */
  YYSYMBOL_MOD = 330,                      /* "mod"  */
  YYSYMBOL_OFFSET = 331,                   /* "offset"  */
  YYSYMBOL_JHASH = 332,                    /* "jhash"  */
  YYSYMBOL_SYMHASH = 333,                  /* "symhash"  */
  YYSYMBOL_SEED = 334,                     /* "seed"  */
  YYSYMBOL_POSITION = 335,                 /* "position"  */
  YYSYMBOL_INDEX = 336,                    /* "index"  */
  YYSYMBOL_COMMENT = 337,                  /* "comment"  */
  YYSYMBOL_XML = 338,                      /* "xml"  */
  YYSYMBOL_JSON = 339,                     /* "json"  */
  YYSYMBOL_VM = 340,                       /* "vm"  */
  YYSYMBOL_NOTRACK = 341,                  /* "notrack"  */
  YYSYMBOL_EXISTS = 342,                   /* "exists"  */
  YYSYMBOL_MISSING = 343,                  /* "missing"  */
  YYSYMBOL_EXTHDR = 344,                   /* "exthdr"  */
  YYSYMBOL_IPSEC = 345,                    /* "ipsec"  */
  YYSYMBOL_MODE = 346,                     /* "mode"  */
  YYSYMBOL_REQID = 347,                    /* "reqid"  */
  YYSYMBOL_SPNUM = 348,                    /* "spnum"  */
  YYSYMBOL_TRANSPORT = 349,                /* "transport"  */
  YYSYMBOL_TUNNEL = 350,                   /* "tunnel"  */
  YYSYMBOL_IN = 351,                       /* "in"  */
  YYSYMBOL_OUT = 352,                      /* "out"  */
  YYSYMBOL_353_ = 353,                     /* '='  */
  YYSYMBOL_354_ = 354,                     /* '{'  */
  YYSYMBOL_355_ = 355,                     /* '}'  */
  YYSYMBOL_356_ = 356,                     /* '('  */
  YYSYMBOL_357_ = 357,                     /* ')'  */
  YYSYMBOL_358_ = 358,                     /* '|'  */
  YYSYMBOL_359_ = 359,                     /* '$'  */
  YYSYMBOL_360_ = 360,                     /* '['  */
  YYSYMBOL_361_ = 361,                     /* ']'  */
  YYSYMBOL_YYACCEPT = 362,                 /* $accept  */
  YYSYMBOL_input = 363,                    /* input  */
  YYSYMBOL_stmt_separator = 364,           /* stmt_separator  */
  YYSYMBOL_opt_newline = 365,              /* opt_newline  */
  YYSYMBOL_close_scope_hash = 366,         /* close_scope_hash  */
  YYSYMBOL_close_scope_numgen = 367,       /* close_scope_numgen  */
  YYSYMBOL_close_scope_sctp = 368,         /* close_scope_sctp  */
  YYSYMBOL_close_scope_sctp_chunk = 369,   /* close_scope_sctp_chunk  */
  YYSYMBOL_common_block = 370,             /* common_block  */
  YYSYMBOL_line = 371,                     /* line  */
  YYSYMBOL_base_cmd = 372,                 /* base_cmd  */
  YYSYMBOL_add_cmd = 373,                  /* add_cmd  */
  YYSYMBOL_replace_cmd = 374,              /* replace_cmd  */
  YYSYMBOL_create_cmd = 375,               /* create_cmd  */
  YYSYMBOL_insert_cmd = 376,               /* insert_cmd  */
  YYSYMBOL_delete_cmd = 377,               /* delete_cmd  */
  YYSYMBOL_get_cmd = 378,                  /* get_cmd  */
  YYSYMBOL_list_cmd = 379,                 /* list_cmd  */
  YYSYMBOL_reset_cmd = 380,                /* reset_cmd  */
  YYSYMBOL_flush_cmd = 381,                /* flush_cmd  */
  YYSYMBOL_rename_cmd = 382,               /* rename_cmd  */
  YYSYMBOL_import_cmd = 383,               /* import_cmd  */
  YYSYMBOL_export_cmd = 384,               /* export_cmd  */
  YYSYMBOL_monitor_cmd = 385,              /* monitor_cmd  */
  YYSYMBOL_monitor_event = 386,            /* monitor_event  */
  YYSYMBOL_monitor_object = 387,           /* monitor_object  */
  YYSYMBOL_monitor_format = 388,           /* monitor_format  */
  YYSYMBOL_markup_format = 389,            /* markup_format  */
  YYSYMBOL_describe_cmd = 390,             /* describe_cmd  */
  YYSYMBOL_table_block_alloc = 391,        /* table_block_alloc  */
  YYSYMBOL_table_options = 392,            /* table_options  */
  YYSYMBOL_table_block = 393,              /* table_block  */
  YYSYMBOL_chain_block_alloc = 394,        /* chain_block_alloc  */
  YYSYMBOL_chain_block = 395,              /* chain_block  */
  YYSYMBOL_subchain_block = 396,           /* subchain_block  */
  YYSYMBOL_typeof_expr = 397,              /* typeof_expr  */
  YYSYMBOL_set_block_alloc = 398,          /* set_block_alloc  */
  YYSYMBOL_set_block = 399,                /* set_block  */
  YYSYMBOL_set_block_expr = 400,           /* set_block_expr  */
  YYSYMBOL_set_flag_list = 401,            /* set_flag_list  */
  YYSYMBOL_set_flag = 402,                 /* set_flag  */
  YYSYMBOL_map_block_alloc = 403,          /* map_block_alloc  */
  YYSYMBOL_map_block = 404,                /* map_block  */
  YYSYMBOL_set_mechanism = 405,            /* set_mechanism  */
  YYSYMBOL_set_policy_spec = 406,          /* set_policy_spec  */
  YYSYMBOL_flowtable_block_alloc = 407,    /* flowtable_block_alloc  */
  YYSYMBOL_flowtable_block = 408,          /* flowtable_block  */
  YYSYMBOL_flowtable_expr = 409,           /* flowtable_expr  */
  YYSYMBOL_flowtable_list_expr = 410,      /* flowtable_list_expr  */
  YYSYMBOL_flowtable_expr_member = 411,    /* flowtable_expr_member  */
  YYSYMBOL_data_type_atom_expr = 412,      /* data_type_atom_expr  */
  YYSYMBOL_data_type_expr = 413,           /* data_type_expr  */
  YYSYMBOL_obj_block_alloc = 414,          /* obj_block_alloc  */
  YYSYMBOL_counter_block = 415,            /* counter_block  */
  YYSYMBOL_quota_block = 416,              /* quota_block  */
  YYSYMBOL_ct_helper_block = 417,          /* ct_helper_block  */
  YYSYMBOL_ct_timeout_block = 418,         /* ct_timeout_block  */
  YYSYMBOL_ct_expect_block = 419,          /* ct_expect_block  */
  YYSYMBOL_limit_block = 420,              /* limit_block  */
  YYSYMBOL_secmark_block = 421,            /* secmark_block  */
  YYSYMBOL_synproxy_block = 422,           /* synproxy_block  */
  YYSYMBOL_type_identifier = 423,          /* type_identifier  */
  YYSYMBOL_hook_spec = 424,                /* hook_spec  */
  YYSYMBOL_prio_spec = 425,                /* prio_spec  */
  YYSYMBOL_extended_prio_name = 426,       /* extended_prio_name  */
  YYSYMBOL_extended_prio_spec = 427,       /* extended_prio_spec  */
  YYSYMBOL_int_num = 428,                  /* int_num  */
  YYSYMBOL_dev_spec = 429,                 /* dev_spec  */
  YYSYMBOL_flags_spec = 430,               /* flags_spec  */
  YYSYMBOL_policy_spec = 431,              /* policy_spec  */
  YYSYMBOL_policy_expr = 432,              /* policy_expr  */
  YYSYMBOL_chain_policy = 433,             /* chain_policy  */
  YYSYMBOL_identifier = 434,               /* identifier  */
  YYSYMBOL_string = 435,                   /* string  */
  YYSYMBOL_time_spec = 436,                /* time_spec  */
  YYSYMBOL_family_spec = 437,              /* family_spec  */
  YYSYMBOL_family_spec_explicit = 438,     /* family_spec_explicit  */
  YYSYMBOL_table_spec = 439,               /* table_spec  */
  YYSYMBOL_tableid_spec = 440,             /* tableid_spec  */
  YYSYMBOL_chain_spec = 441,               /* chain_spec  */
  YYSYMBOL_chainid_spec = 442,             /* chainid_spec  */
  YYSYMBOL_chain_identifier = 443,         /* chain_identifier  */
  YYSYMBOL_set_spec = 444,                 /* set_spec  */
  YYSYMBOL_setid_spec = 445,               /* setid_spec  */
  YYSYMBOL_set_identifier = 446,           /* set_identifier  */
  YYSYMBOL_flowtable_spec = 447,           /* flowtable_spec  */
  YYSYMBOL_flowtableid_spec = 448,         /* flowtableid_spec  */
  YYSYMBOL_flowtable_identifier = 449,     /* flowtable_identifier  */
  YYSYMBOL_obj_spec = 450,                 /* obj_spec  */
  YYSYMBOL_objid_spec = 451,               /* objid_spec  */
  YYSYMBOL_obj_identifier = 452,           /* obj_identifier  */
  YYSYMBOL_handle_spec = 453,              /* handle_spec  */
  YYSYMBOL_position_spec = 454,            /* position_spec  */
  YYSYMBOL_index_spec = 455,               /* index_spec  */
  YYSYMBOL_rule_position = 456,            /* rule_position  */
  YYSYMBOL_ruleid_spec = 457,              /* ruleid_spec  */
  YYSYMBOL_comment_spec = 458,             /* comment_spec  */
  YYSYMBOL_ruleset_spec = 459,             /* ruleset_spec  */
  YYSYMBOL_rule = 460,                     /* rule  */
  YYSYMBOL_rule_alloc = 461,               /* rule_alloc  */
  YYSYMBOL_stmt_list = 462,                /* stmt_list  */
  YYSYMBOL_stateful_stmt_list = 463,       /* stateful_stmt_list  */
  YYSYMBOL_stateful_stmt = 464,            /* stateful_stmt  */
  YYSYMBOL_stmt = 465,                     /* stmt  */
  YYSYMBOL_chain_stmt_type = 466,          /* chain_stmt_type  */
  YYSYMBOL_chain_stmt = 467,               /* chain_stmt  */
  YYSYMBOL_verdict_stmt = 468,             /* verdict_stmt  */
  YYSYMBOL_verdict_map_stmt = 469,         /* verdict_map_stmt  */
  YYSYMBOL_verdict_map_expr = 470,         /* verdict_map_expr  */
  YYSYMBOL_verdict_map_list_expr = 471,    /* verdict_map_list_expr  */
  YYSYMBOL_verdict_map_list_member_expr = 472, /* verdict_map_list_member_expr  */
  YYSYMBOL_connlimit_stmt = 473,           /* connlimit_stmt  */
  YYSYMBOL_counter_stmt = 474,             /* counter_stmt  */
  YYSYMBOL_counter_stmt_alloc = 475,       /* counter_stmt_alloc  */
  YYSYMBOL_counter_args = 476,             /* counter_args  */
  YYSYMBOL_counter_arg = 477,              /* counter_arg  */
  YYSYMBOL_log_stmt = 478,                 /* log_stmt  */
  YYSYMBOL_log_stmt_alloc = 479,           /* log_stmt_alloc  */
  YYSYMBOL_log_args = 480,                 /* log_args  */
  YYSYMBOL_log_arg = 481,                  /* log_arg  */
  YYSYMBOL_level_type = 482,               /* level_type  */
  YYSYMBOL_log_flags = 483,                /* log_flags  */
  YYSYMBOL_log_flags_tcp = 484,            /* log_flags_tcp  */
  YYSYMBOL_log_flag_tcp = 485,             /* log_flag_tcp  */
  YYSYMBOL_limit_stmt = 486,               /* limit_stmt  */
  YYSYMBOL_quota_mode = 487,               /* quota_mode  */
  YYSYMBOL_quota_unit = 488,               /* quota_unit  */
  YYSYMBOL_quota_used = 489,               /* quota_used  */
  YYSYMBOL_quota_stmt = 490,               /* quota_stmt  */
  YYSYMBOL_limit_mode = 491,               /* limit_mode  */
  YYSYMBOL_limit_burst_pkts = 492,         /* limit_burst_pkts  */
  YYSYMBOL_limit_burst_bytes = 493,        /* limit_burst_bytes  */
  YYSYMBOL_time_unit = 494,                /* time_unit  */
  YYSYMBOL_reject_stmt = 495,              /* reject_stmt  */
  YYSYMBOL_reject_stmt_alloc = 496,        /* reject_stmt_alloc  */
  YYSYMBOL_reject_opts = 497,              /* reject_opts  */
  YYSYMBOL_nat_stmt = 498,                 /* nat_stmt  */
  YYSYMBOL_nat_stmt_alloc = 499,           /* nat_stmt_alloc  */
  YYSYMBOL_tproxy_stmt = 500,              /* tproxy_stmt  */
  YYSYMBOL_synproxy_stmt = 501,            /* synproxy_stmt  */
  YYSYMBOL_synproxy_stmt_alloc = 502,      /* synproxy_stmt_alloc  */
  YYSYMBOL_synproxy_args = 503,            /* synproxy_args  */
  YYSYMBOL_synproxy_arg = 504,             /* synproxy_arg  */
  YYSYMBOL_synproxy_config = 505,          /* synproxy_config  */
  YYSYMBOL_synproxy_obj = 506,             /* synproxy_obj  */
  YYSYMBOL_synproxy_ts = 507,              /* synproxy_ts  */
  YYSYMBOL_synproxy_sack = 508,            /* synproxy_sack  */
  YYSYMBOL_primary_stmt_expr = 509,        /* primary_stmt_expr  */
  YYSYMBOL_shift_stmt_expr = 510,          /* shift_stmt_expr  */
  YYSYMBOL_and_stmt_expr = 511,            /* and_stmt_expr  */
  YYSYMBOL_exclusive_or_stmt_expr = 512,   /* exclusive_or_stmt_expr  */
  YYSYMBOL_inclusive_or_stmt_expr = 513,   /* inclusive_or_stmt_expr  */
  YYSYMBOL_basic_stmt_expr = 514,          /* basic_stmt_expr  */
  YYSYMBOL_concat_stmt_expr = 515,         /* concat_stmt_expr  */
  YYSYMBOL_map_stmt_expr_set = 516,        /* map_stmt_expr_set  */
  YYSYMBOL_map_stmt_expr = 517,            /* map_stmt_expr  */
  YYSYMBOL_prefix_stmt_expr = 518,         /* prefix_stmt_expr  */
  YYSYMBOL_range_stmt_expr = 519,          /* range_stmt_expr  */
  YYSYMBOL_wildcard_expr = 520,            /* wildcard_expr  */
  YYSYMBOL_multiton_stmt_expr = 521,       /* multiton_stmt_expr  */
  YYSYMBOL_stmt_expr = 522,                /* stmt_expr  */
  YYSYMBOL_nat_stmt_args = 523,            /* nat_stmt_args  */
  YYSYMBOL_masq_stmt = 524,                /* masq_stmt  */
  YYSYMBOL_masq_stmt_alloc = 525,          /* masq_stmt_alloc  */
  YYSYMBOL_masq_stmt_args = 526,           /* masq_stmt_args  */
  YYSYMBOL_redir_stmt = 527,               /* redir_stmt  */
  YYSYMBOL_redir_stmt_alloc = 528,         /* redir_stmt_alloc  */
  YYSYMBOL_redir_stmt_arg = 529,           /* redir_stmt_arg  */
  YYSYMBOL_dup_stmt = 530,                 /* dup_stmt  */
  YYSYMBOL_fwd_stmt = 531,                 /* fwd_stmt  */
  YYSYMBOL_nf_nat_flags = 532,             /* nf_nat_flags  */
  YYSYMBOL_nf_nat_flag = 533,              /* nf_nat_flag  */
  YYSYMBOL_queue_stmt = 534,               /* queue_stmt  */
  YYSYMBOL_queue_stmt_alloc = 535,         /* queue_stmt_alloc  */
  YYSYMBOL_queue_stmt_args = 536,          /* queue_stmt_args  */
  YYSYMBOL_queue_stmt_arg = 537,           /* queue_stmt_arg  */
  YYSYMBOL_queue_stmt_flags = 538,         /* queue_stmt_flags  */
  YYSYMBOL_queue_stmt_flag = 539,          /* queue_stmt_flag  */
  YYSYMBOL_set_elem_expr_stmt = 540,       /* set_elem_expr_stmt  */
  YYSYMBOL_set_elem_expr_stmt_alloc = 541, /* set_elem_expr_stmt_alloc  */
  YYSYMBOL_set_stmt = 542,                 /* set_stmt  */
  YYSYMBOL_set_stmt_op = 543,              /* set_stmt_op  */
  YYSYMBOL_map_stmt = 544,                 /* map_stmt  */
  YYSYMBOL_meter_stmt = 545,               /* meter_stmt  */
  YYSYMBOL_flow_stmt_legacy_alloc = 546,   /* flow_stmt_legacy_alloc  */
  YYSYMBOL_flow_stmt_opts = 547,           /* flow_stmt_opts  */
  YYSYMBOL_flow_stmt_opt = 548,            /* flow_stmt_opt  */
  YYSYMBOL_meter_stmt_alloc = 549,         /* meter_stmt_alloc  */
  YYSYMBOL_match_stmt = 550,               /* match_stmt  */
  YYSYMBOL_variable_expr = 551,            /* variable_expr  */
  YYSYMBOL_symbol_expr = 552,              /* symbol_expr  */
  YYSYMBOL_set_ref_expr = 553,             /* set_ref_expr  */
  YYSYMBOL_set_ref_symbol_expr = 554,      /* set_ref_symbol_expr  */
  YYSYMBOL_integer_expr = 555,             /* integer_expr  */
  YYSYMBOL_primary_expr = 556,             /* primary_expr  */
  YYSYMBOL_fib_expr = 557,                 /* fib_expr  */
  YYSYMBOL_fib_result = 558,               /* fib_result  */
  YYSYMBOL_fib_flag = 559,                 /* fib_flag  */
  YYSYMBOL_fib_tuple = 560,                /* fib_tuple  */
  YYSYMBOL_osf_expr = 561,                 /* osf_expr  */
  YYSYMBOL_osf_ttl = 562,                  /* osf_ttl  */
  YYSYMBOL_shift_expr = 563,               /* shift_expr  */
  YYSYMBOL_and_expr = 564,                 /* and_expr  */
  YYSYMBOL_exclusive_or_expr = 565,        /* exclusive_or_expr  */
  YYSYMBOL_inclusive_or_expr = 566,        /* inclusive_or_expr  */
  YYSYMBOL_basic_expr = 567,               /* basic_expr  */
  YYSYMBOL_concat_expr = 568,              /* concat_expr  */
  YYSYMBOL_prefix_rhs_expr = 569,          /* prefix_rhs_expr  */
  YYSYMBOL_range_rhs_expr = 570,           /* range_rhs_expr  */
  YYSYMBOL_multiton_rhs_expr = 571,        /* multiton_rhs_expr  */
  YYSYMBOL_map_expr = 572,                 /* map_expr  */
  YYSYMBOL_expr = 573,                     /* expr  */
  YYSYMBOL_set_expr = 574,                 /* set_expr  */
  YYSYMBOL_set_list_expr = 575,            /* set_list_expr  */
  YYSYMBOL_set_list_member_expr = 576,     /* set_list_member_expr  */
  YYSYMBOL_meter_key_expr = 577,           /* meter_key_expr  */
  YYSYMBOL_meter_key_expr_alloc = 578,     /* meter_key_expr_alloc  */
  YYSYMBOL_set_elem_expr = 579,            /* set_elem_expr  */
  YYSYMBOL_set_elem_expr_alloc = 580,      /* set_elem_expr_alloc  */
  YYSYMBOL_set_elem_options = 581,         /* set_elem_options  */
  YYSYMBOL_set_elem_option = 582,          /* set_elem_option  */
  YYSYMBOL_set_elem_expr_options = 583,    /* set_elem_expr_options  */
  YYSYMBOL_set_elem_stmt_list = 584,       /* set_elem_stmt_list  */
  YYSYMBOL_set_elem_stmt = 585,            /* set_elem_stmt  */
  YYSYMBOL_set_elem_expr_option = 586,     /* set_elem_expr_option  */
  YYSYMBOL_set_lhs_expr = 587,             /* set_lhs_expr  */
  YYSYMBOL_set_rhs_expr = 588,             /* set_rhs_expr  */
  YYSYMBOL_initializer_expr = 589,         /* initializer_expr  */
  YYSYMBOL_counter_config = 590,           /* counter_config  */
  YYSYMBOL_counter_obj = 591,              /* counter_obj  */
  YYSYMBOL_quota_config = 592,             /* quota_config  */
  YYSYMBOL_quota_obj = 593,                /* quota_obj  */
  YYSYMBOL_secmark_config = 594,           /* secmark_config  */
  YYSYMBOL_secmark_obj = 595,              /* secmark_obj  */
  YYSYMBOL_ct_obj_type = 596,              /* ct_obj_type  */
  YYSYMBOL_ct_l4protoname = 597,           /* ct_l4protoname  */
  YYSYMBOL_ct_helper_config = 598,         /* ct_helper_config  */
  YYSYMBOL_timeout_states = 599,           /* timeout_states  */
  YYSYMBOL_timeout_state = 600,            /* timeout_state  */
  YYSYMBOL_ct_timeout_config = 601,        /* ct_timeout_config  */
  YYSYMBOL_ct_expect_config = 602,         /* ct_expect_config  */
  YYSYMBOL_ct_obj_alloc = 603,             /* ct_obj_alloc  */
  YYSYMBOL_limit_config = 604,             /* limit_config  */
  YYSYMBOL_limit_obj = 605,                /* limit_obj  */
  YYSYMBOL_relational_expr = 606,          /* relational_expr  */
  YYSYMBOL_list_rhs_expr = 607,            /* list_rhs_expr  */
  YYSYMBOL_rhs_expr = 608,                 /* rhs_expr  */
  YYSYMBOL_shift_rhs_expr = 609,           /* shift_rhs_expr  */
  YYSYMBOL_and_rhs_expr = 610,             /* and_rhs_expr  */
  YYSYMBOL_exclusive_or_rhs_expr = 611,    /* exclusive_or_rhs_expr  */
  YYSYMBOL_inclusive_or_rhs_expr = 612,    /* inclusive_or_rhs_expr  */
  YYSYMBOL_basic_rhs_expr = 613,           /* basic_rhs_expr  */
  YYSYMBOL_concat_rhs_expr = 614,          /* concat_rhs_expr  */
  YYSYMBOL_boolean_keys = 615,             /* boolean_keys  */
  YYSYMBOL_boolean_expr = 616,             /* boolean_expr  */
  YYSYMBOL_keyword_expr = 617,             /* keyword_expr  */
  YYSYMBOL_primary_rhs_expr = 618,         /* primary_rhs_expr  */
  YYSYMBOL_relational_op = 619,            /* relational_op  */
  YYSYMBOL_verdict_expr = 620,             /* verdict_expr  */
  YYSYMBOL_chain_expr = 621,               /* chain_expr  */
  YYSYMBOL_meta_expr = 622,                /* meta_expr  */
  YYSYMBOL_meta_key = 623,                 /* meta_key  */
  YYSYMBOL_meta_key_qualified = 624,       /* meta_key_qualified  */
  YYSYMBOL_meta_key_unqualified = 625,     /* meta_key_unqualified  */
  YYSYMBOL_meta_stmt = 626,                /* meta_stmt  */
  YYSYMBOL_socket_expr = 627,              /* socket_expr  */
  YYSYMBOL_socket_key = 628,               /* socket_key  */
  YYSYMBOL_offset_opt = 629,               /* offset_opt  */
  YYSYMBOL_numgen_type = 630,              /* numgen_type  */
  YYSYMBOL_numgen_expr = 631,              /* numgen_expr  */
  YYSYMBOL_xfrm_spnum = 632,               /* xfrm_spnum  */
  YYSYMBOL_xfrm_dir = 633,                 /* xfrm_dir  */
  YYSYMBOL_xfrm_state_key = 634,           /* xfrm_state_key  */
  YYSYMBOL_xfrm_state_proto_key = 635,     /* xfrm_state_proto_key  */
  YYSYMBOL_xfrm_expr = 636,                /* xfrm_expr  */
  YYSYMBOL_hash_expr = 637,                /* hash_expr  */
  YYSYMBOL_nf_key_proto = 638,             /* nf_key_proto  */
  YYSYMBOL_rt_expr = 639,                  /* rt_expr  */
  YYSYMBOL_rt_key = 640,                   /* rt_key  */
  YYSYMBOL_ct_expr = 641,                  /* ct_expr  */
  YYSYMBOL_ct_dir = 642,                   /* ct_dir  */
  YYSYMBOL_ct_key = 643,                   /* ct_key  */
  YYSYMBOL_ct_key_dir = 644,               /* ct_key_dir  */
  YYSYMBOL_ct_key_proto_field = 645,       /* ct_key_proto_field  */
  YYSYMBOL_ct_key_dir_optional = 646,      /* ct_key_dir_optional  */
  YYSYMBOL_symbol_stmt_expr = 647,         /* symbol_stmt_expr  */
  YYSYMBOL_list_stmt_expr = 648,           /* list_stmt_expr  */
  YYSYMBOL_ct_stmt = 649,                  /* ct_stmt  */
  YYSYMBOL_payload_stmt = 650,             /* payload_stmt  */
  YYSYMBOL_payload_expr = 651,             /* payload_expr  */
  YYSYMBOL_payload_raw_expr = 652,         /* payload_raw_expr  */
  YYSYMBOL_payload_base_spec = 653,        /* payload_base_spec  */
  YYSYMBOL_eth_hdr_expr = 654,             /* eth_hdr_expr  */
  YYSYMBOL_eth_hdr_field = 655,            /* eth_hdr_field  */
  YYSYMBOL_vlan_hdr_expr = 656,            /* vlan_hdr_expr  */
  YYSYMBOL_vlan_hdr_field = 657,           /* vlan_hdr_field  */
  YYSYMBOL_arp_hdr_expr = 658,             /* arp_hdr_expr  */
  YYSYMBOL_arp_hdr_field = 659,            /* arp_hdr_field  */
  YYSYMBOL_ip_hdr_expr = 660,              /* ip_hdr_expr  */
  YYSYMBOL_ip_hdr_field = 661,             /* ip_hdr_field  */
  YYSYMBOL_ip_option_type = 662,           /* ip_option_type  */
  YYSYMBOL_ip_option_field = 663,          /* ip_option_field  */
  YYSYMBOL_icmp_hdr_expr = 664,            /* icmp_hdr_expr  */
  YYSYMBOL_icmp_hdr_field = 665,           /* icmp_hdr_field  */
  YYSYMBOL_igmp_hdr_expr = 666,            /* igmp_hdr_expr  */
  YYSYMBOL_igmp_hdr_field = 667,           /* igmp_hdr_field  */
  YYSYMBOL_ip6_hdr_expr = 668,             /* ip6_hdr_expr  */
  YYSYMBOL_ip6_hdr_field = 669,            /* ip6_hdr_field  */
  YYSYMBOL_icmp6_hdr_expr = 670,           /* icmp6_hdr_expr  */
  YYSYMBOL_icmp6_hdr_field = 671,          /* icmp6_hdr_field  */
  YYSYMBOL_auth_hdr_expr = 672,            /* auth_hdr_expr  */
  YYSYMBOL_auth_hdr_field = 673,           /* auth_hdr_field  */
  YYSYMBOL_esp_hdr_expr = 674,             /* esp_hdr_expr  */
  YYSYMBOL_esp_hdr_field = 675,            /* esp_hdr_field  */
  YYSYMBOL_comp_hdr_expr = 676,            /* comp_hdr_expr  */
  YYSYMBOL_comp_hdr_field = 677,           /* comp_hdr_field  */
  YYSYMBOL_udp_hdr_expr = 678,             /* udp_hdr_expr  */
  YYSYMBOL_udp_hdr_field = 679,            /* udp_hdr_field  */
  YYSYMBOL_udplite_hdr_expr = 680,         /* udplite_hdr_expr  */
  YYSYMBOL_udplite_hdr_field = 681,        /* udplite_hdr_field  */
  YYSYMBOL_tcp_hdr_expr = 682,             /* tcp_hdr_expr  */
  YYSYMBOL_tcp_hdr_field = 683,            /* tcp_hdr_field  */
  YYSYMBOL_tcp_hdr_option_type = 684,      /* tcp_hdr_option_type  */
  YYSYMBOL_tcp_hdr_option_field = 685,     /* tcp_hdr_option_field  */
  YYSYMBOL_dccp_hdr_expr = 686,            /* dccp_hdr_expr  */
  YYSYMBOL_dccp_hdr_field = 687,           /* dccp_hdr_field  */
  YYSYMBOL_sctp_chunk_type = 688,          /* sctp_chunk_type  */
  YYSYMBOL_sctp_chunk_common_field = 689,  /* sctp_chunk_common_field  */
  YYSYMBOL_sctp_chunk_data_field = 690,    /* sctp_chunk_data_field  */
  YYSYMBOL_sctp_chunk_init_field = 691,    /* sctp_chunk_init_field  */
  YYSYMBOL_sctp_chunk_sack_field = 692,    /* sctp_chunk_sack_field  */
  YYSYMBOL_sctp_chunk_alloc = 693,         /* sctp_chunk_alloc  */
  YYSYMBOL_sctp_hdr_expr = 694,            /* sctp_hdr_expr  */
  YYSYMBOL_sctp_hdr_field = 695,           /* sctp_hdr_field  */
  YYSYMBOL_th_hdr_expr = 696,              /* th_hdr_expr  */
  YYSYMBOL_th_hdr_field = 697,             /* th_hdr_field  */
  YYSYMBOL_exthdr_expr = 698,              /* exthdr_expr  */
  YYSYMBOL_hbh_hdr_expr = 699,             /* hbh_hdr_expr  */
  YYSYMBOL_hbh_hdr_field = 700,            /* hbh_hdr_field  */
  YYSYMBOL_rt_hdr_expr = 701,              /* rt_hdr_expr  */
  YYSYMBOL_rt_hdr_field = 702,             /* rt_hdr_field  */
  YYSYMBOL_rt0_hdr_expr = 703,             /* rt0_hdr_expr  */
  YYSYMBOL_rt0_hdr_field = 704,            /* rt0_hdr_field  */
  YYSYMBOL_rt2_hdr_expr = 705,             /* rt2_hdr_expr  */
  YYSYMBOL_rt2_hdr_field = 706,            /* rt2_hdr_field  */
  YYSYMBOL_rt4_hdr_expr = 707,             /* rt4_hdr_expr  */
  YYSYMBOL_rt4_hdr_field = 708,            /* rt4_hdr_field  */
  YYSYMBOL_frag_hdr_expr = 709,            /* frag_hdr_expr  */
  YYSYMBOL_frag_hdr_field = 710,           /* frag_hdr_field  */
  YYSYMBOL_dst_hdr_expr = 711,             /* dst_hdr_expr  */
  YYSYMBOL_dst_hdr_field = 712,            /* dst_hdr_field  */
  YYSYMBOL_mh_hdr_expr = 713,              /* mh_hdr_expr  */
  YYSYMBOL_mh_hdr_field = 714,             /* mh_hdr_field  */
  YYSYMBOL_exthdr_exists_expr = 715,       /* exthdr_exists_expr  */
  YYSYMBOL_exthdr_key = 716                /* exthdr_key  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                            \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if 1

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* 1 */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
             && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE) \
             + YYSIZEOF (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  2
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   7717

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  362
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  355
/* YYNRULES -- Number of rules.  */
#define YYNRULES  1178
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  1904

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   607


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,   359,     2,     2,     2,
     356,   357,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   353,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   360,     2,   361,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   354,   358,   355,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   880,   880,   881,   890,   891,   894,   895,   898,   899,
     900,   901,   903,   911,   926,   933,   944,   952,   953,   954,
     955,   975,   976,   977,   978,   979,   980,   981,   982,   983,
     984,   985,   986,   987,   988,   989,   992,   996,  1003,  1007,
    1015,  1019,  1023,  1030,  1037,  1041,  1048,  1057,  1061,  1065,
    1069,  1073,  1077,  1081,  1085,  1089,  1093,  1097,  1101,  1105,
    1111,  1117,  1121,  1128,  1132,  1140,  1147,  1154,  1158,  1165,
    1174,  1178,  1182,  1186,  1190,  1194,  1198,  1202,  1208,  1214,
    1218,  1222,  1226,  1230,  1234,  1238,  1242,  1246,  1250,  1254,
    1258,  1265,  1269,  1273,  1277,  1281,  1285,  1289,  1293,  1297,
    1301,  1305,  1311,  1317,  1321,  1325,  1329,  1333,  1337,  1341,
    1345,  1349,  1353,  1357,  1361,  1365,  1369,  1373,  1377,  1381,
    1385,  1389,  1393,  1397,  1401,  1405,  1409,  1413,  1417,  1421,
    1425,  1429,  1433,  1437,  1441,  1445,  1449,  1453,  1459,  1463,
    1467,  1471,  1475,  1479,  1485,  1489,  1493,  1497,  1501,  1505,
    1509,  1515,  1522,  1528,  1536,  1542,  1550,  1559,  1560,  1563,
    1564,  1565,  1566,  1567,  1568,  1569,  1570,  1573,  1574,  1577,
    1578,  1579,  1582,  1591,  1597,  1609,  1619,  1620,  1621,  1622,
    1623,  1634,  1644,  1655,  1665,  1676,  1687,  1696,  1705,  1714,
    1725,  1736,  1750,  1756,  1757,  1758,  1759,  1760,  1761,  1762,
    1767,  1777,  1778,  1779,  1786,  1797,  1810,  1815,  1816,  1817,
    1818,  1823,  1829,  1834,  1839,  1844,  1850,  1855,  1860,  1861,
    1872,  1873,  1876,  1880,  1883,  1884,  1885,  1886,  1890,  1895,
    1896,  1897,  1898,  1903,  1913,  1924,  1935,  1947,  1956,  1965,
    1974,  1983,  1988,  1993,  2002,  2005,  2009,  2015,  2016,  2020,
    2025,  2026,  2027,  2028,  2042,  2046,  2052,  2057,  2064,  2069,
    2074,  2077,  2084,  2091,  2103,  2110,  2111,  2123,  2128,  2129,
    2130,  2131,  2135,  2145,  2146,  2147,  2148,  2152,  2162,  2163,
    2164,  2165,  2169,  2180,  2184,  2185,  2186,  2190,  2200,  2201,
    2202,  2203,  2207,  2217,  2218,  2219,  2220,  2224,  2234,  2235,
    2236,  2237,  2241,  2251,  2252,  2253,  2254,  2258,  2268,  2269,
    2270,  2271,  2272,  2275,  2305,  2312,  2316,  2319,  2329,  2336,
    2347,  2360,  2375,  2376,  2379,  2391,  2397,  2401,  2404,  2410,
    2423,  2428,  2437,  2438,  2441,  2444,  2445,  2446,  2449,  2464,
    2465,  2468,  2469,  2470,  2471,  2472,  2473,  2476,  2485,  2494,
    2502,  2510,  2518,  2526,  2534,  2542,  2550,  2558,  2566,  2574,
    2582,  2590,  2598,  2606,  2614,  2618,  2623,  2631,  2638,  2645,
    2658,  2662,  2669,  2673,  2679,  2691,  2697,  2704,  2710,  2717,
    2718,  2719,  2720,  2723,  2724,  2725,  2726,  2727,  2728,  2729,
    2730,  2731,  2732,  2733,  2734,  2735,  2736,  2737,  2738,  2739,
    2740,  2741,  2742,  2745,  2746,  2749,  2758,  2762,  2768,  2774,
    2779,  2782,  2787,  2792,  2795,  2801,  2806,  2814,  2815,  2817,
    2821,  2829,  2833,  2836,  2840,  2846,  2847,  2850,  2856,  2860,
    2863,  2988,  2993,  2998,  3003,  3008,  3014,  3044,  3048,  3052,
    3056,  3060,  3066,  3070,  3073,  3077,  3083,  3097,  3122,  3130,
    3131,  3132,  3135,  3136,  3139,  3140,  3155,  3171,  3179,  3180,
    3181,  3184,  3185,  3188,  3189,  3190,  3205,  3206,  3207,  3208,
    3209,  3212,  3215,  3222,  3226,  3237,  3248,  3258,  3264,  3267,
    3268,  3271,  3277,  3283,  3289,  3296,  3303,  3311,  3312,  3315,
    3319,  3327,  3331,  3334,  3339,  3344,  3348,  3354,  3370,  3389,
    3395,  3396,  3402,  3403,  3409,  3410,  3411,  3412,  3413,  3414,
    3415,  3416,  3417,  3418,  3419,  3420,  3421,  3424,  3425,  3429,
    3435,  3436,  3442,  3443,  3449,  3450,  3456,  3459,  3460,  3471,
    3472,  3475,  3479,  3482,  3488,  3494,  3505,  3506,  3507,  3510,
    3511,  3512,  3515,  3519,  3523,  3528,  3533,  3538,  3544,  3548,
    3552,  3556,  3562,  3568,  3573,  3582,  3592,  3593,  3596,  3599,
    3603,  3608,  3614,  3615,  3618,  3621,  3625,  3629,  3633,  3638,
    3645,  3650,  3658,  3663,  3672,  3673,  3679,  3680,  3681,  3684,
    3685,  3688,  3694,  3698,  3701,  3706,  3712,  3713,  3719,  3720,
    3723,  3724,  3727,  3733,  3740,  3747,  3758,  3759,  3760,  3763,
    3771,  3783,  3790,  3793,  3799,  3803,  3806,  3812,  3821,  3832,
    3838,  3864,  3865,  3874,  3875,  3878,  3887,  3898,  3899,  3900,
    3901,  3902,  3903,  3904,  3905,  3906,  3907,  3908,  3909,  3910,
    3911,  3912,  3915,  3938,  3939,  3940,  3943,  3944,  3945,  3946,
    3947,  3950,  3954,  3957,  3961,  3968,  3971,  3985,  3986,  3990,
    3996,  3997,  4003,  4004,  4010,  4011,  4017,  4020,  4021,  4032,
    4038,  4044,  4045,  4048,  4054,  4055,  4056,  4059,  4066,  4071,
    4076,  4079,  4083,  4087,  4093,  4094,  4101,  4107,  4108,  4111,
    4117,  4123,  4127,  4130,  4134,  4138,  4148,  4152,  4155,  4161,
    4168,  4172,  4178,  4192,  4218,  4222,  4226,  4236,  4237,  4240,
    4241,  4244,  4245,  4246,  4247,  4258,  4269,  4275,  4296,  4302,
    4319,  4325,  4326,  4327,  4330,  4331,  4334,  4350,  4356,  4362,
    4369,  4383,  4391,  4399,  4405,  4409,  4413,  4417,  4421,  4428,
    4433,  4444,  4466,  4472,  4476,  4480,  4486,  4492,  4500,  4501,
    4502,  4503,  4506,  4507,  4511,  4517,  4518,  4524,  4525,  4531,
    4532,  4538,  4541,  4542,  4543,  4552,  4563,  4564,  4567,  4575,
    4576,  4577,  4578,  4579,  4580,  4581,  4582,  4583,  4584,  4585,
    4586,  4589,  4590,  4591,  4592,  4593,  4600,  4607,  4614,  4621,
    4628,  4635,  4642,  4649,  4656,  4663,  4670,  4677,  4680,  4681,
    4682,  4683,  4684,  4685,  4688,  4692,  4696,  4700,  4704,  4708,
    4714,  4715,  4725,  4729,  4733,  4749,  4750,  4753,  4754,  4755,
    4756,  4757,  4760,  4761,  4762,  4763,  4764,  4765,  4766,  4767,
    4768,  4769,  4770,  4771,  4772,  4773,  4774,  4775,  4776,  4777,
    4778,  4779,  4780,  4781,  4782,  4783,  4786,  4806,  4810,  4824,
    4828,  4832,  4838,  4844,  4845,  4846,  4849,  4850,  4853,  4854,
    4857,  4863,  4864,  4867,  4868,  4871,  4872,  4875,  4876,  4879,
    4887,  4914,  4919,  4924,  4930,  4931,  4934,  4938,  4958,  4959,
    4960,  4961,  4964,  4968,  4972,  4978,  4979,  4982,  4983,  4984,
    4985,  4986,  4987,  4988,  4989,  4990,  4991,  4992,  4993,  4994,
    4995,  4996,  4997,  4998,  5001,  5002,  5003,  5004,  5005,  5006,
    5007,  5010,  5011,  5012,  5013,  5016,  5017,  5018,  5019,  5022,
    5023,  5026,  5032,  5040,  5053,  5060,  5066,  5072,  5081,  5082,
    5083,  5084,  5085,  5086,  5087,  5088,  5089,  5090,  5091,  5092,
    5093,  5094,  5095,  5096,  5097,  5098,  5101,  5110,  5111,  5112,
    5115,  5121,  5122,  5123,  5126,  5132,  5133,  5134,  5135,  5138,
    5144,  5145,  5146,  5147,  5148,  5149,  5150,  5151,  5152,  5155,
    5159,  5163,  5170,  5171,  5172,  5173,  5174,  5175,  5176,  5177,
    5178,  5179,  5180,  5181,  5184,  5185,  5186,  5187,  5190,  5191,
    5192,  5193,  5194,  5197,  5203,  5204,  5205,  5206,  5207,  5208,
    5209,  5212,  5218,  5219,  5220,  5221,  5224,  5230,  5231,  5232,
    5233,  5234,  5235,  5236,  5237,  5238,  5240,  5246,  5247,  5248,
    5249,  5250,  5251,  5252,  5253,  5256,  5262,  5263,  5264,  5265,
    5266,  5269,  5275,  5276,  5279,  5285,  5286,  5287,  5290,  5296,
    5297,  5298,  5299,  5302,  5308,  5309,  5310,  5311,  5314,  5318,
    5322,  5327,  5334,  5335,  5336,  5337,  5338,  5339,  5340,  5341,
    5342,  5343,  5346,  5347,  5348,  5349,  5350,  5351,  5352,  5353,
    5354,  5355,  5356,  5357,  5358,  5367,  5368,  5369,  5370,  5371,
    5372,  5373,  5374,  5377,  5383,  5384,  5385,  5388,  5389,  5390,
    5391,  5392,  5393,  5394,  5395,  5396,  5397,  5398,  5399,  5400,
    5401,  5402,  5403,  5404,  5405,  5408,  5409,  5410,  5413,  5414,
    5415,  5416,  5419,  5420,  5421,  5422,  5423,  5426,  5427,  5428,
    5429,  5432,  5437,  5441,  5445,  5449,  5453,  5457,  5462,  5467,
    5472,  5477,  5482,  5489,  5493,  5499,  5500,  5501,  5502,  5505,
    5513,  5514,  5517,  5518,  5519,  5520,  5521,  5522,  5523,  5524,
    5527,  5533,  5534,  5537,  5543,  5544,  5545,  5546,  5549,  5555,
    5561,  5567,  5570,  5576,  5577,  5578,  5579,  5585,  5591,  5592,
    5593,  5594,  5595,  5596,  5599,  5605,  5606,  5609,  5615,  5616,
    5617,  5618,  5619,  5622,  5636,  5637,  5638,  5639,  5640
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if 1
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "\"junk\"",
  "\"newline\"", "\"colon\"", "\"semicolon\"", "\"comma\"", "\".\"",
  "\"==\"", "\"!=\"", "\"<\"", "\">\"", "\">=\"", "\"<=\"", "\"<<\"",
  "\">>\"", "\"&\"", "\"^\"", "\"!\"", "\"/\"", "\"*\"", "\"-\"", "\"@\"",
  "\"vmap\"", "\"+\"", "\"include\"", "\"define\"", "\"redefine\"",
  "\"undefine\"", "\"fib\"", "\"socket\"", "\"transparent\"",
  "\"wildcard\"", "\"tproxy\"", "\"osf\"", "\"synproxy\"", "\"mss\"",
  "\"wscale\"", "\"typeof\"", "\"hook\"", "\"device\"", "\"devices\"",
  "\"table\"", "\"tables\"", "\"chain\"", "\"chains\"", "\"rule\"",
  "\"rules\"", "\"sets\"", "\"set\"", "\"element\"", "\"map\"", "\"maps\"",
  "\"flowtable\"", "\"handle\"", "\"ruleset\"", "\"trace\"", "\"inet\"",
  "\"netdev\"", "\"add\"", "\"update\"", "\"replace\"", "\"create\"",
  "\"insert\"", "\"delete\"", "\"get\"", "\"list\"", "\"reset\"",
  "\"flush\"", "\"rename\"", "\"describe\"", "\"import\"", "\"export\"",
  "\"monitor\"", "\"all\"", "\"accept\"", "\"drop\"", "\"continue\"",
  "\"jump\"", "\"goto\"", "\"return\"", "\"to\"", "\"constant\"",
  "\"interval\"", "\"dynamic\"", "\"auto-merge\"", "\"timeout\"",
  "\"gc-interval\"", "\"elements\"", "\"expires\"", "\"policy\"",
  "\"memory\"", "\"performance\"", "\"size\"", "\"flow\"", "\"offload\"",
  "\"meter\"", "\"meters\"", "\"flowtables\"", "\"number\"", "\"string\"",
  "\"quoted string\"", "\"string with a trailing asterisk\"", "\"ll\"",
  "\"nh\"", "\"th\"", "\"bridge\"", "\"ether\"", "\"saddr\"", "\"daddr\"",
  "\"type\"", "\"vlan\"", "\"id\"", "\"cfi\"", "\"pcp\"", "\"arp\"",
  "\"htype\"", "\"ptype\"", "\"hlen\"", "\"plen\"", "\"operation\"",
  "\"ip\"", "\"version\"", "\"hdrlength\"", "\"dscp\"", "\"ecn\"",
  "\"length\"", "\"frag-off\"", "\"ttl\"", "\"protocol\"", "\"checksum\"",
  "\"ptr\"", "\"value\"", "\"lsrr\"", "\"rr\"", "\"ssrr\"", "\"ra\"",
  "\"icmp\"", "\"code\"", "\"seq\"", "\"gateway\"", "\"mtu\"", "\"igmp\"",
  "\"mrt\"", "\"options\"", "\"ip6\"", "\"priority\"", "\"flowlabel\"",
  "\"nexthdr\"", "\"hoplimit\"", "\"icmpv6\"", "\"param-problem\"",
  "\"max-delay\"", "\"ah\"", "\"reserved\"", "\"spi\"", "\"esp\"",
  "\"comp\"", "\"flags\"", "\"cpi\"", "\"port\"", "\"udp\"", "\"sport\"",
  "\"dport\"", "\"udplite\"", "\"csumcov\"", "\"tcp\"", "\"ackseq\"",
  "\"doff\"", "\"window\"", "\"urgptr\"", "\"option\"", "\"echo\"",
  "\"eol\"", "\"nop\"", "\"sack\"", "\"sack0\"", "\"sack1\"", "\"sack2\"",
  "\"sack3\"", "\"sack-permitted\"", "\"timestamp\"", "\"kind\"",
  "\"count\"", "\"left\"", "\"right\"", "\"tsval\"", "\"tsecr\"",
  "\"dccp\"", "\"sctp\"", "\"chunk\"", "\"data\"", "\"init\"",
  "\"init-ack\"", "\"heartbeat\"", "\"heartbeat-ack\"", "\"abort\"",
  "\"shutdown\"", "\"shutdown-ack\"", "\"error\"", "\"cookie-echo\"",
  "\"cookie-ack\"", "\"ecne\"", "\"cwr\"", "\"shutdown-complete\"",
  "\"asconf-ack\"", "\"forward-tsn\"", "\"asconf\"", "\"tsn\"",
  "\"stream\"", "\"ssn\"", "\"ppid\"", "\"init-tag\"", "\"a-rwnd\"",
  "\"num-outbound-streams\"", "\"num-inbound-streams\"", "\"initial-tsn\"",
  "\"cum-tsn-ack\"", "\"num-gap-ack-blocks\"", "\"num-dup-tsns\"",
  "\"lowest-tsn\"", "\"seqno\"", "\"new-cum-tsn\"", "\"vtag\"", "\"rt\"",
  "\"rt0\"", "\"rt2\"", "\"srh\"", "\"seg-left\"", "\"addr\"",
  "\"last-entry\"", "\"tag\"", "\"sid\"", "\"hbh\"", "\"frag\"",
  "\"reserved2\"", "\"more-fragments\"", "\"dst\"", "\"mh\"", "\"meta\"",
  "\"mark\"", "\"iif\"", "\"iifname\"", "\"iiftype\"", "\"oif\"",
  "\"oifname\"", "\"oiftype\"", "\"skuid\"", "\"skgid\"", "\"nftrace\"",
  "\"rtclassid\"", "\"ibriport\"", "\"obriport\"", "\"ibrname\"",
  "\"obrname\"", "\"pkttype\"", "\"cpu\"", "\"iifgroup\"", "\"oifgroup\"",
  "\"cgroup\"", "\"time\"", "\"classid\"", "\"nexthop\"", "\"ct\"",
  "\"l3proto\"", "\"proto-src\"", "\"proto-dst\"", "\"zone\"",
  "\"direction\"", "\"event\"", "\"expectation\"", "\"expiration\"",
  "\"helper\"", "\"label\"", "\"state\"", "\"status\"", "\"original\"",
  "\"reply\"", "\"counter\"", "\"name\"", "\"packets\"", "\"bytes\"",
  "\"avgpkt\"", "\"counters\"", "\"quotas\"", "\"limits\"",
  "\"synproxys\"", "\"helpers\"", "\"log\"", "\"prefix\"", "\"group\"",
  "\"snaplen\"", "\"queue-threshold\"", "\"level\"", "\"limit\"",
  "\"rate\"", "\"burst\"", "\"over\"", "\"until\"", "\"quota\"",
  "\"used\"", "\"secmark\"", "\"secmarks\"", "\"nanosecond\"",
  "\"microsecond\"", "\"millisecond\"", "\"second\"", "\"minute\"",
  "\"hour\"", "\"day\"", "\"week\"", "\"reject\"", "\"with\"", "\"icmpx\"",
  "\"snat\"", "\"dnat\"", "\"masquerade\"", "\"redirect\"", "\"random\"",
  "\"fully-random\"", "\"persistent\"", "\"queue\"", "\"num\"",
  "\"bypass\"", "\"fanout\"", "\"dup\"", "\"fwd\"", "\"numgen\"",
  "\"inc\"", "\"mod\"", "\"offset\"", "\"jhash\"", "\"symhash\"",
  "\"seed\"", "\"position\"", "\"index\"", "\"comment\"", "\"xml\"",
  "\"json\"", "\"vm\"", "\"notrack\"", "\"exists\"", "\"missing\"",
  "\"exthdr\"", "\"ipsec\"", "\"mode\"", "\"reqid\"", "\"spnum\"",
  "\"transport\"", "\"tunnel\"", "\"in\"", "\"out\"", "'='", "'{'", "'}'",
  "'('", "')'", "'|'", "'$'", "'['", "']'", "$accept", "input",
  "stmt_separator", "opt_newline", "close_scope_hash",
  "close_scope_numgen", "close_scope_sctp", "close_scope_sctp_chunk",
  "common_block", "line", "base_cmd", "add_cmd", "replace_cmd",
  "create_cmd", "insert_cmd", "delete_cmd", "get_cmd", "list_cmd",
  "reset_cmd", "flush_cmd", "rename_cmd", "import_cmd", "export_cmd",
  "monitor_cmd", "monitor_event", "monitor_object", "monitor_format",
  "markup_format", "describe_cmd", "table_block_alloc", "table_options",
  "table_block", "chain_block_alloc", "chain_block", "subchain_block",
  "typeof_expr", "set_block_alloc", "set_block", "set_block_expr",
  "set_flag_list", "set_flag", "map_block_alloc", "map_block",
  "set_mechanism", "set_policy_spec", "flowtable_block_alloc",
  "flowtable_block", "flowtable_expr", "flowtable_list_expr",
  "flowtable_expr_member", "data_type_atom_expr", "data_type_expr",
  "obj_block_alloc", "counter_block", "quota_block", "ct_helper_block",
  "ct_timeout_block", "ct_expect_block", "limit_block", "secmark_block",
  "synproxy_block", "type_identifier", "hook_spec", "prio_spec",
  "extended_prio_name", "extended_prio_spec", "int_num", "dev_spec",
  "flags_spec", "policy_spec", "policy_expr", "chain_policy", "identifier",
  "string", "time_spec", "family_spec", "family_spec_explicit",
  "table_spec", "tableid_spec", "chain_spec", "chainid_spec",
  "chain_identifier", "set_spec", "setid_spec", "set_identifier",
  "flowtable_spec", "flowtableid_spec", "flowtable_identifier", "obj_spec",
  "objid_spec", "obj_identifier", "handle_spec", "position_spec",
  "index_spec", "rule_position", "ruleid_spec", "comment_spec",
  "ruleset_spec", "rule", "rule_alloc", "stmt_list", "stateful_stmt_list",
  "stateful_stmt", "stmt", "chain_stmt_type", "chain_stmt", "verdict_stmt",
  "verdict_map_stmt", "verdict_map_expr", "verdict_map_list_expr",
  "verdict_map_list_member_expr", "connlimit_stmt", "counter_stmt",
  "counter_stmt_alloc", "counter_args", "counter_arg", "log_stmt",
  "log_stmt_alloc", "log_args", "log_arg", "level_type", "log_flags",
  "log_flags_tcp", "log_flag_tcp", "limit_stmt", "quota_mode",
  "quota_unit", "quota_used", "quota_stmt", "limit_mode",
  "limit_burst_pkts", "limit_burst_bytes", "time_unit", "reject_stmt",
  "reject_stmt_alloc", "reject_opts", "nat_stmt", "nat_stmt_alloc",
  "tproxy_stmt", "synproxy_stmt", "synproxy_stmt_alloc", "synproxy_args",
  "synproxy_arg", "synproxy_config", "synproxy_obj", "synproxy_ts",
  "synproxy_sack", "primary_stmt_expr", "shift_stmt_expr", "and_stmt_expr",
  "exclusive_or_stmt_expr", "inclusive_or_stmt_expr", "basic_stmt_expr",
  "concat_stmt_expr", "map_stmt_expr_set", "map_stmt_expr",
  "prefix_stmt_expr", "range_stmt_expr", "wildcard_expr",
  "multiton_stmt_expr", "stmt_expr", "nat_stmt_args", "masq_stmt",
  "masq_stmt_alloc", "masq_stmt_args", "redir_stmt", "redir_stmt_alloc",
  "redir_stmt_arg", "dup_stmt", "fwd_stmt", "nf_nat_flags", "nf_nat_flag",
  "queue_stmt", "queue_stmt_alloc", "queue_stmt_args", "queue_stmt_arg",
  "queue_stmt_flags", "queue_stmt_flag", "set_elem_expr_stmt",
  "set_elem_expr_stmt_alloc", "set_stmt", "set_stmt_op", "map_stmt",
  "meter_stmt", "flow_stmt_legacy_alloc", "flow_stmt_opts",
  "flow_stmt_opt", "meter_stmt_alloc", "match_stmt", "variable_expr",
  "symbol_expr", "set_ref_expr", "set_ref_symbol_expr", "integer_expr",
  "primary_expr", "fib_expr", "fib_result", "fib_flag", "fib_tuple",
  "osf_expr", "osf_ttl", "shift_expr", "and_expr", "exclusive_or_expr",
  "inclusive_or_expr", "basic_expr", "concat_expr", "prefix_rhs_expr",
  "range_rhs_expr", "multiton_rhs_expr", "map_expr", "expr", "set_expr",
  "set_list_expr", "set_list_member_expr", "meter_key_expr",
  "meter_key_expr_alloc", "set_elem_expr", "set_elem_expr_alloc",
  "set_elem_options", "set_elem_option", "set_elem_expr_options",
  "set_elem_stmt_list", "set_elem_stmt", "set_elem_expr_option",
  "set_lhs_expr", "set_rhs_expr", "initializer_expr", "counter_config",
  "counter_obj", "quota_config", "quota_obj", "secmark_config",
  "secmark_obj", "ct_obj_type", "ct_l4protoname", "ct_helper_config",
  "timeout_states", "timeout_state", "ct_timeout_config",
  "ct_expect_config", "ct_obj_alloc", "limit_config", "limit_obj",
  "relational_expr", "list_rhs_expr", "rhs_expr", "shift_rhs_expr",
  "and_rhs_expr", "exclusive_or_rhs_expr", "inclusive_or_rhs_expr",
  "basic_rhs_expr", "concat_rhs_expr", "boolean_keys", "boolean_expr",
  "keyword_expr", "primary_rhs_expr", "relational_op", "verdict_expr",
  "chain_expr", "meta_expr", "meta_key", "meta_key_qualified",
  "meta_key_unqualified", "meta_stmt", "socket_expr", "socket_key",
  "offset_opt", "numgen_type", "numgen_expr", "xfrm_spnum", "xfrm_dir",
  "xfrm_state_key", "xfrm_state_proto_key", "xfrm_expr", "hash_expr",
  "nf_key_proto", "rt_expr", "rt_key", "ct_expr", "ct_dir", "ct_key",
  "ct_key_dir", "ct_key_proto_field", "ct_key_dir_optional",
  "symbol_stmt_expr", "list_stmt_expr", "ct_stmt", "payload_stmt",
  "payload_expr", "payload_raw_expr", "payload_base_spec", "eth_hdr_expr",
  "eth_hdr_field", "vlan_hdr_expr", "vlan_hdr_field", "arp_hdr_expr",
  "arp_hdr_field", "ip_hdr_expr", "ip_hdr_field", "ip_option_type",
  "ip_option_field", "icmp_hdr_expr", "icmp_hdr_field", "igmp_hdr_expr",
  "igmp_hdr_field", "ip6_hdr_expr", "ip6_hdr_field", "icmp6_hdr_expr",
  "icmp6_hdr_field", "auth_hdr_expr", "auth_hdr_field", "esp_hdr_expr",
  "esp_hdr_field", "comp_hdr_expr", "comp_hdr_field", "udp_hdr_expr",
  "udp_hdr_field", "udplite_hdr_expr", "udplite_hdr_field", "tcp_hdr_expr",
  "tcp_hdr_field", "tcp_hdr_option_type", "tcp_hdr_option_field",
  "dccp_hdr_expr", "dccp_hdr_field", "sctp_chunk_type",
  "sctp_chunk_common_field", "sctp_chunk_data_field",
  "sctp_chunk_init_field", "sctp_chunk_sack_field", "sctp_chunk_alloc",
  "sctp_hdr_expr", "sctp_hdr_field", "th_hdr_expr", "th_hdr_field",
  "exthdr_expr", "hbh_hdr_expr", "hbh_hdr_field", "rt_hdr_expr",
  "rt_hdr_field", "rt0_hdr_expr", "rt0_hdr_field", "rt2_hdr_expr",
  "rt2_hdr_field", "rt4_hdr_expr", "rt4_hdr_field", "frag_hdr_expr",
  "frag_hdr_field", "dst_hdr_expr", "dst_hdr_field", "mh_hdr_expr",
  "mh_hdr_field", "exthdr_exists_expr", "exthdr_key", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_int16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,    61,   123,   125,    40,    41,   124,    36,
      91,    93
};
#endif

#define YYPACT_NINF (-1588)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-911)

#define yytable_value_is_error(Yyn) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
   -1588,  7278, -1588,   665, -1588, -1588,    62,    89,    89,    89,
    1114,  1114,  1114,  1114,  1114,  1114,  1114,  1114, -1588, -1588,
    2538,   171,  2335,   208,   630,   211,  4080,   704,  1874,   227,
    6711,   192,   203,   234, -1588, -1588, -1588, -1588,   200,  1114,
    1114,  1114,  1114, -1588, -1588, -1588,   679, -1588,    89, -1588,
      89,   147,  6093, -1588,   665, -1588,    -5,    15,   665,    89,
   -1588,    45,   136,  6093,    89, -1588,    64, -1588,    89, -1588,
   -1588,  1114, -1588,  1114,  1114,  1114,  1114,  1114,  1114,  1114,
     226,  1114,  1114,  1114,  1114, -1588,  1114, -1588,  1114,  1114,
    1114,  1114,  1114,  1114,  1114,  1114,   238,  1114,  1114,  1114,
    1114, -1588,  1114, -1588,  1114,  1114,  1114,  1114,  1114,   693,
    1114,  1114,  1114,  1114,  1114,   705,  1114,  1114,  1114,   371,
    1114,  1396,  1547,  2049,  2052,  1114,  1114,  1114,  2204, -1588,
    1114,  2304,  2426,  1114, -1588,  1114,  1114,  1114,  1114,  1114,
     458,  1114, -1588,  1114, -1588,   712,   261,   123,   405, -1588,
   -1588, -1588, -1588,   624,   886,   936,  1959,  2824,  1714,    37,
    2611,  1071,   641,   186,   546,   426,   640,  2893,   525,    65,
    1422,   328,   357,    50,   363,   925,   396,   619,  4392, -1588,
   -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588,
   -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588,
    4887, -1588, -1588,   -69,  6354,   282,   857,   532,  6711,    89,
   -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588,
   -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588,
   -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588,
   -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588,
   -1588, -1588, -1588, -1588, -1588,   739, -1588, -1588,   252, -1588,
   -1588,   739, -1588, -1588, -1588, -1588,  1526,  1114,  1114,  1114,
    -114, -1588, -1588, -1588, -1588, -1588, -1588, -1588,   516,   526,
     547, -1588, -1588, -1588,   112,   350,   667, -1588, -1588, -1588,
   -1588, -1588, -1588,     4,     4, -1588,   181,    89,  4653,  3837,
     354, -1588,   -17,   334, -1588, -1588, -1588, -1588, -1588, -1588,
     569,   148, -1588,   658, -1588,   339,  6093, -1588, -1588, -1588,
   -1588, -1588, -1588, -1588, -1588,   670, -1588,   743, -1588, -1588,
   -1588,   400, -1588,  3910, -1588, -1588,   573, -1588,   264, -1588,
     298, -1588, -1588, -1588,   851, -1588,    97, -1588, -1588,   680,
   -1588, -1588, -1588,   946,   725,   735,   401, -1588,   484, -1588,
    5224, -1588, -1588, -1588,   711, -1588, -1588, -1588,   717, -1588,
    5613,  5613, -1588, -1588,    66,   438,   453, -1588, -1588,   475,
   -1588, -1588, -1588,   486, -1588,   493,   770,  6093, -1588,    45,
     136, -1588,    64, -1588, -1588,  1114,  1114,  1114,   577, -1588,
   -1588, -1588,  6093,   111, -1588, -1588,   130, -1588, -1588,   134,
   -1588, -1588, -1588,   143, -1588, -1588,    64, -1588,   194,   507,
   -1588, -1588, -1588, -1588,  1114, -1588, -1588, -1588, -1588, -1588,
   -1588, -1588, -1588,    64, -1588, -1588, -1588, -1588, -1588, -1588,
    1114, -1588, -1588, -1588, -1588, -1588, -1588,  1114,  1114, -1588,
   -1588, -1588,   820,   822,   829,  1114, -1588,  1114, -1588,  1114,
   -1588,  1114, -1588,  1114, -1588, -1588, -1588, -1588,  1114, -1588,
   -1588,  1114, -1588,  1114, -1588, -1588, -1588, -1588, -1588, -1588,
   -1588,  1114, -1588,    89, -1588, -1588, -1588,   868, -1588, -1588,
   -1588, -1588, -1588,   873,    84, -1588, -1588, -1588, -1588,   789,
      -9, -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588,
   -1588, -1588, -1588,    91,   303, -1588, -1588, -1588, -1588, -1588,
   -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588,
   -1588, -1588, -1588,   935, -1588, -1588, -1588, -1588, -1588, -1588,
   -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588,
   -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588,
   -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588,
   -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588,
   -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588,
   -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588,
    3005, -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588,  3319,
   -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588,
   -1588, -1588,    30, -1588, -1588,   537, -1588, -1588, -1588, -1588,
   -1588, -1588,   541, -1588, -1588, -1588, -1588, -1588, -1588, -1588,
   -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588,
   -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588,
   -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588,
   -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588,
   -1588, -1588, -1588, -1588, -1588,  1096, -1588, -1588, -1588, -1588,
     576,   244,   580,   803, -1588, -1588, -1588, -1588, -1588, -1588,
   -1588, -1588,   566,   562, -1588, -1588, -1588, -1588, -1588, -1588,
   -1588, -1588, -1588, -1588, -1588,   739, -1588, -1588, -1588,  -111,
    -112,   283,    29, -1588, -1588, -1588,  4171,   839,  5367,  6711,
   -1588, -1588, -1588, -1588,   901,   917,    -2,   894,   898,   908,
      21,   914,  1096,   923,  5367,  5367,   677,  5367, -1588, -1588,
     867,  5367,  5367,   904, -1588,  5755,    77, -1588,  1195, -1588,
   -1588,   636,   892,   912,   670, -1588,   545,  1195,   929,   932,
     939,  1195,   743, -1588,    24, -1588,  5367, -1588, -1588,  4432,
     959,   886,   936,  1959,  3644, -1588,  1917,   424, -1588, -1588,
   -1588,   964, -1588, -1588, -1588, -1588,  6957, -1588,   985,  1043,
    1045,   736,   530,   471, -1588, -1588, -1588, -1588, -1588,  1102,
     997,  1112, -1588, -1588, -1588, -1588,  1132, -1588, -1588, -1588,
   -1588,   435, -1588, -1588,  1138,  1149, -1588,  1021,  1059, -1588,
   -1588,   573, -1588,  1158, -1588, -1588, -1588, -1588,  1164, -1588,
    4693, -1588,  1164,  5367, -1588, -1588,   851, -1588,  1172, -1588,
      89, -1588,   811, -1588,    89,    56, -1588,  7358,  7358,  7358,
    7358,  7358,  6711,    94,  5684, -1588, -1588, -1588, -1588, -1588,
   -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588,
   -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588,  7358, -1588,
   -1588, -1588, -1588, -1588, -1588, -1588, -1588,  1178, -1588,  1041,
    1170,  1181,   843,   788,  1199, -1588, -1588, -1588,  5684,  5367,
    5367,  1117,    82,   665,  1178, -1588,   665,  1119, -1588, -1588,
   -1588, -1588, -1588, -1588, -1588, -1588, -1588,  1175,   875,   909,
     911, -1588,   927,   930, -1588, -1588, -1588,   941,   931,   787,
    1195, -1588,  1147,  1155,  1161,  1171, -1588,  1179,   949, -1588,
   -1588, -1588, -1588, -1588,  1114,  1114,  1114, -1588, -1588, -1588,
   -1588, -1588, -1588, -1588, -1588, -1588, -1588,  1189,   261, -1588,
   -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588,
   -1588, -1588, -1588, -1588,    90,  2618, -1588, -1588, -1588, -1588,
   -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588,  1089,
     559,  1040,   639,   639, -1588, -1588, -1588,  1088, -1588, -1588,
   -1588, -1588,  1093,  1098, -1588,  1099,  1106,  1113,   164, -1588,
   -1588, -1588,  1230,  1237, -1588, -1588,   990, -1588,  1033, -1588,
   -1588, -1588, -1588, -1588, -1588,  1241,  1243,  1014,  1246,    13,
   -1588, -1588, -1588,   993,   996,   999,  1251, -1588, -1588,   677,
   -1588, -1588, -1588,  1256, -1588, -1588, -1588, -1588,  5367,  2824,
    2611,  1360,  4954, -1588,    97,    59,  1351,  1195,  1195,  1266,
    6711,  5367,  5367,  5367, -1588,  1267,  5367,  1319,  5367, -1588,
   -1588, -1588, -1588,  1270, -1588,    36,  1330, -1588,  5367, -1588,
     658,  1129,   137,    74,   715,  1199,   658, -1588, -1588, -1588,
   -1588, -1588, -1588, -1588, -1588,  1228,   163, -1588, -1588, -1588,
   -1588, -1588, -1588, -1588, -1588, -1588,  1273,  1275,  1322,  1280,
   -1588,  5367,  1387,  5367,  5367,  1036, -1588, -1588,  6957,  6957,
    6957,  6957,  6957,  1295,  6957,  6957,    95,  5367,  1164,  5367,
    1314,  1389,  1321,  2507,  2507, -1588, -1588, -1588,  5367,   997,
    5367,   997, -1588, -1588,   910, -1588,  6711, -1588,  6711, -1588,
   -1588, -1588,  1041,  1170,  1181, -1588,   658, -1588, -1588, -1588,
   -1588,  1048,  7358,  7358,  7358,  7358,  7358,  7358,  7358,  1306,
    7358,  7358, -1588, -1588, -1588, -1588, -1588, -1588, -1588,   625,
     272,  4978,  2667,  2044,   378,   361, -1588, -1588, -1588, -1588,
   -1588, -1588,  1054,  1055,  1063, -1588, -1588, -1588, -1588, -1588,
   -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588,  1406,
   -1588, -1588, -1588, -1588, -1588, -1588, -1588,  1416, -1588, -1588,
   -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588,
   -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588,
   -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588,
   -1588, -1588, -1588, -1588, -1588,  1066,  1068, -1588, -1588, -1588,
   -1588,  1014,   191,  1324, -1588, -1588, -1588, -1588, -1588,  1134,
   -1588, -1588, -1588,  1148,  1039,  1343,  1464,   550,    36,   718,
   -1588,  5367,  5367,  1439, -1588,  1346,  1346, -1588,    59, -1588,
   -1588, -1588,  1097,  1351,  6093,    59, -1588, -1588, -1588, -1588,
   -1588,  5367, -1588,   153, -1588, -1588,  1152,  5367,  1419, -1588,
    7287, -1588,  1346,  1346, -1588,   137, -1588,  1182,  1177,    74,
   -1588,  5755, -1588,  3643, -1588, -1588, -1588,  1459, -1588,  1366,
    1373, -1588,  1374, -1588,  5367, -1588, -1588, -1588, -1588, -1588,
     985,  1043,  1045, -1588, -1588, -1588, -1588, -1588, -1588, -1588,
    1471,  5367,  1316,  5367, -1588, -1588, -1588, -1588,   997, -1588,
     997,  1164, -1588,   102,  6093,  5950,    83, -1588, -1588, -1588,
   -1588, -1588,  1041,  1170,  1181, -1588, -1588, -1588, -1588,   715,
    1381,  1445, -1588, -1588, -1588, -1588, -1588,    89,    89,    89,
      89,    89,  1384,   399,    89,    89,    89,    89, -1588, -1588,
   -1588,   665, -1588,    35,  1386,  1392, -1588, -1588, -1588,   665,
     665,   665,   665,   665,  6711, -1588,  1346,  1346,  1136,  1165,
    1394,   638,   808,  1311, -1588, -1588, -1588,   665,   665,   280,
   -1588,  6711,  1346,  1143,   638,   808, -1588, -1588, -1588,   665,
     665,  1397,  1146, -1588, -1588, -1588, -1588,  5097,  3009,  2435,
     567,   487, -1588, -1588, -1588,   907,  1400,  1401, -1588, -1588,
   -1588, -1588,  1402, -1588, -1588, -1588, -1588, -1588, -1588,  1298,
     210,  1109,  1408, -1588, -1588, -1588, -1588, -1588,   156, -1588,
   -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588,  1152,
   -1588, -1588, -1588, -1588, -1588, -1588, -1588,  5367, -1588, -1588,
   -1588, -1588,  6711,  1154,    59, -1588,   709,  1214,  1410, -1588,
   -1588,  5367,     4,     4,   658,  1199, -1588, -1588, -1588, -1588,
    1417,   677, -1588, -1588, -1588,   665,   163, -1588, -1588, -1588,
   -1588,  5367, -1588,  1437, -1588,  1164,  1164,  6711, -1588,   121,
    1176,  1515,   658, -1588,  1348,  1425, -1588, -1588, -1588, -1588,
   -1588, -1588, -1588, -1588, -1588, -1588,    89,    89,    89, -1588,
   -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588,  1495,
   -1588, -1588, -1588, -1588, -1588, -1588,  1108, -1588,   665,   665,
      64, -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588,
   -1588, -1588,  1190, -1588, -1588, -1588, -1588, -1588,   597, -1588,
   -1588, -1588, -1588, -1588,   564,   665,    64,   647,   597, -1588,
   -1588,  1390,   284, -1588, -1588, -1588, -1588, -1588,  1354,   534,
    2033, -1588, -1588,  1529, -1588,  1014, -1588,  1185,    25,  1114,
   -1588, -1588, -1588, -1588, -1588,  1346,  1443,    25,  1447,  1114,
   -1588, -1588, -1588, -1588, -1588,  1446,  1114, -1588, -1588, -1588,
   -1588, -1588, -1588,   709,  1214, -1588, -1588,  6093, -1588, -1588,
   -1588, -1588, -1588, -1588,  1248,  1451, -1588,    36, -1588, -1588,
    1271,  1454, -1588, -1588, -1588,  5367,  1204,  6711, -1588, -1588,
    1047,  5950, -1588, -1588,  1379,   665,  1211,  1215,  1222,  1223,
    1225, -1588, -1588, -1588,  1226,  1227,  1232,  1235,  1466,  6711,
   -1588, -1588, -1588, -1588,   638, -1588,   808, -1588,  6538, -1588,
   -1588,  2053, -1588,   125,   665,    18,   665, -1588, -1588, -1588,
   -1588,  1484, -1588,  1238, -1588, -1588,   665,   665,   665,   665,
     665,   665,   665,  1463,   665,  1248, -1588,  1239,  1496, -1588,
      76, -1588,  1497,   168, -1588, -1588,  1240,   658, -1588, -1588,
    1348, -1588, -1588, -1588, -1588, -1588,  1244,  1249,  1254, -1588,
   -1588, -1588, -1588,  1250, -1588, -1588, -1588,  6711,  1108,   638,
     665,   665,   665,   665,  1190,  1500, -1588, -1588, -1588,   776,
   -1588, -1588, -1588, -1588, -1588,    86, -1588, -1588, -1588, -1588,
   -1588,  1501, -1588, -1588, -1588, -1588, -1588, -1588, -1588,    25,
   -1588, -1588, -1588,  1328, -1588, -1588, -1588,   709,  1214, -1588,
   -1588,  1379,  1814,  3343,  3203,  3054,  1630, -1588, -1588, -1588,
    1620,  1964,   785,   840,   104,  1258,  1390,  1108, -1588,  1190,
   -1588, -1588, -1588, -1588, -1588, -1588,  1512,  1513,    85, -1588,
    1613,    87, -1588,   665, -1588,  1248, -1588, -1588,   665,   665,
     665,   665,   665,  2027,   756,  2100,   665,   665,   665,   665,
   -1588, -1588,   284, -1588, -1588, -1588, -1588, -1588, -1588, -1588,
    1523,  1501,   665, -1588, -1588, -1588, -1588, -1588, -1588, -1588,
     665,   665,   665, -1588, -1588, -1588, -1588, -1588, -1588, -1588,
   -1588, -1588, -1588, -1588
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       2,     0,     1,     0,     4,     5,     0,     0,     0,     0,
     339,   339,   339,   339,   339,   339,   339,   339,   343,   346,
     339,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   157,   345,   344,   341,   342,     0,   339,
     339,   339,   339,    18,    17,     3,     0,    21,     0,   340,
       0,   364,     0,    16,     0,   334,     0,     0,     0,     0,
     499,    36,    38,     0,     0,   206,     0,   228,     0,   249,
      22,   339,    23,   339,   339,   339,   339,   339,   339,   339,
       0,   339,   339,   339,   339,    24,   339,    25,   339,   339,
     339,   339,   339,   339,   339,   339,     0,   339,   339,   339,
     339,    26,   339,    27,   339,   339,   370,   339,   370,   370,
     339,   339,   370,   339,   370,     0,   339,   370,   370,     0,
     339,   370,   370,   370,   370,   339,   339,   339,   370,    28,
     339,   370,   370,   339,    29,   339,   339,   339,   339,   370,
       0,   339,    30,   339,    31,     0,     0,     0,   645,   616,
     335,   336,   337,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   812,
     813,   814,   815,   816,   817,   818,   819,   820,   821,   822,
     823,   824,   825,   826,   827,   828,   829,   830,   831,   833,
       0,   835,   834,     0,     0,     0,     0,   832,     0,     0,
      35,   612,   611,   617,   618,   172,   628,   629,   622,   803,
     623,   626,   630,   627,   624,   625,   619,   918,   919,   920,
     921,   922,   923,   924,   925,   926,   927,   928,   929,   930,
     931,   932,   933,   934,   935,   620,  1132,  1133,  1134,  1135,
    1136,  1137,  1138,  1139,   621,     0,   169,   170,     0,    32,
     153,     0,    33,   155,   158,    34,   159,   339,   339,   339,
      46,   732,   708,   710,    20,    19,   347,   349,     0,     0,
       0,   366,   365,   367,     0,   489,     0,   596,   597,   598,
     794,   795,   796,   403,   404,   799,   603,     0,     0,     0,
     419,   427,     0,   451,   472,   479,   480,   558,   564,   581,
       0,     0,   839,     7,    41,   372,   374,   387,   375,   192,
     402,   383,   407,   382,   379,   417,   389,   425,   380,   381,
     390,   473,   391,     0,   392,   401,   487,   395,   557,   396,
     563,   397,   398,   393,   579,   399,     0,   400,   385,     0,
     602,   384,   647,   650,   652,   654,   656,   657,   664,   666,
       0,   665,   609,   406,   803,   388,   394,   386,   619,    12,
       0,     0,    15,   358,     0,     0,     0,    40,   352,     0,
      44,   221,   220,     0,   355,     0,     0,     0,   499,    61,
      63,   206,     0,   228,   249,   339,   339,   339,    69,   732,
     708,   710,     0,     0,   100,   101,     0,    79,    80,     0,
      81,    82,    83,     0,    84,    85,     0,    86,     0,    88,
      89,   712,   713,   711,   339,    91,    92,    96,    97,    93,
      94,    98,    99,     0,   124,   103,   371,   104,   105,   106,
     339,   107,   109,   133,   132,   131,   125,   339,   370,   129,
     128,   130,   712,   713,     0,   339,   112,   339,   110,   339,
     113,   339,   116,   339,   122,   118,   115,   121,   339,   119,
     140,   339,   138,   339,   141,   143,   144,   145,   146,   147,
     150,   339,   149,     0,   937,   938,   939,     0,   636,   637,
     638,   639,   640,   642,     0,   843,   845,   844,   842,     0,
       0,  1130,  1131,  1129,   941,   942,   943,   940,   948,   945,
     946,   947,   944,     0,     0,   950,   951,   952,   953,   954,
     949,   972,   973,   967,   962,   963,   964,   965,   966,   968,
     969,   970,   971,     0,   959,   984,   987,   986,   985,   988,
     989,   990,   983,   992,   993,   994,   995,   991,  1004,  1005,
     997,   998,   999,  1001,  1000,  1002,  1003,   996,  1007,  1012,
    1009,  1008,  1013,  1011,  1010,  1014,  1006,  1017,  1020,  1016,
    1018,  1019,  1015,  1023,  1022,  1021,  1025,  1026,  1027,  1024,
    1031,  1032,  1029,  1030,  1028,  1037,  1034,  1035,  1036,  1033,
    1050,  1044,  1047,  1048,  1042,  1043,  1045,  1046,  1049,  1051,
       0,  1038,  1076,  1074,  1075,  1073,  1128,  1125,  1126,     0,
    1127,    10,  1146,   864,  1145,   870,   865,  1144,  1147,   868,
     869,   871,     0,   866,  1143,     0,  1148,  1151,  1150,  1154,
    1153,  1155,     0,  1152,  1142,  1141,  1140,  1163,  1160,  1158,
    1159,  1161,  1162,  1157,  1166,  1165,  1164,  1170,  1169,  1172,
    1168,  1171,  1167,   804,   807,   808,   809,   811,   810,   832,
     802,   805,   806,   885,   886,   892,   878,   879,   877,   887,
     888,   908,   881,   890,   883,   884,   889,   880,   882,   875,
     876,   906,   905,   907,   891,     0,   872,   893,   849,   848,
       0,   664,     0,     0,  1175,  1174,  1176,  1177,  1178,  1173,
     853,   854,   852,     0,   610,   152,   171,   154,   160,   161,
     163,   162,   165,   166,   164,   167,   729,   729,   729,     0,
       0,   451,     0,   361,   362,   363,     0,     0,     0,     0,
     801,   800,   797,   798,     0,     0,     0,   804,   802,     0,
       0,     0,     0,   872,     0,     0,   460,     0,   449,   450,
       0,     0,     0,     0,     6,     0,     0,   668,     0,   373,
     376,     0,     0,     0,   418,   421,     0,     0,     0,     0,
       0,     0,   426,   428,     0,   471,     0,   535,   767,     0,
       0,   759,   762,   763,   760,   766,   761,     0,   770,   768,
     769,     0,   765,   764,   756,   757,     0,   517,   520,   522,
     524,   526,   527,   532,   539,   536,   537,   538,   540,   542,
     478,   504,   505,   515,   758,   506,   513,   507,   514,   510,
     511,     0,   508,   509,     0,   541,   512,     0,     0,   496,
     495,   488,   491,     0,   576,   577,   578,   556,   561,   574,
       0,   562,   567,     0,   588,   589,   580,   582,   585,   586,
       0,   614,     0,   613,     0,     0,   604,     0,     0,     0,
       0,     0,     0,     0,     0,   788,   789,   790,   791,   792,
     793,   759,   762,   763,   760,   780,   781,   761,   782,   779,
     778,   783,   776,   777,   775,   784,    10,   786,     0,   739,
     771,   741,   772,   661,   662,   753,   740,   734,   733,   745,
     747,   749,   751,   752,   738,   773,   774,   742,     0,     0,
       0,     0,     7,     0,   702,   701,     0,     0,   303,    58,
     176,   193,   207,   229,   250,   368,    60,     0,     0,     0,
       0,    67,     0,     0,   729,   729,   729,     0,     0,   451,
       0,    78,     0,     0,     0,     0,    87,     0,     0,   729,
     102,   108,   127,   126,   339,   339,   339,   134,   111,   114,
     117,   123,   120,   139,   142,   148,   151,     0,     0,   635,
     633,   634,   632,   646,   643,   644,   955,   957,   956,   958,
     974,   975,   976,   977,   961,     0,  1054,  1064,  1055,  1062,
    1052,  1053,  1057,  1058,  1059,  1060,  1061,  1056,  1063,  1040,
    1080,  1077,  1078,  1079,  1081,  1082,  1083,  1084,  1085,  1086,
    1087,  1088,  1089,  1090,  1091,  1092,  1093,  1094,  1111,    11,
    1123,   867,     0,     0,   894,   895,     0,   897,     0,   896,
     898,   899,   873,   874,   900,     0,     0,   846,     0,     0,
     631,   156,   168,     0,     0,     0,     0,   268,    47,   460,
     293,    54,   273,     0,    49,   298,   709,    56,     0,   760,
     761,   481,     0,   490,     0,   590,   592,     0,     0,     0,
       0,     0,     0,     0,   415,     0,     0,   900,     0,   420,
     448,   458,   459,     0,   457,     0,   570,   572,     0,   698,
       7,     7,   677,   680,   752,   697,     7,   667,   369,   201,
     423,   424,   422,   441,   440,     0,     0,   439,   435,   430,
     431,   432,   433,   436,   434,   429,     0,     0,     0,     0,
     548,     0,   543,     0,     0,     0,   504,   513,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   550,     0,
       0,     0,     0,     0,     0,   493,   494,   492,     0,     0,
       0,   565,   584,   583,     0,   615,     0,   606,     0,   605,
     648,   649,   651,   653,   655,   658,     7,   408,   410,   663,
     785,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   735,   837,   917,   704,   703,    13,    14,     0,
       0,     0,     0,     0,     0,     0,    77,   176,   193,   207,
     229,   250,     0,     0,     0,    70,    75,    71,    76,   359,
     348,   350,   353,   356,   250,    95,   136,   137,   135,     0,
     641,   978,   979,   981,   980,   982,   960,     0,  1067,  1066,
    1065,  1068,  1069,  1070,  1071,  1072,  1039,  1108,  1107,  1109,
    1110,  1116,  1098,  1099,  1100,  1101,  1113,  1102,  1103,  1104,
    1105,  1106,  1114,  1115,  1117,  1118,  1119,  1120,  1121,  1122,
    1095,  1097,  1096,  1112,    10,     0,     0,   901,   902,   903,
     904,   846,   846,     0,     8,   851,   855,   856,   859,     0,
     283,   288,   278,     0,     0,     0,     0,     0,     0,     0,
     483,     0,     0,   482,   593,     0,     0,   685,   591,   681,
     841,   840,     0,   676,     0,   674,   838,   836,   914,   416,
     915,     0,   913,     0,   453,   452,   454,     0,     0,   671,
       0,   672,     0,     0,   696,   678,   686,   690,     0,   679,
     688,   670,   669,     0,   438,   444,   445,   437,   443,     0,
       0,   477,     0,   549,     0,   553,   555,   516,   518,   519,
     521,   523,   525,   533,   534,   528,   531,   530,   529,   545,
     544,     0,     0,     0,   909,   910,   911,   912,   559,   575,
     566,   568,   587,     0,     0,     0,     0,   411,   787,   737,
     743,   744,   746,   748,   750,   736,   659,   660,   754,   755,
       0,     0,    59,   305,   304,   307,   306,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    37,   178,
     177,     0,   175,     0,     0,     0,    39,   195,   194,     0,
       0,     0,     0,     0,     0,   217,     0,     0,     0,     0,
       0,     0,     0,     0,    42,   209,   208,     0,     0,     0,
     377,     0,     0,     0,     0,     0,    43,   231,   230,     0,
       0,     0,     0,   255,    45,   252,   251,     0,     0,     0,
       0,     0,   283,   288,   278,     0,     0,     0,  1124,  1149,
    1156,     9,     0,     8,   847,   863,   858,   857,   860,     0,
       0,     0,     0,    48,   270,   269,   272,   271,     0,    55,
     295,   294,   297,   296,    50,   275,   274,   277,   276,   454,
      57,   300,   299,   302,   301,   484,   486,     0,   338,   683,
     684,   682,     0,     0,   675,   916,     0,   463,     0,   456,
     571,     0,     0,     0,     7,   699,   700,   694,   695,   687,
       0,   460,   689,   405,   202,     0,     0,   474,   475,   476,
     546,     0,   552,     0,   554,   560,   569,     0,   594,     0,
       0,     0,     7,   409,   500,     0,   360,   267,   351,   192,
     354,   206,   228,   357,   249,   174,     0,     0,     0,   267,
     267,   267,   267,   179,   332,   333,   329,   331,   330,     0,
     328,   196,   198,   197,   200,   199,     0,   204,     0,     0,
       0,   248,   247,   245,   246,   308,   310,   311,   309,   264,
     312,   265,     0,   263,   224,   225,   227,   226,     0,   223,
     218,   219,   215,   378,     0,     0,     0,     0,     0,   244,
     243,     0,     0,    62,    64,    65,    66,    68,     0,     0,
       0,    90,   936,     0,   850,   846,   862,     0,     0,     0,
      52,   285,   284,   287,   286,     0,     0,     0,     0,     0,
      53,   290,   289,   292,   291,     0,     0,    51,   280,   279,
     282,   281,   705,     0,   463,   707,   485,     0,   607,   466,
     467,   468,   469,   470,   461,     0,   447,     0,   573,   673,
       0,     0,   203,   442,   547,     0,     0,     0,   595,   601,
       0,   413,   412,   501,   502,     0,     0,     0,     0,     0,
       0,   267,   267,   267,     0,     0,     0,     0,     0,     0,
     211,   213,   214,   216,     0,   210,     0,   212,     0,   232,
     242,     0,   241,     0,     0,     0,     0,   257,    73,    74,
      72,     0,     8,     0,   715,   714,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   461,   731,     0,     0,   446,
       0,   455,     0,     0,   551,   599,     0,     7,   503,   497,
     500,   303,   193,   207,   229,   250,     0,     0,     0,   268,
     293,   273,   298,   327,   205,   266,   222,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   322,   316,   315,   319,
     314,   317,   318,   253,   261,     0,   258,   262,   254,  1041,
     861,     0,   721,   723,   726,   727,   724,   725,   728,     0,
     717,   730,   608,     0,   465,   464,   691,     0,   463,   600,
     414,   502,     0,     0,     0,     0,     0,   283,   288,   278,
       0,     0,     0,     0,     0,     0,     0,     0,   235,     0,
     237,   239,   238,   240,   233,   323,     0,     0,     7,   256,
       0,     0,   718,     0,   462,   461,   693,   498,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     324,   325,     0,   313,   236,   234,   321,   320,   260,   259,
       0,     0,     0,   716,   692,   191,   180,   181,   182,   183,
       0,     0,     0,   184,   189,   185,   190,   326,   720,   719,
     722,   187,   188,   186
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -1588, -1588,    -1, -1026, -1373, -1588,  -814, -1588,    47, -1588,
   -1588,  1605, -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588,
   -1588, -1588, -1588, -1588, -1588, -1588, -1588,    19, -1588,  1255,
   -1588,   433,  -311, -1162, -1588, -1325,  -361, -1141,  -357,   188,
     -77,  -382, -1139, -1121, -1588,  -367, -1158,  -232, -1588,  -205,
     -64, -1348,  -302,  -117,  -105, -1389, -1384, -1382,  -110,  -104,
     -94, -1588, -1588,  -165, -1588, -1588, -1588, -1588, -1588, -1588,
   -1588, -1588,   115,  -676, -1181,  1584,   -99,  2402, -1588,  1297,
   -1588, -1588,   861, -1588,   274,   544, -1588, -1588,  1854,  1213,
    -478,  1293, -1588, -1588,   167,  1589,   816,  2113,   -46, -1588,
   -1588,   308, -1122,  -313, -1588, -1588, -1588, -1588, -1588, -1588,
     135, -1588, -1588, -1588, -1588,   922, -1588, -1588, -1588,   916,
   -1588, -1588, -1588,   154, -1588,  1393, -1222,   190, -1588,  -982,
   -1587, -1511, -1506, -1588, -1588, -1588, -1588, -1588, -1588, -1588,
   -1588, -1588,   864,  -312,  1309,   -60,  -109,  -305,   581,   582,
     575, -1588,  -698, -1588, -1588, -1588, -1588, -1588,  -316, -1588,
    -643, -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588,
    -306,   565, -1588, -1588, -1588,   869, -1588,   563, -1088, -1588,
   -1588,  1432, -1588, -1588, -1588, -1588,   866, -1588, -1588,   -61,
     -26,  -750,  -308,   844,     1, -1588, -1588, -1588,   754,    11,
   -1588, -1588, -1588, -1588, -1588,  -166,  -190, -1588, -1588,   543,
   -1588,  1522,   -38, -1588,   631, -1078, -1588, -1269, -1588,   428,
   -1164, -1588, -1588,   402,   409, -1588, -1588,  1371,  -622,  1347,
    -596,  1344,  -593,  1345,  1628, -1504, -1588, -1588,  -133, -1588,
   -1588,   -18,  -581,  1350, -1588,  1398,  -300,  -749,  -708,  -707,
   -1588,  -321,  -734, -1588,  -167,  -150,  -713, -1588, -1243,  -278,
      98,  1452, -1588,   -51, -1588,   108, -1588, -1184, -1588,   258,
   -1588, -1588, -1588, -1588, -1588,   572,  -264,   742,  1135,   893,
    1455,  1457, -1588, -1588,  -534,   195, -1588, -1588, -1588,  1024,
   -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588,
   -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588,
   -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588,
   -1588, -1588,   774, -1588, -1588, -1588, -1588, -1588, -1588,   758,
   -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588,
   -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588, -1588,
   -1588, -1588, -1588, -1588, -1588
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     1,  1455,   755,  1475,  1634,  1020,  1264,  1456,    45,
      46,    47,    72,    85,    87,   101,   103,   129,   134,   142,
     144,   259,   262,   265,   266,   715,  1041,   260,   210,   375,
    1411,  1191,   376,  1192,  1333,  1586,   379,  1193,   380,  1608,
    1609,   383,  1194,  1437,  1593,   385,  1195,  1726,  1795,  1796,
    1601,  1602,  1696,  1284,  1287,  1481,  1479,  1480,  1286,  1289,
    1190,  1603,  1419,  1724,  1789,  1790,  1791,  1836,  1420,  1421,
    1576,  1577,  1556,   211,  1509,    48,    49,    59,   408,    51,
     411,  1559,    65,   415,  1561,    69,   420,  1564,    60,   405,
    1557,   281,   282,   283,    52,   387,  1297,   437,  1423,   315,
     316,  1439,   317,   318,   319,   320,   321,   322,  1167,  1376,
    1377,   323,   324,   325,   764,   765,   326,   327,   772,   773,
    1114,  1108,  1337,  1338,   328,  1053,  1316,  1519,   329,  1083,
    1749,  1676,  1674,   330,   331,   775,   332,   333,   334,   335,
     336,   831,   832,  1396,   374,  1694,  1759,   797,   798,   799,
     800,   801,   802,   803,  1356,   804,   805,   806,   807,   808,
     809,   810,   337,   338,   837,   339,   340,   841,   341,   342,
     838,   839,   343,   344,   846,   847,   848,   849,  1064,  1065,
     345,   346,   347,   348,   349,   855,   856,   350,   351,   212,
     811,   852,   891,   812,   352,   216,   972,   493,   494,   813,
     500,   353,   354,   355,   356,   357,   358,   893,   894,   895,
     359,   360,   361,   756,   757,  1304,  1305,  1091,  1092,  1298,
    1299,  1325,  1329,  1330,  1326,  1093,  1524,   913,  1487,   719,
    1498,   721,  1504,   722,   424,  1736,  1661,  1851,  1852,  1644,
    1654,  1043,  1493,   720,   362,   914,   915,   899,   900,   901,
     902,  1094,   904,   814,   815,   816,   907,   908,   363,   732,
     817,   660,   661,   219,   365,   818,   498,  1274,   690,   819,
    1039,   702,  1278,  1478,   222,   820,   622,   822,   623,   823,
     685,   686,  1032,  1033,   687,   824,   825,   366,   367,   826,
     227,   487,   228,   507,   229,   512,   230,   520,   231,   534,
     984,  1226,   232,   542,   233,   547,   234,   557,   235,   566,
     236,   572,   237,   575,   238,   579,   239,   584,   240,   589,
     241,   601,   999,  1236,   242,   605,  1018,  1263,  1246,  1252,
    1241,  1019,   243,   611,   244,   503,   245,   246,   636,   247,
     624,   248,   626,   249,   628,   250,   633,   251,   643,   252,
     646,   253,   652,   254,   699
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      43,   364,    53,   760,   213,   381,   314,   436,   761,   436,
     436,   932,   364,   436,   691,   436,   733,   377,   436,   436,
     727,  1095,   436,   436,   436,   436,   213,   933,   382,   436,
     930,   215,   436,   436,   842,   931,  1458,   213,   853,   903,
     436,   217,   703,  1461,   889,   275,  1056,   753,    44,   903,
     903,   263,   948,   369,   889,   889,  1465,   372,  1459,   946,
     898,  1460,   919,   217,  1319,  1321,  1499,  1285,  1373,   821,
    1331,  1440,  1170,  1449,   217,  1630,   950,  1526,  1628,   929,
    1374,  1629,  1098,  1061,  1096,  1063,   754,  1471,  1473,   754,
    1552,  1109,  1069,  1848,  1881,  1113,  1617,  1048,  1125,   854,
    1636,  1079,  1080,   917,  1084,    55,  1551,  1547,  1086,  1087,
    1162,  1574,  1575,  1168,   974,  1510,  1614,   850,   850,  1794,
     850,  1074,    56,    57,    58,  1054,  1687,   662,   218,  1057,
     150,   151,   152,  1120,  1511,   613,  1122,  1314,   220,  1051,
    1375,  1527,  1528,  1740,  1160,  1161,  1295,  1785,   543,  1296,
     218,  1034,  1163,  1746,  1164,   495,   496,  1745,  1811,   616,
     220,   218,  1116,   276,    54,   277,   942,  -706,   544,  1276,
    1046,   220,   615,  1516,   373,  1117,  1663,  1814,   213,   378,
      63,   545,   213,   384,  1049,   943,  1794,  1734,  1817,   944,
      55,  1118,  1735,   905,   726,   969,   606,  1151,   945,   976,
    1152,  1221,   278,   905,   905,   150,   151,   152,  1077,   629,
     906,     3,    55,   977,     4,   217,     5,  1222,    71,   217,
     906,   906,  1223,  1224,  1322,  1786,  1787,  1323,   607,   608,
     752,    55,   731,   731,   613,    55,     6,     7,     8,     9,
    -706,   734,  1050,  1047,    55,  1588,  1589,   662,   255,   947,
     688,  1440,   862,   402,  1517,    86,   609,  1664,   616,   261,
     689,  1615,   102,   745,  1056,   364,  1183,  1184,  1884,  1818,
     613,   975,   143,     3,   705,  1260,     4,   735,     5,   746,
     707,   630,   631,   632,     4,   851,     5,   267,   221,   610,
     213,  1261,   619,   620,   616,    55,   864,  1645,     6,     7,
       8,     9,   218,  1335,  1646,  1853,   218,  1856,  1336,   917,
     221,  1855,   220,   395,  1294,  1205,   220,  1613,  1315,  1075,
    1225,   221,   896,  1262,   704,   421,   573,   217,   546,   970,
     971,   381,   896,   896,   890,   264,   364,  1440,  1119,  1449,
    1647,   926,   574,  1207,   890,   890,   833,  1208,   370,   436,
    1511,   364,  1070,  1327,   382,   381,   941,  1206,  1815,  1800,
    1277,   213,     3,   209,   497,     4,  1433,     5,   371,  1328,
     488,   489,   381,  1784,  1648,   621,   213,   209,   382,     3,
     840,   300,     4,  1055,     5,  1433,  1357,     6,     7,     8,
       9,  1300,  1301,  1778,   209,   382,   758,   302,   217,  -173,
     300,  1451,   303,  1452,     6,     7,     8,     9,   730,   730,
    1158,   978,   736,   217,   218,  1290,   302,  1441,   313,  1293,
     918,   303,  1551,   209,   220,   979,  1382,  1613,  1306,  1307,
    1308,  1839,  1097,  1310,  1667,  1312,  1354,  1186,  1553,  1089,
    1865,  1849,  1882,  1863,   209,  1318,  1864,  1757,  1166,   313,
    1468,  1732,  1837,   209,   209,  1751,   209,  1548,   452,  1686,
    1380,  1381,   221,   209,  1738,  1442,   221,  1443,  1383,  1429,
    1384,   268,  1430,   269,   758,  1649,  1688,  1788,  1343,  1135,
    1345,  1346,   279,   280,   209,   218,  1566,   634,     3,  1444,
    -192,     4,   862,     5,  1359,   220,  1360,   396,  1679,   397,
     218,   481,   490,   491,  1138,  1368,   492,  1370,   863,   422,
     220,   423,   635,     6,     7,     8,     9,  1139,   373,  1140,
     644,   276,  1273,  1136,   277,  1472,  1691,  1451,   378,  1452,
     256,   257,   258,   384,   499,     3,   864,  1445,     4,  1066,
       5,   256,   257,   258,  1433,   645,   613,   758,   889,  1681,
    1133,     3,  1134,   580,     4,   853,     5,   581,   625,   300,
       6,     7,     8,     9,  1169,  1650,   615,  1171,     3,  1718,
     616,     4,  1709,     5,   221,   302,     6,     7,     8,     9,
     303,   748,   749,   834,   835,   836,  1525,   627,   905,   582,
     583,   706,   889,     6,     7,     8,     9,  1095,   966,  1756,
    1823,     4,   223,     5,  1716,   906,  1441,  1826,  1182,   758,
     827,   828,   693,  1056,   747,  1196,   723,   834,   835,   836,
    1103,  1645,  1824,   394,   223,  1825,   724,  1392,  1646,     4,
     728,     5,   748,   749,   744,   223,   602,  1052,  1725,   419,
    1453,  1095,   453,   209,   423,   221,  1127,   725,  1505,  1506,
    -451,   751,  1721,  1104,  1442,  1714,  1443,   445,  1429,   454,
     221,  1430,   754,  1390,  1647,  1141,    88,  1105,  1515,     4,
    1567,     5,  1568,    89,  1520,    90,   758,    91,  1444,   274,
      92,    93,    94,     4,    95,     5,   619,   620,   603,   604,
     905,   905,   905,   905,   905,   576,  1165,   905,  1648,  1044,
    1045,  1540,  1440,   213,  1449,   577,   578,   906,   906,   906,
     906,   906,  1106,   774,   906,   758,  1454,  1090,  1542,     3,
    1544,   905,     4,   854,     5,  1142,  1445,   287,   288,   890,
     647,  1820,   289,  1446,  1042,  1179,   440,  1180,   906,  1595,
     217,   905,   859,   648,     6,     7,     8,     9,   447,   448,
     649,    18,    19,   860,   829,   830,   853,     3,   906,   861,
       4,   909,     5,  1596,  1597,   567,  1453,   910,   650,   621,
    1126,   585,   224,  1237,   651,  1279,   223,  1238,  1239,  1240,
     223,   568,     6,     7,     8,     9,     3,   501,   502,     4,
     569,     5,   920,  1107,   224,  1178,   570,   571,  1846,  1649,
      34,  1847,   851,   586,   587,   224,   588,   921,  1179,    35,
    1180,     6,     7,     8,     9,    36,   484,   485,   486,   150,
     151,   152,  1878,  1348,  1349,   278,   896,   218,   853,   922,
    1355,   890,   890,   890,   890,   890,   213,   220,   890,    37,
     923,     3,  1627,  1645,     4,  1371,     5,   924,   748,   749,
    1646,  1379,  1247,  1248,  1249,  1250,  1251,  1385,  -706,  1387,
    1389,  -249,   890,   954,  1666,   955,     6,     7,     8,     9,
     896,   758,   956,   217,   214,   967,    66,    67,  1678,  1598,
    1303,   968,   890,   700,   701,  -451,  1647,   758,   223,  1729,
     973,  1604,  1605,  1606,    96,  1607,   214,  1022,  1684,  1599,
    1600,  1023,   766,  1037,   758,  1494,  1035,   214,     3,    97,
    1036,     4,  1187,     5,  1038,  1188,  1202,  1203,  1204,  1040,
    1648,  1062,  1626,   225,  1067,    98,  1569,  1570,  1571,  1572,
      99,  1215,   100,     6,     7,     8,     9,   391,   392,   393,
    1068,   150,   151,   152,  1071,   225,   224,  1451,  1072,  1452,
     224,   762,   763,   414,   416,   417,   225,  1095,  1073,   223,
     218,   857,   858,   433,  1076,  1155,  1066,  1085,  1303,  1157,
     220,   442,   443,  1078,   223,  1081,  1082,   449,  1127,  1127,
    1127,  1127,  1127,   130,  1127,  1127,  1088,   221,   131,   132,
    1099,  1513,  1100,  1365,  1365,   504,   505,   506,   478,   479,
    1128,  1129,   482,   851,   133,   905,   905,   905,   905,   905,
     905,   905,  1101,   905,   905,  1089,  1669,  1670,  1671,  1672,
    1673,  1649,   906,   906,   906,   906,   906,   906,   906,  1110,
     906,   906,  1111,   767,   768,   769,   770,   771,   637,  1112,
       3,  1123,  1754,     4,   213,     5,  1124,   508,   214,   509,
     510,   511,   214,   638,   226,   758,  1173,  1174,   224,  1089,
    1130,  1550,  1545,  1131,  1546,     6,     7,     8,     9,   980,
     981,   982,   983,  1500,   639,   851,   368,   256,   257,   258,
     640,   217,   694,   748,   749,   748,   749,   368,  1701,  1702,
    1703,   695,   696,   758,  1132,   697,   698,   225,  1358,  1267,
    1268,   225,  1126,  1126,  1126,  1126,  1126,  1137,  1126,  1126,
       3,  1891,     4,     4,     5,     5,  1709,  1364,  1364,  -909,
     221,  1145,   758,   290,   291,   292,  1522,  1523,   295,   224,
     213,   759,   213,   754,  1320,     6,     7,     8,     9,  -910,
    1868,   364,  1269,  1270,   224,  1143,   890,   890,   890,   890,
     890,   890,   890,   905,   890,   890,  1144,  1056,  1870,  1146,
     214,   641,   642,  1148,   905,  1156,   213,   217,   218,   217,
     906,  1149,    18,    19,   843,   844,   845,   758,   220,  1154,
    1699,   906,   558,  1228,   559,  1172,  1453,  1175,  1391,  1393,
    1409,  1417,  1435,  1447,     4,  1869,     5,  1700,  1714,  1176,
    1698,  1177,   560,   217,   892,  1024,  1025,  1181,   905,   225,
     561,   562,   917,   563,   892,   892,  1229,  1185,  1026,  1189,
    1655,    34,  1046,   564,   565,   906,  1027,  1049,   226,  1197,
      35,   214,   226,  1713,   844,   845,    36,  1394,  1410,  1418,
    1436,  1448,  1028,  1476,  1477,   733,   214,  1209,  1697,  1242,
    1243,  1244,  1245,   364,   218,  1210,   218,  1591,  1592,  1720,
      37,  1211,  1631,  1198,   220,  1199,   220,  1704,  1705,  1706,
    1707,  1212,  1230,  1231,  1232,  1233,  1234,  1235,   213,  1213,
     225,  1200,   364,  1484,  1201,  1490,  1495,  1535,  1501,  1219,
     218,  1834,  1835,  1090,   890,   225,   150,   151,   152,     3,
     220,   223,     4,  1214,     5,   890,  1254,   213,   952,    62,
     426,   428,   430,   432,  1255,   217,   834,   835,   836,  1256,
    1046,  1257,  1303,   364,     6,     7,     8,     9,   221,  1258,
    1265,  1485,  1534,  1491,  1496,  1259,  1502,  1266,  1366,  1367,
     368,  1271,   965,  1272,   217,  1273,  1275,  1280,   213,   890,
    1281,  1283,  1578,  1282,  1747,     3,  1288,  1066,     4,   862,
       5,  1029,  1030,  1031,   671,  1291,  1302,  1309,   386,  1311,
    1313,  1317,   390,  1334,  1656,  1089,   758,   681,   682,   683,
       6,     7,     8,     9,  1339,   217,  1340,   410,   386,  1637,
    1341,  1342,  1344,  1347,  1483,  1353,  1361,  1362,   213,  1766,
    1767,  1768,   218,  1363,   438,  1378,  1386,   364,  1462,  1463,
    1573,   368,   220,  1466,   221,   213,   221,  1464,  1581,  1582,
    1583,  1584,  1585,  1467,  1474,  1587,   368,  1469,  1638,  1470,
    1482,   218,   213,   477,   223,   217,  1610,  1611,  1612,   457,
     483,   220,  1587,  1488,  1507,  1637,   758,  1508,  1619,  1620,
     221,  1512,   217,  1518,    18,    19,  1409,  1417,  1435,  1447,
    1521,   731,   731,  1530,  1657,     3,  1536,  1537,     4,   217,
       5,   224,   218,  1531,  1538,  1539,  1541,  1543,  1641,  1651,
    1658,  1554,   220,  1555,  1638,  1565,   213,  1579,  1580,  1590,
       6,     7,     8,     9,  1594,   740,  1616,  1066,  1621,  1622,
    1632,  1633,  1635,    34,  1410,  1418,  1436,  1448,  1662,  1668,
    1677,  1675,    35,  1558,  1560,  1560,  1563,  1680,    36,  1685,
    1690,   213,   218,   217,   905,  1695,  1642,  1652,  1659,   381,
    1693,  1689,   220,   612,  1682,  1708,  1731,  1723,  1733,   218,
    1737,   906,    37,  1739,   613,  1748,   614,  1741,  1743,   220,
    1742,  1750,   382,  1752,  1753,   381,   218,  1744,   217,  1755,
    1758,  1727,   221,  1639,   615,  1761,   220,  1773,   616,  1762,
     708,   617,   709,   214,   710,   711,  1763,  1764,   382,  1765,
    1769,  1770,   712,   713,  1799,  1710,  1771,  1711,  1712,  1772,
     459,   221,  1801,  1809,  1812,  1819,  1813,  1816,  1827,   892,
    1845,  1715,  1850,  1828,   224,    18,    19,  1717,  1829,  1854,
     218,  1872,  1876,  1877,  1719,   714,   364,  1722,  1880,  1639,
     220,     3,   225,  1898,     4,    70,     5,  1641,  1651,  1658,
    1457,     3,   221,  1618,     4,   758,     5,   730,   730,  1776,
    1897,   213,   223,  1879,   928,   218,     6,     7,     8,     9,
    1775,   618,  1830,  1640,    34,   220,     6,     7,     8,     9,
    1831,   213,  1792,    35,  1797,   890,  1832,  1822,  1833,    36,
    1451,  1873,  1452,   406,  1562,  1642,  1652,  1659,   217,   925,
     412,  1549,   221,   213,   619,   620,  1102,  1692,  1115,  1665,
    1683,   758,   213,    37,  1760,  1147,   750,   927,   217,   221,
    1821,   892,   892,   892,   892,   892,   214,  1352,   892,  1728,
    1774,  1350,  1857,  1351,  1369,  1153,   221,  1372,   729,  1587,
     217,  1159,  1220,  1793,  1388,  1798,   692,  1332,   223,   217,
     223,  1532,   892,  1514,  1529,  1802,  1803,  1804,  1805,  1806,
    1807,  1808,   916,  1810,   939,   937,   940,   455,  1899,   938,
     738,   213,   892,   226,   742,   225,   743,  1021,   897,  1227,
    1049,  1253,     0,     0,   223,   218,     0,   621,     0,     0,
     221,     0,   364,  1871,     0,   220,     0,  1838,  1587,  1840,
    1841,  1842,  1843,  1844,     0,   218,     0,  1797,   217,     0,
       0,     0,     0,     0,     0,   220,     0,   213,     0,     0,
       0,   758,     0,     0,     0,   221,     0,   218,     0,     0,
       0,  1727,   224,     0,     0,     3,   218,   220,     4,  1489,
       5,  1393,  1417,  1435,  1447,   535,   220,   536,     0,  1484,
    1490,  1495,  1501,     0,   217,     0,  1874,     0,  1875,     0,
       6,     7,     8,     9,     0,   537,     0,     0,     0,     0,
       0,   917,  1883,   538,   539,   540,   541,  1885,  1886,  1887,
    1888,  1889,  1641,  1651,  1658,  1893,  1894,  1895,  1896,  1394,
    1418,  1436,  1448,     0,     0,   218,   223,  1485,  1491,  1496,
    1502,  1900,     0,     0,     0,   220,   226,     0,     0,  1901,
    1902,  1903,     0,   270,   271,   272,   273,     0,   224,     0,
     224,  1046,     0,     0,     0,   223,     0,     0,  1324,  1453,
    1642,  1652,  1659,     0,   214,     0,     0,   135,     0,   136,
       0,   218,     0,     0,   137,   221,   138,   388,     0,     0,
     139,   220,     0,     0,   224,   398,   399,   400,   401,     0,
       0,     0,   404,     0,     0,   221,   223,     0,     0,     0,
       0,   425,   427,   429,   431,     0,     0,   758,   434,     0,
       0,     0,     0,   225,     0,     3,     0,   221,     4,   140,
       5,   141,     0,     0,   456,  1866,   221,     0,     0,   465,
     466,   467,     0,     0,   470,  1862,     0,   475,     0,     0,
       6,     7,     8,     9,     0,     0,   223,     0,     0,  -865,
     214,  -865,   214,     0,     0,     0,  1395,  1412,  1422,  1438,
    1450,     0,     0,   223,     0,     0,   892,   892,   892,   892,
     892,   892,   892,     0,   892,   892,   548,   549,     3,     0,
     223,     4,     0,     5,     3,   221,   214,     4,     0,     5,
     550,     0,   551,   552,   553,     3,   224,     0,     4,   225,
       5,   225,     0,     6,     7,     8,     9,     0,     0,     6,
       7,     8,     9,     0,     0,   554,   555,   556,   513,   514,
       6,     7,     8,     9,     0,   224,   515,   516,   517,   518,
     519,   221,     0,  1424,   223,   225,     0,     0,     0,     0,
       0,     0,   461,     0,   226,   463,     0,     0,     0,     0,
    1486,     3,  1492,  1497,     4,  1503,     5,    18,    19,     0,
      18,    19,     0,     0,     0,     0,   224,     0,  1637,   223,
       0,   716,   717,   718,     0,     0,     6,     7,     8,     9,
    1425,  1426,  1427,  1428,     0,  1429,     0,  1779,  1430,     0,
       0,  1324,     0,     0,  1655,     0,     0,  -865,   214,     0,
       0,   758,     0,     0,  1595,  1431,    34,  1638,     0,    34,
       0,     0,     0,     0,   892,    35,   224,     0,    35,  1858,
       0,    36,     0,     0,    36,   892,     0,   214,  1596,  1597,
     226,     0,   226,   224,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    37,     0,   225,    37,     0,
     224,     0,     0,  1432,     0,     0,     0,  -865,     0,     0,
       0,  1655,     0,     0,     0,     0,   368,     0,   214,   892,
       0,   439,   441,     0,     0,   444,   225,   446,     0,     0,
     450,   451,     0,     0,   458,   460,   462,   464,     0,   223,
       0,   469,     0,     0,   472,   474,     0,   468,     0,   934,
     935,   936,   480,     0,   224,     0,     0,     0,     0,   223,
    1049,     0,    18,    19,     0,     0,     0,   225,   214,     0,
       0,     0,     0,  1412,  1422,  1438,  1450,     0,   949,     0,
       0,   223,     0,     0,     0,   214,     0,     0,     0,   224,
     223,     0,  1639,     0,  1598,  1643,  1653,  1660,  1656,     0,
       0,   758,   214,     0,     0,     0,     0,     0,  1433,   957,
       0,    34,     0,     0,  1599,  1600,     0,   225,     0,  1867,
      35,     0,     0,   300,     0,     0,    36,     0,   368,     0,
       0,     0,  1780,     0,   225,     0,     0,     0,     0,   302,
       0,     0,     0,     0,   303,     0,     0,   471,  1781,   223,
      37,   225,     0,  1782,     0,  1783,   214,   368,     0,     0,
       0,     0,    18,    19,   758,  1656,     0,     0,     0,     0,
     758,    73,     0,     0,     0,     0,     0,     0,    74,     0,
      75,   758,  1890,     0,     0,    76,    77,    78,  1730,    79,
       0,   214,     0,     0,     0,   223,     0,     0,   368,  1434,
       0,     0,     0,    50,     0,   225,     0,     0,     0,   224,
       0,    34,     0,    61,    50,    50,    64,    64,    64,    68,
      35,     0,    50,     0,     0,     0,    36,     0,     0,   224,
       0,     0,     0,     0,     0,     0,     3,   758,     0,     4,
     225,     5,     0,     0,  1643,  1653,  1660,     0,   226,     0,
      37,   224,     0,     0,     0,  1892,     0,     0,     0,     0,
     224,     6,     7,     8,     9,   226,     0,     0,     0,   473,
       0,     0,     0,    50,  1424,     0,   389,    50,    64,    64,
      64,    68,   368,     0,    18,    19,     0,     0,    50,     0,
     403,   407,   409,    50,   413,    64,    64,   418,     0,   403,
     403,   403,   403,     0,    64,     0,     0,   435,     0,    50,
       0,   214,    64,    64,     0,    68,     0,     0,    64,   224,
       0,  1425,  1426,  1427,  1428,     0,  1429,     0,     0,  1430,
       0,   214,     0,    34,     0,   892,   226,   476,    50,    64,
      64,     0,    35,    64,     0,    50,  1431,     0,    36,     0,
       0,     0,     0,   214,     0,     0,     0,     0,     0,     0,
     225,   953,   214,     0,     0,   224,     0,     0,     0,     0,
       0,   226,    37,     0,    10,   778,     0,     0,     0,     0,
     225,    11,     0,    12,     0,    13,     0,     0,    14,    15,
      16,     0,    17,     0,  1432,     0,    18,    19,     0,    80,
       0,     0,   225,     0,     0,     0,     0,     0,   150,   151,
     152,   225,     0,     0,    81,   871,     0,     0,     0,   872,
       0,   214,     0,   873,     0,     0,     0,     0,     0,   874,
      82,     0,     0,   785,     0,    83,     0,    84,  1395,  1422,
    1438,  1450,     0,     0,     0,    34,  1486,  1492,  1497,  1503,
       0,     0,     0,   877,    35,   986,     0,     0,     0,     0,
      36,     0,     0,     0,     0,     0,     0,   214,     3,     0,
     225,     4,     0,     5,     0,     0,     0,     0,     0,  1643,
    1653,  1660,     0,     0,    37,     0,     0,     0,     0,     0,
     145,   368,     0,     6,     7,     8,     9,   146,   147,  1433,
       0,   284,   148,   285,     0,     0,     0,     0,     0,     0,
       0,   226,     0,     0,   300,     0,   225,   286,   987,     0,
     548,   549,     0,     0,     0,     0,     0,   287,   288,     0,
     302,     0,   289,   226,   550,   303,   551,   552,   553,     0,
       0,     0,   226,   290,   291,   292,   293,   294,   295,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1413,   554,
     555,   556,   296,     0,   297,     0,     0,   149,   150,   151,
     152,     0,   758,   153,     0,   154,     0,     0,  1414,   155,
       0,   788,     0,   156,   789,   790,     0,     0,   988,   157,
    1625,   989,   990,   991,   992,   993,   994,   995,   996,   997,
     998,   226,    38,     0,     0,   158,     0,     0,     0,     0,
     159,     0,     0,   160,     0,     0,     0,    39,   161,     0,
       0,   162,   792,   793,   163,   164,  1415,     0,     0,   165,
       0,     0,   166,    40,   167,     0,     0,     0,    41,     0,
      42,     0,   951,     0,     0,     0,     0,   368,     0,    64,
       0,     0,     0,     0,     0,     0,   168,   169,     0,   958,
       0,   959,     0,   960,     0,   961,   209,     0,     0,     0,
     962,     0,     0,   963,     0,   964,     0,     0,     0,     0,
       0,     0,     0,    64,     0,     0,     0,     0,     0,     0,
       0,     0,   170,   171,   172,   173,     0,     0,     0,     0,
       0,   174,   175,     0,     0,   176,   177,   298,   179,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,     0,
       0,   299,     0,   521,   522,     0,     0,   523,     0,     0,
       0,     0,     0,     0,     0,     0,   300,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   301,     0,     0,     0,
       0,     0,   302,     0,     0,     0,     0,   303,     0,     0,
       0,     0,     0,     0,     0,     0,   201,   202,     0,   304,
       0,     0,   305,   306,   307,   308,     0,     0,     0,   309,
       0,     0,     0,   310,   311,   203,   533,     0,     0,   204,
     205,     0,     0,     0,   758,     0,     0,     0,   312,     0,
       3,   206,   207,     4,     0,     5,     0,     0,     0,     0,
       0,   313,  1416,   208,   590,     0,   209,     0,   985,     0,
       0,     0,   145,   591,     0,     6,     7,     8,     9,   146,
     147,     0,   986,   284,   148,   285,     0,     0,   592,     0,
       0,     0,   593,     0,     0,     3,   594,   595,     4,   286,
       5,   596,   597,   598,   599,   600,     0,     0,     0,   287,
     288,     0,     0,     0,   289,     0,     0,     0,     0,     0,
       6,     7,     8,     9,     0,   290,   291,   292,   293,   294,
     295,     0,     0,  1441,     0,     0,     0,     0,     0,     0,
    1413,     0,     0,     0,   296,   987,   297,     0,     0,   149,
     150,   151,   152,     0,     0,   153,     0,   154,     0,     0,
    1414,   155,     0,     0,     0,   156,     0,     0,     0,     0,
       0,   157,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1442,     0,  1443,     0,  1429,     0,   158,  1430,     0,
       0,     0,   159,     0,     0,   160,     0,     0,     0,     0,
     161,     0,     0,   162,     0,  1444,   163,   164,  1415,     0,
       0,   165,     0,     0,   166,   988,   167,     0,   989,   990,
     991,   992,   993,   994,   995,   996,   997,   998,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   168,   169,
       0,     0,     0,     0,     3,     0,     0,     4,     0,     5,
       0,     0,     0,  1445,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     6,
       7,     8,     9,     0,   170,   171,   172,   173,     0,     0,
       0,     0,  1424,   174,   175,     0,     0,   176,   177,   298,
     179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,     0,     0,   299,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   300,  1425,
    1426,  1427,  1428,     0,  1429,     0,     0,  1430,   301,     0,
       0,     0,     0,     0,   302,     0,     0,     0,     0,   303,
       0,     0,     0,     0,  1431,     0,     0,     0,   201,   202,
       0,   304,     0,     0,   305,   306,   307,   308,     0,     0,
       0,   309,     0,     0,     0,   310,   311,   203,     0,     0,
       0,   204,   205,     0,     3,     0,   758,     4,     0,     5,
     312,     0,     0,   206,   207,     0,  1216,  1217,  1218,     0,
       0,     0,  1432,   313,  1624,   208,   145,     0,   209,     6,
       7,     8,     9,   146,   147,     0,     0,   284,   148,   285,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   758,     0,   286,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   287,   288,     0,     0,     0,   289,  1861,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   290,
     291,   292,   293,   294,   295,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1413,     0,     0,     0,   296,     0,
     297,     0,     0,   149,   150,   151,   152,     0,     0,   153,
       0,   154,     0,     0,  1414,   155,     0,     0,     0,   156,
       0,     0,     0,     0,     0,   157,     0,  1433,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   158,   300,     0,     0,     0,   159,     0,     0,   160,
       0,     0,     0,     0,   161,  1000,     0,   162,   302,     0,
     163,   164,  1415,   303,     0,   165,     0,     0,   166,     0,
     167,  1001,  1002,  1003,  1004,  1005,  1006,  1007,  1008,  1009,
    1010,  1011,  1012,  1013,  1014,  1015,  1016,  1017,     0,     0,
       0,     0,   168,   169,     0,     0,     0,     0,     0,     0,
     758,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1860,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   170,   171,
     172,   173,     0,     0,     0,     0,     0,   174,   175,     0,
       0,   176,   177,   298,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,     0,     0,   299,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   300,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   301,     0,     0,     0,     0,     0,   302,     0,
       0,     0,     0,   303,     0,     0,     0,     4,     0,     5,
       0,     0,   201,   202,     0,   304,     0,     0,   305,   306,
     307,   308,     0,     0,     0,   309,   145,     0,     0,   310,
     311,   203,     0,   146,   147,   204,   205,   284,   148,   285,
     758,     0,     0,     0,   312,     0,     0,   206,   207,     0,
       0,     0,     0,   286,     0,     0,     0,   313,  1859,   208,
       0,     0,   209,   287,   288,     0,     0,     0,   289,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   290,
     291,   292,   293,   294,   295,     0,  -864,     0,  -864,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   296,     0,
     297,     0,     0,   149,   150,   151,   152,     0,     0,   153,
       0,   154,     0,   521,   522,   155,     0,   523,     0,   156,
       0,     0,     0,     0,     0,   157,     0,   524,   525,   526,
     527,   528,   529,   530,   531,   532,     0,     0,     0,     0,
       0,   158,     0,     0,     0,     0,   159,     0,     0,   160,
       0,     0,     0,     0,   161,     0,     0,   162,     0,     0,
     163,   164,     0,     0,     0,   165,     0,     0,   166,     0,
     167,     0,     0,     0,     0,     0,   533,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   168,   169,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   170,   171,
     172,   173,     0,     0,  -864,     0,     0,   174,   175,     0,
       0,   176,   177,   298,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,     0,     0,   299,     0,     0,
       0,     0,     0,     0,     0,   776,     0,     0,     0,     0,
       0,     0,   300,     0,   739,     0,     0,     0,     0,     0,
       0,   777,   301,   145,  -864,     0,     0,     0,   302,     0,
       0,   147,     0,   303,     0,   148,   663,   664,     0,     0,
     665,     0,   201,   202,     0,   304,     0,     0,   305,   306,
     307,   308,     0,     0,     0,   309,     0,   666,     0,   310,
     311,   203,     0,     0,     0,   204,   205,     0,   778,     0,
       0,     0,     0,     0,   312,     0,     0,   206,   207,     0,
       0,     0,   779,     0,   780,     0,     0,   313,  1533,   208,
       0,     0,   209,     0,     0,     0,     0,     0,     0,     0,
     149,   150,   151,   152,     0,     0,   153,     0,   781,     0,
       0,   740,   782,     0,     0,     0,   783,     0,     0,     0,
       0,     0,   784,     0,     0,     0,   785,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   158,     0,
       0,     0,     0,   159,     0,     0,   786,     0,     0,     0,
       0,   161,     0,     0,   162,     0,     0,   163,   164,     0,
       0,     0,   165,     0,     0,   166,     0,   167,   667,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   168,
     169,     0,   668,   669,   670,   671,   672,   673,   741,   674,
     675,   676,   677,   678,   679,   680,   104,     0,   681,   682,
     683,     0,     0,   105,   106,   107,   108,     0,     0,   109,
     110,     0,   111,   112,   113,   787,   114,     0,     0,   684,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,     0,     0,   200,   115,  1058,   116,   117,   118,
       0,     0,     0,     0,   788,     0,     0,   789,   790,     0,
       0,     0,   777,     0,   145,     0,     0,     0,     0,     0,
     791,     0,   147,     0,     0,     0,   148,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   201,
     202,     0,     0,     0,     0,   792,   793,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   203,   778,
       0,     0,   204,   205,     0,     0,     0,     0,     0,     0,
       0,     0,   794,   795,     0,   659,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   796,     0,     0,   209,
       0,   149,   150,   151,   152,     0,     0,   153,     0,   781,
       0,     0,     0,   782,     0,     0,     0,   783,     0,     0,
       0,     0,     0,  1059,     0,     0,     0,   785,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   158,
       0,     0,     0,     0,   159,     0,     0,  1060,     0,     0,
       0,     0,   161,     0,     0,   162,     0,     0,   163,   164,
       0,     0,     0,   165,     0,     0,   166,     0,   167,     0,
       0,     0,     0,     0,   119,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   120,
     168,   169,     0,     0,   121,   122,   123,   124,     0,     0,
       0,     0,     0,     0,     0,   125,     0,     0,     0,     0,
     126,     0,   127,   128,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   787,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   178,   179,   180,   181,   182,   183,   184,   185,   186,
     187,   188,   189,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,     0,     0,   200,     0,  1121,     0,     0,
       0,     0,     0,     0,     0,   788,     0,     0,   789,   790,
       0,     0,     0,   777,     0,   145,     0,     0,     0,     0,
       0,     0,     0,   147,     0,     0,     0,   148,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     201,   202,     0,     0,     0,     0,   792,   793,     0,     0,
       0,     0,     0,   653,     0,     0,     0,     0,     0,   203,
     778,     0,     0,   204,   205,     0,     0,     0,     0,     0,
       0,     0,     0,   794,   795,     0,   659,     0,     0,   654,
       0,     0,   655,     0,     0,     0,     0,   796,     0,     0,
     209,     0,   149,   150,   151,   152,     0,     0,   153,   656,
     781,     0,     0,     0,   782,     0,     0,     0,   783,     0,
       0,     0,     0,     0,  1059,     0,     0,     0,   785,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     158,     0,     0,     0,     0,   159,     0,     0,  1060,     0,
       0,     0,     0,   161,     0,     0,   162,     0,     0,   163,
     164,     0,     0,     0,   165,     0,     0,   166,     0,   167,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   168,   169,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,     0,     0,     0,   787,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   657,     0,   200,     0,  1150,     0,
       0,   201,   202,     0,     0,     0,   788,     0,     0,   789,
     790,   658,     0,     0,   777,     0,   145,     0,     0,     0,
       0,     0,     0,     0,   147,     0,     0,     0,   148,     0,
       0,     0,     0,     0,     0,     0,     0,   659,     0,     0,
       0,   201,   202,     0,     0,     0,     0,   792,   793,     0,
       0,     0,     0,     0,   737,     0,     0,     0,     0,     0,
     203,   778,     0,     0,   204,   205,     0,     0,     0,     0,
       0,     0,     0,     0,   794,   795,     0,   659,     0,     0,
     654,     0,     0,   655,     0,     0,     0,     0,   796,     0,
       0,   209,     0,   149,   150,   151,   152,     0,     0,   153,
     656,   781,     0,     0,     0,   782,     0,     0,     0,   783,
       0,     0,     0,     0,     0,  1059,     0,     0,     0,   785,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   158,     0,     0,     0,     0,   159,     0,     0,  1060,
       0,     0,     0,     0,   161,     0,     0,   162,     0,     0,
     163,   164,     0,     0,     0,   165,     0,     0,   166,     0,
     167,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   168,   169,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,     0,     0,     0,   787,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   657,     0,   200,     0,  1292,
       0,     0,   201,   202,     0,     0,     0,   788,     0,     0,
     789,   790,   658,     0,     0,   777,     0,   145,     0,     3,
       0,     0,     4,     0,     5,   147,     0,     0,     0,   148,
       0,     0,     0,     0,     0,     0,   663,   664,   659,     0,
     665,     0,   201,   202,     6,     7,     8,     9,   792,   793,
       0,     0,     0,     0,  1397,     0,     0,   666,     0,     0,
       0,   203,   778,  1398,     0,   204,   205,     0,  1399,     0,
    1400,     0,  1401,     0,     0,   794,   795,     0,   659,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   796,
       0,     0,   209,     0,   149,   150,   151,   152,     0,     0,
     153,     0,   781,     0,     0,     0,   782,     0,     0,     0,
     783,     0,     0,     0,     0,     0,  1059,     0,     0,     0,
     785,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   158,     0,     0,     0,     0,   159,     3,     0,
    1060,     4,     0,     5,     0,   161,     0,     0,   162,     0,
       0,   163,   164,     0,     0,     0,   165,     0,     0,   166,
       0,   167,     0,     6,     7,     8,     9,     0,   667,     0,
       0,     0,     0,  1397,     0,     0,     0,  1402,     0,     0,
       0,     0,  1398,   168,   169,     0,     0,  1399,     0,  1400,
       0,  1401,   668,   669,   670,   671,   672,   673,     0,   674,
     675,   676,   677,   678,   679,   680,     0,     0,   681,   682,
     683,     0,     0,     0,     0,     0,     0,     0,     0,   787,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   684,
       0,     0,     0,     0,   178,   179,   180,   181,   182,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,     0,     0,   200,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   788,     0,
       0,   789,   790,   865,   866,   867,   868,   869,   870,     0,
       0,     0,  1403,     0,     0,   777,     0,   850,     0,     0,
       0,     0,     0,     0,     0,     0,  1402,  1404,     0,     0,
       0,     0,     0,   201,   202,     0,     0,     0,     0,   792,
     793,     0,     0,  1405,     0,     0,     0,     0,  1406,     0,
    1407,     0,   203,     0,     0,     0,   204,   205,     0,     0,
       0,     0,   778,     0,     0,     0,   794,   795,     0,   659,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     796,     0,     0,   209,     0,   758,     0,     0,     0,     0,
       0,     0,     0,     0,   149,   150,   151,   152,     0,     0,
       0,     0,   871,  1408,     0,     0,   872,     0,     0,     0,
     873,     0,     0,     0,     0,     0,   874,     0,     0,     0,
     785,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1403,   875,     0,     0,     0,     0,   876,     0,     0,
     877,     0,     0,     0,     0,   878,  1404,     0,   879,     0,
       0,   880,   881,     0,     0,     0,   882,     0,   777,   883,
     145,   884,  1405,     0,     0,     0,     0,  1406,   147,  1407,
       0,     0,   148,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   885,   886,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   758,   778,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1623,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   149,   150,   151,
     152,     0,     0,   153,     0,   781,     0,     0,     0,   782,
       0,     0,     0,   783,     0,     0,     0,     0,     0,  1059,
       0,     0,     0,   785,     0,     0,     0,     0,   788,     0,
       0,   789,   790,     0,     0,   158,     0,     0,     0,     0,
     159,     0,     0,  1060,     0,     0,     0,     0,   161,     0,
       0,   162,     0,     0,   163,   164,     0,     0,     0,   165,
       0,     0,   166,     0,   167,     0,     0,     0,     0,   792,
     793,     0,   887,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   168,   169,     0,     0,
       0,     0,     0,     0,     0,     0,   794,   795,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   313,     0,
     888,     0,     0,   209,     0,     0,     0,     0,     0,     0,
       0,     0,   787,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   178,   179,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,     0,
       0,   200,     0,     0,   777,   911,   850,     0,     0,     0,
       0,   788,     0,     0,   789,   790,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   201,   202,     0,     0,
       0,   778,   792,   793,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   203,     0,     0,     0,   204,
     205,     0,     0,     0,     0,   777,     0,   850,     0,   794,
     795,     0,   659,   149,   150,   151,   152,     0,     0,     0,
       0,   871,     0,   796,     0,   872,   209,     0,     0,   873,
       0,     0,     0,     0,     0,   874,     0,     0,     0,   785,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   875,   778,     0,     0,     0,   876,     0,     0,   877,
       0,     0,     0,     0,   878,     0,     0,   879,     0,     0,
     880,   881,     0,     0,     0,   882,   777,     0,   883,     0,
     884,     0,     0,     0,   149,   150,   151,   152,     0,     0,
       0,     0,   871,     0,     0,     0,   872,     0,     0,     0,
     873,     0,   885,   886,     0,     0,   874,     0,     0,     0,
     785,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   875,   778,     0,     0,     0,   876,     0,     0,
     877,     0,     0,     0,     0,   878,     0,     0,   879,     0,
       0,   880,   881,     0,     0,     0,   882,     0,     0,   883,
       0,   884,     0,     0,     0,   149,   150,   151,   152,     0,
       0,     0,     0,   871,     0,     0,     0,   872,     0,     0,
       0,   873,     0,   885,   886,     0,     0,   874,     0,     0,
       0,   785,     0,     0,     0,     0,     0,   788,     0,     0,
     789,   790,     0,   875,     0,     0,     0,     0,   876,     0,
       0,   877,     0,     0,     0,     0,   878,     0,     0,   879,
       0,     0,   880,   881,     0,     0,     0,   882,     0,     0,
     883,     0,   884,     0,     0,     0,     0,     0,   792,   793,
       0,   887,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   885,   886,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   794,   795,     0,   788,     0,
       0,   789,   790,     0,     0,     0,     0,   912,     0,   888,
       0,   777,   209,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   792,
     793,     0,   887,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   778,     0,
       0,     0,     0,     0,     0,     0,   794,   795,     0,   788,
       0,     0,   789,   790,     0,     0,     0,     0,   313,     0,
     888,     0,     0,   209,     0,     0,     0,     0,     0,     0,
     149,   150,   151,   152,     0,     0,     0,     0,   871,     0,
       0,     0,   872,     0,     0,     0,   873,     0,     0,     0,
     792,   793,   874,   887,     0,     0,   785,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   875,     0,
       0,     0,     0,   876,     0,     0,   877,   794,   795,     0,
       0,   878,     0,     0,   879,     0,     0,   880,   881,   313,
       0,   888,   882,     0,   209,   883,   145,   884,     0,     0,
       0,     0,     0,   146,   147,     0,     0,   284,   148,   285,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   885,
     886,     0,     0,   286,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   287,   288,     0,     0,     0,   289,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   290,
     291,   292,   293,   294,   295,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   296,     0,
     297,     0,     0,   149,   150,   151,   152,     0,     0,   153,
       0,   154,     0,     0,     0,   155,     0,     0,     0,   156,
       0,     0,     0,     0,     0,   157,     0,     0,     0,     0,
       0,     0,     0,     0,   788,     0,     0,   789,   790,     0,
       0,   158,     0,     0,     0,     0,   159,     0,     0,   160,
       0,     0,     0,     0,   161,     0,     0,   162,     0,     0,
     163,   164,     0,     0,     0,   165,     0,     0,   166,     0,
     167,     0,     0,     0,     0,   792,   793,     0,   887,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   168,   169,     0,     0,     0,     0,     0,     0,
       0,     0,   794,   795,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   888,     0,     0,   209,
       0,     0,     0,     0,     0,     0,     0,     0,   170,   171,
     172,   173,     0,     0,     0,     0,     0,   174,   175,     0,
       0,   176,   177,   298,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,     0,     0,   299,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   300,     0,     0,     0,     0,   145,     0,     0,
       0,     0,   301,     0,   146,   147,     0,     0,   302,   148,
       0,     0,     0,   303,     0,     0,     0,     0,     0,     0,
       0,     0,   201,   202,     0,   304,     0,     0,   305,   306,
     307,   308,     0,     0,     0,   309,     0,     0,     0,   310,
     311,   203,     0,     0,     0,   204,   205,     0,     0,     0,
       0,     0,     0,     0,   312,     0,     0,   206,   207,     0,
       0,     0,     0,     0,     0,     0,     0,   313,     0,   208,
       0,     0,   209,     0,   149,   150,   151,   152,     0,     0,
     153,     0,   154,     0,     0,     0,   155,     0,     0,     0,
     156,     0,     0,     0,     0,     0,   157,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   158,     0,     0,     0,     0,   159,     0,     0,
     160,     0,     0,     0,     0,   161,     0,     0,   162,     0,
       0,   163,   164,     0,     0,     0,   165,     0,     0,   166,
       0,   167,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   168,   169,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   145,     0,     0,     0,     0,     0,     0,   146,   147,
       0,     0,     0,   148,     0,     0,     0,     0,     0,   170,
     171,   172,   173,     0,     0,     0,     0,     0,   174,   175,
       0,     0,   176,   177,   178,   179,   180,   181,   182,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,     0,     0,   200,     0,
       0,     0,  1777,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   149,   150,
     151,   152,     0,     0,   153,     0,   154,     0,     0,     0,
     155,     0,     0,     0,   156,     0,     0,     0,     0,     0,
     157,     0,     0,   201,   202,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   158,     0,     0,     0,
       0,   159,   203,     0,   160,     0,   204,   205,     0,   161,
       0,     0,   162,     0,     0,   163,   164,     0,   206,   207,
     165,     0,     0,   166,     0,   167,     0,     0,   313,     0,
     208,     0,     0,   209,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   168,   169,     0,
       0,     0,     0,     0,   145,     0,     0,     0,     0,     0,
       0,   146,   147,     0,     0,     0,   148,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   170,   171,   172,   173,     0,     0,     0,
       0,     0,   174,   175,     0,     0,   176,   177,   178,   179,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
       0,     0,   200,     0,     0,     0,     0,     0,     0,     0,
       0,   149,   150,   151,   152,     0,     0,   153,     0,   154,
       0,     0,     0,   155,     0,     0,     0,   156,     0,     0,
       0,     0,     0,   157,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   201,   202,   158,
       0,     0,     0,     0,   159,     0,     0,   160,     0,     0,
       0,     0,   161,     0,     0,   162,   203,     0,   163,   164,
     204,   205,     0,   165,     0,     0,   166,     0,   167,     0,
       0,     0,   206,   207,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   208,     0,     0,   209,     0,     0,
     168,   169,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   170,   171,   172,   173,
       0,     0,     0,     0,     0,   174,   175,     0,     0,   176,
     177,   178,   179,   180,   181,   182,   183,   184,   185,   186,
     187,   188,   189,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,     0,     0,   200,     0,     0,     0,     0,
     145,     0,     0,     0,     0,     0,     0,     0,   147,     0,
       0,     0,   148,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     201,   202,     0,     0,     0,   778,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   203,
       0,     0,     0,   204,   205,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   206,   207,   149,   150,   151,
     152,     0,     0,   153,     0,   781,     0,   208,     0,   782,
     209,     0,     0,   783,     0,     0,     0,     0,     0,  1059,
       0,     0,     0,   785,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   158,     0,     0,     0,     0,
     159,     0,     0,  1060,     0,     0,     0,     0,   161,     0,
       0,   162,     0,     0,   163,   164,     0,     0,     0,   165,
       0,     0,   166,     0,   167,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   168,   169,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   787,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   178,   179,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,     0,
       0,   200,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   788,     0,     0,   789,   790,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   201,   202,     0,     0,
       0,     0,   792,   793,     0,     0,     0,     0,     2,     3,
       0,     0,     4,     0,     5,   203,     0,     0,     0,   204,
     205,     0,     0,     0,     0,     0,     0,     0,     0,   794,
     795,     0,   659,     0,     6,     7,     8,     9,     0,     0,
       0,     0,     0,   796,    10,     0,   209,     0,     0,     0,
       0,    11,     0,    12,     0,    13,     0,     0,    14,    15,
      16,     0,    17,     0,     0,     0,    18,    19,    20,     0,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,     0,     0,   778,     0,     0,     0,     0,
       0,     0,     0,   290,   291,   292,  1522,  1523,   295,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  -339,
       0,     0,     0,     0,     0,    34,     0,   149,   150,   151,
     152,     0,     0,     0,    35,   871,     0,     0,     0,   872,
      36,     0,     0,   873,     0,     0,     0,     0,     0,   874,
       0,     0,     0,   785,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    37,   875,   778,     0,     0,     0,
     876,     0,     0,   877,     0,     0,     0,     0,   878,     0,
       0,   879,     0,     0,   880,   881,     0,     0,     0,   882,
       0,     0,   883,     0,   884,     0,     0,     0,   149,   150,
     151,   152,     0,     0,     0,     0,   871,     0,     0,     0,
     872,     0,     0,     0,   873,     0,   885,   886,     0,     0,
     874,     0,     0,     0,   785,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   875,     0,     0,     0,
       0,   876,     0,     0,   877,     0,     0,     0,     0,   878,
       0,     0,   879,     0,     0,   880,   881,     0,     0,     0,
     882,     0,     0,   883,     0,   884,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    38,     0,     0,     0,     0,   885,   886,     0,
       0,     0,     0,     0,     0,     0,     0,    39,     0,     0,
       0,   788,     0,     0,   789,   790,     0,     0,     0,     0,
       0,     0,     0,    40,     0,     0,     0,     0,    41,     0,
      42,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   792,   793,     0,   887,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   794,
     795,     0,   788,     0,     0,   789,   790,     0,     0,     0,
       0,     0,     0,   888,     0,     0,   209,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   792,   793,     0,   887,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     794,   795,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   888,     0,     0,   209
};

static const yytype_int16 yycheck[] =
{
       1,    52,     3,   316,    30,    66,    52,   106,   319,   108,
     109,   393,    63,   112,   204,   114,   294,    63,   117,   118,
     284,   755,   121,   122,   123,   124,    52,   394,    66,   128,
     391,    30,   131,   132,   340,   392,  1198,    63,   346,   360,
     139,    30,   208,  1201,   360,    46,   722,   311,     1,   370,
     371,    32,   419,    54,   370,   371,  1214,    58,  1199,   416,
     360,  1200,   374,    52,  1090,  1091,  1288,  1049,  1156,   333,
    1096,  1193,   886,  1194,    63,  1464,   433,  1320,  1462,   390,
    1158,  1463,   758,   726,     7,   728,     4,  1271,  1272,     4,
       7,   767,    94,     7,     7,   771,  1444,   719,   796,    43,
    1473,   744,   745,    37,   747,   101,  1375,     5,   751,   752,
     859,    76,    77,   863,   123,  1296,  1441,    23,    23,   101,
      23,   100,     7,     8,     9,   721,     5,   178,    30,   722,
     101,   102,   103,   776,  1298,   122,   779,   101,    30,   720,
    1166,  1322,  1323,  1647,   857,   858,    87,    22,   111,    90,
      52,   685,   860,  1664,   861,    32,    33,  1663,  1745,   146,
      52,    63,   138,    48,   102,    50,    55,   281,   131,   156,
     281,    63,   142,    20,    59,   151,    20,   101,   204,    64,
      13,   144,   208,    68,   296,    55,   101,   162,    20,    55,
     101,   167,   167,   360,    82,   111,   131,   840,    55,   108,
     843,   111,    55,   370,   371,   101,   102,   103,   742,   159,
     360,     1,   101,   122,     4,   204,     6,   127,    47,   208,
     370,   371,   132,   133,    87,   100,   101,    90,   163,   164,
      82,   101,   293,   294,   122,   101,    26,    27,    28,    29,
     354,    60,   354,   354,   101,  1426,  1427,   298,    56,    55,
     319,  1373,     8,    86,   101,    47,   191,   101,   146,    56,
     329,  1442,    51,   280,   940,   316,   909,   910,  1855,   101,
     122,   280,    45,     1,   255,   111,     4,    96,     6,   296,
     261,   231,   232,   233,     4,   346,     6,    87,    30,   224,
     316,   127,   262,   263,   146,   101,    52,    87,    26,    27,
      28,    29,   204,   140,    94,  1809,   208,  1818,   145,    37,
      52,  1817,   204,    87,  1064,   937,   208,  1439,   282,   298,
     230,    63,   360,   159,   209,    87,   140,   316,   291,   245,
     246,   392,   370,   371,   360,   101,   387,  1459,   314,  1460,
     130,   387,   156,   939,   370,   371,    82,   940,   353,   448,
    1514,   402,   354,   279,   392,   416,   402,   938,   282,  1732,
     347,   387,     1,   359,   241,     4,   264,     6,   353,   295,
     109,   110,   433,  1721,   164,   345,   402,   359,   416,     1,
      82,   279,     4,   354,     6,   264,  1136,    26,    27,    28,
      29,  1067,  1068,  1718,   359,   433,   337,   295,   387,   354,
     279,    40,   300,    42,    26,    27,    28,    29,   293,   294,
     354,   108,   297,   402,   316,  1058,   295,    39,   354,  1062,
     354,   300,  1691,   359,   316,   122,  1175,  1549,  1071,  1072,
    1073,  1779,   355,  1076,  1512,  1078,  1134,   355,   355,   755,
    1829,   355,   355,  1827,   359,  1088,  1828,  1690,   354,   354,
    1264,  1635,  1777,   359,   359,  1677,   359,   355,    87,  1547,
    1173,  1174,   204,   359,  1645,    87,   208,    89,  1176,    91,
    1177,   271,    94,   273,   337,   265,   355,   352,  1121,     8,
    1123,  1124,   335,   336,   359,   387,    87,   124,     1,   111,
     354,     4,     8,     6,  1137,   387,  1139,   271,  1524,   273,
     402,    43,   241,   242,   810,  1148,   245,  1150,    24,   271,
     402,   273,   149,    26,    27,    28,    29,    82,   403,    84,
     124,   406,   331,    52,   409,   334,  1552,    40,   413,    42,
     338,   339,   340,   418,   129,     1,    52,   159,     4,   729,
       6,   338,   339,   340,   264,   149,   122,   337,   864,  1531,
      20,     1,    22,   127,     4,   863,     6,   131,   230,   279,
      26,    27,    28,    29,   864,   355,   142,   888,     1,     5,
     146,     4,     8,     6,   316,   295,    26,    27,    28,    29,
     300,   298,   299,   319,   320,   321,  1320,   230,   755,   163,
     164,   339,   908,    26,    27,    28,    29,  1331,   483,  1687,
    1762,     4,    30,     6,     7,   755,    39,  1765,   908,   337,
      37,    38,   330,  1289,   280,   927,   100,   319,   320,   321,
      75,    87,  1763,    79,    52,  1764,   100,   355,    94,     4,
     280,     6,   298,   299,   280,    63,   111,   354,   354,    95,
     279,  1375,   271,   359,   273,   387,   796,   100,  1291,  1292,
     100,    82,     5,   108,    87,     8,    89,   113,    91,   288,
     402,    94,     4,    38,   130,   230,    36,   122,  1311,     4,
     271,     6,   273,    43,  1317,    45,   337,    47,   111,     0,
      50,    51,    52,     4,    54,     6,   262,   263,   163,   164,
     857,   858,   859,   860,   861,   149,   862,   864,   164,   717,
     718,  1344,  1824,   729,  1825,   159,   160,   857,   858,   859,
     860,   861,   167,   313,   864,   337,   355,   755,  1361,     1,
    1363,   888,     4,    43,     6,   290,   159,    60,    61,   755,
     111,  1757,    65,   355,   715,    20,    43,    22,   888,   101,
     729,   908,    17,   124,    26,    27,    28,    29,    43,    44,
     131,    58,    59,    18,   181,   182,  1064,     1,   908,   358,
       4,    50,     6,   125,   126,   124,   279,    50,   149,   345,
     796,   131,    30,   214,   155,  1039,   204,   218,   219,   220,
     208,   140,    26,    27,    28,    29,     1,   163,   164,     4,
     149,     6,   354,   248,    52,     7,   155,   156,    22,   265,
     107,    25,   863,   163,   164,    63,   166,   354,    20,   116,
      22,    26,    27,    28,    29,   122,   104,   105,   106,   101,
     102,   103,  1848,  1128,  1129,    55,   864,   729,  1136,   354,
    1135,   857,   858,   859,   860,   861,   862,   729,   864,   146,
     354,     1,   355,    87,     4,  1151,     6,   354,   298,   299,
      94,  1172,   213,   214,   215,   216,   217,  1178,   281,  1180,
    1181,   354,   888,    43,  1507,    43,    26,    27,    28,    29,
     908,   337,    43,   862,    30,     7,    15,    16,  1521,   241,
    1070,     8,   908,   351,   352,   100,   130,   337,   316,   355,
     101,    83,    84,    85,   264,    87,    52,   360,  1541,   261,
     262,   360,   159,   100,   337,   355,   330,    63,     1,   279,
     330,     4,   913,     6,   348,   916,   934,   935,   936,   357,
     164,    82,   355,    30,    23,   295,  1404,  1405,  1406,  1407,
     300,   949,   302,    26,    27,    28,    29,    76,    77,    78,
      23,   101,   102,   103,    50,    52,   204,    40,    50,    42,
     208,   281,   282,    92,    93,    94,    63,  1691,    50,   387,
     862,    15,    16,   102,    50,   850,  1156,   100,  1158,   854,
     862,   110,   111,    50,   402,   298,   299,   116,  1128,  1129,
    1130,  1131,  1132,   279,  1134,  1135,    82,   729,   284,   285,
     354,  1304,   100,  1143,  1144,   109,   110,   111,   137,   138,
      15,    16,   141,  1064,   300,  1172,  1173,  1174,  1175,  1176,
    1177,  1178,   100,  1180,  1181,  1331,   307,   308,   309,   310,
     311,   265,  1172,  1173,  1174,  1175,  1176,  1177,  1178,   100,
    1180,  1181,   100,   290,   291,   292,   293,   294,   113,   100,
       1,    82,  1685,     4,  1070,     6,    82,   111,   204,   113,
     114,   115,   208,   128,    30,   337,    15,    16,   316,  1375,
      17,  1374,  1368,    18,  1370,    26,    27,    28,    29,   134,
     135,   136,   137,   355,   149,  1136,    52,   338,   339,   340,
     155,  1070,   225,   298,   299,   298,   299,    63,  1566,  1567,
    1568,   234,   235,   337,   358,   238,   239,   204,  1136,   109,
     110,   208,  1128,  1129,  1130,  1131,  1132,     5,  1134,  1135,
       1,   355,     4,     4,     6,     6,     8,  1143,  1144,     7,
     862,   100,   337,    76,    77,    78,    79,    80,    81,   387,
    1156,   315,  1158,     4,     5,    26,    27,    28,    29,     7,
     355,  1192,   109,   110,   402,     7,  1172,  1173,  1174,  1175,
    1176,  1177,  1178,  1320,  1180,  1181,     7,  1833,  1834,   100,
     316,   236,   237,     5,  1331,   354,  1192,  1156,  1070,  1158,
    1320,     7,    58,    59,   323,   324,   325,   337,  1070,     7,
    1562,  1331,   111,    94,   113,     7,   279,    17,  1189,  1190,
    1191,  1192,  1193,  1194,     4,   355,     6,  1564,     8,    18,
    1561,   358,   131,  1192,   360,   109,   110,     8,  1375,   316,
     139,   140,    37,   142,   370,   371,   127,   100,   122,   100,
     111,   107,   281,   152,   153,  1375,   130,   296,   204,   354,
     116,   387,   208,  1590,   324,   325,   122,  1190,  1191,  1192,
    1193,  1194,   146,   109,   110,  1523,   402,   100,  1559,   209,
     210,   211,   212,  1304,  1156,   100,  1158,    92,    93,  1616,
     146,   100,   355,   354,  1156,   354,  1158,  1569,  1570,  1571,
    1572,   100,   183,   184,   185,   186,   187,   188,  1304,   100,
     387,   354,  1333,  1284,   354,  1286,  1287,  1333,  1289,   100,
    1192,    41,    42,  1331,  1320,   402,   101,   102,   103,     1,
    1192,   729,     4,   354,     6,  1331,   218,  1333,   447,    12,
      97,    98,    99,   100,   221,  1304,   319,   320,   321,   221,
     281,   222,  1512,  1374,    26,    27,    28,    29,  1070,   223,
     100,  1284,  1333,  1286,  1287,   222,  1289,   100,  1143,  1144,
     316,   100,   481,   100,  1333,   331,   100,   354,  1374,  1375,
     354,   100,  1413,   354,  1667,     1,   100,  1547,     4,     8,
       6,   265,   266,   267,   268,     5,   100,   100,    71,    50,
     100,    41,    75,   145,   265,  1691,   337,   281,   282,   283,
      26,    27,    28,    29,   111,  1374,   111,    90,    91,    91,
      68,   111,     5,   357,   355,   100,    82,     8,  1424,  1701,
    1702,  1703,  1304,    82,   107,   357,   100,  1458,   354,   354,
    1411,   387,  1304,     7,  1156,  1441,  1158,   354,  1419,  1420,
    1421,  1422,  1423,     7,   100,  1424,   402,   361,   130,   361,
     282,  1333,  1458,   136,   862,  1424,  1437,  1438,  1439,    43,
     143,  1333,  1441,   100,     5,    91,   337,   101,  1449,  1450,
    1192,   354,  1441,   301,    58,    59,  1457,  1458,  1459,  1460,
      41,  1522,  1523,   281,   355,     1,     7,   101,     4,  1458,
       6,   729,  1374,   296,   101,   101,     5,   161,  1479,  1480,
    1481,   100,  1374,    38,   130,   101,  1512,   101,    96,   353,
      26,    27,    28,    29,   100,   184,   353,  1687,   101,   353,
     100,   100,   100,   107,  1457,  1458,  1459,  1460,   100,   355,
     100,   297,   116,  1398,  1399,  1400,  1401,   100,   122,    82,
       5,  1547,  1424,  1512,  1691,   100,  1479,  1480,  1481,  1590,
     182,   355,  1424,   111,  1535,    40,     7,   147,   353,  1441,
    1639,  1691,   146,   100,   122,   297,   124,   100,   102,  1441,
    1649,   100,  1590,   282,   100,  1616,  1458,  1656,  1547,   355,
     181,  1622,  1304,   265,   142,   354,  1458,   101,   146,   354,
      44,   149,    46,   729,    48,    49,   354,   354,  1616,   354,
     354,   354,    56,    57,   100,  1586,   354,  1588,  1589,   354,
      43,  1333,   354,   130,   355,   355,   100,   100,   354,   755,
     100,  1602,   101,   354,   862,    58,    59,  1608,   354,   281,
    1512,   353,   100,   100,  1615,    89,  1667,  1618,     5,   265,
    1512,     1,   729,   100,     4,    20,     6,  1628,  1629,  1630,
    1197,     1,  1374,  1445,     4,   337,     6,  1522,  1523,  1716,
    1872,  1667,  1070,  1848,   389,  1547,    26,    27,    28,    29,
    1714,   229,  1769,   355,   107,  1547,    26,    27,    28,    29,
    1770,  1687,  1723,   116,  1725,  1691,  1771,  1761,  1772,   122,
      40,  1836,    42,    89,  1400,  1628,  1629,  1630,  1667,   386,
      91,  1373,  1424,  1709,   262,   263,   764,  1552,   772,  1499,
    1536,   337,  1718,   146,  1695,   831,   303,   388,  1687,  1441,
    1760,   857,   858,   859,   860,   861,   862,  1132,   864,   355,
    1709,  1130,  1821,  1131,  1149,   846,  1458,  1154,   286,  1718,
    1709,   855,   968,  1724,  1181,  1726,   204,  1096,  1156,  1718,
    1158,  1329,   888,  1305,  1325,  1736,  1737,  1738,  1739,  1740,
    1741,  1742,   371,  1744,   400,   398,   401,   119,  1881,   399,
     298,  1777,   908,   729,   299,   862,   299,   622,   360,   985,
     296,  1003,    -1,    -1,  1192,  1667,    -1,   345,    -1,    -1,
    1512,    -1,  1823,  1834,    -1,  1667,    -1,  1778,  1777,  1780,
    1781,  1782,  1783,  1784,    -1,  1687,    -1,  1848,  1777,    -1,
      -1,    -1,    -1,    -1,    -1,  1687,    -1,  1823,    -1,    -1,
      -1,   337,    -1,    -1,    -1,  1547,    -1,  1709,    -1,    -1,
      -1,  1872,  1070,    -1,    -1,     1,  1718,  1709,     4,   355,
       6,  1822,  1823,  1824,  1825,   111,  1718,   113,    -1,  1830,
    1831,  1832,  1833,    -1,  1823,    -1,  1837,    -1,  1839,    -1,
      26,    27,    28,    29,    -1,   131,    -1,    -1,    -1,    -1,
      -1,    37,  1853,   139,   140,   141,   142,  1858,  1859,  1860,
    1861,  1862,  1863,  1864,  1865,  1866,  1867,  1868,  1869,  1822,
    1823,  1824,  1825,    -1,    -1,  1777,  1304,  1830,  1831,  1832,
    1833,  1882,    -1,    -1,    -1,  1777,   862,    -1,    -1,  1890,
    1891,  1892,    -1,    39,    40,    41,    42,    -1,  1156,    -1,
    1158,   281,    -1,    -1,    -1,  1333,    -1,    -1,  1092,   279,
    1863,  1864,  1865,    -1,  1070,    -1,    -1,    43,    -1,    45,
      -1,  1823,    -1,    -1,    50,  1667,    52,    73,    -1,    -1,
      56,  1823,    -1,    -1,  1192,    81,    82,    83,    84,    -1,
      -1,    -1,    88,    -1,    -1,  1687,  1374,    -1,    -1,    -1,
      -1,    97,    98,    99,   100,    -1,    -1,   337,   104,    -1,
      -1,    -1,    -1,  1070,    -1,     1,    -1,  1709,     4,    95,
       6,    97,    -1,    -1,   120,   355,  1718,    -1,    -1,   125,
     126,   127,    -1,    -1,   130,   355,    -1,   133,    -1,    -1,
      26,    27,    28,    29,    -1,    -1,  1424,    -1,    -1,    82,
    1156,    84,  1158,    -1,    -1,    -1,  1190,  1191,  1192,  1193,
    1194,    -1,    -1,  1441,    -1,    -1,  1172,  1173,  1174,  1175,
    1176,  1177,  1178,    -1,  1180,  1181,   109,   110,     1,    -1,
    1458,     4,    -1,     6,     1,  1777,  1192,     4,    -1,     6,
     123,    -1,   125,   126,   127,     1,  1304,    -1,     4,  1156,
       6,  1158,    -1,    26,    27,    28,    29,    -1,    -1,    26,
      27,    28,    29,    -1,    -1,   148,   149,   150,   109,   110,
      26,    27,    28,    29,    -1,  1333,   117,   118,   119,   120,
     121,  1823,    -1,    39,  1512,  1192,    -1,    -1,    -1,    -1,
      -1,    -1,    43,    -1,  1070,    43,    -1,    -1,    -1,    -1,
    1284,     1,  1286,  1287,     4,  1289,     6,    58,    59,    -1,
      58,    59,    -1,    -1,    -1,    -1,  1374,    -1,    91,  1547,
      -1,   267,   268,   269,    -1,    -1,    26,    27,    28,    29,
      86,    87,    88,    89,    -1,    91,    -1,    84,    94,    -1,
      -1,  1325,    -1,    -1,   111,    -1,    -1,   230,  1304,    -1,
      -1,   337,    -1,    -1,   101,   111,   107,   130,    -1,   107,
      -1,    -1,    -1,    -1,  1320,   116,  1424,    -1,   116,   355,
      -1,   122,    -1,    -1,   122,  1331,    -1,  1333,   125,   126,
    1156,    -1,  1158,  1441,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   146,    -1,  1304,   146,    -1,
    1458,    -1,    -1,   159,    -1,    -1,    -1,   290,    -1,    -1,
      -1,   111,    -1,    -1,    -1,    -1,  1192,    -1,  1374,  1375,
      -1,   108,   109,    -1,    -1,   112,  1333,   114,    -1,    -1,
     117,   118,    -1,    -1,   121,   122,   123,   124,    -1,  1667,
      -1,   128,    -1,    -1,   131,   132,    -1,    43,    -1,   395,
     396,   397,   139,    -1,  1512,    -1,    -1,    -1,    -1,  1687,
     296,    -1,    58,    59,    -1,    -1,    -1,  1374,  1424,    -1,
      -1,    -1,    -1,  1457,  1458,  1459,  1460,    -1,   424,    -1,
      -1,  1709,    -1,    -1,    -1,  1441,    -1,    -1,    -1,  1547,
    1718,    -1,   265,    -1,   241,  1479,  1480,  1481,   265,    -1,
      -1,   337,  1458,    -1,    -1,    -1,    -1,    -1,   264,   455,
      -1,   107,    -1,    -1,   261,   262,    -1,  1424,    -1,   355,
     116,    -1,    -1,   279,    -1,    -1,   122,    -1,  1304,    -1,
      -1,    -1,   279,    -1,  1441,    -1,    -1,    -1,    -1,   295,
      -1,    -1,    -1,    -1,   300,    -1,    -1,    43,   295,  1777,
     146,  1458,    -1,   300,    -1,   302,  1512,  1333,    -1,    -1,
      -1,    -1,    58,    59,   337,   265,    -1,    -1,    -1,    -1,
     337,    36,    -1,    -1,    -1,    -1,    -1,    -1,    43,    -1,
      45,   337,   355,    -1,    -1,    50,    51,    52,   355,    54,
      -1,  1547,    -1,    -1,    -1,  1823,    -1,    -1,  1374,   355,
      -1,    -1,    -1,     1,    -1,  1512,    -1,    -1,    -1,  1667,
      -1,   107,    -1,    11,    12,    13,    14,    15,    16,    17,
     116,    -1,    20,    -1,    -1,    -1,   122,    -1,    -1,  1687,
      -1,    -1,    -1,    -1,    -1,    -1,     1,   337,    -1,     4,
    1547,     6,    -1,    -1,  1628,  1629,  1630,    -1,  1424,    -1,
     146,  1709,    -1,    -1,    -1,   355,    -1,    -1,    -1,    -1,
    1718,    26,    27,    28,    29,  1441,    -1,    -1,    -1,    43,
      -1,    -1,    -1,    71,    39,    -1,    74,    75,    76,    77,
      78,    79,  1458,    -1,    58,    59,    -1,    -1,    86,    -1,
      88,    89,    90,    91,    92,    93,    94,    95,    -1,    97,
      98,    99,   100,    -1,   102,    -1,    -1,   105,    -1,   107,
      -1,  1667,   110,   111,    -1,   113,    -1,    -1,   116,  1777,
      -1,    86,    87,    88,    89,    -1,    91,    -1,    -1,    94,
      -1,  1687,    -1,   107,    -1,  1691,  1512,   135,   136,   137,
     138,    -1,   116,   141,    -1,   143,   111,    -1,   122,    -1,
      -1,    -1,    -1,  1709,    -1,    -1,    -1,    -1,    -1,    -1,
    1667,   448,  1718,    -1,    -1,  1823,    -1,    -1,    -1,    -1,
      -1,  1547,   146,    -1,    36,    68,    -1,    -1,    -1,    -1,
    1687,    43,    -1,    45,    -1,    47,    -1,    -1,    50,    51,
      52,    -1,    54,    -1,   159,    -1,    58,    59,    -1,   264,
      -1,    -1,  1709,    -1,    -1,    -1,    -1,    -1,   101,   102,
     103,  1718,    -1,    -1,   279,   108,    -1,    -1,    -1,   112,
      -1,  1777,    -1,   116,    -1,    -1,    -1,    -1,    -1,   122,
     295,    -1,    -1,   126,    -1,   300,    -1,   302,  1822,  1823,
    1824,  1825,    -1,    -1,    -1,   107,  1830,  1831,  1832,  1833,
      -1,    -1,    -1,   146,   116,    37,    -1,    -1,    -1,    -1,
     122,    -1,    -1,    -1,    -1,    -1,    -1,  1823,     1,    -1,
    1777,     4,    -1,     6,    -1,    -1,    -1,    -1,    -1,  1863,
    1864,  1865,    -1,    -1,   146,    -1,    -1,    -1,    -1,    -1,
      23,  1667,    -1,    26,    27,    28,    29,    30,    31,   264,
      -1,    34,    35,    36,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1687,    -1,    -1,   279,    -1,  1823,    50,   100,    -1,
     109,   110,    -1,    -1,    -1,    -1,    -1,    60,    61,    -1,
     295,    -1,    65,  1709,   123,   300,   125,   126,   127,    -1,
      -1,    -1,  1718,    76,    77,    78,    79,    80,    81,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,   148,
     149,   150,    95,    -1,    97,    -1,    -1,   100,   101,   102,
     103,    -1,   337,   106,    -1,   108,    -1,    -1,   111,   112,
      -1,   274,    -1,   116,   277,   278,    -1,    -1,   170,   122,
     355,   173,   174,   175,   176,   177,   178,   179,   180,   181,
     182,  1777,   264,    -1,    -1,   138,    -1,    -1,    -1,    -1,
     143,    -1,    -1,   146,    -1,    -1,    -1,   279,   151,    -1,
      -1,   154,   315,   316,   157,   158,   159,    -1,    -1,   162,
      -1,    -1,   165,   295,   167,    -1,    -1,    -1,   300,    -1,
     302,    -1,   440,    -1,    -1,    -1,    -1,  1823,    -1,   447,
      -1,    -1,    -1,    -1,    -1,    -1,   189,   190,    -1,   457,
      -1,   459,    -1,   461,    -1,   463,   359,    -1,    -1,    -1,
     468,    -1,    -1,   471,    -1,   473,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   481,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   225,   226,   227,   228,    -1,    -1,    -1,    -1,
      -1,   234,   235,    -1,    -1,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,    -1,
      -1,   264,    -1,   109,   110,    -1,    -1,   113,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   279,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   289,    -1,    -1,    -1,
      -1,    -1,   295,    -1,    -1,    -1,    -1,   300,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   309,   310,    -1,   312,
      -1,    -1,   315,   316,   317,   318,    -1,    -1,    -1,   322,
      -1,    -1,    -1,   326,   327,   328,   172,    -1,    -1,   332,
     333,    -1,    -1,    -1,   337,    -1,    -1,    -1,   341,    -1,
       1,   344,   345,     4,    -1,     6,    -1,    -1,    -1,    -1,
      -1,   354,   355,   356,   131,    -1,   359,    -1,    23,    -1,
      -1,    -1,    23,   140,    -1,    26,    27,    28,    29,    30,
      31,    -1,    37,    34,    35,    36,    -1,    -1,   155,    -1,
      -1,    -1,   159,    -1,    -1,     1,   163,   164,     4,    50,
       6,   168,   169,   170,   171,   172,    -1,    -1,    -1,    60,
      61,    -1,    -1,    -1,    65,    -1,    -1,    -1,    -1,    -1,
      26,    27,    28,    29,    -1,    76,    77,    78,    79,    80,
      81,    -1,    -1,    39,    -1,    -1,    -1,    -1,    -1,    -1,
      91,    -1,    -1,    -1,    95,   100,    97,    -1,    -1,   100,
     101,   102,   103,    -1,    -1,   106,    -1,   108,    -1,    -1,
     111,   112,    -1,    -1,    -1,   116,    -1,    -1,    -1,    -1,
      -1,   122,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    87,    -1,    89,    -1,    91,    -1,   138,    94,    -1,
      -1,    -1,   143,    -1,    -1,   146,    -1,    -1,    -1,    -1,
     151,    -1,    -1,   154,    -1,   111,   157,   158,   159,    -1,
      -1,   162,    -1,    -1,   165,   170,   167,    -1,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   189,   190,
      -1,    -1,    -1,    -1,     1,    -1,    -1,     4,    -1,     6,
      -1,    -1,    -1,   159,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    26,
      27,    28,    29,    -1,   225,   226,   227,   228,    -1,    -1,
      -1,    -1,    39,   234,   235,    -1,    -1,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,    -1,    -1,   264,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   279,    86,
      87,    88,    89,    -1,    91,    -1,    -1,    94,   289,    -1,
      -1,    -1,    -1,    -1,   295,    -1,    -1,    -1,    -1,   300,
      -1,    -1,    -1,    -1,   111,    -1,    -1,    -1,   309,   310,
      -1,   312,    -1,    -1,   315,   316,   317,   318,    -1,    -1,
      -1,   322,    -1,    -1,    -1,   326,   327,   328,    -1,    -1,
      -1,   332,   333,    -1,     1,    -1,   337,     4,    -1,     6,
     341,    -1,    -1,   344,   345,    -1,   954,   955,   956,    -1,
      -1,    -1,   159,   354,   355,   356,    23,    -1,   359,    26,
      27,    28,    29,    30,    31,    -1,    -1,    34,    35,    36,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   337,    -1,    50,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    60,    61,    -1,    -1,    -1,    65,   355,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    76,
      77,    78,    79,    80,    81,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    -1,    -1,    -1,    95,    -1,
      97,    -1,    -1,   100,   101,   102,   103,    -1,    -1,   106,
      -1,   108,    -1,    -1,   111,   112,    -1,    -1,    -1,   116,
      -1,    -1,    -1,    -1,    -1,   122,    -1,   264,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   138,   279,    -1,    -1,    -1,   143,    -1,    -1,   146,
      -1,    -1,    -1,    -1,   151,   176,    -1,   154,   295,    -1,
     157,   158,   159,   300,    -1,   162,    -1,    -1,   165,    -1,
     167,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,    -1,    -1,
      -1,    -1,   189,   190,    -1,    -1,    -1,    -1,    -1,    -1,
     337,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   355,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   225,   226,
     227,   228,    -1,    -1,    -1,    -1,    -1,   234,   235,    -1,
      -1,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,    -1,    -1,   264,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   279,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   289,    -1,    -1,    -1,    -1,    -1,   295,    -1,
      -1,    -1,    -1,   300,    -1,    -1,    -1,     4,    -1,     6,
      -1,    -1,   309,   310,    -1,   312,    -1,    -1,   315,   316,
     317,   318,    -1,    -1,    -1,   322,    23,    -1,    -1,   326,
     327,   328,    -1,    30,    31,   332,   333,    34,    35,    36,
     337,    -1,    -1,    -1,   341,    -1,    -1,   344,   345,    -1,
      -1,    -1,    -1,    50,    -1,    -1,    -1,   354,   355,   356,
      -1,    -1,   359,    60,    61,    -1,    -1,    -1,    65,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    76,
      77,    78,    79,    80,    81,    -1,    82,    -1,    84,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    -1,
      97,    -1,    -1,   100,   101,   102,   103,    -1,    -1,   106,
      -1,   108,    -1,   109,   110,   112,    -1,   113,    -1,   116,
      -1,    -1,    -1,    -1,    -1,   122,    -1,   123,   124,   125,
     126,   127,   128,   129,   130,   131,    -1,    -1,    -1,    -1,
      -1,   138,    -1,    -1,    -1,    -1,   143,    -1,    -1,   146,
      -1,    -1,    -1,    -1,   151,    -1,    -1,   154,    -1,    -1,
     157,   158,    -1,    -1,    -1,   162,    -1,    -1,   165,    -1,
     167,    -1,    -1,    -1,    -1,    -1,   172,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   189,   190,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   225,   226,
     227,   228,    -1,    -1,   230,    -1,    -1,   234,   235,    -1,
      -1,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,    -1,    -1,   264,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     5,    -1,    -1,    -1,    -1,
      -1,    -1,   279,    -1,    87,    -1,    -1,    -1,    -1,    -1,
      -1,    21,   289,    23,   290,    -1,    -1,    -1,   295,    -1,
      -1,    31,    -1,   300,    -1,    35,   109,   110,    -1,    -1,
     113,    -1,   309,   310,    -1,   312,    -1,    -1,   315,   316,
     317,   318,    -1,    -1,    -1,   322,    -1,   130,    -1,   326,
     327,   328,    -1,    -1,    -1,   332,   333,    -1,    68,    -1,
      -1,    -1,    -1,    -1,   341,    -1,    -1,   344,   345,    -1,
      -1,    -1,    82,    -1,    84,    -1,    -1,   354,   355,   356,
      -1,    -1,   359,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     100,   101,   102,   103,    -1,    -1,   106,    -1,   108,    -1,
      -1,   184,   112,    -1,    -1,    -1,   116,    -1,    -1,    -1,
      -1,    -1,   122,    -1,    -1,    -1,   126,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   138,    -1,
      -1,    -1,    -1,   143,    -1,    -1,   146,    -1,    -1,    -1,
      -1,   151,    -1,    -1,   154,    -1,    -1,   157,   158,    -1,
      -1,    -1,   162,    -1,    -1,   165,    -1,   167,   241,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   189,
     190,    -1,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,    36,    -1,   281,   282,
     283,    -1,    -1,    43,    44,    45,    46,    -1,    -1,    49,
      50,    -1,    52,    53,    54,   225,    56,    -1,    -1,   302,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,    -1,    -1,   264,    95,     5,    97,    98,    99,
      -1,    -1,    -1,    -1,   274,    -1,    -1,   277,   278,    -1,
      -1,    -1,    21,    -1,    23,    -1,    -1,    -1,    -1,    -1,
     290,    -1,    31,    -1,    -1,    -1,    35,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   309,
     310,    -1,    -1,    -1,    -1,   315,   316,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   328,    68,
      -1,    -1,   332,   333,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   342,   343,    -1,   345,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   356,    -1,    -1,   359,
      -1,   100,   101,   102,   103,    -1,    -1,   106,    -1,   108,
      -1,    -1,    -1,   112,    -1,    -1,    -1,   116,    -1,    -1,
      -1,    -1,    -1,   122,    -1,    -1,    -1,   126,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   138,
      -1,    -1,    -1,    -1,   143,    -1,    -1,   146,    -1,    -1,
      -1,    -1,   151,    -1,    -1,   154,    -1,    -1,   157,   158,
      -1,    -1,    -1,   162,    -1,    -1,   165,    -1,   167,    -1,
      -1,    -1,    -1,    -1,   264,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   279,
     189,   190,    -1,    -1,   284,   285,   286,   287,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   295,    -1,    -1,    -1,    -1,
     300,    -1,   302,   303,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   225,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,    -1,    -1,   264,    -1,     5,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   274,    -1,    -1,   277,   278,
      -1,    -1,    -1,    21,    -1,    23,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    31,    -1,    -1,    -1,    35,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     309,   310,    -1,    -1,    -1,    -1,   315,   316,    -1,    -1,
      -1,    -1,    -1,   101,    -1,    -1,    -1,    -1,    -1,   328,
      68,    -1,    -1,   332,   333,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   342,   343,    -1,   345,    -1,    -1,   127,
      -1,    -1,   130,    -1,    -1,    -1,    -1,   356,    -1,    -1,
     359,    -1,   100,   101,   102,   103,    -1,    -1,   106,   147,
     108,    -1,    -1,    -1,   112,    -1,    -1,    -1,   116,    -1,
      -1,    -1,    -1,    -1,   122,    -1,    -1,    -1,   126,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     138,    -1,    -1,    -1,    -1,   143,    -1,    -1,   146,    -1,
      -1,    -1,    -1,   151,    -1,    -1,   154,    -1,    -1,   157,
     158,    -1,    -1,    -1,   162,    -1,    -1,   165,    -1,   167,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   189,   190,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,    -1,    -1,    -1,   225,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   302,    -1,   264,    -1,     5,    -1,
      -1,   309,   310,    -1,    -1,    -1,   274,    -1,    -1,   277,
     278,   319,    -1,    -1,    21,    -1,    23,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    31,    -1,    -1,    -1,    35,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   345,    -1,    -1,
      -1,   309,   310,    -1,    -1,    -1,    -1,   315,   316,    -1,
      -1,    -1,    -1,    -1,   101,    -1,    -1,    -1,    -1,    -1,
     328,    68,    -1,    -1,   332,   333,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   342,   343,    -1,   345,    -1,    -1,
     127,    -1,    -1,   130,    -1,    -1,    -1,    -1,   356,    -1,
      -1,   359,    -1,   100,   101,   102,   103,    -1,    -1,   106,
     147,   108,    -1,    -1,    -1,   112,    -1,    -1,    -1,   116,
      -1,    -1,    -1,    -1,    -1,   122,    -1,    -1,    -1,   126,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   138,    -1,    -1,    -1,    -1,   143,    -1,    -1,   146,
      -1,    -1,    -1,    -1,   151,    -1,    -1,   154,    -1,    -1,
     157,   158,    -1,    -1,    -1,   162,    -1,    -1,   165,    -1,
     167,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   189,   190,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,    -1,    -1,    -1,   225,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   302,    -1,   264,    -1,     5,
      -1,    -1,   309,   310,    -1,    -1,    -1,   274,    -1,    -1,
     277,   278,   319,    -1,    -1,    21,    -1,    23,    -1,     1,
      -1,    -1,     4,    -1,     6,    31,    -1,    -1,    -1,    35,
      -1,    -1,    -1,    -1,    -1,    -1,   109,   110,   345,    -1,
     113,    -1,   309,   310,    26,    27,    28,    29,   315,   316,
      -1,    -1,    -1,    -1,    36,    -1,    -1,   130,    -1,    -1,
      -1,   328,    68,    45,    -1,   332,   333,    -1,    50,    -1,
      52,    -1,    54,    -1,    -1,   342,   343,    -1,   345,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   356,
      -1,    -1,   359,    -1,   100,   101,   102,   103,    -1,    -1,
     106,    -1,   108,    -1,    -1,    -1,   112,    -1,    -1,    -1,
     116,    -1,    -1,    -1,    -1,    -1,   122,    -1,    -1,    -1,
     126,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   138,    -1,    -1,    -1,    -1,   143,     1,    -1,
     146,     4,    -1,     6,    -1,   151,    -1,    -1,   154,    -1,
      -1,   157,   158,    -1,    -1,    -1,   162,    -1,    -1,   165,
      -1,   167,    -1,    26,    27,    28,    29,    -1,   241,    -1,
      -1,    -1,    -1,    36,    -1,    -1,    -1,   159,    -1,    -1,
      -1,    -1,    45,   189,   190,    -1,    -1,    50,    -1,    52,
      -1,    54,   265,   266,   267,   268,   269,   270,    -1,   272,
     273,   274,   275,   276,   277,   278,    -1,    -1,   281,   282,
     283,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   225,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   302,
      -1,    -1,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,    -1,    -1,   264,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   274,    -1,
      -1,   277,   278,     9,    10,    11,    12,    13,    14,    -1,
      -1,    -1,   264,    -1,    -1,    21,    -1,    23,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   159,   279,    -1,    -1,
      -1,    -1,    -1,   309,   310,    -1,    -1,    -1,    -1,   315,
     316,    -1,    -1,   295,    -1,    -1,    -1,    -1,   300,    -1,
     302,    -1,   328,    -1,    -1,    -1,   332,   333,    -1,    -1,
      -1,    -1,    68,    -1,    -1,    -1,   342,   343,    -1,   345,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     356,    -1,    -1,   359,    -1,   337,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   100,   101,   102,   103,    -1,    -1,
      -1,    -1,   108,   355,    -1,    -1,   112,    -1,    -1,    -1,
     116,    -1,    -1,    -1,    -1,    -1,   122,    -1,    -1,    -1,
     126,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   264,   138,    -1,    -1,    -1,    -1,   143,    -1,    -1,
     146,    -1,    -1,    -1,    -1,   151,   279,    -1,   154,    -1,
      -1,   157,   158,    -1,    -1,    -1,   162,    -1,    21,   165,
      23,   167,   295,    -1,    -1,    -1,    -1,   300,    31,   302,
      -1,    -1,    35,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   189,   190,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   337,    68,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   355,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,
     103,    -1,    -1,   106,    -1,   108,    -1,    -1,    -1,   112,
      -1,    -1,    -1,   116,    -1,    -1,    -1,    -1,    -1,   122,
      -1,    -1,    -1,   126,    -1,    -1,    -1,    -1,   274,    -1,
      -1,   277,   278,    -1,    -1,   138,    -1,    -1,    -1,    -1,
     143,    -1,    -1,   146,    -1,    -1,    -1,    -1,   151,    -1,
      -1,   154,    -1,    -1,   157,   158,    -1,    -1,    -1,   162,
      -1,    -1,   165,    -1,   167,    -1,    -1,    -1,    -1,   315,
     316,    -1,   318,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   189,   190,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   342,   343,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   354,    -1,
     356,    -1,    -1,   359,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   225,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,    -1,
      -1,   264,    -1,    -1,    21,    22,    23,    -1,    -1,    -1,
      -1,   274,    -1,    -1,   277,   278,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   309,   310,    -1,    -1,
      -1,    68,   315,   316,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   328,    -1,    -1,    -1,   332,
     333,    -1,    -1,    -1,    -1,    21,    -1,    23,    -1,   342,
     343,    -1,   345,   100,   101,   102,   103,    -1,    -1,    -1,
      -1,   108,    -1,   356,    -1,   112,   359,    -1,    -1,   116,
      -1,    -1,    -1,    -1,    -1,   122,    -1,    -1,    -1,   126,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   138,    68,    -1,    -1,    -1,   143,    -1,    -1,   146,
      -1,    -1,    -1,    -1,   151,    -1,    -1,   154,    -1,    -1,
     157,   158,    -1,    -1,    -1,   162,    21,    -1,   165,    -1,
     167,    -1,    -1,    -1,   100,   101,   102,   103,    -1,    -1,
      -1,    -1,   108,    -1,    -1,    -1,   112,    -1,    -1,    -1,
     116,    -1,   189,   190,    -1,    -1,   122,    -1,    -1,    -1,
     126,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   138,    68,    -1,    -1,    -1,   143,    -1,    -1,
     146,    -1,    -1,    -1,    -1,   151,    -1,    -1,   154,    -1,
      -1,   157,   158,    -1,    -1,    -1,   162,    -1,    -1,   165,
      -1,   167,    -1,    -1,    -1,   100,   101,   102,   103,    -1,
      -1,    -1,    -1,   108,    -1,    -1,    -1,   112,    -1,    -1,
      -1,   116,    -1,   189,   190,    -1,    -1,   122,    -1,    -1,
      -1,   126,    -1,    -1,    -1,    -1,    -1,   274,    -1,    -1,
     277,   278,    -1,   138,    -1,    -1,    -1,    -1,   143,    -1,
      -1,   146,    -1,    -1,    -1,    -1,   151,    -1,    -1,   154,
      -1,    -1,   157,   158,    -1,    -1,    -1,   162,    -1,    -1,
     165,    -1,   167,    -1,    -1,    -1,    -1,    -1,   315,   316,
      -1,   318,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   189,   190,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   342,   343,    -1,   274,    -1,
      -1,   277,   278,    -1,    -1,    -1,    -1,   354,    -1,   356,
      -1,    21,   359,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   315,
     316,    -1,   318,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    68,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   342,   343,    -1,   274,
      -1,    -1,   277,   278,    -1,    -1,    -1,    -1,   354,    -1,
     356,    -1,    -1,   359,    -1,    -1,    -1,    -1,    -1,    -1,
     100,   101,   102,   103,    -1,    -1,    -1,    -1,   108,    -1,
      -1,    -1,   112,    -1,    -1,    -1,   116,    -1,    -1,    -1,
     315,   316,   122,   318,    -1,    -1,   126,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   138,    -1,
      -1,    -1,    -1,   143,    -1,    -1,   146,   342,   343,    -1,
      -1,   151,    -1,    -1,   154,    -1,    -1,   157,   158,   354,
      -1,   356,   162,    -1,   359,   165,    23,   167,    -1,    -1,
      -1,    -1,    -1,    30,    31,    -1,    -1,    34,    35,    36,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   189,
     190,    -1,    -1,    50,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    60,    61,    -1,    -1,    -1,    65,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    76,
      77,    78,    79,    80,    81,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    -1,
      97,    -1,    -1,   100,   101,   102,   103,    -1,    -1,   106,
      -1,   108,    -1,    -1,    -1,   112,    -1,    -1,    -1,   116,
      -1,    -1,    -1,    -1,    -1,   122,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   274,    -1,    -1,   277,   278,    -1,
      -1,   138,    -1,    -1,    -1,    -1,   143,    -1,    -1,   146,
      -1,    -1,    -1,    -1,   151,    -1,    -1,   154,    -1,    -1,
     157,   158,    -1,    -1,    -1,   162,    -1,    -1,   165,    -1,
     167,    -1,    -1,    -1,    -1,   315,   316,    -1,   318,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   189,   190,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   342,   343,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   356,    -1,    -1,   359,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   225,   226,
     227,   228,    -1,    -1,    -1,    -1,    -1,   234,   235,    -1,
      -1,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,    -1,    -1,   264,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   279,    -1,    -1,    -1,    -1,    23,    -1,    -1,
      -1,    -1,   289,    -1,    30,    31,    -1,    -1,   295,    35,
      -1,    -1,    -1,   300,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   309,   310,    -1,   312,    -1,    -1,   315,   316,
     317,   318,    -1,    -1,    -1,   322,    -1,    -1,    -1,   326,
     327,   328,    -1,    -1,    -1,   332,   333,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   341,    -1,    -1,   344,   345,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   354,    -1,   356,
      -1,    -1,   359,    -1,   100,   101,   102,   103,    -1,    -1,
     106,    -1,   108,    -1,    -1,    -1,   112,    -1,    -1,    -1,
     116,    -1,    -1,    -1,    -1,    -1,   122,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   138,    -1,    -1,    -1,    -1,   143,    -1,    -1,
     146,    -1,    -1,    -1,    -1,   151,    -1,    -1,   154,    -1,
      -1,   157,   158,    -1,    -1,    -1,   162,    -1,    -1,   165,
      -1,   167,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   189,   190,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    23,    -1,    -1,    -1,    -1,    -1,    -1,    30,    31,
      -1,    -1,    -1,    35,    -1,    -1,    -1,    -1,    -1,   225,
     226,   227,   228,    -1,    -1,    -1,    -1,    -1,   234,   235,
      -1,    -1,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,    -1,    -1,   264,    -1,
      -1,    -1,    84,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,
     102,   103,    -1,    -1,   106,    -1,   108,    -1,    -1,    -1,
     112,    -1,    -1,    -1,   116,    -1,    -1,    -1,    -1,    -1,
     122,    -1,    -1,   309,   310,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   138,    -1,    -1,    -1,
      -1,   143,   328,    -1,   146,    -1,   332,   333,    -1,   151,
      -1,    -1,   154,    -1,    -1,   157,   158,    -1,   344,   345,
     162,    -1,    -1,   165,    -1,   167,    -1,    -1,   354,    -1,
     356,    -1,    -1,   359,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   189,   190,    -1,
      -1,    -1,    -1,    -1,    23,    -1,    -1,    -1,    -1,    -1,
      -1,    30,    31,    -1,    -1,    -1,    35,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   225,   226,   227,   228,    -1,    -1,    -1,
      -1,    -1,   234,   235,    -1,    -1,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
      -1,    -1,   264,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   100,   101,   102,   103,    -1,    -1,   106,    -1,   108,
      -1,    -1,    -1,   112,    -1,    -1,    -1,   116,    -1,    -1,
      -1,    -1,    -1,   122,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   309,   310,   138,
      -1,    -1,    -1,    -1,   143,    -1,    -1,   146,    -1,    -1,
      -1,    -1,   151,    -1,    -1,   154,   328,    -1,   157,   158,
     332,   333,    -1,   162,    -1,    -1,   165,    -1,   167,    -1,
      -1,    -1,   344,   345,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   356,    -1,    -1,   359,    -1,    -1,
     189,   190,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   225,   226,   227,   228,
      -1,    -1,    -1,    -1,    -1,   234,   235,    -1,    -1,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,    -1,    -1,   264,    -1,    -1,    -1,    -1,
      23,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    31,    -1,
      -1,    -1,    35,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     309,   310,    -1,    -1,    -1,    68,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   328,
      -1,    -1,    -1,   332,   333,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   344,   345,   100,   101,   102,
     103,    -1,    -1,   106,    -1,   108,    -1,   356,    -1,   112,
     359,    -1,    -1,   116,    -1,    -1,    -1,    -1,    -1,   122,
      -1,    -1,    -1,   126,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   138,    -1,    -1,    -1,    -1,
     143,    -1,    -1,   146,    -1,    -1,    -1,    -1,   151,    -1,
      -1,   154,    -1,    -1,   157,   158,    -1,    -1,    -1,   162,
      -1,    -1,   165,    -1,   167,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   189,   190,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   225,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,    -1,
      -1,   264,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   274,    -1,    -1,   277,   278,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   309,   310,    -1,    -1,
      -1,    -1,   315,   316,    -1,    -1,    -1,    -1,     0,     1,
      -1,    -1,     4,    -1,     6,   328,    -1,    -1,    -1,   332,
     333,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   342,
     343,    -1,   345,    -1,    26,    27,    28,    29,    -1,    -1,
      -1,    -1,    -1,   356,    36,    -1,   359,    -1,    -1,    -1,
      -1,    43,    -1,    45,    -1,    47,    -1,    -1,    50,    51,
      52,    -1,    54,    -1,    -1,    -1,    58,    59,    60,    -1,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    -1,    -1,    68,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    76,    77,    78,    79,    80,    81,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   101,
      -1,    -1,    -1,    -1,    -1,   107,    -1,   100,   101,   102,
     103,    -1,    -1,    -1,   116,   108,    -1,    -1,    -1,   112,
     122,    -1,    -1,   116,    -1,    -1,    -1,    -1,    -1,   122,
      -1,    -1,    -1,   126,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   146,   138,    68,    -1,    -1,    -1,
     143,    -1,    -1,   146,    -1,    -1,    -1,    -1,   151,    -1,
      -1,   154,    -1,    -1,   157,   158,    -1,    -1,    -1,   162,
      -1,    -1,   165,    -1,   167,    -1,    -1,    -1,   100,   101,
     102,   103,    -1,    -1,    -1,    -1,   108,    -1,    -1,    -1,
     112,    -1,    -1,    -1,   116,    -1,   189,   190,    -1,    -1,
     122,    -1,    -1,    -1,   126,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   138,    -1,    -1,    -1,
      -1,   143,    -1,    -1,   146,    -1,    -1,    -1,    -1,   151,
      -1,    -1,   154,    -1,    -1,   157,   158,    -1,    -1,    -1,
     162,    -1,    -1,   165,    -1,   167,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   264,    -1,    -1,    -1,    -1,   189,   190,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   279,    -1,    -1,
      -1,   274,    -1,    -1,   277,   278,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   295,    -1,    -1,    -1,    -1,   300,    -1,
     302,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   315,   316,    -1,   318,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   342,
     343,    -1,   274,    -1,    -1,   277,   278,    -1,    -1,    -1,
      -1,    -1,    -1,   356,    -1,    -1,   359,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   315,   316,    -1,   318,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     342,   343,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   356,    -1,    -1,   359
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,   363,     0,     1,     4,     6,    26,    27,    28,    29,
      36,    43,    45,    47,    50,    51,    52,    54,    58,    59,
      60,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,   107,   116,   122,   146,   264,   279,
     295,   300,   302,   364,   370,   371,   372,   373,   437,   438,
     439,   441,   456,   364,   102,   101,   434,   434,   434,   439,
     450,   439,   441,   456,   439,   444,   444,   444,   439,   447,
     373,    47,   374,    36,    43,    45,    50,    51,    52,    54,
     264,   279,   295,   300,   302,   375,    47,   376,    36,    43,
      45,    47,    50,    51,    52,    54,   264,   279,   295,   300,
     302,   377,    51,   378,    36,    43,    44,    45,    46,    49,
      50,    52,    53,    54,    56,    95,    97,    98,    99,   264,
     279,   284,   285,   286,   287,   295,   300,   302,   303,   379,
     279,   284,   285,   300,   380,    43,    45,    50,    52,    56,
      95,    97,   381,    45,   382,    23,    30,    31,    35,   100,
     101,   102,   103,   106,   108,   112,   116,   122,   138,   143,
     146,   151,   154,   157,   158,   162,   165,   167,   189,   190,
     225,   226,   227,   228,   234,   235,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     264,   309,   310,   328,   332,   333,   344,   345,   356,   359,
     390,   435,   551,   552,   555,   556,   557,   561,   622,   625,
     627,   631,   636,   637,   639,   641,   651,   652,   654,   656,
     658,   660,   664,   666,   668,   670,   672,   674,   676,   678,
     680,   682,   686,   694,   696,   698,   699,   701,   703,   705,
     707,   709,   711,   713,   715,    56,   338,   339,   340,   383,
     389,    56,   384,   389,   101,   385,   386,    87,   271,   273,
     450,   450,   450,   450,     0,   364,   434,   434,    55,   335,
     336,   453,   454,   455,    34,    36,    50,    60,    61,    65,
      76,    77,    78,    79,    80,    81,    95,    97,   240,   264,
     279,   289,   295,   300,   312,   315,   316,   317,   318,   322,
     326,   327,   341,   354,   460,   461,   462,   464,   465,   466,
     467,   468,   469,   473,   474,   475,   478,   479,   486,   490,
     495,   496,   498,   499,   500,   501,   502,   524,   525,   527,
     528,   530,   531,   534,   535,   542,   543,   544,   545,   546,
     549,   550,   556,   563,   564,   565,   566,   567,   568,   572,
     573,   574,   606,   620,   625,   626,   649,   650,   651,   364,
     353,   353,   364,   434,   506,   391,   394,   460,   434,   398,
     400,   551,   574,   403,   434,   407,   441,   457,   450,   439,
     441,   444,   444,   444,   447,    87,   271,   273,   450,   450,
     450,   450,   456,   439,   450,   451,   437,   439,   440,   439,
     441,   442,   457,   439,   444,   445,   444,   444,   439,   447,
     448,    87,   271,   273,   596,   450,   451,   450,   451,   450,
     451,   450,   451,   444,   450,   439,   438,   459,   441,   459,
      43,   459,   444,   444,   459,   447,   459,    43,    44,   444,
     459,   459,    87,   271,   288,   596,   450,    43,   459,    43,
     459,    43,   459,    43,   459,   450,   450,   450,    43,   459,
     450,    43,   459,    43,   459,   450,   439,   441,   444,   444,
     459,    43,   444,   441,   104,   105,   106,   653,   109,   110,
     241,   242,   245,   559,   560,    32,    33,   241,   628,   129,
     562,   163,   164,   697,   109,   110,   111,   655,   111,   113,
     114,   115,   657,   109,   110,   117,   118,   119,   120,   121,
     659,   109,   110,   113,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   172,   661,   111,   113,   131,   139,   140,
     141,   142,   665,   111,   131,   144,   291,   667,   109,   110,
     123,   125,   126,   127,   148,   149,   150,   669,   111,   113,
     131,   139,   140,   142,   152,   153,   671,   124,   140,   149,
     155,   156,   673,   140,   156,   675,   149,   159,   160,   677,
     127,   131,   163,   164,   679,   131,   163,   164,   166,   681,
     131,   140,   155,   159,   163,   164,   168,   169,   170,   171,
     172,   683,   111,   163,   164,   687,   131,   163,   164,   191,
     224,   695,   111,   122,   124,   142,   146,   149,   229,   262,
     263,   345,   638,   640,   702,   230,   704,   230,   706,   159,
     231,   232,   233,   708,   124,   149,   700,   113,   128,   149,
     155,   236,   237,   710,   124,   149,   712,   111,   124,   131,
     149,   155,   714,   101,   127,   130,   147,   302,   319,   345,
     623,   624,   625,   109,   110,   113,   130,   241,   265,   266,
     267,   268,   269,   270,   272,   273,   274,   275,   276,   277,
     278,   281,   282,   283,   302,   642,   643,   646,   319,   329,
     630,   568,   573,   330,   225,   234,   235,   238,   239,   716,
     351,   352,   633,   567,   434,   389,   339,   389,    44,    46,
      48,    49,    56,    57,    89,   387,   450,   450,   450,   591,
     605,   593,   595,   100,   100,   100,    82,   638,   280,   543,
     434,   551,   621,   621,    60,    96,   434,   101,   623,    87,
     184,   271,   642,   643,   280,   280,   296,   280,   298,   299,
     487,    82,    82,   638,     4,   365,   575,   576,   337,   458,
     465,   394,   281,   282,   476,   477,   159,   290,   291,   292,
     293,   294,   480,   481,   313,   497,     5,    21,    68,    82,
      84,   108,   112,   116,   122,   126,   146,   225,   274,   277,
     278,   290,   315,   316,   342,   343,   356,   509,   510,   511,
     512,   513,   514,   515,   517,   518,   519,   520,   521,   522,
     523,   552,   555,   561,   615,   616,   617,   622,   627,   631,
     637,   638,   639,   641,   647,   648,   651,    37,    38,   181,
     182,   503,   504,    82,   319,   320,   321,   526,   532,   533,
      82,   529,   532,   323,   324,   325,   536,   537,   538,   539,
      23,   551,   553,   554,    43,   547,   548,    15,    16,    17,
      18,   358,     8,    24,    52,     9,    10,    11,    12,    13,
      14,   108,   112,   116,   122,   138,   143,   146,   151,   154,
     157,   158,   162,   165,   167,   189,   190,   318,   356,   520,
     552,   554,   555,   569,   570,   571,   574,   607,   608,   609,
     610,   611,   612,   613,   614,   616,   617,   618,   619,    50,
      50,    22,   354,   589,   607,   608,   589,    37,   354,   505,
     354,   354,   354,   354,   354,   453,   460,   506,   391,   394,
     398,   400,   403,   407,   450,   450,   450,   591,   605,   593,
     595,   460,    55,    55,    55,    55,   400,    55,   407,   450,
     400,   439,   444,   459,    43,    43,    43,   450,   439,   439,
     439,   439,   439,   439,   439,   444,   434,     7,     8,   111,
     245,   246,   558,   101,   123,   280,   108,   122,   108,   122,
     134,   135,   136,   137,   662,    23,    37,   100,   170,   173,
     174,   175,   176,   177,   178,   179,   180,   181,   182,   684,
     176,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   688,   693,
     368,   640,   360,   360,   109,   110,   122,   130,   146,   265,
     266,   267,   644,   645,   646,   330,   330,   100,   348,   632,
     357,   388,   389,   603,   603,   603,   281,   354,   590,   296,
     354,   604,   354,   487,   592,   354,   435,   594,     5,   122,
     146,   522,    82,   522,   540,   541,   568,    23,    23,    94,
     354,    50,    50,    50,   100,   298,    50,   646,    50,   522,
     522,   298,   299,   491,   522,   100,   522,   522,    82,   520,
     574,   579,   580,   587,   613,   614,     7,   355,   435,   354,
     100,   100,   477,    75,   108,   122,   167,   248,   483,   435,
     100,   100,   100,   435,   482,   481,   138,   151,   167,   314,
     522,     5,   522,    82,    82,   514,   552,   617,    15,    16,
      17,    18,   358,    20,    22,     8,    52,     5,   532,    82,
      84,   230,   290,     7,     7,   100,   100,   504,     5,     7,
       5,   522,   522,   537,     7,   434,   354,   434,   354,   548,
     618,   618,   609,   610,   611,   567,   354,   470,   553,   608,
     368,   613,     7,    15,    16,    17,    18,   358,     7,    20,
      22,     8,   608,   522,   522,   100,   355,   364,   364,   100,
     422,   393,   395,   399,   404,   408,   505,   354,   354,   354,
     354,   354,   603,   603,   603,   590,   604,   592,   594,   100,
     100,   100,   100,   100,   354,   603,   439,   439,   439,   100,
     560,   111,   127,   132,   133,   230,   663,   684,    94,   127,
     183,   184,   185,   186,   187,   188,   685,   214,   218,   219,
     220,   692,   209,   210,   211,   212,   690,   213,   214,   215,
     216,   217,   691,   691,   218,   221,   221,   222,   223,   222,
     111,   127,   159,   689,   369,   100,   100,   109,   110,   109,
     110,   100,   100,   331,   629,   100,   156,   347,   634,   638,
     354,   354,   354,   100,   415,   491,   420,   416,   100,   421,
     522,     5,     5,   522,   553,    87,    90,   458,   581,   582,
     435,   435,   100,   568,   577,   578,   522,   522,   522,   100,
     522,    50,   522,   100,   101,   282,   488,    41,   522,   365,
       5,   365,    87,    90,   458,   583,   586,   279,   295,   584,
     585,   365,   576,   396,   145,   140,   145,   484,   485,   111,
     111,    68,   111,   522,     5,   522,   522,   357,   509,   509,
     510,   511,   512,   100,   514,   509,   516,   553,   574,   522,
     522,    82,     8,    82,   552,   617,   647,   647,   522,   533,
     522,   532,   539,   540,   577,   365,   471,   472,   357,   613,
     618,   618,   609,   610,   611,   613,   100,   613,   571,   613,
      38,   364,   355,   364,   370,   458,   505,    36,    45,    50,
      52,    54,   159,   264,   279,   295,   300,   302,   355,   364,
     370,   392,   458,    91,   111,   159,   355,   364,   370,   424,
     430,   431,   458,   460,    39,    86,    87,    88,    89,    91,
      94,   111,   159,   264,   355,   364,   370,   405,   458,   463,
     464,    39,    87,    89,   111,   159,   355,   364,   370,   405,
     458,    40,    42,   279,   355,   364,   370,   393,   395,   399,
     404,   408,   354,   354,   354,   408,     7,     7,   368,   361,
     361,   629,   334,   629,   100,   366,   109,   110,   635,   418,
     419,   417,   282,   355,   364,   370,   458,   590,   100,   355,
     364,   370,   458,   604,   355,   364,   370,   458,   592,   488,
     355,   364,   370,   458,   594,   522,   522,     5,   101,   436,
     436,   582,   354,   465,   581,   522,    20,   101,   301,   489,
     522,    41,    79,    80,   588,   614,   620,   436,   436,   586,
     281,   296,   585,   355,   364,   460,     7,   101,   101,   101,
     522,     5,   522,   161,   522,   532,   532,     5,   355,   463,
     465,   579,     7,   355,   100,    38,   434,   452,   434,   443,
     434,   446,   446,   434,   449,   101,    87,   271,   273,   452,
     452,   452,   452,   364,    76,    77,   432,   433,   551,   101,
      96,   364,   364,   364,   364,   364,   397,   556,   436,   436,
     353,    92,    93,   406,   100,   101,   125,   126,   241,   261,
     262,   412,   413,   423,    83,    84,    85,    87,   401,   402,
     364,   364,   364,   464,   397,   436,   353,   413,   401,   364,
     364,   101,   353,   355,   355,   355,   355,   355,   418,   419,
     417,   355,   100,   100,   367,   100,   366,    91,   130,   265,
     355,   364,   370,   458,   601,    87,    94,   130,   164,   265,
     355,   364,   370,   458,   602,   111,   265,   355,   364,   370,
     458,   598,   100,    20,   101,   489,   522,   577,   355,   307,
     308,   309,   310,   311,   494,   297,   493,   100,   522,   365,
     100,   491,   364,   485,   522,    82,   540,     5,   355,   355,
       5,   365,   472,   182,   507,   100,   414,   394,   398,   403,
     407,   452,   452,   452,   414,   414,   414,   414,    40,     8,
     364,   364,   364,   400,     8,   364,     7,   364,     5,   364,
     400,     5,   364,   147,   425,   354,   409,   551,   355,   355,
     355,     7,   629,   353,   162,   167,   597,   438,   436,   100,
     597,   100,   438,   102,   438,   494,   493,   465,   297,   492,
     100,   488,   282,   100,   522,   355,   540,   620,   181,   508,
     364,   354,   354,   354,   354,   354,   414,   414,   414,   354,
     354,   354,   354,   101,   556,   412,   402,    84,   397,    84,
     279,   295,   300,   302,   413,    22,   100,   101,   352,   426,
     427,   428,   551,   364,   101,   410,   411,   551,   364,   100,
     366,   354,   364,   364,   364,   364,   364,   364,   364,   130,
     364,   492,   355,   100,   101,   282,   100,    20,   101,   355,
     365,   507,   422,   395,   399,   404,   408,   354,   354,   354,
     415,   420,   416,   421,    41,    42,   429,   397,   364,   413,
     364,   364,   364,   364,   364,   100,    22,    25,     7,   355,
     101,   599,   600,   597,   281,   494,   493,   508,   355,   355,
     355,   355,   355,   418,   419,   417,   355,   355,   355,   355,
     435,   551,   353,   425,   364,   364,   100,   100,   365,   411,
       5,     7,   355,   364,   492,   364,   364,   364,   364,   364,
     355,   355,   355,   364,   364,   364,   364,   409,   100,   600,
     364,   364,   364,   364
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_int16 yyr1[] =
{
       0,   362,   363,   363,   364,   364,   365,   365,   366,   367,
     368,   369,   370,   370,   370,   370,   370,   371,   371,   371,
     371,   372,   372,   372,   372,   372,   372,   372,   372,   372,
     372,   372,   372,   372,   372,   372,   373,   373,   373,   373,
     373,   373,   373,   373,   373,   373,   373,   373,   373,   373,
     373,   373,   373,   373,   373,   373,   373,   373,   373,   373,
     374,   375,   375,   375,   375,   375,   375,   375,   375,   375,
     375,   375,   375,   375,   375,   375,   375,   375,   376,   377,
     377,   377,   377,   377,   377,   377,   377,   377,   377,   377,
     377,   377,   377,   377,   377,   377,   377,   377,   377,   377,
     377,   377,   378,   379,   379,   379,   379,   379,   379,   379,
     379,   379,   379,   379,   379,   379,   379,   379,   379,   379,
     379,   379,   379,   379,   379,   379,   379,   379,   379,   379,
     379,   379,   379,   379,   379,   379,   379,   379,   380,   380,
     380,   380,   380,   380,   381,   381,   381,   381,   381,   381,
     381,   382,   383,   383,   384,   384,   385,   386,   386,   387,
     387,   387,   387,   387,   387,   387,   387,   388,   388,   389,
     389,   389,   390,   391,   392,   392,   393,   393,   393,   393,
     393,   393,   393,   393,   393,   393,   393,   393,   393,   393,
     393,   393,   394,   395,   395,   395,   395,   395,   395,   395,
     395,   396,   396,   396,   397,   397,   398,   399,   399,   399,
     399,   399,   399,   399,   399,   399,   399,   399,   399,   399,
     400,   400,   401,   401,   402,   402,   402,   402,   403,   404,
     404,   404,   404,   404,   404,   404,   404,   404,   404,   404,
     404,   404,   404,   404,   404,   405,   405,   406,   406,   407,
     408,   408,   408,   408,   408,   408,   409,   409,   410,   410,
     410,   411,   411,   412,   412,   413,   413,   414,   415,   415,
     415,   415,   415,   416,   416,   416,   416,   416,   417,   417,
     417,   417,   417,   418,   418,   418,   418,   418,   419,   419,
     419,   419,   419,   420,   420,   420,   420,   420,   421,   421,
     421,   421,   421,   422,   422,   422,   422,   422,   423,   423,
     423,   423,   423,   424,   425,   426,   426,   427,   427,   427,
     427,   427,   428,   428,   429,   429,   429,   429,   430,   431,
     432,   432,   433,   433,   434,   435,   435,   435,   436,   437,
     437,   438,   438,   438,   438,   438,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   456,   456,   456,   457,   458,
     459,   459,   460,   460,   461,   462,   462,   463,   463,   464,
     464,   464,   464,   465,   465,   465,   465,   465,   465,   465,
     465,   465,   465,   465,   465,   465,   465,   465,   465,   465,
     465,   465,   465,   466,   466,   467,   468,   468,   469,   470,
     470,   471,   471,   471,   472,   473,   473,   474,   474,   475,
     475,   476,   476,   477,   477,   478,   478,   479,   480,   480,
     481,   481,   481,   481,   481,   481,   482,   483,   483,   483,
     483,   483,   484,   484,   485,   485,   486,   486,   486,   487,
     487,   487,   488,   488,   489,   489,   490,   490,   491,   491,
     491,   492,   492,   493,   493,   493,   494,   494,   494,   494,
     494,   495,   496,   497,   497,   497,   497,   497,   498,   499,
     499,   500,   500,   500,   500,   500,   500,   501,   501,   502,
     502,   503,   503,   504,   504,   504,   504,   505,   505,   506,
     507,   507,   508,   508,   509,   509,   509,   509,   509,   509,
     509,   509,   509,   509,   509,   509,   509,   510,   510,   510,
     511,   511,   512,   512,   513,   513,   514,   515,   515,   516,
     516,   517,   517,   518,   519,   520,   521,   521,   521,   522,
     522,   522,   523,   523,   523,   523,   523,   523,   523,   523,
     523,   523,   523,   523,   523,   523,   524,   524,   525,   526,
     526,   526,   527,   527,   528,   529,   529,   529,   529,   529,
     530,   530,   531,   531,   532,   532,   533,   533,   533,   534,
     534,   535,   536,   536,   537,   537,   538,   538,   539,   539,
     540,   540,   541,   542,   542,   542,   543,   543,   543,   544,
     544,   545,   545,   546,   547,   547,   548,   549,   549,   550,
     551,   552,   552,   553,   553,   554,   555,   556,   556,   556,
     556,   556,   556,   556,   556,   556,   556,   556,   556,   556,
     556,   556,   557,   558,   558,   558,   559,   559,   559,   559,
     559,   560,   560,   561,   561,   562,   562,   563,   563,   563,
     564,   564,   565,   565,   566,   566,   567,   568,   568,   569,
     570,   571,   571,   572,   573,   573,   573,   574,   575,   575,
     575,   576,   576,   576,   577,   577,   578,   579,   579,   580,
     580,   581,   581,   582,   582,   582,   583,   583,   584,   584,
     585,   585,   585,   585,   586,   586,   586,   587,   587,   588,
     588,   589,   589,   589,   589,   590,   591,   592,   593,   594,
     595,   596,   596,   596,   597,   597,   598,   598,   599,   599,
     600,   601,   601,   601,   602,   602,   602,   602,   602,   603,
     604,   604,   605,   606,   606,   606,   607,   607,   608,   608,
     608,   608,   609,   609,   609,   610,   610,   611,   611,   612,
     612,   613,   614,   614,   614,   614,   615,   615,   616,   617,
     617,   617,   617,   617,   617,   617,   617,   617,   617,   617,
     617,   618,   618,   618,   618,   618,   618,   618,   618,   618,
     618,   618,   618,   618,   618,   618,   618,   618,   619,   619,
     619,   619,   619,   619,   620,   620,   620,   620,   620,   620,
     621,   621,   622,   622,   622,   623,   623,   624,   624,   624,
     624,   624,   625,   625,   625,   625,   625,   625,   625,   625,
     625,   625,   625,   625,   625,   625,   625,   625,   625,   625,
     625,   625,   625,   625,   625,   625,   626,   626,   626,   626,
     626,   626,   627,   628,   628,   628,   629,   629,   630,   630,
     631,   632,   632,   633,   633,   634,   634,   635,   635,   636,
     636,   637,   637,   637,   638,   638,   639,   639,   640,   640,
     640,   640,   641,   641,   641,   642,   642,   643,   643,   643,
     643,   643,   643,   643,   643,   643,   643,   643,   643,   643,
     643,   643,   643,   643,   644,   644,   644,   644,   644,   644,
     644,   645,   645,   645,   645,   646,   646,   646,   646,   647,
     647,   648,   648,   649,   649,   649,   649,   650,   651,   651,
     651,   651,   651,   651,   651,   651,   651,   651,   651,   651,
     651,   651,   651,   651,   651,   651,   652,   653,   653,   653,
     654,   655,   655,   655,   656,   657,   657,   657,   657,   658,
     659,   659,   659,   659,   659,   659,   659,   659,   659,   660,
     660,   660,   661,   661,   661,   661,   661,   661,   661,   661,
     661,   661,   661,   661,   662,   662,   662,   662,   663,   663,
     663,   663,   663,   664,   665,   665,   665,   665,   665,   665,
     665,   666,   667,   667,   667,   667,   668,   669,   669,   669,
     669,   669,   669,   669,   669,   669,   670,   671,   671,   671,
     671,   671,   671,   671,   671,   672,   673,   673,   673,   673,
     673,   674,   675,   675,   676,   677,   677,   677,   678,   679,
     679,   679,   679,   680,   681,   681,   681,   681,   682,   682,
     682,   682,   683,   683,   683,   683,   683,   683,   683,   683,
     683,   683,   684,   684,   684,   684,   684,   684,   684,   684,
     684,   684,   684,   684,   684,   685,   685,   685,   685,   685,
     685,   685,   685,   686,   687,   687,   687,   688,   688,   688,
     688,   688,   688,   688,   688,   688,   688,   688,   688,   688,
     688,   688,   688,   688,   688,   689,   689,   689,   690,   690,
     690,   690,   691,   691,   691,   691,   691,   692,   692,   692,
     692,   693,   693,   693,   693,   693,   693,   693,   693,   693,
     693,   693,   693,   694,   694,   695,   695,   695,   695,   696,
     697,   697,   698,   698,   698,   698,   698,   698,   698,   698,
     699,   700,   700,   701,   702,   702,   702,   702,   703,   704,
     705,   706,   707,   708,   708,   708,   708,   709,   710,   710,
     710,   710,   710,   710,   711,   712,   712,   713,   714,   714,
     714,   714,   714,   715,   716,   716,   716,   716,   716
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     0,     2,     1,     1,     1,     0,     0,     0,
       0,     0,     3,     5,     5,     3,     2,     1,     1,     2,
       2,     1,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     6,     2,     6,
       3,     2,     6,     6,     3,     6,     2,     4,     6,     4,
       6,     7,     7,     7,     4,     6,     4,     6,     4,     6,
       3,     2,     6,     2,     6,     6,     6,     3,     6,     2,
       4,     4,     7,     7,     7,     4,     4,     4,     3,     2,
       2,     2,     2,     2,     2,     2,     2,     3,     2,     2,
       6,     2,     2,     2,     2,     4,     2,     2,     2,     2,
       2,     2,     3,     2,     2,     2,     2,     2,     3,     2,
       2,     3,     2,     2,     3,     2,     2,     3,     2,     2,
       3,     2,     2,     3,     2,     2,     3,     3,     2,     2,
       2,     2,     2,     2,     3,     4,     4,     4,     2,     3,
       2,     2,     3,     2,     2,     2,     2,     2,     3,     2,
       2,     3,     2,     1,     2,     1,     3,     0,     1,     0,
       1,     1,     1,     1,     1,     1,     1,     0,     1,     1,
       1,     2,     1,     0,     2,     1,     0,     2,     2,     3,
       8,     8,     8,     8,     8,     8,     9,     9,     9,     8,
       8,     8,     0,     0,     2,     2,     3,     3,     3,     3,
       3,     0,     2,     3,     1,     3,     0,     0,     2,     2,
       4,     4,     4,     4,     4,     3,     4,     2,     3,     3,
       1,     1,     3,     1,     1,     1,     1,     1,     0,     0,
       2,     2,     4,     6,     7,     6,     7,     6,     6,     6,
       6,     4,     4,     3,     3,     2,     2,     1,     1,     0,
       0,     2,     2,     5,     5,     2,     3,     1,     1,     3,
       3,     1,     1,     1,     1,     1,     3,     0,     0,     2,
       2,     2,     2,     0,     2,     2,     2,     2,     0,     2,
       2,     2,     2,     0,     2,     2,     2,     2,     0,     2,
       2,     2,     2,     0,     2,     2,     2,     2,     0,     2,
       2,     2,     2,     0,     2,     2,     2,     2,     1,     1,
       1,     1,     1,     6,     2,     1,     1,     1,     1,     1,
       3,     3,     1,     2,     2,     2,     3,     0,     2,     2,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     0,
       1,     1,     1,     1,     1,     1,     1,     2,     3,     2,
       3,     1,     2,     3,     1,     2,     3,     1,     2,     3,
       1,     2,     2,     2,     1,     2,     2,     2,     2,     2,
       0,     1,     1,     2,     1,     1,     2,     1,     2,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     5,     1,     1,     3,     3,
       1,     1,     3,     3,     5,     3,     4,     1,     2,     1,
       3,     1,     2,     2,     2,     1,     2,     1,     1,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     2,     1,
       1,     1,     3,     1,     1,     1,     7,     6,     3,     1,
       1,     0,     1,     1,     0,     3,     5,     3,     1,     1,
       0,     0,     3,     0,     3,     3,     1,     1,     1,     1,
       1,     2,     1,     0,     4,     4,     4,     3,     2,     1,
       1,     3,     4,     4,     5,     6,     5,     1,     2,     1,
       3,     1,     2,     2,     2,     1,     1,     6,     8,     0,
       0,     1,     0,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     3,     1,     3,     3,
       1,     3,     1,     3,     1,     3,     1,     1,     3,     1,
       1,     3,     1,     3,     3,     1,     1,     1,     1,     1,
       1,     1,     1,     2,     3,     3,     4,     5,     2,     3,
       2,     6,     4,     3,     4,     3,     2,     1,     1,     3,
       4,     1,     2,     1,     1,     2,     3,     1,     3,     4,
       3,     5,     3,     6,     1,     3,     1,     1,     1,     1,
       2,     1,     1,     2,     2,     1,     1,     3,     1,     1,
       1,     2,     1,     4,     5,     6,     1,     1,     1,     7,
       8,     6,     1,     1,     1,     2,     2,     6,     8,     1,
       2,     1,     1,     1,     1,     2,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     3,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     3,     1,     3,     3,     0,     2,     1,     3,     3,
       1,     3,     1,     3,     1,     3,     1,     1,     3,     3,
       3,     1,     1,     3,     1,     1,     1,     3,     1,     3,
       3,     3,     3,     5,     1,     2,     1,     1,     2,     2,
       1,     1,     2,     2,     2,     1,     1,     2,     1,     2,
       1,     5,     7,     6,     2,     2,     1,     1,     1,     1,
       1,     1,     1,     2,     2,     4,     0,     4,     0,     1,
       0,     1,     1,     1,     1,     1,     5,     3,     1,     3,
       3,     3,     6,     3,     3,     3,     3,     3,     3,     0,
       6,     5,     0,     2,     2,     3,     3,     3,     1,     1,
       1,     1,     1,     3,     3,     1,     3,     1,     3,     1,
       3,     1,     1,     1,     3,     3,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     2,     1,     3,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     2,     2,     1,
       1,     1,     2,     1,     2,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     4,     3,     4,     1,
       4,     4,     2,     1,     1,     1,     0,     2,     1,     1,
       6,     2,     0,     1,     1,     1,     1,     1,     1,     4,
       5,     8,     6,     5,     1,     1,     2,     3,     1,     1,
       1,     1,     2,     3,     3,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     2,     2,     2,     1,     1,     1,     1,     1,
       1,     3,     3,     4,     4,     4,     5,     3,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     6,     1,     1,     1,
       2,     1,     1,     1,     2,     1,     1,     1,     1,     2,
       1,     1,     1,     1,     1,     2,     2,     2,     2,     2,
       4,     3,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     2,     1,     1,     1,     1,     1,     1,
       1,     2,     1,     1,     1,     1,     2,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     2,     1,     1,     1,
       1,     1,     1,     1,     1,     2,     1,     1,     1,     1,
       1,     2,     1,     1,     2,     1,     1,     1,     2,     1,
       1,     1,     1,     2,     1,     1,     1,     1,     2,     4,
       3,     8,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     3,     5,     1,     1,     1,     1,     2,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       2,     1,     1,     2,     1,     1,     1,     1,     2,     4,
       2,     1,     2,     1,     1,     1,     4,     2,     1,     1,
       1,     1,     1,     1,     2,     1,     1,     2,     1,     1,
       1,     1,     1,     2,     1,     1,     1,     1,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (&yylloc, nft, scanner, state, YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF

/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

# ifndef YY_LOCATION_PRINT
#  if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static int
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  int res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
 }

#   define YY_LOCATION_PRINT(File, Loc)          \
  yy_location_print_ (File, &(Loc))

#  else
#   define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#  endif
# endif /* !defined YY_LOCATION_PRINT */


# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value, Location, nft, scanner, state); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, struct nft_ctx *nft, void *scanner, struct parser_state *state)
{
  FILE *yyoutput = yyo;
  YYUSE (yyoutput);
  YYUSE (yylocationp);
  YYUSE (nft);
  YYUSE (scanner);
  YYUSE (state);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yykind < YYNTOKENS)
    YYPRINT (yyo, yytoknum[yykind], *yyvaluep);
# endif
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, struct nft_ctx *nft, void *scanner, struct parser_state *state)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  YY_LOCATION_PRINT (yyo, *yylocationp);
  YYFPRINTF (yyo, ": ");
  yy_symbol_value_print (yyo, yykind, yyvaluep, yylocationp, nft, scanner, state);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp,
                 int yyrule, struct nft_ctx *nft, void *scanner, struct parser_state *state)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)],
                       &(yylsp[(yyi + 1) - (yynrhs)]), nft, scanner, state);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule, nft, scanner, state); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


/* Context of a parse error.  */
typedef struct
{
  yy_state_t *yyssp;
  yysymbol_kind_t yytoken;
  YYLTYPE *yylloc;
} yypcontext_t;

/* Put in YYARG at most YYARGN of the expected tokens given the
   current YYCTX, and return the number of tokens stored in YYARG.  If
   YYARG is null, return the number of expected tokens (guaranteed to
   be less than YYNTOKENS).  Return YYENOMEM on memory exhaustion.
   Return 0 if there are more than YYARGN expected tokens, yet fill
   YYARG up to YYARGN. */
static int
yypcontext_expected_tokens (const yypcontext_t *yyctx,
                            yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  int yyn = yypact[+*yyctx->yyssp];
  if (!yypact_value_is_default (yyn))
    {
      /* Start YYX at -YYN if negative to avoid negative indexes in
         YYCHECK.  In other words, skip the first -YYN actions for
         this state because they are default actions.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;
      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yyx;
      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
        if (yycheck[yyx + yyn] == yyx && yyx != YYSYMBOL_YYerror
            && !yytable_value_is_error (yytable[yyx + yyn]))
          {
            if (!yyarg)
              ++yycount;
            else if (yycount == yyargn)
              return 0;
            else
              yyarg[yycount++] = YY_CAST (yysymbol_kind_t, yyx);
          }
    }
  if (yyarg && yycount == 0 && 0 < yyargn)
    yyarg[0] = YYSYMBOL_YYEMPTY;
  return yycount;
}




#ifndef yystrlen
# if defined __GLIBC__ && defined _STRING_H
#  define yystrlen(S) (YY_CAST (YYPTRDIFF_T, strlen (S)))
# else
/* Return the length of YYSTR.  */
static YYPTRDIFF_T
yystrlen (const char *yystr)
{
  YYPTRDIFF_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
# endif
#endif

#ifndef yystpcpy
# if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#  define yystpcpy stpcpy
# else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
# endif
#endif

#ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYPTRDIFF_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYPTRDIFF_T yyn = 0;
      char const *yyp = yystr;
      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            else
              goto append;

          append:
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (yyres)
    return yystpcpy (yyres, yystr) - yyres;
  else
    return yystrlen (yystr);
}
#endif


static int
yy_syntax_error_arguments (const yypcontext_t *yyctx,
                           yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yyctx->yytoken != YYSYMBOL_YYEMPTY)
    {
      int yyn;
      if (yyarg)
        yyarg[yycount] = yyctx->yytoken;
      ++yycount;
      yyn = yypcontext_expected_tokens (yyctx,
                                        yyarg ? yyarg + 1 : yyarg, yyargn - 1);
      if (yyn == YYENOMEM)
        return YYENOMEM;
      else
        yycount += yyn;
    }
  return yycount;
}

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return -1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return YYENOMEM if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYPTRDIFF_T *yymsg_alloc, char **yymsg,
                const yypcontext_t *yyctx)
{
  enum { YYARGS_MAX = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat: reported tokens (one for the "unexpected",
     one per "expected"). */
  yysymbol_kind_t yyarg[YYARGS_MAX];
  /* Cumulated lengths of YYARG.  */
  YYPTRDIFF_T yysize = 0;

  /* Actual size of YYARG. */
  int yycount = yy_syntax_error_arguments (yyctx, yyarg, YYARGS_MAX);
  if (yycount == YYENOMEM)
    return YYENOMEM;

  switch (yycount)
    {
#define YYCASE_(N, S)                       \
      case N:                               \
        yyformat = S;                       \
        break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
    }

  /* Compute error message size.  Don't count the "%s"s, but reserve
     room for the terminator.  */
  yysize = yystrlen (yyformat) - 2 * yycount + 1;
  {
    int yyi;
    for (yyi = 0; yyi < yycount; ++yyi)
      {
        YYPTRDIFF_T yysize1
          = yysize + yytnamerr (YY_NULLPTR, yytname[yyarg[yyi]]);
        if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
          yysize = yysize1;
        else
          return YYENOMEM;
      }
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return -1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yytname[yyarg[yyi++]]);
          yyformat += 2;
        }
      else
        {
          ++yyp;
          ++yyformat;
        }
  }
  return 0;
}


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep, YYLTYPE *yylocationp, struct nft_ctx *nft, void *scanner, struct parser_state *state)
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);
  YYUSE (nft);
  YYUSE (scanner);
  YYUSE (state);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  switch (yykind)
    {
    case YYSYMBOL_STRING: /* "string"  */
#line 313 "parser_bison.y"
            { xfree(((*yyvaluep).string)); }
#line 5536 "parser_bison.c"
        break;

    case YYSYMBOL_QUOTED_STRING: /* "quoted string"  */
#line 313 "parser_bison.y"
            { xfree(((*yyvaluep).string)); }
#line 5542 "parser_bison.c"
        break;

    case YYSYMBOL_ASTERISK_STRING: /* "string with a trailing asterisk"  */
#line 313 "parser_bison.y"
            { xfree(((*yyvaluep).string)); }
#line 5548 "parser_bison.c"
        break;

    case YYSYMBOL_line: /* line  */
#line 622 "parser_bison.y"
            { cmd_free(((*yyvaluep).cmd)); }
#line 5554 "parser_bison.c"
        break;

    case YYSYMBOL_base_cmd: /* base_cmd  */
#line 625 "parser_bison.y"
            { cmd_free(((*yyvaluep).cmd)); }
#line 5560 "parser_bison.c"
        break;

    case YYSYMBOL_add_cmd: /* add_cmd  */
#line 625 "parser_bison.y"
            { cmd_free(((*yyvaluep).cmd)); }
#line 5566 "parser_bison.c"
        break;

    case YYSYMBOL_replace_cmd: /* replace_cmd  */
#line 625 "parser_bison.y"
            { cmd_free(((*yyvaluep).cmd)); }
#line 5572 "parser_bison.c"
        break;

    case YYSYMBOL_create_cmd: /* create_cmd  */
#line 625 "parser_bison.y"
            { cmd_free(((*yyvaluep).cmd)); }
#line 5578 "parser_bison.c"
        break;

    case YYSYMBOL_insert_cmd: /* insert_cmd  */
#line 625 "parser_bison.y"
            { cmd_free(((*yyvaluep).cmd)); }
#line 5584 "parser_bison.c"
        break;

    case YYSYMBOL_delete_cmd: /* delete_cmd  */
#line 625 "parser_bison.y"
            { cmd_free(((*yyvaluep).cmd)); }
#line 5590 "parser_bison.c"
        break;

    case YYSYMBOL_get_cmd: /* get_cmd  */
#line 625 "parser_bison.y"
            { cmd_free(((*yyvaluep).cmd)); }
#line 5596 "parser_bison.c"
        break;

    case YYSYMBOL_list_cmd: /* list_cmd  */
#line 625 "parser_bison.y"
            { cmd_free(((*yyvaluep).cmd)); }
#line 5602 "parser_bison.c"
        break;

    case YYSYMBOL_reset_cmd: /* reset_cmd  */
#line 625 "parser_bison.y"
            { cmd_free(((*yyvaluep).cmd)); }
#line 5608 "parser_bison.c"
        break;

    case YYSYMBOL_flush_cmd: /* flush_cmd  */
#line 625 "parser_bison.y"
            { cmd_free(((*yyvaluep).cmd)); }
#line 5614 "parser_bison.c"
        break;

    case YYSYMBOL_rename_cmd: /* rename_cmd  */
#line 625 "parser_bison.y"
            { cmd_free(((*yyvaluep).cmd)); }
#line 5620 "parser_bison.c"
        break;

    case YYSYMBOL_import_cmd: /* import_cmd  */
#line 625 "parser_bison.y"
            { cmd_free(((*yyvaluep).cmd)); }
#line 5626 "parser_bison.c"
        break;

    case YYSYMBOL_export_cmd: /* export_cmd  */
#line 625 "parser_bison.y"
            { cmd_free(((*yyvaluep).cmd)); }
#line 5632 "parser_bison.c"
        break;

    case YYSYMBOL_monitor_cmd: /* monitor_cmd  */
#line 625 "parser_bison.y"
            { cmd_free(((*yyvaluep).cmd)); }
#line 5638 "parser_bison.c"
        break;

    case YYSYMBOL_monitor_event: /* monitor_event  */
#line 851 "parser_bison.y"
            { xfree(((*yyvaluep).string)); }
#line 5644 "parser_bison.c"
        break;

    case YYSYMBOL_describe_cmd: /* describe_cmd  */
#line 625 "parser_bison.y"
            { cmd_free(((*yyvaluep).cmd)); }
#line 5650 "parser_bison.c"
        break;

    case YYSYMBOL_table_block_alloc: /* table_block_alloc  */
#line 641 "parser_bison.y"
            { close_scope(state); table_free(((*yyvaluep).table)); }
#line 5656 "parser_bison.c"
        break;

    case YYSYMBOL_chain_block_alloc: /* chain_block_alloc  */
#line 643 "parser_bison.y"
            { close_scope(state); chain_free(((*yyvaluep).chain)); }
#line 5662 "parser_bison.c"
        break;

    case YYSYMBOL_typeof_expr: /* typeof_expr  */
#line 712 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 5668 "parser_bison.c"
        break;

    case YYSYMBOL_set_block_alloc: /* set_block_alloc  */
#line 652 "parser_bison.y"
            { set_free(((*yyvaluep).set)); }
#line 5674 "parser_bison.c"
        break;

    case YYSYMBOL_set_block_expr: /* set_block_expr  */
#line 753 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 5680 "parser_bison.c"
        break;

    case YYSYMBOL_map_block_alloc: /* map_block_alloc  */
#line 655 "parser_bison.y"
            { set_free(((*yyvaluep).set)); }
#line 5686 "parser_bison.c"
        break;

    case YYSYMBOL_flowtable_block_alloc: /* flowtable_block_alloc  */
#line 658 "parser_bison.y"
            { flowtable_free(((*yyvaluep).flowtable)); }
#line 5692 "parser_bison.c"
        break;

    case YYSYMBOL_flowtable_expr: /* flowtable_expr  */
#line 753 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 5698 "parser_bison.c"
        break;

    case YYSYMBOL_flowtable_list_expr: /* flowtable_list_expr  */
#line 753 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 5704 "parser_bison.c"
        break;

    case YYSYMBOL_flowtable_expr_member: /* flowtable_expr_member  */
#line 753 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 5710 "parser_bison.c"
        break;

    case YYSYMBOL_data_type_atom_expr: /* data_type_atom_expr  */
#line 619 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 5716 "parser_bison.c"
        break;

    case YYSYMBOL_data_type_expr: /* data_type_expr  */
#line 619 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 5722 "parser_bison.c"
        break;

    case YYSYMBOL_obj_block_alloc: /* obj_block_alloc  */
#line 661 "parser_bison.y"
            { obj_free(((*yyvaluep).obj)); }
#line 5728 "parser_bison.c"
        break;

    case YYSYMBOL_type_identifier: /* type_identifier  */
#line 614 "parser_bison.y"
            { xfree(((*yyvaluep).string)); }
#line 5734 "parser_bison.c"
        break;

    case YYSYMBOL_extended_prio_name: /* extended_prio_name  */
#line 635 "parser_bison.y"
            { xfree(((*yyvaluep).string)); }
#line 5740 "parser_bison.c"
        break;

    case YYSYMBOL_dev_spec: /* dev_spec  */
#line 638 "parser_bison.y"
            { xfree(((*yyvaluep).expr)); }
#line 5746 "parser_bison.c"
        break;

    case YYSYMBOL_policy_expr: /* policy_expr  */
#line 710 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 5752 "parser_bison.c"
        break;

    case YYSYMBOL_identifier: /* identifier  */
#line 614 "parser_bison.y"
            { xfree(((*yyvaluep).string)); }
#line 5758 "parser_bison.c"
        break;

    case YYSYMBOL_string: /* string  */
#line 614 "parser_bison.y"
            { xfree(((*yyvaluep).string)); }
#line 5764 "parser_bison.c"
        break;

    case YYSYMBOL_table_spec: /* table_spec  */
#line 628 "parser_bison.y"
            { handle_free(&((*yyvaluep).handle)); }
#line 5770 "parser_bison.c"
        break;

    case YYSYMBOL_tableid_spec: /* tableid_spec  */
#line 628 "parser_bison.y"
            { handle_free(&((*yyvaluep).handle)); }
#line 5776 "parser_bison.c"
        break;

    case YYSYMBOL_chain_spec: /* chain_spec  */
#line 628 "parser_bison.y"
            { handle_free(&((*yyvaluep).handle)); }
#line 5782 "parser_bison.c"
        break;

    case YYSYMBOL_chainid_spec: /* chainid_spec  */
#line 628 "parser_bison.y"
            { handle_free(&((*yyvaluep).handle)); }
#line 5788 "parser_bison.c"
        break;

    case YYSYMBOL_chain_identifier: /* chain_identifier  */
#line 628 "parser_bison.y"
            { handle_free(&((*yyvaluep).handle)); }
#line 5794 "parser_bison.c"
        break;

    case YYSYMBOL_set_spec: /* set_spec  */
#line 630 "parser_bison.y"
            { handle_free(&((*yyvaluep).handle)); }
#line 5800 "parser_bison.c"
        break;

    case YYSYMBOL_setid_spec: /* setid_spec  */
#line 630 "parser_bison.y"
            { handle_free(&((*yyvaluep).handle)); }
#line 5806 "parser_bison.c"
        break;

    case YYSYMBOL_set_identifier: /* set_identifier  */
#line 630 "parser_bison.y"
            { handle_free(&((*yyvaluep).handle)); }
#line 5812 "parser_bison.c"
        break;

    case YYSYMBOL_flowtable_spec: /* flowtable_spec  */
#line 628 "parser_bison.y"
            { handle_free(&((*yyvaluep).handle)); }
#line 5818 "parser_bison.c"
        break;

    case YYSYMBOL_flowtableid_spec: /* flowtableid_spec  */
#line 630 "parser_bison.y"
            { handle_free(&((*yyvaluep).handle)); }
#line 5824 "parser_bison.c"
        break;

    case YYSYMBOL_obj_spec: /* obj_spec  */
#line 630 "parser_bison.y"
            { handle_free(&((*yyvaluep).handle)); }
#line 5830 "parser_bison.c"
        break;

    case YYSYMBOL_objid_spec: /* objid_spec  */
#line 630 "parser_bison.y"
            { handle_free(&((*yyvaluep).handle)); }
#line 5836 "parser_bison.c"
        break;

    case YYSYMBOL_obj_identifier: /* obj_identifier  */
#line 630 "parser_bison.y"
            { handle_free(&((*yyvaluep).handle)); }
#line 5842 "parser_bison.c"
        break;

    case YYSYMBOL_handle_spec: /* handle_spec  */
#line 628 "parser_bison.y"
            { handle_free(&((*yyvaluep).handle)); }
#line 5848 "parser_bison.c"
        break;

    case YYSYMBOL_position_spec: /* position_spec  */
#line 628 "parser_bison.y"
            { handle_free(&((*yyvaluep).handle)); }
#line 5854 "parser_bison.c"
        break;

    case YYSYMBOL_index_spec: /* index_spec  */
#line 628 "parser_bison.y"
            { handle_free(&((*yyvaluep).handle)); }
#line 5860 "parser_bison.c"
        break;

    case YYSYMBOL_rule_position: /* rule_position  */
#line 628 "parser_bison.y"
            { handle_free(&((*yyvaluep).handle)); }
#line 5866 "parser_bison.c"
        break;

    case YYSYMBOL_ruleid_spec: /* ruleid_spec  */
#line 628 "parser_bison.y"
            { handle_free(&((*yyvaluep).handle)); }
#line 5872 "parser_bison.c"
        break;

    case YYSYMBOL_comment_spec: /* comment_spec  */
#line 614 "parser_bison.y"
            { xfree(((*yyvaluep).string)); }
#line 5878 "parser_bison.c"
        break;

    case YYSYMBOL_ruleset_spec: /* ruleset_spec  */
#line 628 "parser_bison.y"
            { handle_free(&((*yyvaluep).handle)); }
#line 5884 "parser_bison.c"
        break;

    case YYSYMBOL_rule: /* rule  */
#line 645 "parser_bison.y"
            { rule_free(((*yyvaluep).rule)); }
#line 5890 "parser_bison.c"
        break;

    case YYSYMBOL_stmt_list: /* stmt_list  */
#line 664 "parser_bison.y"
            { stmt_list_free(((*yyvaluep).list)); xfree(((*yyvaluep).list)); }
#line 5896 "parser_bison.c"
        break;

    case YYSYMBOL_stateful_stmt_list: /* stateful_stmt_list  */
#line 664 "parser_bison.y"
            { stmt_list_free(((*yyvaluep).list)); xfree(((*yyvaluep).list)); }
#line 5902 "parser_bison.c"
        break;

    case YYSYMBOL_stateful_stmt: /* stateful_stmt  */
#line 668 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 5908 "parser_bison.c"
        break;

    case YYSYMBOL_stmt: /* stmt  */
#line 666 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 5914 "parser_bison.c"
        break;

    case YYSYMBOL_chain_stmt: /* chain_stmt  */
#line 691 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 5920 "parser_bison.c"
        break;

    case YYSYMBOL_verdict_stmt: /* verdict_stmt  */
#line 666 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 5926 "parser_bison.c"
        break;

    case YYSYMBOL_verdict_map_stmt: /* verdict_map_stmt  */
#line 747 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 5932 "parser_bison.c"
        break;

    case YYSYMBOL_verdict_map_expr: /* verdict_map_expr  */
#line 750 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 5938 "parser_bison.c"
        break;

    case YYSYMBOL_verdict_map_list_expr: /* verdict_map_list_expr  */
#line 750 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 5944 "parser_bison.c"
        break;

    case YYSYMBOL_verdict_map_list_member_expr: /* verdict_map_list_member_expr  */
#line 750 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 5950 "parser_bison.c"
        break;

    case YYSYMBOL_connlimit_stmt: /* connlimit_stmt  */
#line 679 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 5956 "parser_bison.c"
        break;

    case YYSYMBOL_counter_stmt: /* counter_stmt  */
#line 668 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 5962 "parser_bison.c"
        break;

    case YYSYMBOL_counter_stmt_alloc: /* counter_stmt_alloc  */
#line 668 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 5968 "parser_bison.c"
        break;

    case YYSYMBOL_log_stmt: /* log_stmt  */
#line 676 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 5974 "parser_bison.c"
        break;

    case YYSYMBOL_log_stmt_alloc: /* log_stmt_alloc  */
#line 676 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 5980 "parser_bison.c"
        break;

    case YYSYMBOL_limit_stmt: /* limit_stmt  */
#line 679 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 5986 "parser_bison.c"
        break;

    case YYSYMBOL_quota_unit: /* quota_unit  */
#line 635 "parser_bison.y"
            { xfree(((*yyvaluep).string)); }
#line 5992 "parser_bison.c"
        break;

    case YYSYMBOL_quota_stmt: /* quota_stmt  */
#line 679 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 5998 "parser_bison.c"
        break;

    case YYSYMBOL_reject_stmt: /* reject_stmt  */
#line 682 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 6004 "parser_bison.c"
        break;

    case YYSYMBOL_reject_stmt_alloc: /* reject_stmt_alloc  */
#line 682 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 6010 "parser_bison.c"
        break;

    case YYSYMBOL_nat_stmt: /* nat_stmt  */
#line 684 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 6016 "parser_bison.c"
        break;

    case YYSYMBOL_nat_stmt_alloc: /* nat_stmt_alloc  */
#line 684 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 6022 "parser_bison.c"
        break;

    case YYSYMBOL_tproxy_stmt: /* tproxy_stmt  */
#line 687 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 6028 "parser_bison.c"
        break;

    case YYSYMBOL_synproxy_stmt: /* synproxy_stmt  */
#line 689 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 6034 "parser_bison.c"
        break;

    case YYSYMBOL_synproxy_stmt_alloc: /* synproxy_stmt_alloc  */
#line 689 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 6040 "parser_bison.c"
        break;

    case YYSYMBOL_synproxy_obj: /* synproxy_obj  */
#line 773 "parser_bison.y"
            { obj_free(((*yyvaluep).obj)); }
#line 6046 "parser_bison.c"
        break;

    case YYSYMBOL_primary_stmt_expr: /* primary_stmt_expr  */
#line 734 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6052 "parser_bison.c"
        break;

    case YYSYMBOL_shift_stmt_expr: /* shift_stmt_expr  */
#line 736 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6058 "parser_bison.c"
        break;

    case YYSYMBOL_and_stmt_expr: /* and_stmt_expr  */
#line 738 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6064 "parser_bison.c"
        break;

    case YYSYMBOL_exclusive_or_stmt_expr: /* exclusive_or_stmt_expr  */
#line 738 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6070 "parser_bison.c"
        break;

    case YYSYMBOL_inclusive_or_stmt_expr: /* inclusive_or_stmt_expr  */
#line 738 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6076 "parser_bison.c"
        break;

    case YYSYMBOL_basic_stmt_expr: /* basic_stmt_expr  */
#line 734 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6082 "parser_bison.c"
        break;

    case YYSYMBOL_concat_stmt_expr: /* concat_stmt_expr  */
#line 726 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6088 "parser_bison.c"
        break;

    case YYSYMBOL_map_stmt_expr_set: /* map_stmt_expr_set  */
#line 726 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6094 "parser_bison.c"
        break;

    case YYSYMBOL_map_stmt_expr: /* map_stmt_expr  */
#line 726 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6100 "parser_bison.c"
        break;

    case YYSYMBOL_prefix_stmt_expr: /* prefix_stmt_expr  */
#line 731 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6106 "parser_bison.c"
        break;

    case YYSYMBOL_range_stmt_expr: /* range_stmt_expr  */
#line 731 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6112 "parser_bison.c"
        break;

    case YYSYMBOL_wildcard_expr: /* wildcard_expr  */
#line 731 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6118 "parser_bison.c"
        break;

    case YYSYMBOL_multiton_stmt_expr: /* multiton_stmt_expr  */
#line 729 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6124 "parser_bison.c"
        break;

    case YYSYMBOL_stmt_expr: /* stmt_expr  */
#line 726 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6130 "parser_bison.c"
        break;

    case YYSYMBOL_masq_stmt: /* masq_stmt  */
#line 684 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 6136 "parser_bison.c"
        break;

    case YYSYMBOL_masq_stmt_alloc: /* masq_stmt_alloc  */
#line 684 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 6142 "parser_bison.c"
        break;

    case YYSYMBOL_redir_stmt: /* redir_stmt  */
#line 684 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 6148 "parser_bison.c"
        break;

    case YYSYMBOL_redir_stmt_alloc: /* redir_stmt_alloc  */
#line 684 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 6154 "parser_bison.c"
        break;

    case YYSYMBOL_dup_stmt: /* dup_stmt  */
#line 698 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 6160 "parser_bison.c"
        break;

    case YYSYMBOL_fwd_stmt: /* fwd_stmt  */
#line 700 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 6166 "parser_bison.c"
        break;

    case YYSYMBOL_queue_stmt: /* queue_stmt  */
#line 695 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 6172 "parser_bison.c"
        break;

    case YYSYMBOL_queue_stmt_alloc: /* queue_stmt_alloc  */
#line 695 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 6178 "parser_bison.c"
        break;

    case YYSYMBOL_set_elem_expr_stmt: /* set_elem_expr_stmt  */
#line 757 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6184 "parser_bison.c"
        break;

    case YYSYMBOL_set_elem_expr_stmt_alloc: /* set_elem_expr_stmt_alloc  */
#line 757 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6190 "parser_bison.c"
        break;

    case YYSYMBOL_set_stmt: /* set_stmt  */
#line 702 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 6196 "parser_bison.c"
        break;

    case YYSYMBOL_map_stmt: /* map_stmt  */
#line 705 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 6202 "parser_bison.c"
        break;

    case YYSYMBOL_meter_stmt: /* meter_stmt  */
#line 707 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 6208 "parser_bison.c"
        break;

    case YYSYMBOL_flow_stmt_legacy_alloc: /* flow_stmt_legacy_alloc  */
#line 707 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 6214 "parser_bison.c"
        break;

    case YYSYMBOL_meter_stmt_alloc: /* meter_stmt_alloc  */
#line 707 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 6220 "parser_bison.c"
        break;

    case YYSYMBOL_match_stmt: /* match_stmt  */
#line 666 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 6226 "parser_bison.c"
        break;

    case YYSYMBOL_variable_expr: /* variable_expr  */
#line 710 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6232 "parser_bison.c"
        break;

    case YYSYMBOL_symbol_expr: /* symbol_expr  */
#line 710 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6238 "parser_bison.c"
        break;

    case YYSYMBOL_set_ref_expr: /* set_ref_expr  */
#line 718 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6244 "parser_bison.c"
        break;

    case YYSYMBOL_set_ref_symbol_expr: /* set_ref_symbol_expr  */
#line 718 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6250 "parser_bison.c"
        break;

    case YYSYMBOL_integer_expr: /* integer_expr  */
#line 710 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6256 "parser_bison.c"
        break;

    case YYSYMBOL_primary_expr: /* primary_expr  */
#line 712 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6262 "parser_bison.c"
        break;

    case YYSYMBOL_fib_expr: /* fib_expr  */
#line 842 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6268 "parser_bison.c"
        break;

    case YYSYMBOL_osf_expr: /* osf_expr  */
#line 847 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6274 "parser_bison.c"
        break;

    case YYSYMBOL_shift_expr: /* shift_expr  */
#line 712 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6280 "parser_bison.c"
        break;

    case YYSYMBOL_and_expr: /* and_expr  */
#line 712 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6286 "parser_bison.c"
        break;

    case YYSYMBOL_exclusive_or_expr: /* exclusive_or_expr  */
#line 714 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6292 "parser_bison.c"
        break;

    case YYSYMBOL_inclusive_or_expr: /* inclusive_or_expr  */
#line 714 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6298 "parser_bison.c"
        break;

    case YYSYMBOL_basic_expr: /* basic_expr  */
#line 716 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6304 "parser_bison.c"
        break;

    case YYSYMBOL_concat_expr: /* concat_expr  */
#line 741 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6310 "parser_bison.c"
        break;

    case YYSYMBOL_prefix_rhs_expr: /* prefix_rhs_expr  */
#line 723 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6316 "parser_bison.c"
        break;

    case YYSYMBOL_range_rhs_expr: /* range_rhs_expr  */
#line 723 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6322 "parser_bison.c"
        break;

    case YYSYMBOL_multiton_rhs_expr: /* multiton_rhs_expr  */
#line 721 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6328 "parser_bison.c"
        break;

    case YYSYMBOL_map_expr: /* map_expr  */
#line 744 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6334 "parser_bison.c"
        break;

    case YYSYMBOL_expr: /* expr  */
#line 763 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6340 "parser_bison.c"
        break;

    case YYSYMBOL_set_expr: /* set_expr  */
#line 753 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6346 "parser_bison.c"
        break;

    case YYSYMBOL_set_list_expr: /* set_list_expr  */
#line 753 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6352 "parser_bison.c"
        break;

    case YYSYMBOL_set_list_member_expr: /* set_list_member_expr  */
#line 753 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6358 "parser_bison.c"
        break;

    case YYSYMBOL_meter_key_expr: /* meter_key_expr  */
#line 760 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6364 "parser_bison.c"
        break;

    case YYSYMBOL_meter_key_expr_alloc: /* meter_key_expr_alloc  */
#line 760 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6370 "parser_bison.c"
        break;

    case YYSYMBOL_set_elem_expr: /* set_elem_expr  */
#line 755 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6376 "parser_bison.c"
        break;

    case YYSYMBOL_set_elem_expr_alloc: /* set_elem_expr_alloc  */
#line 755 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6382 "parser_bison.c"
        break;

    case YYSYMBOL_set_elem_stmt_list: /* set_elem_stmt_list  */
#line 664 "parser_bison.y"
            { stmt_list_free(((*yyvaluep).list)); xfree(((*yyvaluep).list)); }
#line 6388 "parser_bison.c"
        break;

    case YYSYMBOL_set_elem_stmt: /* set_elem_stmt  */
#line 666 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 6394 "parser_bison.c"
        break;

    case YYSYMBOL_set_lhs_expr: /* set_lhs_expr  */
#line 755 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6400 "parser_bison.c"
        break;

    case YYSYMBOL_set_rhs_expr: /* set_rhs_expr  */
#line 755 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6406 "parser_bison.c"
        break;

    case YYSYMBOL_initializer_expr: /* initializer_expr  */
#line 763 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6412 "parser_bison.c"
        break;

    case YYSYMBOL_counter_obj: /* counter_obj  */
#line 773 "parser_bison.y"
            { obj_free(((*yyvaluep).obj)); }
#line 6418 "parser_bison.c"
        break;

    case YYSYMBOL_quota_obj: /* quota_obj  */
#line 773 "parser_bison.y"
            { obj_free(((*yyvaluep).obj)); }
#line 6424 "parser_bison.c"
        break;

    case YYSYMBOL_secmark_obj: /* secmark_obj  */
#line 773 "parser_bison.y"
            { obj_free(((*yyvaluep).obj)); }
#line 6430 "parser_bison.c"
        break;

    case YYSYMBOL_timeout_states: /* timeout_states  */
#line 872 "parser_bison.y"
            { xfree(((*yyvaluep).list)); }
#line 6436 "parser_bison.c"
        break;

    case YYSYMBOL_timeout_state: /* timeout_state  */
#line 872 "parser_bison.y"
            { xfree(((*yyvaluep).list)); }
#line 6442 "parser_bison.c"
        break;

    case YYSYMBOL_ct_obj_alloc: /* ct_obj_alloc  */
#line 773 "parser_bison.y"
            { obj_free(((*yyvaluep).obj)); }
#line 6448 "parser_bison.c"
        break;

    case YYSYMBOL_limit_obj: /* limit_obj  */
#line 773 "parser_bison.y"
            { obj_free(((*yyvaluep).obj)); }
#line 6454 "parser_bison.c"
        break;

    case YYSYMBOL_relational_expr: /* relational_expr  */
#line 776 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6460 "parser_bison.c"
        break;

    case YYSYMBOL_list_rhs_expr: /* list_rhs_expr  */
#line 768 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6466 "parser_bison.c"
        break;

    case YYSYMBOL_rhs_expr: /* rhs_expr  */
#line 766 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6472 "parser_bison.c"
        break;

    case YYSYMBOL_shift_rhs_expr: /* shift_rhs_expr  */
#line 768 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6478 "parser_bison.c"
        break;

    case YYSYMBOL_and_rhs_expr: /* and_rhs_expr  */
#line 770 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6484 "parser_bison.c"
        break;

    case YYSYMBOL_exclusive_or_rhs_expr: /* exclusive_or_rhs_expr  */
#line 770 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6490 "parser_bison.c"
        break;

    case YYSYMBOL_inclusive_or_rhs_expr: /* inclusive_or_rhs_expr  */
#line 770 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6496 "parser_bison.c"
        break;

    case YYSYMBOL_basic_rhs_expr: /* basic_rhs_expr  */
#line 766 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6502 "parser_bison.c"
        break;

    case YYSYMBOL_concat_rhs_expr: /* concat_rhs_expr  */
#line 766 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6508 "parser_bison.c"
        break;

    case YYSYMBOL_boolean_expr: /* boolean_expr  */
#line 862 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6514 "parser_bison.c"
        break;

    case YYSYMBOL_keyword_expr: /* keyword_expr  */
#line 763 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6520 "parser_bison.c"
        break;

    case YYSYMBOL_primary_rhs_expr: /* primary_rhs_expr  */
#line 768 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6526 "parser_bison.c"
        break;

    case YYSYMBOL_verdict_expr: /* verdict_expr  */
#line 710 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6532 "parser_bison.c"
        break;

    case YYSYMBOL_chain_expr: /* chain_expr  */
#line 710 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6538 "parser_bison.c"
        break;

    case YYSYMBOL_meta_expr: /* meta_expr  */
#line 824 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6544 "parser_bison.c"
        break;

    case YYSYMBOL_meta_stmt: /* meta_stmt  */
#line 674 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 6550 "parser_bison.c"
        break;

    case YYSYMBOL_socket_expr: /* socket_expr  */
#line 828 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6556 "parser_bison.c"
        break;

    case YYSYMBOL_numgen_expr: /* numgen_expr  */
#line 789 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6562 "parser_bison.c"
        break;

    case YYSYMBOL_xfrm_expr: /* xfrm_expr  */
#line 876 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6568 "parser_bison.c"
        break;

    case YYSYMBOL_hash_expr: /* hash_expr  */
#line 789 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6574 "parser_bison.c"
        break;

    case YYSYMBOL_rt_expr: /* rt_expr  */
#line 834 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6580 "parser_bison.c"
        break;

    case YYSYMBOL_ct_expr: /* ct_expr  */
#line 838 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6586 "parser_bison.c"
        break;

    case YYSYMBOL_symbol_stmt_expr: /* symbol_stmt_expr  */
#line 768 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6592 "parser_bison.c"
        break;

    case YYSYMBOL_list_stmt_expr: /* list_stmt_expr  */
#line 736 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6598 "parser_bison.c"
        break;

    case YYSYMBOL_ct_stmt: /* ct_stmt  */
#line 672 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 6604 "parser_bison.c"
        break;

    case YYSYMBOL_payload_stmt: /* payload_stmt  */
#line 670 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 6610 "parser_bison.c"
        break;

    case YYSYMBOL_payload_expr: /* payload_expr  */
#line 780 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6616 "parser_bison.c"
        break;

    case YYSYMBOL_payload_raw_expr: /* payload_raw_expr  */
#line 780 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6622 "parser_bison.c"
        break;

    case YYSYMBOL_eth_hdr_expr: /* eth_hdr_expr  */
#line 783 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6628 "parser_bison.c"
        break;

    case YYSYMBOL_vlan_hdr_expr: /* vlan_hdr_expr  */
#line 783 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6634 "parser_bison.c"
        break;

    case YYSYMBOL_arp_hdr_expr: /* arp_hdr_expr  */
#line 786 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6640 "parser_bison.c"
        break;

    case YYSYMBOL_ip_hdr_expr: /* ip_hdr_expr  */
#line 789 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6646 "parser_bison.c"
        break;

    case YYSYMBOL_icmp_hdr_expr: /* icmp_hdr_expr  */
#line 789 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6652 "parser_bison.c"
        break;

    case YYSYMBOL_igmp_hdr_expr: /* igmp_hdr_expr  */
#line 789 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6658 "parser_bison.c"
        break;

    case YYSYMBOL_ip6_hdr_expr: /* ip6_hdr_expr  */
#line 793 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6664 "parser_bison.c"
        break;

    case YYSYMBOL_icmp6_hdr_expr: /* icmp6_hdr_expr  */
#line 793 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6670 "parser_bison.c"
        break;

    case YYSYMBOL_auth_hdr_expr: /* auth_hdr_expr  */
#line 796 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6676 "parser_bison.c"
        break;

    case YYSYMBOL_esp_hdr_expr: /* esp_hdr_expr  */
#line 796 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6682 "parser_bison.c"
        break;

    case YYSYMBOL_comp_hdr_expr: /* comp_hdr_expr  */
#line 796 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6688 "parser_bison.c"
        break;

    case YYSYMBOL_udp_hdr_expr: /* udp_hdr_expr  */
#line 799 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6694 "parser_bison.c"
        break;

    case YYSYMBOL_udplite_hdr_expr: /* udplite_hdr_expr  */
#line 799 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6700 "parser_bison.c"
        break;

    case YYSYMBOL_tcp_hdr_expr: /* tcp_hdr_expr  */
#line 857 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6706 "parser_bison.c"
        break;

    case YYSYMBOL_dccp_hdr_expr: /* dccp_hdr_expr  */
#line 802 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6712 "parser_bison.c"
        break;

    case YYSYMBOL_sctp_chunk_alloc: /* sctp_chunk_alloc  */
#line 802 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6718 "parser_bison.c"
        break;

    case YYSYMBOL_sctp_hdr_expr: /* sctp_hdr_expr  */
#line 802 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6724 "parser_bison.c"
        break;

    case YYSYMBOL_th_hdr_expr: /* th_hdr_expr  */
#line 808 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6730 "parser_bison.c"
        break;

    case YYSYMBOL_exthdr_expr: /* exthdr_expr  */
#line 812 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6736 "parser_bison.c"
        break;

    case YYSYMBOL_hbh_hdr_expr: /* hbh_hdr_expr  */
#line 814 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6742 "parser_bison.c"
        break;

    case YYSYMBOL_rt_hdr_expr: /* rt_hdr_expr  */
#line 817 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6748 "parser_bison.c"
        break;

    case YYSYMBOL_rt0_hdr_expr: /* rt0_hdr_expr  */
#line 817 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6754 "parser_bison.c"
        break;

    case YYSYMBOL_rt2_hdr_expr: /* rt2_hdr_expr  */
#line 817 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6760 "parser_bison.c"
        break;

    case YYSYMBOL_rt4_hdr_expr: /* rt4_hdr_expr  */
#line 817 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6766 "parser_bison.c"
        break;

    case YYSYMBOL_frag_hdr_expr: /* frag_hdr_expr  */
#line 814 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6772 "parser_bison.c"
        break;

    case YYSYMBOL_dst_hdr_expr: /* dst_hdr_expr  */
#line 814 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6778 "parser_bison.c"
        break;

    case YYSYMBOL_mh_hdr_expr: /* mh_hdr_expr  */
#line 820 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6784 "parser_bison.c"
        break;

    case YYSYMBOL_exthdr_exists_expr: /* exthdr_exists_expr  */
#line 866 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6790 "parser_bison.c"
        break;

      default:
        break;
    }
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}






/*----------.
| yyparse.  |
`----------*/

int
yyparse (struct nft_ctx *nft, void *scanner, struct parser_state *state)
{
/* Lookahead token kind.  */
int yychar;


/* The semantic value of the lookahead symbol.  */
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
YY_INITIAL_VALUE (static YYSTYPE yyval_default;)
YYSTYPE yylval YY_INITIAL_VALUE (= yyval_default);

/* Location data for the lookahead symbol.  */
static YYLTYPE yyloc_default
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
YYLTYPE yylloc = yyloc_default;

    /* Number of syntax errors so far.  */
    int yynerrs = 0;

    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

    /* The location stack: array, bottom, top.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls = yylsa;
    YYLTYPE *yylsp = yyls;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

  /* The locations where the error started and ended.  */
  YYLTYPE yyerror_range[3];

  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYPTRDIFF_T yymsg_alloc = sizeof yymsgbuf;

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

/* User initialization code.  */
#line 159 "parser_bison.y"
{
	location_init(scanner, state, &yylloc);
	if (nft->debug_mask & NFT_DEBUG_SCANNER)
		nft_set_debug(1, scanner);
	if (nft->debug_mask & NFT_DEBUG_PARSER)
		yydebug = 1;
}

#line 6895 "parser_bison.c"

  yylsp[0] = yylloc;
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    goto yyexhaustedlab;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yyls1, yysize * YYSIZEOF (*yylsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
        yyls = yyls1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex (&yylval, &yylloc, scanner);
    }

  if (yychar <= TOKEN_EOF)
    {
      yychar = TOKEN_EOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      yyerror_range[1] = yylloc;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location. */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  yyerror_range[1] = yyloc;
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 3: /* input: input line  */
#line 882 "parser_bison.y"
                        {
				if ((yyvsp[0].cmd) != NULL) {
					(yyvsp[0].cmd)->location = (yylsp[0]);
					list_add_tail(&(yyvsp[0].cmd)->list, state->cmds);
				}
			}
#line 7112 "parser_bison.c"
    break;

  case 8: /* close_scope_hash: %empty  */
#line 898 "parser_bison.y"
                          { scanner_pop_start_cond(nft->scanner, PARSER_SC_EXPR_HASH); }
#line 7118 "parser_bison.c"
    break;

  case 9: /* close_scope_numgen: %empty  */
#line 899 "parser_bison.y"
                          { scanner_pop_start_cond(nft->scanner, PARSER_SC_EXPR_NUMGEN); }
#line 7124 "parser_bison.c"
    break;

  case 10: /* close_scope_sctp: %empty  */
#line 900 "parser_bison.y"
                          { scanner_pop_start_cond(nft->scanner, PARSER_SC_SCTP); }
#line 7130 "parser_bison.c"
    break;

  case 11: /* close_scope_sctp_chunk: %empty  */
#line 901 "parser_bison.y"
                          { scanner_pop_start_cond(nft->scanner, PARSER_SC_EXPR_SCTP_CHUNK); }
#line 7136 "parser_bison.c"
    break;

  case 12: /* common_block: "include" "quoted string" stmt_separator  */
#line 904 "parser_bison.y"
                        {
				if (scanner_include_file(nft, scanner, (yyvsp[-1].string), &(yyloc)) < 0) {
					xfree((yyvsp[-1].string));
					YYERROR;
				}
				xfree((yyvsp[-1].string));
			}
#line 7148 "parser_bison.c"
    break;

  case 13: /* common_block: "define" identifier '=' initializer_expr stmt_separator  */
#line 912 "parser_bison.y"
                        {
				struct scope *scope = current_scope(state);

				if (symbol_lookup(scope, (yyvsp[-3].string)) != NULL) {
					erec_queue(error(&(yylsp[-3]), "redefinition of symbol '%s'", (yyvsp[-3].string)),
						   state->msgs);
					expr_free((yyvsp[-1].expr));
					xfree((yyvsp[-3].string));
					YYERROR;
				}

				symbol_bind(scope, (yyvsp[-3].string), (yyvsp[-1].expr));
				xfree((yyvsp[-3].string));
			}
#line 7167 "parser_bison.c"
    break;

  case 14: /* common_block: "redefine" identifier '=' initializer_expr stmt_separator  */
#line 927 "parser_bison.y"
                        {
				struct scope *scope = current_scope(state);

				symbol_bind(scope, (yyvsp[-3].string), (yyvsp[-1].expr));
				xfree((yyvsp[-3].string));
			}
#line 7178 "parser_bison.c"
    break;

  case 15: /* common_block: "undefine" identifier stmt_separator  */
#line 934 "parser_bison.y"
                        {
				struct scope *scope = current_scope(state);

				if (symbol_unbind(scope, (yyvsp[-1].string)) < 0) {
					erec_queue(error(&(yylsp[-1]), "undefined symbol '%s'", (yyvsp[-1].string)),
						   state->msgs);
					YYERROR;
				}
				xfree((yyvsp[-1].string));
			}
#line 7193 "parser_bison.c"
    break;

  case 16: /* common_block: error stmt_separator  */
#line 945 "parser_bison.y"
                        {
				if (++state->nerrs == nft->parser_max_errors)
					YYABORT;
				yyerrok;
			}
#line 7203 "parser_bison.c"
    break;

  case 17: /* line: common_block  */
#line 952 "parser_bison.y"
                                                                { (yyval.cmd) = NULL; }
#line 7209 "parser_bison.c"
    break;

  case 18: /* line: stmt_separator  */
#line 953 "parser_bison.y"
                                                                { (yyval.cmd) = NULL; }
#line 7215 "parser_bison.c"
    break;

  case 19: /* line: base_cmd stmt_separator  */
#line 954 "parser_bison.y"
                                                                { (yyval.cmd) = (yyvsp[-1].cmd); }
#line 7221 "parser_bison.c"
    break;

  case 20: /* line: base_cmd "end of file"  */
#line 956 "parser_bison.y"
                        {
				/*
				 * Very hackish workaround for bison >= 2.4: previous versions
				 * terminated parsing after EOF, 2.4+ tries to get further input
				 * in 'input' and calls the scanner again, causing a crash when
				 * the final input buffer has been popped. Terminate manually to
				 * avoid this. The correct fix should be to adjust the grammar
				 * to accept EOF in input, but for unknown reasons it does not
				 * work.
				 */
				if ((yyvsp[-1].cmd) != NULL) {
					(yyvsp[-1].cmd)->location = (yylsp[-1]);
					list_add_tail(&(yyvsp[-1].cmd)->list, state->cmds);
				}
				(yyval.cmd) = NULL;
				YYACCEPT;
			}
#line 7243 "parser_bison.c"
    break;

  case 21: /* base_cmd: add_cmd  */
#line 975 "parser_bison.y"
                                                                { (yyval.cmd) = (yyvsp[0].cmd); }
#line 7249 "parser_bison.c"
    break;

  case 22: /* base_cmd: "add" add_cmd  */
#line 976 "parser_bison.y"
                                                                { (yyval.cmd) = (yyvsp[0].cmd); }
#line 7255 "parser_bison.c"
    break;

  case 23: /* base_cmd: "replace" replace_cmd  */
#line 977 "parser_bison.y"
                                                                { (yyval.cmd) = (yyvsp[0].cmd); }
#line 7261 "parser_bison.c"
    break;

  case 24: /* base_cmd: "create" create_cmd  */
#line 978 "parser_bison.y"
                                                                { (yyval.cmd) = (yyvsp[0].cmd); }
#line 7267 "parser_bison.c"
    break;

  case 25: /* base_cmd: "insert" insert_cmd  */
#line 979 "parser_bison.y"
                                                                { (yyval.cmd) = (yyvsp[0].cmd); }
#line 7273 "parser_bison.c"
    break;

  case 26: /* base_cmd: "delete" delete_cmd  */
#line 980 "parser_bison.y"
                                                                { (yyval.cmd) = (yyvsp[0].cmd); }
#line 7279 "parser_bison.c"
    break;

  case 27: /* base_cmd: "get" get_cmd  */
#line 981 "parser_bison.y"
                                                                { (yyval.cmd) = (yyvsp[0].cmd); }
#line 7285 "parser_bison.c"
    break;

  case 28: /* base_cmd: "list" list_cmd  */
#line 982 "parser_bison.y"
                                                                { (yyval.cmd) = (yyvsp[0].cmd); }
#line 7291 "parser_bison.c"
    break;

  case 29: /* base_cmd: "reset" reset_cmd  */
#line 983 "parser_bison.y"
                                                                { (yyval.cmd) = (yyvsp[0].cmd); }
#line 7297 "parser_bison.c"
    break;

  case 30: /* base_cmd: "flush" flush_cmd  */
#line 984 "parser_bison.y"
                                                                { (yyval.cmd) = (yyvsp[0].cmd); }
#line 7303 "parser_bison.c"
    break;

  case 31: /* base_cmd: "rename" rename_cmd  */
#line 985 "parser_bison.y"
                                                                { (yyval.cmd) = (yyvsp[0].cmd); }
#line 7309 "parser_bison.c"
    break;

  case 32: /* base_cmd: "import" import_cmd  */
#line 986 "parser_bison.y"
                                                                { (yyval.cmd) = (yyvsp[0].cmd); }
#line 7315 "parser_bison.c"
    break;

  case 33: /* base_cmd: "export" export_cmd  */
#line 987 "parser_bison.y"
                                                                { (yyval.cmd) = (yyvsp[0].cmd); }
#line 7321 "parser_bison.c"
    break;

  case 34: /* base_cmd: "monitor" monitor_cmd  */
#line 988 "parser_bison.y"
                                                                { (yyval.cmd) = (yyvsp[0].cmd); }
#line 7327 "parser_bison.c"
    break;

  case 35: /* base_cmd: "describe" describe_cmd  */
#line 989 "parser_bison.y"
                                                                { (yyval.cmd) = (yyvsp[0].cmd); }
#line 7333 "parser_bison.c"
    break;

  case 36: /* add_cmd: "table" table_spec  */
#line 993 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_ADD, CMD_OBJ_TABLE, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7341 "parser_bison.c"
    break;

  case 37: /* add_cmd: "table" table_spec table_block_alloc '{' table_block '}'  */
#line 998 "parser_bison.y"
                        {
				handle_merge(&(yyvsp[-3].table)->handle, &(yyvsp[-4].handle));
				close_scope(state);
				(yyval.cmd) = cmd_alloc(CMD_ADD, CMD_OBJ_TABLE, &(yyvsp[-4].handle), &(yyloc), (yyvsp[-1].table));
			}
#line 7351 "parser_bison.c"
    break;

  case 38: /* add_cmd: "chain" chain_spec  */
#line 1004 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_ADD, CMD_OBJ_CHAIN, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7359 "parser_bison.c"
    break;

  case 39: /* add_cmd: "chain" chain_spec chain_block_alloc '{' chain_block '}'  */
#line 1009 "parser_bison.y"
                        {
				(yyvsp[-1].chain)->location = (yylsp[-1]);
				handle_merge(&(yyvsp[-3].chain)->handle, &(yyvsp[-4].handle));
				close_scope(state);
				(yyval.cmd) = cmd_alloc(CMD_ADD, CMD_OBJ_CHAIN, &(yyvsp[-4].handle), &(yyloc), (yyvsp[-1].chain));
			}
#line 7370 "parser_bison.c"
    break;

  case 40: /* add_cmd: "rule" rule_position rule  */
#line 1016 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_ADD, CMD_OBJ_RULE, &(yyvsp[-1].handle), &(yyloc), (yyvsp[0].rule));
			}
#line 7378 "parser_bison.c"
    break;

  case 41: /* add_cmd: rule_position rule  */
#line 1020 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_ADD, CMD_OBJ_RULE, &(yyvsp[-1].handle), &(yyloc), (yyvsp[0].rule));
			}
#line 7386 "parser_bison.c"
    break;

  case 42: /* add_cmd: "set" set_spec set_block_alloc '{' set_block '}'  */
#line 1025 "parser_bison.y"
                        {
				(yyvsp[-1].set)->location = (yylsp[-1]);
				handle_merge(&(yyvsp[-3].set)->handle, &(yyvsp[-4].handle));
				(yyval.cmd) = cmd_alloc(CMD_ADD, CMD_OBJ_SET, &(yyvsp[-4].handle), &(yyloc), (yyvsp[-1].set));
			}
#line 7396 "parser_bison.c"
    break;

  case 43: /* add_cmd: "map" set_spec map_block_alloc '{' map_block '}'  */
#line 1032 "parser_bison.y"
                        {
				(yyvsp[-1].set)->location = (yylsp[-1]);
				handle_merge(&(yyvsp[-3].set)->handle, &(yyvsp[-4].handle));
				(yyval.cmd) = cmd_alloc(CMD_ADD, CMD_OBJ_SET, &(yyvsp[-4].handle), &(yyloc), (yyvsp[-1].set));
			}
#line 7406 "parser_bison.c"
    break;

  case 44: /* add_cmd: "element" set_spec set_block_expr  */
#line 1038 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_ADD, CMD_OBJ_ELEMENTS, &(yyvsp[-1].handle), &(yyloc), (yyvsp[0].expr));
			}
#line 7414 "parser_bison.c"
    break;

  case 45: /* add_cmd: "flowtable" flowtable_spec flowtable_block_alloc '{' flowtable_block '}'  */
#line 1043 "parser_bison.y"
                        {
				(yyvsp[-1].flowtable)->location = (yylsp[-1]);
				handle_merge(&(yyvsp[-3].flowtable)->handle, &(yyvsp[-4].handle));
				(yyval.cmd) = cmd_alloc(CMD_ADD, CMD_OBJ_FLOWTABLE, &(yyvsp[-4].handle), &(yyloc), (yyvsp[-1].flowtable));
			}
#line 7424 "parser_bison.c"
    break;

  case 46: /* add_cmd: "counter" obj_spec  */
#line 1049 "parser_bison.y"
                        {
				struct obj *obj;

				obj = obj_alloc(&(yyloc));
				obj->type = NFT_OBJECT_COUNTER;
				handle_merge(&obj->handle, &(yyvsp[0].handle));
				(yyval.cmd) = cmd_alloc(CMD_ADD, CMD_OBJ_COUNTER, &(yyvsp[0].handle), &(yyloc), obj);
			}
#line 7437 "parser_bison.c"
    break;

  case 47: /* add_cmd: "counter" obj_spec counter_obj counter_config  */
#line 1058 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_ADD, CMD_OBJ_COUNTER, &(yyvsp[-2].handle), &(yyloc), (yyvsp[-1].obj));
			}
#line 7445 "parser_bison.c"
    break;

  case 48: /* add_cmd: "counter" obj_spec counter_obj '{' counter_block '}'  */
#line 1062 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_ADD, CMD_OBJ_COUNTER, &(yyvsp[-4].handle), &(yyloc), (yyvsp[-3].obj));
			}
#line 7453 "parser_bison.c"
    break;

  case 49: /* add_cmd: "quota" obj_spec quota_obj quota_config  */
#line 1066 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_ADD, CMD_OBJ_QUOTA, &(yyvsp[-2].handle), &(yyloc), (yyvsp[-1].obj));
			}
#line 7461 "parser_bison.c"
    break;

  case 50: /* add_cmd: "quota" obj_spec quota_obj '{' quota_block '}'  */
#line 1070 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_ADD, CMD_OBJ_QUOTA, &(yyvsp[-4].handle), &(yyloc), (yyvsp[-3].obj));
			}
#line 7469 "parser_bison.c"
    break;

  case 51: /* add_cmd: "ct" "helper" obj_spec ct_obj_alloc '{' ct_helper_block '}'  */
#line 1074 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc_obj_ct(CMD_ADD, NFT_OBJECT_CT_HELPER, &(yyvsp[-4].handle), &(yyloc), (yyvsp[-3].obj));
			}
#line 7477 "parser_bison.c"
    break;

  case 52: /* add_cmd: "ct" "timeout" obj_spec ct_obj_alloc '{' ct_timeout_block '}'  */
#line 1078 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc_obj_ct(CMD_ADD, NFT_OBJECT_CT_TIMEOUT, &(yyvsp[-4].handle), &(yyloc), (yyvsp[-3].obj));
			}
#line 7485 "parser_bison.c"
    break;

  case 53: /* add_cmd: "ct" "expectation" obj_spec ct_obj_alloc '{' ct_expect_block '}'  */
#line 1082 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc_obj_ct(CMD_ADD, NFT_OBJECT_CT_EXPECT, &(yyvsp[-4].handle), &(yyloc), (yyvsp[-3].obj));
			}
#line 7493 "parser_bison.c"
    break;

  case 54: /* add_cmd: "limit" obj_spec limit_obj limit_config  */
#line 1086 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_ADD, CMD_OBJ_LIMIT, &(yyvsp[-2].handle), &(yyloc), (yyvsp[-1].obj));
			}
#line 7501 "parser_bison.c"
    break;

  case 55: /* add_cmd: "limit" obj_spec limit_obj '{' limit_block '}'  */
#line 1090 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_ADD, CMD_OBJ_LIMIT, &(yyvsp[-4].handle), &(yyloc), (yyvsp[-3].obj));
			}
#line 7509 "parser_bison.c"
    break;

  case 56: /* add_cmd: "secmark" obj_spec secmark_obj secmark_config  */
#line 1094 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_ADD, CMD_OBJ_SECMARK, &(yyvsp[-2].handle), &(yyloc), (yyvsp[-1].obj));
			}
#line 7517 "parser_bison.c"
    break;

  case 57: /* add_cmd: "secmark" obj_spec secmark_obj '{' secmark_block '}'  */
#line 1098 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_ADD, CMD_OBJ_SECMARK, &(yyvsp[-4].handle), &(yyloc), (yyvsp[-3].obj));
			}
#line 7525 "parser_bison.c"
    break;

  case 58: /* add_cmd: "synproxy" obj_spec synproxy_obj synproxy_config  */
#line 1102 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_ADD, CMD_OBJ_SYNPROXY, &(yyvsp[-2].handle), &(yyloc), (yyvsp[-1].obj));
			}
#line 7533 "parser_bison.c"
    break;

  case 59: /* add_cmd: "synproxy" obj_spec synproxy_obj '{' synproxy_block '}'  */
#line 1106 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_ADD, CMD_OBJ_SYNPROXY, &(yyvsp[-4].handle), &(yyloc), (yyvsp[-3].obj));
			}
#line 7541 "parser_bison.c"
    break;

  case 60: /* replace_cmd: "rule" ruleid_spec rule  */
#line 1112 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_REPLACE, CMD_OBJ_RULE, &(yyvsp[-1].handle), &(yyloc), (yyvsp[0].rule));
			}
#line 7549 "parser_bison.c"
    break;

  case 61: /* create_cmd: "table" table_spec  */
#line 1118 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_CREATE, CMD_OBJ_TABLE, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7557 "parser_bison.c"
    break;

  case 62: /* create_cmd: "table" table_spec table_block_alloc '{' table_block '}'  */
#line 1123 "parser_bison.y"
                        {
				handle_merge(&(yyvsp[-3].table)->handle, &(yyvsp[-4].handle));
				close_scope(state);
				(yyval.cmd) = cmd_alloc(CMD_CREATE, CMD_OBJ_TABLE, &(yyvsp[-4].handle), &(yyloc), (yyvsp[-1].table));
			}
#line 7567 "parser_bison.c"
    break;

  case 63: /* create_cmd: "chain" chain_spec  */
#line 1129 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_CREATE, CMD_OBJ_CHAIN, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7575 "parser_bison.c"
    break;

  case 64: /* create_cmd: "chain" chain_spec chain_block_alloc '{' chain_block '}'  */
#line 1134 "parser_bison.y"
                        {
				(yyvsp[-1].chain)->location = (yylsp[-1]);
				handle_merge(&(yyvsp[-3].chain)->handle, &(yyvsp[-4].handle));
				close_scope(state);
				(yyval.cmd) = cmd_alloc(CMD_CREATE, CMD_OBJ_CHAIN, &(yyvsp[-4].handle), &(yyloc), (yyvsp[-1].chain));
			}
#line 7586 "parser_bison.c"
    break;

  case 65: /* create_cmd: "set" set_spec set_block_alloc '{' set_block '}'  */
#line 1142 "parser_bison.y"
                        {
				(yyvsp[-1].set)->location = (yylsp[-1]);
				handle_merge(&(yyvsp[-3].set)->handle, &(yyvsp[-4].handle));
				(yyval.cmd) = cmd_alloc(CMD_CREATE, CMD_OBJ_SET, &(yyvsp[-4].handle), &(yyloc), (yyvsp[-1].set));
			}
#line 7596 "parser_bison.c"
    break;

  case 66: /* create_cmd: "map" set_spec map_block_alloc '{' map_block '}'  */
#line 1149 "parser_bison.y"
                        {
				(yyvsp[-1].set)->location = (yylsp[-1]);
				handle_merge(&(yyvsp[-3].set)->handle, &(yyvsp[-4].handle));
				(yyval.cmd) = cmd_alloc(CMD_CREATE, CMD_OBJ_SET, &(yyvsp[-4].handle), &(yyloc), (yyvsp[-1].set));
			}
#line 7606 "parser_bison.c"
    break;

  case 67: /* create_cmd: "element" set_spec set_block_expr  */
#line 1155 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_CREATE, CMD_OBJ_ELEMENTS, &(yyvsp[-1].handle), &(yyloc), (yyvsp[0].expr));
			}
#line 7614 "parser_bison.c"
    break;

  case 68: /* create_cmd: "flowtable" flowtable_spec flowtable_block_alloc '{' flowtable_block '}'  */
#line 1160 "parser_bison.y"
                        {
				(yyvsp[-1].flowtable)->location = (yylsp[-1]);
				handle_merge(&(yyvsp[-3].flowtable)->handle, &(yyvsp[-4].handle));
				(yyval.cmd) = cmd_alloc(CMD_CREATE, CMD_OBJ_FLOWTABLE, &(yyvsp[-4].handle), &(yyloc), (yyvsp[-1].flowtable));
			}
#line 7624 "parser_bison.c"
    break;

  case 69: /* create_cmd: "counter" obj_spec  */
#line 1166 "parser_bison.y"
                        {
				struct obj *obj;

				obj = obj_alloc(&(yyloc));
				obj->type = NFT_OBJECT_COUNTER;
				handle_merge(&obj->handle, &(yyvsp[0].handle));
				(yyval.cmd) = cmd_alloc(CMD_CREATE, CMD_OBJ_COUNTER, &(yyvsp[0].handle), &(yyloc), obj);
			}
#line 7637 "parser_bison.c"
    break;

  case 70: /* create_cmd: "counter" obj_spec counter_obj counter_config  */
#line 1175 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_CREATE, CMD_OBJ_COUNTER, &(yyvsp[-2].handle), &(yyloc), (yyvsp[-1].obj));
			}
#line 7645 "parser_bison.c"
    break;

  case 71: /* create_cmd: "quota" obj_spec quota_obj quota_config  */
#line 1179 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_CREATE, CMD_OBJ_QUOTA, &(yyvsp[-2].handle), &(yyloc), (yyvsp[-1].obj));
			}
#line 7653 "parser_bison.c"
    break;

  case 72: /* create_cmd: "ct" "helper" obj_spec ct_obj_alloc '{' ct_helper_block '}'  */
#line 1183 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc_obj_ct(CMD_CREATE, NFT_OBJECT_CT_HELPER, &(yyvsp[-4].handle), &(yyloc), (yyvsp[-3].obj));
			}
#line 7661 "parser_bison.c"
    break;

  case 73: /* create_cmd: "ct" "timeout" obj_spec ct_obj_alloc '{' ct_timeout_block '}'  */
#line 1187 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc_obj_ct(CMD_CREATE, NFT_OBJECT_CT_TIMEOUT, &(yyvsp[-4].handle), &(yyloc), (yyvsp[-3].obj));
			}
#line 7669 "parser_bison.c"
    break;

  case 74: /* create_cmd: "ct" "expectation" obj_spec ct_obj_alloc '{' ct_expect_block '}'  */
#line 1191 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc_obj_ct(CMD_CREATE, NFT_OBJECT_CT_EXPECT, &(yyvsp[-4].handle), &(yyloc), (yyvsp[-3].obj));
			}
#line 7677 "parser_bison.c"
    break;

  case 75: /* create_cmd: "limit" obj_spec limit_obj limit_config  */
#line 1195 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_CREATE, CMD_OBJ_LIMIT, &(yyvsp[-2].handle), &(yyloc), (yyvsp[-1].obj));
			}
#line 7685 "parser_bison.c"
    break;

  case 76: /* create_cmd: "secmark" obj_spec secmark_obj secmark_config  */
#line 1199 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_CREATE, CMD_OBJ_SECMARK, &(yyvsp[-2].handle), &(yyloc), (yyvsp[-1].obj));
			}
#line 7693 "parser_bison.c"
    break;

  case 77: /* create_cmd: "synproxy" obj_spec synproxy_obj synproxy_config  */
#line 1203 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_CREATE, CMD_OBJ_SYNPROXY, &(yyvsp[-2].handle), &(yyloc), (yyvsp[-1].obj));
			}
#line 7701 "parser_bison.c"
    break;

  case 78: /* insert_cmd: "rule" rule_position rule  */
#line 1209 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_INSERT, CMD_OBJ_RULE, &(yyvsp[-1].handle), &(yyloc), (yyvsp[0].rule));
			}
#line 7709 "parser_bison.c"
    break;

  case 79: /* delete_cmd: "table" table_spec  */
#line 1215 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_DELETE, CMD_OBJ_TABLE, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7717 "parser_bison.c"
    break;

  case 80: /* delete_cmd: "table" tableid_spec  */
#line 1219 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_DELETE, CMD_OBJ_TABLE, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7725 "parser_bison.c"
    break;

  case 81: /* delete_cmd: "chain" chain_spec  */
#line 1223 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_DELETE, CMD_OBJ_CHAIN, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7733 "parser_bison.c"
    break;

  case 82: /* delete_cmd: "chain" chainid_spec  */
#line 1227 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_DELETE, CMD_OBJ_CHAIN, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7741 "parser_bison.c"
    break;

  case 83: /* delete_cmd: "rule" ruleid_spec  */
#line 1231 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_DELETE, CMD_OBJ_RULE, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7749 "parser_bison.c"
    break;

  case 84: /* delete_cmd: "set" set_spec  */
#line 1235 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_DELETE, CMD_OBJ_SET, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7757 "parser_bison.c"
    break;

  case 85: /* delete_cmd: "set" setid_spec  */
#line 1239 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_DELETE, CMD_OBJ_SET, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7765 "parser_bison.c"
    break;

  case 86: /* delete_cmd: "map" set_spec  */
#line 1243 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_DELETE, CMD_OBJ_SET, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7773 "parser_bison.c"
    break;

  case 87: /* delete_cmd: "element" set_spec set_block_expr  */
#line 1247 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_DELETE, CMD_OBJ_ELEMENTS, &(yyvsp[-1].handle), &(yyloc), (yyvsp[0].expr));
			}
#line 7781 "parser_bison.c"
    break;

  case 88: /* delete_cmd: "flowtable" flowtable_spec  */
#line 1251 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_DELETE, CMD_OBJ_FLOWTABLE, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7789 "parser_bison.c"
    break;

  case 89: /* delete_cmd: "flowtable" flowtableid_spec  */
#line 1255 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_DELETE, CMD_OBJ_FLOWTABLE, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7797 "parser_bison.c"
    break;

  case 90: /* delete_cmd: "flowtable" flowtable_spec flowtable_block_alloc '{' flowtable_block '}'  */
#line 1260 "parser_bison.y"
                        {
				(yyvsp[-1].flowtable)->location = (yylsp[-1]);
				handle_merge(&(yyvsp[-3].flowtable)->handle, &(yyvsp[-4].handle));
				(yyval.cmd) = cmd_alloc(CMD_DELETE, CMD_OBJ_FLOWTABLE, &(yyvsp[-4].handle), &(yyloc), (yyvsp[-1].flowtable));
			}
#line 7807 "parser_bison.c"
    break;

  case 91: /* delete_cmd: "counter" obj_spec  */
#line 1266 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_DELETE, CMD_OBJ_COUNTER, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7815 "parser_bison.c"
    break;

  case 92: /* delete_cmd: "counter" objid_spec  */
#line 1270 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_DELETE, CMD_OBJ_COUNTER, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7823 "parser_bison.c"
    break;

  case 93: /* delete_cmd: "quota" obj_spec  */
#line 1274 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_DELETE, CMD_OBJ_QUOTA, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7831 "parser_bison.c"
    break;

  case 94: /* delete_cmd: "quota" objid_spec  */
#line 1278 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_DELETE, CMD_OBJ_QUOTA, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7839 "parser_bison.c"
    break;

  case 95: /* delete_cmd: "ct" ct_obj_type obj_spec ct_obj_alloc  */
#line 1282 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc_obj_ct(CMD_DELETE, (yyvsp[-2].val), &(yyvsp[-1].handle), &(yyloc), (yyvsp[0].obj));
			}
#line 7847 "parser_bison.c"
    break;

  case 96: /* delete_cmd: "limit" obj_spec  */
#line 1286 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_DELETE, CMD_OBJ_LIMIT, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7855 "parser_bison.c"
    break;

  case 97: /* delete_cmd: "limit" objid_spec  */
#line 1290 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_DELETE, CMD_OBJ_LIMIT, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7863 "parser_bison.c"
    break;

  case 98: /* delete_cmd: "secmark" obj_spec  */
#line 1294 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_DELETE, CMD_OBJ_SECMARK, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7871 "parser_bison.c"
    break;

  case 99: /* delete_cmd: "secmark" objid_spec  */
#line 1298 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_DELETE, CMD_OBJ_SECMARK, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7879 "parser_bison.c"
    break;

  case 100: /* delete_cmd: "synproxy" obj_spec  */
#line 1302 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_DELETE, CMD_OBJ_SYNPROXY, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7887 "parser_bison.c"
    break;

  case 101: /* delete_cmd: "synproxy" objid_spec  */
#line 1306 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_DELETE, CMD_OBJ_SYNPROXY, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7895 "parser_bison.c"
    break;

  case 102: /* get_cmd: "element" set_spec set_block_expr  */
#line 1312 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_GET, CMD_OBJ_ELEMENTS, &(yyvsp[-1].handle), &(yyloc), (yyvsp[0].expr));
			}
#line 7903 "parser_bison.c"
    break;

  case 103: /* list_cmd: "table" table_spec  */
#line 1318 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_TABLE, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7911 "parser_bison.c"
    break;

  case 104: /* list_cmd: "tables" ruleset_spec  */
#line 1322 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_TABLE, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7919 "parser_bison.c"
    break;

  case 105: /* list_cmd: "chain" chain_spec  */
#line 1326 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_CHAIN, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7927 "parser_bison.c"
    break;

  case 106: /* list_cmd: "chains" ruleset_spec  */
#line 1330 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_CHAINS, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7935 "parser_bison.c"
    break;

  case 107: /* list_cmd: "sets" ruleset_spec  */
#line 1334 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_SETS, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7943 "parser_bison.c"
    break;

  case 108: /* list_cmd: "sets" "table" table_spec  */
#line 1338 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_SETS, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7951 "parser_bison.c"
    break;

  case 109: /* list_cmd: "set" set_spec  */
#line 1342 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_SET, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7959 "parser_bison.c"
    break;

  case 110: /* list_cmd: "counters" ruleset_spec  */
#line 1346 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_COUNTERS, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7967 "parser_bison.c"
    break;

  case 111: /* list_cmd: "counters" "table" table_spec  */
#line 1350 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_COUNTERS, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7975 "parser_bison.c"
    break;

  case 112: /* list_cmd: "counter" obj_spec  */
#line 1354 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_COUNTER, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7983 "parser_bison.c"
    break;

  case 113: /* list_cmd: "quotas" ruleset_spec  */
#line 1358 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_QUOTAS, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7991 "parser_bison.c"
    break;

  case 114: /* list_cmd: "quotas" "table" table_spec  */
#line 1362 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_QUOTAS, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7999 "parser_bison.c"
    break;

  case 115: /* list_cmd: "quota" obj_spec  */
#line 1366 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_QUOTA, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 8007 "parser_bison.c"
    break;

  case 116: /* list_cmd: "limits" ruleset_spec  */
#line 1370 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_LIMITS, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 8015 "parser_bison.c"
    break;

  case 117: /* list_cmd: "limits" "table" table_spec  */
#line 1374 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_LIMITS, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 8023 "parser_bison.c"
    break;

  case 118: /* list_cmd: "limit" obj_spec  */
#line 1378 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_LIMIT, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 8031 "parser_bison.c"
    break;

  case 119: /* list_cmd: "secmarks" ruleset_spec  */
#line 1382 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_SECMARKS, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 8039 "parser_bison.c"
    break;

  case 120: /* list_cmd: "secmarks" "table" table_spec  */
#line 1386 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_SECMARKS, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 8047 "parser_bison.c"
    break;

  case 121: /* list_cmd: "secmark" obj_spec  */
#line 1390 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_SECMARK, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 8055 "parser_bison.c"
    break;

  case 122: /* list_cmd: "synproxys" ruleset_spec  */
#line 1394 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_SYNPROXYS, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 8063 "parser_bison.c"
    break;

  case 123: /* list_cmd: "synproxys" "table" table_spec  */
#line 1398 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_SYNPROXYS, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 8071 "parser_bison.c"
    break;

  case 124: /* list_cmd: "synproxy" obj_spec  */
#line 1402 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_SYNPROXY, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 8079 "parser_bison.c"
    break;

  case 125: /* list_cmd: "ruleset" ruleset_spec  */
#line 1406 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_RULESET, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 8087 "parser_bison.c"
    break;

  case 126: /* list_cmd: "flow" "tables" ruleset_spec  */
#line 1410 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_METERS, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 8095 "parser_bison.c"
    break;

  case 127: /* list_cmd: "flow" "table" set_spec  */
#line 1414 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_METER, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 8103 "parser_bison.c"
    break;

  case 128: /* list_cmd: "meters" ruleset_spec  */
#line 1418 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_METERS, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 8111 "parser_bison.c"
    break;

  case 129: /* list_cmd: "meter" set_spec  */
#line 1422 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_METER, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 8119 "parser_bison.c"
    break;

  case 130: /* list_cmd: "flowtables" ruleset_spec  */
#line 1426 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_FLOWTABLES, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 8127 "parser_bison.c"
    break;

  case 131: /* list_cmd: "flowtable" flowtable_spec  */
#line 1430 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_FLOWTABLE, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 8135 "parser_bison.c"
    break;

  case 132: /* list_cmd: "maps" ruleset_spec  */
#line 1434 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_MAPS, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 8143 "parser_bison.c"
    break;

  case 133: /* list_cmd: "map" set_spec  */
#line 1438 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_MAP, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 8151 "parser_bison.c"
    break;

  case 134: /* list_cmd: "ct" ct_obj_type obj_spec  */
#line 1442 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc_obj_ct(CMD_LIST, (yyvsp[-1].val), &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 8159 "parser_bison.c"
    break;

  case 135: /* list_cmd: "ct" "helpers" "table" table_spec  */
#line 1446 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_CT_HELPERS, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 8167 "parser_bison.c"
    break;

  case 136: /* list_cmd: "ct" "timeout" "table" table_spec  */
#line 1450 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_CT_TIMEOUT, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 8175 "parser_bison.c"
    break;

  case 137: /* list_cmd: "ct" "expectation" "table" table_spec  */
#line 1454 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_CT_EXPECT, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 8183 "parser_bison.c"
    break;

  case 138: /* reset_cmd: "counters" ruleset_spec  */
#line 1460 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_RESET, CMD_OBJ_COUNTERS, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 8191 "parser_bison.c"
    break;

  case 139: /* reset_cmd: "counters" "table" table_spec  */
#line 1464 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_RESET, CMD_OBJ_COUNTERS, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 8199 "parser_bison.c"
    break;

  case 140: /* reset_cmd: "counter" obj_spec  */
#line 1468 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_RESET, CMD_OBJ_COUNTER, &(yyvsp[0].handle),&(yyloc), NULL);
			}
#line 8207 "parser_bison.c"
    break;

  case 141: /* reset_cmd: "quotas" ruleset_spec  */
#line 1472 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_RESET, CMD_OBJ_QUOTAS, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 8215 "parser_bison.c"
    break;

  case 142: /* reset_cmd: "quotas" "table" table_spec  */
#line 1476 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_RESET, CMD_OBJ_QUOTAS, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 8223 "parser_bison.c"
    break;

  case 143: /* reset_cmd: "quota" obj_spec  */
#line 1480 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_RESET, CMD_OBJ_QUOTA, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 8231 "parser_bison.c"
    break;

  case 144: /* flush_cmd: "table" table_spec  */
#line 1486 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_FLUSH, CMD_OBJ_TABLE, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 8239 "parser_bison.c"
    break;

  case 145: /* flush_cmd: "chain" chain_spec  */
#line 1490 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_FLUSH, CMD_OBJ_CHAIN, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 8247 "parser_bison.c"
    break;

  case 146: /* flush_cmd: "set" set_spec  */
#line 1494 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_FLUSH, CMD_OBJ_SET, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 8255 "parser_bison.c"
    break;

  case 147: /* flush_cmd: "map" set_spec  */
#line 1498 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_FLUSH, CMD_OBJ_MAP, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 8263 "parser_bison.c"
    break;

  case 148: /* flush_cmd: "flow" "table" set_spec  */
#line 1502 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_FLUSH, CMD_OBJ_METER, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 8271 "parser_bison.c"
    break;

  case 149: /* flush_cmd: "meter" set_spec  */
#line 1506 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_FLUSH, CMD_OBJ_METER, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 8279 "parser_bison.c"
    break;

  case 150: /* flush_cmd: "ruleset" ruleset_spec  */
#line 1510 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_FLUSH, CMD_OBJ_RULESET, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 8287 "parser_bison.c"
    break;

  case 151: /* rename_cmd: "chain" chain_spec identifier  */
#line 1516 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_RENAME, CMD_OBJ_CHAIN, &(yyvsp[-1].handle), &(yyloc), NULL);
				(yyval.cmd)->arg = (yyvsp[0].string);
			}
#line 8296 "parser_bison.c"
    break;

  case 152: /* import_cmd: "ruleset" markup_format  */
#line 1523 "parser_bison.y"
                        {
				struct handle h = { .family = NFPROTO_UNSPEC };
				struct markup *markup = markup_alloc((yyvsp[0].val));
				(yyval.cmd) = cmd_alloc(CMD_IMPORT, CMD_OBJ_MARKUP, &h, &(yyloc), markup);
			}
#line 8306 "parser_bison.c"
    break;

  case 153: /* import_cmd: markup_format  */
#line 1529 "parser_bison.y"
                        {
				struct handle h = { .family = NFPROTO_UNSPEC };
				struct markup *markup = markup_alloc((yyvsp[0].val));
				(yyval.cmd) = cmd_alloc(CMD_IMPORT, CMD_OBJ_MARKUP, &h, &(yyloc), markup);
			}
#line 8316 "parser_bison.c"
    break;

  case 154: /* export_cmd: "ruleset" markup_format  */
#line 1537 "parser_bison.y"
                        {
				struct handle h = { .family = NFPROTO_UNSPEC };
				struct markup *markup = markup_alloc((yyvsp[0].val));
				(yyval.cmd) = cmd_alloc(CMD_EXPORT, CMD_OBJ_MARKUP, &h, &(yyloc), markup);
			}
#line 8326 "parser_bison.c"
    break;

  case 155: /* export_cmd: markup_format  */
#line 1543 "parser_bison.y"
                        {
				struct handle h = { .family = NFPROTO_UNSPEC };
				struct markup *markup = markup_alloc((yyvsp[0].val));
				(yyval.cmd) = cmd_alloc(CMD_EXPORT, CMD_OBJ_MARKUP, &h, &(yyloc), markup);
			}
#line 8336 "parser_bison.c"
    break;

  case 156: /* monitor_cmd: monitor_event monitor_object monitor_format  */
#line 1551 "parser_bison.y"
                        {
				struct handle h = { .family = NFPROTO_UNSPEC };
				struct monitor *m = monitor_alloc((yyvsp[0].val), (yyvsp[-1].val), (yyvsp[-2].string));
				m->location = (yylsp[-2]);
				(yyval.cmd) = cmd_alloc(CMD_MONITOR, CMD_OBJ_MONITOR, &h, &(yyloc), m);
			}
#line 8347 "parser_bison.c"
    break;

  case 157: /* monitor_event: %empty  */
#line 1559 "parser_bison.y"
                                                { (yyval.string) = NULL; }
#line 8353 "parser_bison.c"
    break;

  case 158: /* monitor_event: "string"  */
#line 1560 "parser_bison.y"
                                                { (yyval.string) = (yyvsp[0].string); }
#line 8359 "parser_bison.c"
    break;

  case 159: /* monitor_object: %empty  */
#line 1563 "parser_bison.y"
                                                { (yyval.val) = CMD_MONITOR_OBJ_ANY; }
#line 8365 "parser_bison.c"
    break;

  case 160: /* monitor_object: "tables"  */
#line 1564 "parser_bison.y"
                                                { (yyval.val) = CMD_MONITOR_OBJ_TABLES; }
#line 8371 "parser_bison.c"
    break;

  case 161: /* monitor_object: "chains"  */
#line 1565 "parser_bison.y"
                                                { (yyval.val) = CMD_MONITOR_OBJ_CHAINS; }
#line 8377 "parser_bison.c"
    break;

  case 162: /* monitor_object: "sets"  */
#line 1566 "parser_bison.y"
                                                { (yyval.val) = CMD_MONITOR_OBJ_SETS; }
#line 8383 "parser_bison.c"
    break;

  case 163: /* monitor_object: "rules"  */
#line 1567 "parser_bison.y"
                                                { (yyval.val) = CMD_MONITOR_OBJ_RULES; }
#line 8389 "parser_bison.c"
    break;

  case 164: /* monitor_object: "elements"  */
#line 1568 "parser_bison.y"
                                                { (yyval.val) = CMD_MONITOR_OBJ_ELEMS; }
#line 8395 "parser_bison.c"
    break;

  case 165: /* monitor_object: "ruleset"  */
#line 1569 "parser_bison.y"
                                                { (yyval.val) = CMD_MONITOR_OBJ_RULESET; }
#line 8401 "parser_bison.c"
    break;

  case 166: /* monitor_object: "trace"  */
#line 1570 "parser_bison.y"
                                                { (yyval.val) = CMD_MONITOR_OBJ_TRACE; }
#line 8407 "parser_bison.c"
    break;

  case 167: /* monitor_format: %empty  */
#line 1573 "parser_bison.y"
                                                { (yyval.val) = NFTNL_OUTPUT_DEFAULT; }
#line 8413 "parser_bison.c"
    break;

  case 169: /* markup_format: "xml"  */
#line 1577 "parser_bison.y"
                                                { (yyval.val) = __NFT_OUTPUT_NOTSUPP; }
#line 8419 "parser_bison.c"
    break;

  case 170: /* markup_format: "json"  */
#line 1578 "parser_bison.y"
                                                { (yyval.val) = NFTNL_OUTPUT_JSON; }
#line 8425 "parser_bison.c"
    break;

  case 171: /* markup_format: "vm" "json"  */
#line 1579 "parser_bison.y"
                                                { (yyval.val) = NFTNL_OUTPUT_JSON; }
#line 8431 "parser_bison.c"
    break;

  case 172: /* describe_cmd: primary_expr  */
#line 1583 "parser_bison.y"
                        {
				struct handle h = { .family = NFPROTO_UNSPEC };
				(yyval.cmd) = cmd_alloc(CMD_DESCRIBE, CMD_OBJ_EXPR, &h, &(yyloc), NULL);
				(yyval.cmd)->expr = (yyvsp[0].expr);
			}
#line 8441 "parser_bison.c"
    break;

  case 173: /* table_block_alloc: %empty  */
#line 1591 "parser_bison.y"
                        {
				(yyval.table) = table_alloc();
				open_scope(state, &(yyval.table)->scope);
			}
#line 8450 "parser_bison.c"
    break;

  case 174: /* table_options: "flags" "string"  */
#line 1598 "parser_bison.y"
                        {
				if (strcmp((yyvsp[0].string), "dormant") == 0) {
					(yyvsp[-2].table)->flags = TABLE_F_DORMANT;
					xfree((yyvsp[0].string));
				} else {
					erec_queue(error(&(yylsp[0]), "unknown table option %s", (yyvsp[0].string)),
						   state->msgs);
					xfree((yyvsp[0].string));
					YYERROR;
				}
			}
#line 8466 "parser_bison.c"
    break;

  case 175: /* table_options: comment_spec  */
#line 1610 "parser_bison.y"
                        {
				if (already_set((yyvsp[-1].table)->comment, &(yyloc), state)) {
					xfree((yyvsp[0].string));
					YYERROR;
				}
				(yyvsp[-1].table)->comment = (yyvsp[0].string);
			}
#line 8478 "parser_bison.c"
    break;

  case 176: /* table_block: %empty  */
#line 1619 "parser_bison.y"
                                                { (yyval.table) = (yyvsp[(-1) - (0)].table); }
#line 8484 "parser_bison.c"
    break;

  case 180: /* table_block: table_block "chain" chain_identifier chain_block_alloc '{' chain_block '}' stmt_separator  */
#line 1626 "parser_bison.y"
                        {
				(yyvsp[-4].chain)->location = (yylsp[-5]);
				handle_merge(&(yyvsp[-4].chain)->handle, &(yyvsp[-5].handle));
				handle_free(&(yyvsp[-5].handle));
				close_scope(state);
				list_add_tail(&(yyvsp[-4].chain)->list, &(yyvsp[-7].table)->chains);
				(yyval.table) = (yyvsp[-7].table);
			}
#line 8497 "parser_bison.c"
    break;

  case 181: /* table_block: table_block "set" set_identifier set_block_alloc '{' set_block '}' stmt_separator  */
#line 1637 "parser_bison.y"
                        {
				(yyvsp[-4].set)->location = (yylsp[-5]);
				handle_merge(&(yyvsp[-4].set)->handle, &(yyvsp[-5].handle));
				handle_free(&(yyvsp[-5].handle));
				list_add_tail(&(yyvsp[-4].set)->list, &(yyvsp[-7].table)->sets);
				(yyval.table) = (yyvsp[-7].table);
			}
#line 8509 "parser_bison.c"
    break;

  case 182: /* table_block: table_block "map" set_identifier map_block_alloc '{' map_block '}' stmt_separator  */
#line 1647 "parser_bison.y"
                        {
				(yyvsp[-4].set)->location = (yylsp[-5]);
				handle_merge(&(yyvsp[-4].set)->handle, &(yyvsp[-5].handle));
				handle_free(&(yyvsp[-5].handle));
				list_add_tail(&(yyvsp[-4].set)->list, &(yyvsp[-7].table)->sets);
				(yyval.table) = (yyvsp[-7].table);
			}
#line 8521 "parser_bison.c"
    break;

  case 183: /* table_block: table_block "flowtable" flowtable_identifier flowtable_block_alloc '{' flowtable_block '}' stmt_separator  */
#line 1658 "parser_bison.y"
                        {
				(yyvsp[-4].flowtable)->location = (yylsp[-5]);
				handle_merge(&(yyvsp[-4].flowtable)->handle, &(yyvsp[-5].handle));
				handle_free(&(yyvsp[-5].handle));
				list_add_tail(&(yyvsp[-4].flowtable)->list, &(yyvsp[-7].table)->flowtables);
				(yyval.table) = (yyvsp[-7].table);
			}
#line 8533 "parser_bison.c"
    break;

  case 184: /* table_block: table_block "counter" obj_identifier obj_block_alloc '{' counter_block '}' stmt_separator  */
#line 1668 "parser_bison.y"
                        {
				(yyvsp[-4].obj)->location = (yylsp[-5]);
				(yyvsp[-4].obj)->type = NFT_OBJECT_COUNTER;
				handle_merge(&(yyvsp[-4].obj)->handle, &(yyvsp[-5].handle));
				handle_free(&(yyvsp[-5].handle));
				list_add_tail(&(yyvsp[-4].obj)->list, &(yyvsp[-7].table)->objs);
				(yyval.table) = (yyvsp[-7].table);
			}
#line 8546 "parser_bison.c"
    break;

  case 185: /* table_block: table_block "quota" obj_identifier obj_block_alloc '{' quota_block '}' stmt_separator  */
#line 1679 "parser_bison.y"
                        {
				(yyvsp[-4].obj)->location = (yylsp[-5]);
				(yyvsp[-4].obj)->type = NFT_OBJECT_QUOTA;
				handle_merge(&(yyvsp[-4].obj)->handle, &(yyvsp[-5].handle));
				handle_free(&(yyvsp[-5].handle));
				list_add_tail(&(yyvsp[-4].obj)->list, &(yyvsp[-7].table)->objs);
				(yyval.table) = (yyvsp[-7].table);
			}
#line 8559 "parser_bison.c"
    break;

  case 186: /* table_block: table_block "ct" "helper" obj_identifier obj_block_alloc '{' ct_helper_block '}' stmt_separator  */
#line 1688 "parser_bison.y"
                        {
				(yyvsp[-4].obj)->location = (yylsp[-5]);
				(yyvsp[-4].obj)->type = NFT_OBJECT_CT_HELPER;
				handle_merge(&(yyvsp[-4].obj)->handle, &(yyvsp[-5].handle));
				handle_free(&(yyvsp[-5].handle));
				list_add_tail(&(yyvsp[-4].obj)->list, &(yyvsp[-8].table)->objs);
				(yyval.table) = (yyvsp[-8].table);
			}
#line 8572 "parser_bison.c"
    break;

  case 187: /* table_block: table_block "ct" "timeout" obj_identifier obj_block_alloc '{' ct_timeout_block '}' stmt_separator  */
#line 1697 "parser_bison.y"
                        {
				(yyvsp[-4].obj)->location = (yylsp[-5]);
				(yyvsp[-4].obj)->type = NFT_OBJECT_CT_TIMEOUT;
				handle_merge(&(yyvsp[-4].obj)->handle, &(yyvsp[-5].handle));
				handle_free(&(yyvsp[-5].handle));
				list_add_tail(&(yyvsp[-4].obj)->list, &(yyvsp[-8].table)->objs);
				(yyval.table) = (yyvsp[-8].table);
			}
#line 8585 "parser_bison.c"
    break;

  case 188: /* table_block: table_block "ct" "expectation" obj_identifier obj_block_alloc '{' ct_expect_block '}' stmt_separator  */
#line 1706 "parser_bison.y"
                        {
				(yyvsp[-4].obj)->location = (yylsp[-5]);
				(yyvsp[-4].obj)->type = NFT_OBJECT_CT_EXPECT;
				handle_merge(&(yyvsp[-4].obj)->handle, &(yyvsp[-5].handle));
				handle_free(&(yyvsp[-5].handle));
				list_add_tail(&(yyvsp[-4].obj)->list, &(yyvsp[-8].table)->objs);
				(yyval.table) = (yyvsp[-8].table);
			}
#line 8598 "parser_bison.c"
    break;

  case 189: /* table_block: table_block "limit" obj_identifier obj_block_alloc '{' limit_block '}' stmt_separator  */
#line 1717 "parser_bison.y"
                        {
				(yyvsp[-4].obj)->location = (yylsp[-5]);
				(yyvsp[-4].obj)->type = NFT_OBJECT_LIMIT;
				handle_merge(&(yyvsp[-4].obj)->handle, &(yyvsp[-5].handle));
				handle_free(&(yyvsp[-5].handle));
				list_add_tail(&(yyvsp[-4].obj)->list, &(yyvsp[-7].table)->objs);
				(yyval.table) = (yyvsp[-7].table);
			}
#line 8611 "parser_bison.c"
    break;

  case 190: /* table_block: table_block "secmark" obj_identifier obj_block_alloc '{' secmark_block '}' stmt_separator  */
#line 1728 "parser_bison.y"
                        {
				(yyvsp[-4].obj)->location = (yylsp[-5]);
				(yyvsp[-4].obj)->type = NFT_OBJECT_SECMARK;
				handle_merge(&(yyvsp[-4].obj)->handle, &(yyvsp[-5].handle));
				handle_free(&(yyvsp[-5].handle));
				list_add_tail(&(yyvsp[-4].obj)->list, &(yyvsp[-7].table)->objs);
				(yyval.table) = (yyvsp[-7].table);
			}
#line 8624 "parser_bison.c"
    break;

  case 191: /* table_block: table_block "synproxy" obj_identifier obj_block_alloc '{' synproxy_block '}' stmt_separator  */
#line 1739 "parser_bison.y"
                        {
				(yyvsp[-4].obj)->location = (yylsp[-5]);
				(yyvsp[-4].obj)->type = NFT_OBJECT_SYNPROXY;
				handle_merge(&(yyvsp[-4].obj)->handle, &(yyvsp[-5].handle));
				handle_free(&(yyvsp[-5].handle));
				list_add_tail(&(yyvsp[-4].obj)->list, &(yyvsp[-7].table)->objs);
				(yyval.table) = (yyvsp[-7].table);
			}
#line 8637 "parser_bison.c"
    break;

  case 192: /* chain_block_alloc: %empty  */
#line 1750 "parser_bison.y"
                        {
				(yyval.chain) = chain_alloc(NULL);
				open_scope(state, &(yyval.chain)->scope);
			}
#line 8646 "parser_bison.c"
    break;

  case 193: /* chain_block: %empty  */
#line 1756 "parser_bison.y"
                                                { (yyval.chain) = (yyvsp[(-1) - (0)].chain); }
#line 8652 "parser_bison.c"
    break;

  case 199: /* chain_block: chain_block rule stmt_separator  */
#line 1763 "parser_bison.y"
                        {
				list_add_tail(&(yyvsp[-1].rule)->list, &(yyvsp[-2].chain)->rules);
				(yyval.chain) = (yyvsp[-2].chain);
			}
#line 8661 "parser_bison.c"
    break;

  case 200: /* chain_block: chain_block comment_spec stmt_separator  */
#line 1768 "parser_bison.y"
                        {
				if (already_set((yyvsp[-2].chain)->comment, &(yylsp[-1]), state)) {
					xfree((yyvsp[-1].string));
					YYERROR;
				}
				(yyvsp[-2].chain)->comment = (yyvsp[-1].string);
			}
#line 8673 "parser_bison.c"
    break;

  case 201: /* subchain_block: %empty  */
#line 1777 "parser_bison.y"
                                                { (yyval.chain) = (yyvsp[(-1) - (0)].chain); }
#line 8679 "parser_bison.c"
    break;

  case 203: /* subchain_block: subchain_block rule stmt_separator  */
#line 1780 "parser_bison.y"
                        {
				list_add_tail(&(yyvsp[-1].rule)->list, &(yyvsp[-2].chain)->rules);
				(yyval.chain) = (yyvsp[-2].chain);
			}
#line 8688 "parser_bison.c"
    break;

  case 204: /* typeof_expr: primary_expr  */
#line 1787 "parser_bison.y"
                        {
				if (expr_ops((yyvsp[0].expr))->build_udata == NULL) {
					erec_queue(error(&(yylsp[0]), "primary expression type '%s' lacks typeof serialization", expr_ops((yyvsp[0].expr))->name),
						   state->msgs);
					expr_free((yyvsp[0].expr));
					YYERROR;
				}

				(yyval.expr) = (yyvsp[0].expr);
			}
#line 8703 "parser_bison.c"
    break;

  case 205: /* typeof_expr: typeof_expr "." primary_expr  */
#line 1798 "parser_bison.y"
                        {
				struct location rhs[] = {
					[1]	= (yylsp[-1]),
					[2]	= (yylsp[0]),
				};

				(yyval.expr) = handle_concat_expr(&(yyloc), (yyval.expr), (yyvsp[-2].expr), (yyvsp[0].expr), rhs);
			}
#line 8716 "parser_bison.c"
    break;

  case 206: /* set_block_alloc: %empty  */
#line 1810 "parser_bison.y"
                        {
				(yyval.set) = set_alloc(NULL);
			}
#line 8724 "parser_bison.c"
    break;

  case 207: /* set_block: %empty  */
#line 1815 "parser_bison.y"
                                                { (yyval.set) = (yyvsp[(-1) - (0)].set); }
#line 8730 "parser_bison.c"
    break;

  case 210: /* set_block: set_block "type" data_type_expr stmt_separator  */
#line 1819 "parser_bison.y"
                        {
				(yyvsp[-3].set)->key = (yyvsp[-1].expr);
				(yyval.set) = (yyvsp[-3].set);
			}
#line 8739 "parser_bison.c"
    break;

  case 211: /* set_block: set_block "typeof" typeof_expr stmt_separator  */
#line 1824 "parser_bison.y"
                        {
				(yyvsp[-3].set)->key = (yyvsp[-1].expr);
				datatype_set((yyvsp[-3].set)->key, (yyvsp[-1].expr)->dtype);
				(yyval.set) = (yyvsp[-3].set);
			}
#line 8749 "parser_bison.c"
    break;

  case 212: /* set_block: set_block "flags" set_flag_list stmt_separator  */
#line 1830 "parser_bison.y"
                        {
				(yyvsp[-3].set)->flags = (yyvsp[-1].val);
				(yyval.set) = (yyvsp[-3].set);
			}
#line 8758 "parser_bison.c"
    break;

  case 213: /* set_block: set_block "timeout" time_spec stmt_separator  */
#line 1835 "parser_bison.y"
                        {
				(yyvsp[-3].set)->timeout = (yyvsp[-1].val);
				(yyval.set) = (yyvsp[-3].set);
			}
#line 8767 "parser_bison.c"
    break;

  case 214: /* set_block: set_block "gc-interval" time_spec stmt_separator  */
#line 1840 "parser_bison.y"
                        {
				(yyvsp[-3].set)->gc_int = (yyvsp[-1].val);
				(yyval.set) = (yyvsp[-3].set);
			}
#line 8776 "parser_bison.c"
    break;

  case 215: /* set_block: set_block stateful_stmt_list stmt_separator  */
#line 1845 "parser_bison.y"
                        {
				list_splice_tail((yyvsp[-1].list), &(yyvsp[-2].set)->stmt_list);
				(yyval.set) = (yyvsp[-2].set);
				free((yyvsp[-1].list));
			}
#line 8786 "parser_bison.c"
    break;

  case 216: /* set_block: set_block "elements" '=' set_block_expr  */
#line 1851 "parser_bison.y"
                        {
				(yyvsp[-3].set)->init = (yyvsp[0].expr);
				(yyval.set) = (yyvsp[-3].set);
			}
#line 8795 "parser_bison.c"
    break;

  case 217: /* set_block: set_block "auto-merge"  */
#line 1856 "parser_bison.y"
                        {
				(yyvsp[-1].set)->automerge = true;
				(yyval.set) = (yyvsp[-1].set);
			}
#line 8804 "parser_bison.c"
    break;

  case 219: /* set_block: set_block comment_spec stmt_separator  */
#line 1862 "parser_bison.y"
                        {
				if (already_set((yyvsp[-2].set)->comment, &(yylsp[-1]), state)) {
					xfree((yyvsp[-1].string));
					YYERROR;
				}
				(yyvsp[-2].set)->comment = (yyvsp[-1].string);
				(yyval.set) = (yyvsp[-2].set);
			}
#line 8817 "parser_bison.c"
    break;

  case 222: /* set_flag_list: set_flag_list "comma" set_flag  */
#line 1877 "parser_bison.y"
                        {
				(yyval.val) = (yyvsp[-2].val) | (yyvsp[0].val);
			}
#line 8825 "parser_bison.c"
    break;

  case 224: /* set_flag: "constant"  */
#line 1883 "parser_bison.y"
                                                { (yyval.val) = NFT_SET_CONSTANT; }
#line 8831 "parser_bison.c"
    break;

  case 225: /* set_flag: "interval"  */
#line 1884 "parser_bison.y"
                                                { (yyval.val) = NFT_SET_INTERVAL; }
#line 8837 "parser_bison.c"
    break;

  case 226: /* set_flag: "timeout"  */
#line 1885 "parser_bison.y"
                                                { (yyval.val) = NFT_SET_TIMEOUT; }
#line 8843 "parser_bison.c"
    break;

  case 227: /* set_flag: "dynamic"  */
#line 1886 "parser_bison.y"
                                                { (yyval.val) = NFT_SET_EVAL; }
#line 8849 "parser_bison.c"
    break;

  case 228: /* map_block_alloc: %empty  */
#line 1890 "parser_bison.y"
                        {
				(yyval.set) = set_alloc(NULL);
			}
#line 8857 "parser_bison.c"
    break;

  case 229: /* map_block: %empty  */
#line 1895 "parser_bison.y"
                                                { (yyval.set) = (yyvsp[(-1) - (0)].set); }
#line 8863 "parser_bison.c"
    break;

  case 232: /* map_block: map_block "timeout" time_spec stmt_separator  */
#line 1899 "parser_bison.y"
                        {
				(yyvsp[-3].set)->timeout = (yyvsp[-1].val);
				(yyval.set) = (yyvsp[-3].set);
			}
#line 8872 "parser_bison.c"
    break;

  case 233: /* map_block: map_block "type" data_type_expr "colon" data_type_expr stmt_separator  */
#line 1906 "parser_bison.y"
                        {
				(yyvsp[-5].set)->key = (yyvsp[-3].expr);
				(yyvsp[-5].set)->data = (yyvsp[-1].expr);

				(yyvsp[-5].set)->flags |= NFT_SET_MAP;
				(yyval.set) = (yyvsp[-5].set);
			}
#line 8884 "parser_bison.c"
    break;

  case 234: /* map_block: map_block "type" data_type_expr "colon" "interval" data_type_expr stmt_separator  */
#line 1916 "parser_bison.y"
                        {
				(yyvsp[-6].set)->key = (yyvsp[-4].expr);
				(yyvsp[-6].set)->data = (yyvsp[-1].expr);
				(yyvsp[-6].set)->data->flags |= EXPR_F_INTERVAL;

				(yyvsp[-6].set)->flags |= NFT_SET_MAP;
				(yyval.set) = (yyvsp[-6].set);
			}
#line 8897 "parser_bison.c"
    break;

  case 235: /* map_block: map_block "typeof" typeof_expr "colon" typeof_expr stmt_separator  */
#line 1927 "parser_bison.y"
                        {
				(yyvsp[-5].set)->key = (yyvsp[-3].expr);
				datatype_set((yyvsp[-5].set)->key, (yyvsp[-3].expr)->dtype);
				(yyvsp[-5].set)->data = (yyvsp[-1].expr);

				(yyvsp[-5].set)->flags |= NFT_SET_MAP;
				(yyval.set) = (yyvsp[-5].set);
			}
#line 8910 "parser_bison.c"
    break;

  case 236: /* map_block: map_block "typeof" typeof_expr "colon" "interval" typeof_expr stmt_separator  */
#line 1938 "parser_bison.y"
                        {
				(yyvsp[-6].set)->key = (yyvsp[-4].expr);
				datatype_set((yyvsp[-6].set)->key, (yyvsp[-4].expr)->dtype);
				(yyvsp[-6].set)->data = (yyvsp[-1].expr);
				(yyvsp[-6].set)->data->flags |= EXPR_F_INTERVAL;

				(yyvsp[-6].set)->flags |= NFT_SET_MAP;
				(yyval.set) = (yyvsp[-6].set);
			}
#line 8924 "parser_bison.c"
    break;

  case 237: /* map_block: map_block "type" data_type_expr "colon" "counter" stmt_separator  */
#line 1950 "parser_bison.y"
                        {
				(yyvsp[-5].set)->key = (yyvsp[-3].expr);
				(yyvsp[-5].set)->objtype = NFT_OBJECT_COUNTER;
				(yyvsp[-5].set)->flags  |= NFT_SET_OBJECT;
				(yyval.set) = (yyvsp[-5].set);
			}
#line 8935 "parser_bison.c"
    break;

  case 238: /* map_block: map_block "type" data_type_expr "colon" "quota" stmt_separator  */
#line 1959 "parser_bison.y"
                        {
				(yyvsp[-5].set)->key = (yyvsp[-3].expr);
				(yyvsp[-5].set)->objtype = NFT_OBJECT_QUOTA;
				(yyvsp[-5].set)->flags  |= NFT_SET_OBJECT;
				(yyval.set) = (yyvsp[-5].set);
			}
#line 8946 "parser_bison.c"
    break;

  case 239: /* map_block: map_block "type" data_type_expr "colon" "limit" stmt_separator  */
#line 1968 "parser_bison.y"
                        {
				(yyvsp[-5].set)->key = (yyvsp[-3].expr);
				(yyvsp[-5].set)->objtype = NFT_OBJECT_LIMIT;
				(yyvsp[-5].set)->flags  |= NFT_SET_OBJECT;
				(yyval.set) = (yyvsp[-5].set);
			}
#line 8957 "parser_bison.c"
    break;

  case 240: /* map_block: map_block "type" data_type_expr "colon" "secmark" stmt_separator  */
#line 1977 "parser_bison.y"
                        {
				(yyvsp[-5].set)->key = (yyvsp[-3].expr);
				(yyvsp[-5].set)->objtype = NFT_OBJECT_SECMARK;
				(yyvsp[-5].set)->flags  |= NFT_SET_OBJECT;
				(yyval.set) = (yyvsp[-5].set);
			}
#line 8968 "parser_bison.c"
    break;

  case 241: /* map_block: map_block "flags" set_flag_list stmt_separator  */
#line 1984 "parser_bison.y"
                        {
				(yyvsp[-3].set)->flags |= (yyvsp[-1].val);
				(yyval.set) = (yyvsp[-3].set);
			}
#line 8977 "parser_bison.c"
    break;

  case 242: /* map_block: map_block "elements" '=' set_block_expr  */
#line 1989 "parser_bison.y"
                        {
				(yyvsp[-3].set)->init = (yyvsp[0].expr);
				(yyval.set) = (yyvsp[-3].set);
			}
#line 8986 "parser_bison.c"
    break;

  case 243: /* map_block: map_block comment_spec stmt_separator  */
#line 1994 "parser_bison.y"
                        {
				if (already_set((yyvsp[-2].set)->comment, &(yylsp[-1]), state)) {
					xfree((yyvsp[-1].string));
					YYERROR;
				}
				(yyvsp[-2].set)->comment = (yyvsp[-1].string);
				(yyval.set) = (yyvsp[-2].set);
			}
#line 8999 "parser_bison.c"
    break;

  case 245: /* set_mechanism: "policy" set_policy_spec  */
#line 2006 "parser_bison.y"
                        {
				(yyvsp[-2].set)->policy = (yyvsp[0].val);
			}
#line 9007 "parser_bison.c"
    break;

  case 246: /* set_mechanism: "size" "number"  */
#line 2010 "parser_bison.y"
                        {
				(yyvsp[-2].set)->desc.size = (yyvsp[0].val);
			}
#line 9015 "parser_bison.c"
    break;

  case 247: /* set_policy_spec: "performance"  */
#line 2015 "parser_bison.y"
                                                { (yyval.val) = NFT_SET_POL_PERFORMANCE; }
#line 9021 "parser_bison.c"
    break;

  case 248: /* set_policy_spec: "memory"  */
#line 2016 "parser_bison.y"
                                                { (yyval.val) = NFT_SET_POL_MEMORY; }
#line 9027 "parser_bison.c"
    break;

  case 249: /* flowtable_block_alloc: %empty  */
#line 2020 "parser_bison.y"
                        {
				(yyval.flowtable) = flowtable_alloc(NULL);
			}
#line 9035 "parser_bison.c"
    break;

  case 250: /* flowtable_block: %empty  */
#line 2025 "parser_bison.y"
                                                { (yyval.flowtable) = (yyvsp[(-1) - (0)].flowtable); }
#line 9041 "parser_bison.c"
    break;

  case 253: /* flowtable_block: flowtable_block "hook" "string" prio_spec stmt_separator  */
#line 2029 "parser_bison.y"
                        {
				(yyval.flowtable)->hook.loc = (yylsp[-2]);
				(yyval.flowtable)->hook.name = chain_hookname_lookup((yyvsp[-2].string));
				if ((yyval.flowtable)->hook.name == NULL) {
					erec_queue(error(&(yylsp[-2]), "unknown chain hook"),
						   state->msgs);
					xfree((yyvsp[-2].string));
					YYERROR;
				}
				xfree((yyvsp[-2].string));

				(yyval.flowtable)->priority = (yyvsp[-1].prio_spec);
			}
#line 9059 "parser_bison.c"
    break;

  case 254: /* flowtable_block: flowtable_block "devices" '=' flowtable_expr stmt_separator  */
#line 2043 "parser_bison.y"
                        {
				(yyval.flowtable)->dev_expr = (yyvsp[-1].expr);
			}
#line 9067 "parser_bison.c"
    break;

  case 255: /* flowtable_block: flowtable_block "counter"  */
#line 2047 "parser_bison.y"
                        {
				(yyval.flowtable)->flags |= NFT_FLOWTABLE_COUNTER;
			}
#line 9075 "parser_bison.c"
    break;

  case 256: /* flowtable_expr: '{' flowtable_list_expr '}'  */
#line 2053 "parser_bison.y"
                        {
				(yyvsp[-1].expr)->location = (yyloc);
				(yyval.expr) = (yyvsp[-1].expr);
			}
#line 9084 "parser_bison.c"
    break;

  case 257: /* flowtable_expr: variable_expr  */
#line 2058 "parser_bison.y"
                        {
				(yyvsp[0].expr)->location = (yyloc);
				(yyval.expr) = (yyvsp[0].expr);
			}
#line 9093 "parser_bison.c"
    break;

  case 258: /* flowtable_list_expr: flowtable_expr_member  */
#line 2065 "parser_bison.y"
                        {
				(yyval.expr) = compound_expr_alloc(&(yyloc), EXPR_LIST);
				compound_expr_add((yyval.expr), (yyvsp[0].expr));
			}
#line 9102 "parser_bison.c"
    break;

  case 259: /* flowtable_list_expr: flowtable_list_expr "comma" flowtable_expr_member  */
#line 2070 "parser_bison.y"
                        {
				compound_expr_add((yyvsp[-2].expr), (yyvsp[0].expr));
				(yyval.expr) = (yyvsp[-2].expr);
			}
#line 9111 "parser_bison.c"
    break;

  case 261: /* flowtable_expr_member: "string"  */
#line 2078 "parser_bison.y"
                        {
				(yyval.expr) = constant_expr_alloc(&(yyloc), &string_type,
							 BYTEORDER_HOST_ENDIAN,
							 strlen((yyvsp[0].string)) * BITS_PER_BYTE, (yyvsp[0].string));
				xfree((yyvsp[0].string));
			}
#line 9122 "parser_bison.c"
    break;

  case 262: /* flowtable_expr_member: variable_expr  */
#line 2085 "parser_bison.y"
                        {
				datatype_set((yyvsp[0].expr)->sym->expr, &ifname_type);
				(yyval.expr) = (yyvsp[0].expr);
			}
#line 9131 "parser_bison.c"
    break;

  case 263: /* data_type_atom_expr: type_identifier  */
#line 2092 "parser_bison.y"
                        {
				const struct datatype *dtype = datatype_lookup_byname((yyvsp[0].string));
				if (dtype == NULL) {
					erec_queue(error(&(yylsp[0]), "unknown datatype %s", (yyvsp[0].string)),
						   state->msgs);
					YYERROR;
				}
				(yyval.expr) = constant_expr_alloc(&(yylsp[0]), dtype, dtype->byteorder,
							 dtype->size, NULL);
				xfree((yyvsp[0].string));
			}
#line 9147 "parser_bison.c"
    break;

  case 264: /* data_type_atom_expr: "time"  */
#line 2104 "parser_bison.y"
                        {
				(yyval.expr) = constant_expr_alloc(&(yylsp[0]), &time_type, time_type.byteorder,
							 time_type.size, NULL);
			}
#line 9156 "parser_bison.c"
    break;

  case 266: /* data_type_expr: data_type_expr "." data_type_atom_expr  */
#line 2112 "parser_bison.y"
                        {
				struct location rhs[] = {
					[1]	= (yylsp[-1]),
					[2]	= (yylsp[0]),
				};

				(yyval.expr) = handle_concat_expr(&(yyloc), (yyval.expr), (yyvsp[-2].expr), (yyvsp[0].expr), rhs);
			}
#line 9169 "parser_bison.c"
    break;

  case 267: /* obj_block_alloc: %empty  */
#line 2123 "parser_bison.y"
                        {
				(yyval.obj) = obj_alloc(NULL);
			}
#line 9177 "parser_bison.c"
    break;

  case 268: /* counter_block: %empty  */
#line 2128 "parser_bison.y"
                                                { (yyval.obj) = (yyvsp[(-1) - (0)].obj); }
#line 9183 "parser_bison.c"
    break;

  case 271: /* counter_block: counter_block counter_config  */
#line 2132 "parser_bison.y"
                        {
				(yyval.obj) = (yyvsp[-1].obj);
			}
#line 9191 "parser_bison.c"
    break;

  case 272: /* counter_block: counter_block comment_spec  */
#line 2136 "parser_bison.y"
                        {
				if (already_set((yyvsp[-1].obj)->comment, &(yylsp[0]), state)) {
					xfree((yyvsp[0].string));
					YYERROR;
				}
				(yyvsp[-1].obj)->comment = (yyvsp[0].string);
			}
#line 9203 "parser_bison.c"
    break;

  case 273: /* quota_block: %empty  */
#line 2145 "parser_bison.y"
                                                { (yyval.obj) = (yyvsp[(-1) - (0)].obj); }
#line 9209 "parser_bison.c"
    break;

  case 276: /* quota_block: quota_block quota_config  */
#line 2149 "parser_bison.y"
                        {
				(yyval.obj) = (yyvsp[-1].obj);
			}
#line 9217 "parser_bison.c"
    break;

  case 277: /* quota_block: quota_block comment_spec  */
#line 2153 "parser_bison.y"
                        {
				if (already_set((yyvsp[-1].obj)->comment, &(yylsp[0]), state)) {
					xfree((yyvsp[0].string));
					YYERROR;
				}
				(yyvsp[-1].obj)->comment = (yyvsp[0].string);
			}
#line 9229 "parser_bison.c"
    break;

  case 278: /* ct_helper_block: %empty  */
#line 2162 "parser_bison.y"
                                                { (yyval.obj) = (yyvsp[(-1) - (0)].obj); }
#line 9235 "parser_bison.c"
    break;

  case 281: /* ct_helper_block: ct_helper_block ct_helper_config  */
#line 2166 "parser_bison.y"
                        {
				(yyval.obj) = (yyvsp[-1].obj);
			}
#line 9243 "parser_bison.c"
    break;

  case 282: /* ct_helper_block: ct_helper_block comment_spec  */
#line 2170 "parser_bison.y"
                        {
				if (already_set((yyvsp[-1].obj)->comment, &(yylsp[0]), state)) {
					xfree((yyvsp[0].string));
					YYERROR;
				}
				(yyvsp[-1].obj)->comment = (yyvsp[0].string);
			}
#line 9255 "parser_bison.c"
    break;

  case 283: /* ct_timeout_block: %empty  */
#line 2180 "parser_bison.y"
                        {
				(yyval.obj) = (yyvsp[(-1) - (0)].obj);
				init_list_head(&(yyval.obj)->ct_timeout.timeout_list);
			}
#line 9264 "parser_bison.c"
    break;

  case 286: /* ct_timeout_block: ct_timeout_block ct_timeout_config  */
#line 2187 "parser_bison.y"
                        {
				(yyval.obj) = (yyvsp[-1].obj);
			}
#line 9272 "parser_bison.c"
    break;

  case 287: /* ct_timeout_block: ct_timeout_block comment_spec  */
#line 2191 "parser_bison.y"
                        {
				if (already_set((yyvsp[-1].obj)->comment, &(yylsp[0]), state)) {
					xfree((yyvsp[0].string));
					YYERROR;
				}
				(yyvsp[-1].obj)->comment = (yyvsp[0].string);
			}
#line 9284 "parser_bison.c"
    break;

  case 288: /* ct_expect_block: %empty  */
#line 2200 "parser_bison.y"
                                                { (yyval.obj) = (yyvsp[(-1) - (0)].obj); }
#line 9290 "parser_bison.c"
    break;

  case 291: /* ct_expect_block: ct_expect_block ct_expect_config  */
#line 2204 "parser_bison.y"
                        {
				(yyval.obj) = (yyvsp[-1].obj);
			}
#line 9298 "parser_bison.c"
    break;

  case 292: /* ct_expect_block: ct_expect_block comment_spec  */
#line 2208 "parser_bison.y"
                        {
				if (already_set((yyvsp[-1].obj)->comment, &(yylsp[0]), state)) {
					xfree((yyvsp[0].string));
					YYERROR;
				}
				(yyvsp[-1].obj)->comment = (yyvsp[0].string);
			}
#line 9310 "parser_bison.c"
    break;

  case 293: /* limit_block: %empty  */
#line 2217 "parser_bison.y"
                                                { (yyval.obj) = (yyvsp[(-1) - (0)].obj); }
#line 9316 "parser_bison.c"
    break;

  case 296: /* limit_block: limit_block limit_config  */
#line 2221 "parser_bison.y"
                        {
				(yyval.obj) = (yyvsp[-1].obj);
			}
#line 9324 "parser_bison.c"
    break;

  case 297: /* limit_block: limit_block comment_spec  */
#line 2225 "parser_bison.y"
                        {
				if (already_set((yyvsp[-1].obj)->comment, &(yylsp[0]), state)) {
					xfree((yyvsp[0].string));
					YYERROR;
				}
				(yyvsp[-1].obj)->comment = (yyvsp[0].string);
			}
#line 9336 "parser_bison.c"
    break;

  case 298: /* secmark_block: %empty  */
#line 2234 "parser_bison.y"
                                                { (yyval.obj) = (yyvsp[(-1) - (0)].obj); }
#line 9342 "parser_bison.c"
    break;

  case 301: /* secmark_block: secmark_block secmark_config  */
#line 2238 "parser_bison.y"
                        {
				(yyval.obj) = (yyvsp[-1].obj);
			}
#line 9350 "parser_bison.c"
    break;

  case 302: /* secmark_block: secmark_block comment_spec  */
#line 2242 "parser_bison.y"
                        {
				if (already_set((yyvsp[-1].obj)->comment, &(yylsp[0]), state)) {
					xfree((yyvsp[0].string));
					YYERROR;
				}
				(yyvsp[-1].obj)->comment = (yyvsp[0].string);
			}
#line 9362 "parser_bison.c"
    break;

  case 303: /* synproxy_block: %empty  */
#line 2251 "parser_bison.y"
                                                { (yyval.obj) = (yyvsp[(-1) - (0)].obj); }
#line 9368 "parser_bison.c"
    break;

  case 306: /* synproxy_block: synproxy_block synproxy_config  */
#line 2255 "parser_bison.y"
                        {
				(yyval.obj) = (yyvsp[-1].obj);
			}
#line 9376 "parser_bison.c"
    break;

  case 307: /* synproxy_block: synproxy_block comment_spec  */
#line 2259 "parser_bison.y"
                        {
				if (already_set((yyvsp[-1].obj)->comment, &(yylsp[0]), state)) {
					xfree((yyvsp[0].string));
					YYERROR;
				}
				(yyvsp[-1].obj)->comment = (yyvsp[0].string);
			}
#line 9388 "parser_bison.c"
    break;

  case 308: /* type_identifier: "string"  */
#line 2268 "parser_bison.y"
                                        { (yyval.string) = (yyvsp[0].string); }
#line 9394 "parser_bison.c"
    break;

  case 309: /* type_identifier: "mark"  */
#line 2269 "parser_bison.y"
                                        { (yyval.string) = xstrdup("mark"); }
#line 9400 "parser_bison.c"
    break;

  case 310: /* type_identifier: "dscp"  */
#line 2270 "parser_bison.y"
                                        { (yyval.string) = xstrdup("dscp"); }
#line 9406 "parser_bison.c"
    break;

  case 311: /* type_identifier: "ecn"  */
#line 2271 "parser_bison.y"
                                        { (yyval.string) = xstrdup("ecn"); }
#line 9412 "parser_bison.c"
    break;

  case 312: /* type_identifier: "classid"  */
#line 2272 "parser_bison.y"
                                        { (yyval.string) = xstrdup("classid"); }
#line 9418 "parser_bison.c"
    break;

  case 313: /* hook_spec: "type" "string" "hook" "string" dev_spec prio_spec  */
#line 2276 "parser_bison.y"
                        {
				const char *chain_type = chain_type_name_lookup((yyvsp[-4].string));

				if (chain_type == NULL) {
					erec_queue(error(&(yylsp[-4]), "unknown chain type"),
						   state->msgs);
					xfree((yyvsp[-4].string));
					YYERROR;
				}
				(yyvsp[-6].chain)->type		= xstrdup(chain_type);
				xfree((yyvsp[-4].string));

				(yyvsp[-6].chain)->loc = (yyloc);
				(yyvsp[-6].chain)->hook.loc = (yylsp[-2]);
				(yyvsp[-6].chain)->hook.name = chain_hookname_lookup((yyvsp[-2].string));
				if ((yyvsp[-6].chain)->hook.name == NULL) {
					erec_queue(error(&(yylsp[-2]), "unknown chain hook"),
						   state->msgs);
					xfree((yyvsp[-2].string));
					YYERROR;
				}
				xfree((yyvsp[-2].string));

				(yyvsp[-6].chain)->dev_expr	= (yyvsp[-1].expr);
				(yyvsp[-6].chain)->priority	= (yyvsp[0].prio_spec);
				(yyvsp[-6].chain)->flags	|= CHAIN_F_BASECHAIN;
			}
#line 9450 "parser_bison.c"
    break;

  case 314: /* prio_spec: "priority" extended_prio_spec  */
#line 2306 "parser_bison.y"
                        {
				(yyval.prio_spec) = (yyvsp[0].prio_spec);
				(yyval.prio_spec).loc = (yyloc);
			}
#line 9459 "parser_bison.c"
    break;

  case 315: /* extended_prio_name: "out"  */
#line 2313 "parser_bison.y"
                        {
				(yyval.string) = strdup("out");
			}
#line 9467 "parser_bison.c"
    break;

  case 317: /* extended_prio_spec: int_num  */
#line 2320 "parser_bison.y"
                        {
				struct prio_spec spec = {0};

				spec.expr = constant_expr_alloc(&(yyloc), &integer_type,
								BYTEORDER_HOST_ENDIAN,
								sizeof(int) *
								BITS_PER_BYTE, &(yyvsp[0].val32));
				(yyval.prio_spec) = spec;
			}
#line 9481 "parser_bison.c"
    break;

  case 318: /* extended_prio_spec: variable_expr  */
#line 2330 "parser_bison.y"
                        {
				struct prio_spec spec = {0};

				spec.expr = (yyvsp[0].expr);
				(yyval.prio_spec) = spec;
			}
#line 9492 "parser_bison.c"
    break;

  case 319: /* extended_prio_spec: extended_prio_name  */
#line 2337 "parser_bison.y"
                        {
				struct prio_spec spec = {0};

				spec.expr = constant_expr_alloc(&(yyloc), &string_type,
								BYTEORDER_HOST_ENDIAN,
								strlen((yyvsp[0].string)) * BITS_PER_BYTE,
								(yyvsp[0].string));
				xfree((yyvsp[0].string));
				(yyval.prio_spec) = spec;
			}
#line 9507 "parser_bison.c"
    break;

  case 320: /* extended_prio_spec: extended_prio_name "+" "number"  */
#line 2348 "parser_bison.y"
                        {
				struct prio_spec spec = {0};

				char str[NFT_NAME_MAXLEN];
				snprintf(str, sizeof(str), "%s + %" PRIu64, (yyvsp[-2].string), (yyvsp[0].val));
				spec.expr = constant_expr_alloc(&(yyloc), &string_type,
								BYTEORDER_HOST_ENDIAN,
								strlen(str) * BITS_PER_BYTE,
								str);
				xfree((yyvsp[-2].string));
				(yyval.prio_spec) = spec;
			}
#line 9524 "parser_bison.c"
    break;

  case 321: /* extended_prio_spec: extended_prio_name "-" "number"  */
#line 2361 "parser_bison.y"
                        {
				struct prio_spec spec = {0};
				char str[NFT_NAME_MAXLEN];

				snprintf(str, sizeof(str), "%s - %" PRIu64, (yyvsp[-2].string), (yyvsp[0].val));
				spec.expr = constant_expr_alloc(&(yyloc), &string_type,
								BYTEORDER_HOST_ENDIAN,
								strlen(str) * BITS_PER_BYTE,
								str);
				xfree((yyvsp[-2].string));
				(yyval.prio_spec) = spec;
			}
#line 9541 "parser_bison.c"
    break;

  case 322: /* int_num: "number"  */
#line 2375 "parser_bison.y"
                                                        { (yyval.val32) = (yyvsp[0].val); }
#line 9547 "parser_bison.c"
    break;

  case 323: /* int_num: "-" "number"  */
#line 2376 "parser_bison.y"
                                                        { (yyval.val32) = -(yyvsp[0].val); }
#line 9553 "parser_bison.c"
    break;

  case 324: /* dev_spec: "device" string  */
#line 2380 "parser_bison.y"
                        {
				struct expr *expr;

				expr = constant_expr_alloc(&(yyloc), &string_type,
							   BYTEORDER_HOST_ENDIAN,
							   strlen((yyvsp[0].string)) * BITS_PER_BYTE, (yyvsp[0].string));
				xfree((yyvsp[0].string));
				(yyval.expr) = compound_expr_alloc(&(yyloc), EXPR_LIST);
				compound_expr_add((yyval.expr), expr);

			}
#line 9569 "parser_bison.c"
    break;

  case 325: /* dev_spec: "device" variable_expr  */
#line 2392 "parser_bison.y"
                        {
				datatype_set((yyvsp[0].expr)->sym->expr, &ifname_type);
				(yyval.expr) = compound_expr_alloc(&(yyloc), EXPR_LIST);
				compound_expr_add((yyval.expr), (yyvsp[0].expr));
			}
#line 9579 "parser_bison.c"
    break;

  case 326: /* dev_spec: "devices" '=' flowtable_expr  */
#line 2398 "parser_bison.y"
                        {
				(yyval.expr) = (yyvsp[0].expr);
			}
#line 9587 "parser_bison.c"
    break;

  case 327: /* dev_spec: %empty  */
#line 2401 "parser_bison.y"
                                                        { (yyval.expr) = NULL; }
#line 9593 "parser_bison.c"
    break;

  case 328: /* flags_spec: "flags" "offload"  */
#line 2405 "parser_bison.y"
                        {
				(yyvsp[-2].chain)->flags |= CHAIN_F_HW_OFFLOAD;
			}
#line 9601 "parser_bison.c"
    break;

  case 329: /* policy_spec: "policy" policy_expr  */
#line 2411 "parser_bison.y"
                        {
				if ((yyvsp[-2].chain)->policy) {
					erec_queue(error(&(yyloc), "you cannot set chain policy twice"),
						   state->msgs);
					expr_free((yyvsp[0].expr));
					YYERROR;
				}
				(yyvsp[-2].chain)->policy		= (yyvsp[0].expr);
				(yyvsp[-2].chain)->policy->location	= (yyloc);
			}
#line 9616 "parser_bison.c"
    break;

  case 330: /* policy_expr: variable_expr  */
#line 2424 "parser_bison.y"
                        {
				datatype_set((yyvsp[0].expr)->sym->expr, &policy_type);
				(yyval.expr) = (yyvsp[0].expr);
			}
#line 9625 "parser_bison.c"
    break;

  case 331: /* policy_expr: chain_policy  */
#line 2429 "parser_bison.y"
                        {
				(yyval.expr) = constant_expr_alloc(&(yyloc), &integer_type,
							 BYTEORDER_HOST_ENDIAN,
							 sizeof(int) *
							 BITS_PER_BYTE, &(yyvsp[0].val32));
			}
#line 9636 "parser_bison.c"
    break;

  case 332: /* chain_policy: "accept"  */
#line 2437 "parser_bison.y"
                                                { (yyval.val32) = NF_ACCEPT; }
#line 9642 "parser_bison.c"
    break;

  case 333: /* chain_policy: "drop"  */
#line 2438 "parser_bison.y"
                                                { (yyval.val32) = NF_DROP;   }
#line 9648 "parser_bison.c"
    break;

  case 338: /* time_spec: "string"  */
#line 2450 "parser_bison.y"
                        {
				struct error_record *erec;
				uint64_t res;

				erec = time_parse(&(yylsp[0]), (yyvsp[0].string), &res);
				xfree((yyvsp[0].string));
				if (erec != NULL) {
					erec_queue(erec, state->msgs);
					YYERROR;
				}
				(yyval.val) = res;
			}
#line 9665 "parser_bison.c"
    break;

  case 339: /* family_spec: %empty  */
#line 2464 "parser_bison.y"
                                                        { (yyval.val) = NFPROTO_IPV4; }
#line 9671 "parser_bison.c"
    break;

  case 341: /* family_spec_explicit: "ip"  */
#line 2468 "parser_bison.y"
                                                { (yyval.val) = NFPROTO_IPV4; }
#line 9677 "parser_bison.c"
    break;

  case 342: /* family_spec_explicit: "ip6"  */
#line 2469 "parser_bison.y"
                                                { (yyval.val) = NFPROTO_IPV6; }
#line 9683 "parser_bison.c"
    break;

  case 343: /* family_spec_explicit: "inet"  */
#line 2470 "parser_bison.y"
                                                { (yyval.val) = NFPROTO_INET; }
#line 9689 "parser_bison.c"
    break;

  case 344: /* family_spec_explicit: "arp"  */
#line 2471 "parser_bison.y"
                                                { (yyval.val) = NFPROTO_ARP; }
#line 9695 "parser_bison.c"
    break;

  case 345: /* family_spec_explicit: "bridge"  */
#line 2472 "parser_bison.y"
                                                { (yyval.val) = NFPROTO_BRIDGE; }
#line 9701 "parser_bison.c"
    break;

  case 346: /* family_spec_explicit: "netdev"  */
#line 2473 "parser_bison.y"
                                                { (yyval.val) = NFPROTO_NETDEV; }
#line 9707 "parser_bison.c"
    break;

  case 347: /* table_spec: family_spec identifier  */
#line 2477 "parser_bison.y"
                        {
				memset(&(yyval.handle), 0, sizeof((yyval.handle)));
				(yyval.handle).family	= (yyvsp[-1].val);
				(yyval.handle).table.location = (yylsp[0]);
				(yyval.handle).table.name	= (yyvsp[0].string);
			}
#line 9718 "parser_bison.c"
    break;

  case 348: /* tableid_spec: family_spec "handle" "number"  */
#line 2486 "parser_bison.y"
                        {
				memset(&(yyval.handle), 0, sizeof((yyval.handle)));
				(yyval.handle).family 		= (yyvsp[-2].val);
				(yyval.handle).handle.id 		= (yyvsp[0].val);
				(yyval.handle).handle.location	= (yylsp[0]);
			}
#line 9729 "parser_bison.c"
    break;

  case 349: /* chain_spec: table_spec identifier  */
#line 2495 "parser_bison.y"
                        {
				(yyval.handle)		= (yyvsp[-1].handle);
				(yyval.handle).chain.name	= (yyvsp[0].string);
				(yyval.handle).chain.location = (yylsp[0]);
			}
#line 9739 "parser_bison.c"
    break;

  case 350: /* chainid_spec: table_spec "handle" "number"  */
#line 2503 "parser_bison.y"
                        {
				(yyval.handle) 			= (yyvsp[-2].handle);
				(yyval.handle).handle.location 	= (yylsp[0]);
				(yyval.handle).handle.id 		= (yyvsp[0].val);
			}
#line 9749 "parser_bison.c"
    break;

  case 351: /* chain_identifier: identifier  */
#line 2511 "parser_bison.y"
                        {
				memset(&(yyval.handle), 0, sizeof((yyval.handle)));
				(yyval.handle).chain.name		= (yyvsp[0].string);
				(yyval.handle).chain.location	= (yylsp[0]);
			}
#line 9759 "parser_bison.c"
    break;

  case 352: /* set_spec: table_spec identifier  */
#line 2519 "parser_bison.y"
                        {
				(yyval.handle)		= (yyvsp[-1].handle);
				(yyval.handle).set.name	= (yyvsp[0].string);
				(yyval.handle).set.location	= (yylsp[0]);
			}
#line 9769 "parser_bison.c"
    break;

  case 353: /* setid_spec: table_spec "handle" "number"  */
#line 2527 "parser_bison.y"
                        {
				(yyval.handle) 			= (yyvsp[-2].handle);
				(yyval.handle).handle.location 	= (yylsp[0]);
				(yyval.handle).handle.id 		= (yyvsp[0].val);
			}
#line 9779 "parser_bison.c"
    break;

  case 354: /* set_identifier: identifier  */
#line 2535 "parser_bison.y"
                        {
				memset(&(yyval.handle), 0, sizeof((yyval.handle)));
				(yyval.handle).set.name	= (yyvsp[0].string);
				(yyval.handle).set.location	= (yylsp[0]);
			}
#line 9789 "parser_bison.c"
    break;

  case 355: /* flowtable_spec: table_spec identifier  */
#line 2543 "parser_bison.y"
                        {
				(yyval.handle)			= (yyvsp[-1].handle);
				(yyval.handle).flowtable.name	= (yyvsp[0].string);
				(yyval.handle).flowtable.location	= (yylsp[0]);
			}
#line 9799 "parser_bison.c"
    break;

  case 356: /* flowtableid_spec: table_spec "handle" "number"  */
#line 2551 "parser_bison.y"
                        {
				(yyval.handle)			= (yyvsp[-2].handle);
				(yyval.handle).handle.location	= (yylsp[0]);
				(yyval.handle).handle.id		= (yyvsp[0].val);
			}
#line 9809 "parser_bison.c"
    break;

  case 357: /* flowtable_identifier: identifier  */
#line 2559 "parser_bison.y"
                        {
				memset(&(yyval.handle), 0, sizeof((yyval.handle)));
				(yyval.handle).flowtable.name	= (yyvsp[0].string);
				(yyval.handle).flowtable.location	= (yylsp[0]);
			}
#line 9819 "parser_bison.c"
    break;

  case 358: /* obj_spec: table_spec identifier  */
#line 2567 "parser_bison.y"
                        {
				(yyval.handle)		= (yyvsp[-1].handle);
				(yyval.handle).obj.name	= (yyvsp[0].string);
				(yyval.handle).obj.location	= (yylsp[0]);
			}
#line 9829 "parser_bison.c"
    break;

  case 359: /* objid_spec: table_spec "handle" "number"  */
#line 2575 "parser_bison.y"
                        {
				(yyval.handle) 			= (yyvsp[-2].handle);
				(yyval.handle).handle.location	= (yylsp[0]);
				(yyval.handle).handle.id		= (yyvsp[0].val);
			}
#line 9839 "parser_bison.c"
    break;

  case 360: /* obj_identifier: identifier  */
#line 2583 "parser_bison.y"
                        {
				memset(&(yyval.handle), 0, sizeof((yyval.handle)));
				(yyval.handle).obj.name		= (yyvsp[0].string);
				(yyval.handle).obj.location		= (yylsp[0]);
			}
#line 9849 "parser_bison.c"
    break;

  case 361: /* handle_spec: "handle" "number"  */
#line 2591 "parser_bison.y"
                        {
				memset(&(yyval.handle), 0, sizeof((yyval.handle)));
				(yyval.handle).handle.location	= (yylsp[0]);
				(yyval.handle).handle.id		= (yyvsp[0].val);
			}
#line 9859 "parser_bison.c"
    break;

  case 362: /* position_spec: "position" "number"  */
#line 2599 "parser_bison.y"
                        {
				memset(&(yyval.handle), 0, sizeof((yyval.handle)));
				(yyval.handle).position.location	= (yyloc);
				(yyval.handle).position.id		= (yyvsp[0].val);
			}
#line 9869 "parser_bison.c"
    break;

  case 363: /* index_spec: "index" "number"  */
#line 2607 "parser_bison.y"
                        {
				memset(&(yyval.handle), 0, sizeof((yyval.handle)));
				(yyval.handle).index.location	= (yyloc);
				(yyval.handle).index.id		= (yyvsp[0].val) + 1;
			}
#line 9879 "parser_bison.c"
    break;

  case 364: /* rule_position: chain_spec  */
#line 2615 "parser_bison.y"
                        {
				(yyval.handle) = (yyvsp[0].handle);
			}
#line 9887 "parser_bison.c"
    break;

  case 365: /* rule_position: chain_spec position_spec  */
#line 2619 "parser_bison.y"
                        {
				handle_merge(&(yyvsp[-1].handle), &(yyvsp[0].handle));
				(yyval.handle) = (yyvsp[-1].handle);
			}
#line 9896 "parser_bison.c"
    break;

  case 366: /* rule_position: chain_spec handle_spec  */
#line 2624 "parser_bison.y"
                        {
				(yyvsp[0].handle).position.location = (yyvsp[0].handle).handle.location;
				(yyvsp[0].handle).position.id = (yyvsp[0].handle).handle.id;
				(yyvsp[0].handle).handle.id = 0;
				handle_merge(&(yyvsp[-1].handle), &(yyvsp[0].handle));
				(yyval.handle) = (yyvsp[-1].handle);
			}
#line 9908 "parser_bison.c"
    break;

  case 367: /* rule_position: chain_spec index_spec  */
#line 2632 "parser_bison.y"
                        {
				handle_merge(&(yyvsp[-1].handle), &(yyvsp[0].handle));
				(yyval.handle) = (yyvsp[-1].handle);
			}
#line 9917 "parser_bison.c"
    break;

  case 368: /* ruleid_spec: chain_spec handle_spec  */
#line 2639 "parser_bison.y"
                        {
				handle_merge(&(yyvsp[-1].handle), &(yyvsp[0].handle));
				(yyval.handle) = (yyvsp[-1].handle);
			}
#line 9926 "parser_bison.c"
    break;

  case 369: /* comment_spec: "comment" string  */
#line 2646 "parser_bison.y"
                        {
				if (strlen((yyvsp[0].string)) > NFTNL_UDATA_COMMENT_MAXLEN) {
					erec_queue(error(&(yylsp[0]), "comment too long, %d characters maximum allowed",
							 NFTNL_UDATA_COMMENT_MAXLEN),
						   state->msgs);
					YYERROR;
				}
				(yyval.string) = (yyvsp[0].string);
			}
#line 9940 "parser_bison.c"
    break;

  case 370: /* ruleset_spec: %empty  */
#line 2658 "parser_bison.y"
                        {
				memset(&(yyval.handle), 0, sizeof((yyval.handle)));
				(yyval.handle).family	= NFPROTO_UNSPEC;
			}
#line 9949 "parser_bison.c"
    break;

  case 371: /* ruleset_spec: family_spec_explicit  */
#line 2663 "parser_bison.y"
                        {
				memset(&(yyval.handle), 0, sizeof((yyval.handle)));
				(yyval.handle).family	= (yyvsp[0].val);
			}
#line 9958 "parser_bison.c"
    break;

  case 372: /* rule: rule_alloc  */
#line 2670 "parser_bison.y"
                        {
				(yyval.rule)->comment = NULL;
			}
#line 9966 "parser_bison.c"
    break;

  case 373: /* rule: rule_alloc comment_spec  */
#line 2674 "parser_bison.y"
                        {
				(yyval.rule)->comment = (yyvsp[0].string);
			}
#line 9974 "parser_bison.c"
    break;

  case 374: /* rule_alloc: stmt_list  */
#line 2680 "parser_bison.y"
                        {
				struct stmt *i;

				(yyval.rule) = rule_alloc(&(yyloc), NULL);
				list_for_each_entry(i, (yyvsp[0].list), list)
					(yyval.rule)->num_stmts++;
				list_splice_tail((yyvsp[0].list), &(yyval.rule)->stmts);
				xfree((yyvsp[0].list));
			}
#line 9988 "parser_bison.c"
    break;

  case 375: /* stmt_list: stmt  */
#line 2692 "parser_bison.y"
                        {
				(yyval.list) = xmalloc(sizeof(*(yyval.list)));
				init_list_head((yyval.list));
				list_add_tail(&(yyvsp[0].stmt)->list, (yyval.list));
			}
#line 9998 "parser_bison.c"
    break;

  case 376: /* stmt_list: stmt_list stmt  */
#line 2698 "parser_bison.y"
                        {
				(yyval.list) = (yyvsp[-1].list);
				list_add_tail(&(yyvsp[0].stmt)->list, (yyvsp[-1].list));
			}
#line 10007 "parser_bison.c"
    break;

  case 377: /* stateful_stmt_list: stateful_stmt  */
#line 2705 "parser_bison.y"
                        {
				(yyval.list) = xmalloc(sizeof(*(yyval.list)));
				init_list_head((yyval.list));
				list_add_tail(&(yyvsp[0].stmt)->list, (yyval.list));
			}
#line 10017 "parser_bison.c"
    break;

  case 378: /* stateful_stmt_list: stateful_stmt_list stateful_stmt  */
#line 2711 "parser_bison.y"
                        {
				(yyval.list) = (yyvsp[-1].list);
				list_add_tail(&(yyvsp[0].stmt)->list, (yyvsp[-1].list));
			}
#line 10026 "parser_bison.c"
    break;

  case 403: /* chain_stmt_type: "jump"  */
#line 2745 "parser_bison.y"
                                        { (yyval.val) = NFT_JUMP; }
#line 10032 "parser_bison.c"
    break;

  case 404: /* chain_stmt_type: "goto"  */
#line 2746 "parser_bison.y"
                                        { (yyval.val) = NFT_GOTO; }
#line 10038 "parser_bison.c"
    break;

  case 405: /* chain_stmt: chain_stmt_type chain_block_alloc '{' subchain_block '}'  */
#line 2750 "parser_bison.y"
                        {
				(yyvsp[-3].chain)->location = (yylsp[-3]);
				close_scope(state);
				(yyvsp[-1].chain)->location = (yylsp[-1]);
				(yyval.stmt) = chain_stmt_alloc(&(yyloc), (yyvsp[-1].chain), (yyvsp[-4].val));
			}
#line 10049 "parser_bison.c"
    break;

  case 406: /* verdict_stmt: verdict_expr  */
#line 2759 "parser_bison.y"
                        {
				(yyval.stmt) = verdict_stmt_alloc(&(yyloc), (yyvsp[0].expr));
			}
#line 10057 "parser_bison.c"
    break;

  case 407: /* verdict_stmt: verdict_map_stmt  */
#line 2763 "parser_bison.y"
                        {
				(yyval.stmt) = verdict_stmt_alloc(&(yyloc), (yyvsp[0].expr));
			}
#line 10065 "parser_bison.c"
    break;

  case 408: /* verdict_map_stmt: concat_expr "vmap" verdict_map_expr  */
#line 2769 "parser_bison.y"
                        {
				(yyval.expr) = map_expr_alloc(&(yyloc), (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 10073 "parser_bison.c"
    break;

  case 409: /* verdict_map_expr: '{' verdict_map_list_expr '}'  */
#line 2775 "parser_bison.y"
                        {
				(yyvsp[-1].expr)->location = (yyloc);
				(yyval.expr) = (yyvsp[-1].expr);
			}
#line 10082 "parser_bison.c"
    break;

  case 411: /* verdict_map_list_expr: verdict_map_list_member_expr  */
#line 2783 "parser_bison.y"
                        {
				(yyval.expr) = set_expr_alloc(&(yyloc), NULL);
				compound_expr_add((yyval.expr), (yyvsp[0].expr));
			}
#line 10091 "parser_bison.c"
    break;

  case 412: /* verdict_map_list_expr: verdict_map_list_expr "comma" verdict_map_list_member_expr  */
#line 2788 "parser_bison.y"
                        {
				compound_expr_add((yyvsp[-2].expr), (yyvsp[0].expr));
				(yyval.expr) = (yyvsp[-2].expr);
			}
#line 10100 "parser_bison.c"
    break;

  case 414: /* verdict_map_list_member_expr: opt_newline set_elem_expr "colon" verdict_expr opt_newline  */
#line 2796 "parser_bison.y"
                        {
				(yyval.expr) = mapping_expr_alloc(&(yyloc), (yyvsp[-3].expr), (yyvsp[-1].expr));
			}
#line 10108 "parser_bison.c"
    break;

  case 415: /* connlimit_stmt: "ct" "count" "number"  */
#line 2802 "parser_bison.y"
                        {
				(yyval.stmt) = connlimit_stmt_alloc(&(yyloc));
				(yyval.stmt)->connlimit.count	= (yyvsp[0].val);
			}
#line 10117 "parser_bison.c"
    break;

  case 416: /* connlimit_stmt: "ct" "count" "over" "number"  */
#line 2807 "parser_bison.y"
                        {
				(yyval.stmt) = connlimit_stmt_alloc(&(yyloc));
				(yyval.stmt)->connlimit.count = (yyvsp[0].val);
				(yyval.stmt)->connlimit.flags = NFT_CONNLIMIT_F_INV;
			}
#line 10127 "parser_bison.c"
    break;

  case 419: /* counter_stmt_alloc: "counter"  */
#line 2818 "parser_bison.y"
                        {
				(yyval.stmt) = counter_stmt_alloc(&(yyloc));
			}
#line 10135 "parser_bison.c"
    break;

  case 420: /* counter_stmt_alloc: "counter" "name" stmt_expr  */
#line 2822 "parser_bison.y"
                        {
				(yyval.stmt) = objref_stmt_alloc(&(yyloc));
				(yyval.stmt)->objref.type = NFT_OBJECT_COUNTER;
				(yyval.stmt)->objref.expr = (yyvsp[0].expr);
			}
#line 10145 "parser_bison.c"
    break;

  case 421: /* counter_args: counter_arg  */
#line 2830 "parser_bison.y"
                        {
				(yyval.stmt)	= (yyvsp[-1].stmt);
			}
#line 10153 "parser_bison.c"
    break;

  case 423: /* counter_arg: "packets" "number"  */
#line 2837 "parser_bison.y"
                        {
				(yyvsp[-2].stmt)->counter.packets = (yyvsp[0].val);
			}
#line 10161 "parser_bison.c"
    break;

  case 424: /* counter_arg: "bytes" "number"  */
#line 2841 "parser_bison.y"
                        {
				(yyvsp[-2].stmt)->counter.bytes	 = (yyvsp[0].val);
			}
#line 10169 "parser_bison.c"
    break;

  case 427: /* log_stmt_alloc: "log"  */
#line 2851 "parser_bison.y"
                        {
				(yyval.stmt) = log_stmt_alloc(&(yyloc));
			}
#line 10177 "parser_bison.c"
    break;

  case 428: /* log_args: log_arg  */
#line 2857 "parser_bison.y"
                        {
				(yyval.stmt)	= (yyvsp[-1].stmt);
			}
#line 10185 "parser_bison.c"
    break;

  case 430: /* log_arg: "prefix" string  */
#line 2864 "parser_bison.y"
                        {
				struct scope *scope = current_scope(state);
				bool done = false, another_var = false;
				char *start, *end, scratch = '\0';
				struct expr *expr, *item;
				struct symbol *sym;
				enum {
					PARSE_TEXT,
					PARSE_VAR,
				} prefix_state;

				/* No variables in log prefix, skip. */
				if (!strchr((yyvsp[0].string), '$')) {
					expr = constant_expr_alloc(&(yyloc), &string_type,
								   BYTEORDER_HOST_ENDIAN,
								   (strlen((yyvsp[0].string)) + 1) * BITS_PER_BYTE, (yyvsp[0].string));
					xfree((yyvsp[0].string));
					(yyvsp[-2].stmt)->log.prefix = expr;
					(yyvsp[-2].stmt)->log.flags |= STMT_LOG_PREFIX;
					break;
				}

				/* Parse variables in log prefix string using a
				 * state machine parser with two states. This
				 * parser creates list of expressions composed
				 * of constant and variable expressions.
				 */
				expr = compound_expr_alloc(&(yyloc), EXPR_LIST);

				start = (char *)(yyvsp[0].string);

				if (*start != '$') {
					prefix_state = PARSE_TEXT;
				} else {
					prefix_state = PARSE_VAR;
					start++;
				}
				end = start;

				/* Not nice, but works. */
				while (!done) {
					switch (prefix_state) {
					case PARSE_TEXT:
						while (*end != '\0' && *end != '$')
							end++;

						if (*end == '\0')
							done = true;

						*end = '\0';
						item = constant_expr_alloc(&(yyloc), &string_type,
									   BYTEORDER_HOST_ENDIAN,
									   (strlen(start) + 1) * BITS_PER_BYTE,
									   start);
						compound_expr_add(expr, item);

						if (done)
							break;

						start = end + 1;
						end = start;

						/* fall through */
					case PARSE_VAR:
						while (isalnum(*end) || *end == '_')
							end++;

						if (*end == '\0')
							done = true;
						else if (*end == '$')
							another_var = true;
						else
							scratch = *end;

						*end = '\0';

						sym = symbol_get(scope, start);
						if (!sym) {
							sym = symbol_lookup_fuzzy(scope, start);
							if (sym) {
								erec_queue(error(&(yylsp[0]), "unknown identifier '%s'; "
										 "did you mean identifier ‘%s’?",
										 start, sym->identifier),
									   state->msgs);
							} else {
								erec_queue(error(&(yylsp[0]), "unknown identifier '%s'",
										 start),
									   state->msgs);
							}
							expr_free(expr);
							xfree((yyvsp[0].string));
							YYERROR;
						}
						item = variable_expr_alloc(&(yyloc), scope, sym);
						compound_expr_add(expr, item);

						if (done)
							break;

						/* Restore original byte after
						 * symbol lookup.
						 */
						if (scratch) {
							*end = scratch;
							scratch = '\0';
						}

						start = end;
						if (another_var) {
							another_var = false;
							start++;
							prefix_state = PARSE_VAR;
						} else {
							prefix_state = PARSE_TEXT;
						}
						end = start;
						break;
					}
				}

				xfree((yyvsp[0].string));
				(yyvsp[-2].stmt)->log.prefix	 = expr;
				(yyvsp[-2].stmt)->log.flags 	|= STMT_LOG_PREFIX;
			}
#line 10314 "parser_bison.c"
    break;

  case 431: /* log_arg: "group" "number"  */
#line 2989 "parser_bison.y"
                        {
				(yyvsp[-2].stmt)->log.group	 = (yyvsp[0].val);
				(yyvsp[-2].stmt)->log.flags 	|= STMT_LOG_GROUP;
			}
#line 10323 "parser_bison.c"
    break;

  case 432: /* log_arg: "snaplen" "number"  */
#line 2994 "parser_bison.y"
                        {
				(yyvsp[-2].stmt)->log.snaplen	 = (yyvsp[0].val);
				(yyvsp[-2].stmt)->log.flags 	|= STMT_LOG_SNAPLEN;
			}
#line 10332 "parser_bison.c"
    break;

  case 433: /* log_arg: "queue-threshold" "number"  */
#line 2999 "parser_bison.y"
                        {
				(yyvsp[-2].stmt)->log.qthreshold = (yyvsp[0].val);
				(yyvsp[-2].stmt)->log.flags 	|= STMT_LOG_QTHRESHOLD;
			}
#line 10341 "parser_bison.c"
    break;

  case 434: /* log_arg: "level" level_type  */
#line 3004 "parser_bison.y"
                        {
				(yyvsp[-2].stmt)->log.level	= (yyvsp[0].val);
				(yyvsp[-2].stmt)->log.flags 	|= STMT_LOG_LEVEL;
			}
#line 10350 "parser_bison.c"
    break;

  case 435: /* log_arg: "flags" log_flags  */
#line 3009 "parser_bison.y"
                        {
				(yyvsp[-2].stmt)->log.logflags	|= (yyvsp[0].val);
			}
#line 10358 "parser_bison.c"
    break;

  case 436: /* level_type: string  */
#line 3015 "parser_bison.y"
                        {
				if (!strcmp("emerg", (yyvsp[0].string)))
					(yyval.val) = NFT_LOGLEVEL_EMERG;
				else if (!strcmp("alert", (yyvsp[0].string)))
					(yyval.val) = NFT_LOGLEVEL_ALERT;
				else if (!strcmp("crit", (yyvsp[0].string)))
					(yyval.val) = NFT_LOGLEVEL_CRIT;
				else if (!strcmp("err", (yyvsp[0].string)))
					(yyval.val) = NFT_LOGLEVEL_ERR;
				else if (!strcmp("warn", (yyvsp[0].string)))
					(yyval.val) = NFT_LOGLEVEL_WARNING;
				else if (!strcmp("notice", (yyvsp[0].string)))
					(yyval.val) = NFT_LOGLEVEL_NOTICE;
				else if (!strcmp("info", (yyvsp[0].string)))
					(yyval.val) = NFT_LOGLEVEL_INFO;
				else if (!strcmp("debug", (yyvsp[0].string)))
					(yyval.val) = NFT_LOGLEVEL_DEBUG;
				else if (!strcmp("audit", (yyvsp[0].string)))
					(yyval.val) = NFT_LOGLEVEL_AUDIT;
				else {
					erec_queue(error(&(yylsp[0]), "invalid log level"),
						   state->msgs);
					xfree((yyvsp[0].string));
					YYERROR;
				}
				xfree((yyvsp[0].string));
			}
#line 10390 "parser_bison.c"
    break;

  case 437: /* log_flags: "tcp" log_flags_tcp  */
#line 3045 "parser_bison.y"
                        {
				(yyval.val) = (yyvsp[0].val);
			}
#line 10398 "parser_bison.c"
    break;

  case 438: /* log_flags: "ip" "options"  */
#line 3049 "parser_bison.y"
                        {
				(yyval.val) = NF_LOG_IPOPT;
			}
#line 10406 "parser_bison.c"
    break;

  case 439: /* log_flags: "skuid"  */
#line 3053 "parser_bison.y"
                        {
				(yyval.val) = NF_LOG_UID;
			}
#line 10414 "parser_bison.c"
    break;

  case 440: /* log_flags: "ether"  */
#line 3057 "parser_bison.y"
                        {
				(yyval.val) = NF_LOG_MACDECODE;
			}
#line 10422 "parser_bison.c"
    break;

  case 441: /* log_flags: "all"  */
#line 3061 "parser_bison.y"
                        {
				(yyval.val) = NF_LOG_MASK;
			}
#line 10430 "parser_bison.c"
    break;

  case 442: /* log_flags_tcp: log_flags_tcp "comma" log_flag_tcp  */
#line 3067 "parser_bison.y"
                        {
				(yyval.val) = (yyvsp[-2].val) | (yyvsp[0].val);
			}
#line 10438 "parser_bison.c"
    break;

  case 444: /* log_flag_tcp: "seq"  */
#line 3074 "parser_bison.y"
                        {
				(yyval.val) = NF_LOG_TCPSEQ;
			}
#line 10446 "parser_bison.c"
    break;

  case 445: /* log_flag_tcp: "options"  */
#line 3078 "parser_bison.y"
                        {
				(yyval.val) = NF_LOG_TCPOPT;
			}
#line 10454 "parser_bison.c"
    break;

  case 446: /* limit_stmt: "limit" "rate" limit_mode "number" "/" time_unit limit_burst_pkts  */
#line 3084 "parser_bison.y"
                        {
				if ((yyvsp[0].val) == 0) {
					erec_queue(error(&(yylsp[0]), "limit burst must be > 0"),
						   state->msgs);
					YYERROR;
				}
				(yyval.stmt) = limit_stmt_alloc(&(yyloc));
				(yyval.stmt)->limit.rate	= (yyvsp[-3].val);
				(yyval.stmt)->limit.unit	= (yyvsp[-1].val);
				(yyval.stmt)->limit.burst	= (yyvsp[0].val);
				(yyval.stmt)->limit.type	= NFT_LIMIT_PKTS;
				(yyval.stmt)->limit.flags = (yyvsp[-4].val);
			}
#line 10472 "parser_bison.c"
    break;

  case 447: /* limit_stmt: "limit" "rate" limit_mode "number" "string" limit_burst_bytes  */
#line 3098 "parser_bison.y"
                        {
				struct error_record *erec;
				uint64_t rate, unit;

				if ((yyvsp[0].val) == 0) {
					erec_queue(error(&(yylsp[0]), "limit burst must be > 0"),
						   state->msgs);
					YYERROR;
				}

				erec = rate_parse(&(yyloc), (yyvsp[-1].string), &rate, &unit);
				xfree((yyvsp[-1].string));
				if (erec != NULL) {
					erec_queue(erec, state->msgs);
					YYERROR;
				}

				(yyval.stmt) = limit_stmt_alloc(&(yyloc));
				(yyval.stmt)->limit.rate	= rate * (yyvsp[-2].val);
				(yyval.stmt)->limit.unit	= unit;
				(yyval.stmt)->limit.burst	= (yyvsp[0].val);
				(yyval.stmt)->limit.type	= NFT_LIMIT_PKT_BYTES;
				(yyval.stmt)->limit.flags = (yyvsp[-3].val);
			}
#line 10501 "parser_bison.c"
    break;

  case 448: /* limit_stmt: "limit" "name" stmt_expr  */
#line 3123 "parser_bison.y"
                        {
				(yyval.stmt) = objref_stmt_alloc(&(yyloc));
				(yyval.stmt)->objref.type = NFT_OBJECT_LIMIT;
				(yyval.stmt)->objref.expr = (yyvsp[0].expr);
			}
#line 10511 "parser_bison.c"
    break;

  case 449: /* quota_mode: "over"  */
#line 3130 "parser_bison.y"
                                                { (yyval.val) = NFT_QUOTA_F_INV; }
#line 10517 "parser_bison.c"
    break;

  case 450: /* quota_mode: "until"  */
#line 3131 "parser_bison.y"
                                                { (yyval.val) = 0; }
#line 10523 "parser_bison.c"
    break;

  case 451: /* quota_mode: %empty  */
#line 3132 "parser_bison.y"
                                                { (yyval.val) = 0; }
#line 10529 "parser_bison.c"
    break;

  case 452: /* quota_unit: "bytes"  */
#line 3135 "parser_bison.y"
                                                { (yyval.string) = xstrdup("bytes"); }
#line 10535 "parser_bison.c"
    break;

  case 453: /* quota_unit: "string"  */
#line 3136 "parser_bison.y"
                                                { (yyval.string) = (yyvsp[0].string); }
#line 10541 "parser_bison.c"
    break;

  case 454: /* quota_used: %empty  */
#line 3139 "parser_bison.y"
                                                { (yyval.val) = 0; }
#line 10547 "parser_bison.c"
    break;

  case 455: /* quota_used: "used" "number" quota_unit  */
#line 3141 "parser_bison.y"
                        {
				struct error_record *erec;
				uint64_t rate;

				erec = data_unit_parse(&(yyloc), (yyvsp[0].string), &rate);
				xfree((yyvsp[0].string));
				if (erec != NULL) {
					erec_queue(erec, state->msgs);
					YYERROR;
				}
				(yyval.val) = (yyvsp[-1].val) * rate;
			}
#line 10564 "parser_bison.c"
    break;

  case 456: /* quota_stmt: "quota" quota_mode "number" quota_unit quota_used  */
#line 3156 "parser_bison.y"
                        {
				struct error_record *erec;
				uint64_t rate;

				erec = data_unit_parse(&(yyloc), (yyvsp[-1].string), &rate);
				xfree((yyvsp[-1].string));
				if (erec != NULL) {
					erec_queue(erec, state->msgs);
					YYERROR;
				}
				(yyval.stmt) = quota_stmt_alloc(&(yyloc));
				(yyval.stmt)->quota.bytes	= (yyvsp[-2].val) * rate;
				(yyval.stmt)->quota.used = (yyvsp[0].val);
				(yyval.stmt)->quota.flags	= (yyvsp[-3].val);
			}
#line 10584 "parser_bison.c"
    break;

  case 457: /* quota_stmt: "quota" "name" stmt_expr  */
#line 3172 "parser_bison.y"
                        {
				(yyval.stmt) = objref_stmt_alloc(&(yyloc));
				(yyval.stmt)->objref.type = NFT_OBJECT_QUOTA;
				(yyval.stmt)->objref.expr = (yyvsp[0].expr);
			}
#line 10594 "parser_bison.c"
    break;

  case 458: /* limit_mode: "over"  */
#line 3179 "parser_bison.y"
                                                                { (yyval.val) = NFT_LIMIT_F_INV; }
#line 10600 "parser_bison.c"
    break;

  case 459: /* limit_mode: "until"  */
#line 3180 "parser_bison.y"
                                                                { (yyval.val) = 0; }
#line 10606 "parser_bison.c"
    break;

  case 460: /* limit_mode: %empty  */
#line 3181 "parser_bison.y"
                                                                { (yyval.val) = 0; }
#line 10612 "parser_bison.c"
    break;

  case 461: /* limit_burst_pkts: %empty  */
#line 3184 "parser_bison.y"
                                                                { (yyval.val) = 5; }
#line 10618 "parser_bison.c"
    break;

  case 462: /* limit_burst_pkts: "burst" "number" "packets"  */
#line 3185 "parser_bison.y"
                                                                { (yyval.val) = (yyvsp[-1].val); }
#line 10624 "parser_bison.c"
    break;

  case 463: /* limit_burst_bytes: %empty  */
#line 3188 "parser_bison.y"
                                                                { (yyval.val) = 5; }
#line 10630 "parser_bison.c"
    break;

  case 464: /* limit_burst_bytes: "burst" "number" "bytes"  */
#line 3189 "parser_bison.y"
                                                                { (yyval.val) = (yyvsp[-1].val); }
#line 10636 "parser_bison.c"
    break;

  case 465: /* limit_burst_bytes: "burst" "number" "string"  */
#line 3191 "parser_bison.y"
                        {
				struct error_record *erec;
				uint64_t rate;

				erec = data_unit_parse(&(yyloc), (yyvsp[0].string), &rate);
				xfree((yyvsp[0].string));
				if (erec != NULL) {
					erec_queue(erec, state->msgs);
					YYERROR;
				}
				(yyval.val) = (yyvsp[-1].val) * rate;
			}
#line 10653 "parser_bison.c"
    break;

  case 466: /* time_unit: "second"  */
#line 3205 "parser_bison.y"
                                                { (yyval.val) = 1ULL; }
#line 10659 "parser_bison.c"
    break;

  case 467: /* time_unit: "minute"  */
#line 3206 "parser_bison.y"
                                                { (yyval.val) = 1ULL * 60; }
#line 10665 "parser_bison.c"
    break;

  case 468: /* time_unit: "hour"  */
#line 3207 "parser_bison.y"
                                                { (yyval.val) = 1ULL * 60 * 60; }
#line 10671 "parser_bison.c"
    break;

  case 469: /* time_unit: "day"  */
#line 3208 "parser_bison.y"
                                                { (yyval.val) = 1ULL * 60 * 60 * 24; }
#line 10677 "parser_bison.c"
    break;

  case 470: /* time_unit: "week"  */
#line 3209 "parser_bison.y"
                                                { (yyval.val) = 1ULL * 60 * 60 * 24 * 7; }
#line 10683 "parser_bison.c"
    break;

  case 472: /* reject_stmt_alloc: "reject"  */
#line 3216 "parser_bison.y"
                        {
				(yyval.stmt) = reject_stmt_alloc(&(yyloc));
			}
#line 10691 "parser_bison.c"
    break;

  case 473: /* reject_opts: %empty  */
#line 3222 "parser_bison.y"
                        {
				(yyvsp[0].stmt)->reject.type = -1;
				(yyvsp[0].stmt)->reject.icmp_code = -1;
			}
#line 10700 "parser_bison.c"
    break;

  case 474: /* reject_opts: "with" "icmp" "type" "string"  */
#line 3227 "parser_bison.y"
                        {
				(yyvsp[-4].stmt)->reject.family = NFPROTO_IPV4;
				(yyvsp[-4].stmt)->reject.type = NFT_REJECT_ICMP_UNREACH;
				(yyvsp[-4].stmt)->reject.expr =
					symbol_expr_alloc(&(yyloc), SYMBOL_VALUE,
							  current_scope(state),
							  (yyvsp[0].string));
				datatype_set((yyvsp[-4].stmt)->reject.expr, &icmp_code_type);
				xfree((yyvsp[0].string));
			}
#line 10715 "parser_bison.c"
    break;

  case 475: /* reject_opts: "with" "icmpv6" "type" "string"  */
#line 3238 "parser_bison.y"
                        {
				(yyvsp[-4].stmt)->reject.family = NFPROTO_IPV6;
				(yyvsp[-4].stmt)->reject.type = NFT_REJECT_ICMP_UNREACH;
				(yyvsp[-4].stmt)->reject.expr =
					symbol_expr_alloc(&(yyloc), SYMBOL_VALUE,
							  current_scope(state),
							  (yyvsp[0].string));
				datatype_set((yyvsp[-4].stmt)->reject.expr, &icmpv6_code_type);
				xfree((yyvsp[0].string));
			}
#line 10730 "parser_bison.c"
    break;

  case 476: /* reject_opts: "with" "icmpx" "type" "string"  */
#line 3249 "parser_bison.y"
                        {
				(yyvsp[-4].stmt)->reject.type = NFT_REJECT_ICMPX_UNREACH;
				(yyvsp[-4].stmt)->reject.expr =
					symbol_expr_alloc(&(yyloc), SYMBOL_VALUE,
							  current_scope(state),
							  (yyvsp[0].string));
				datatype_set((yyvsp[-4].stmt)->reject.expr, &icmpx_code_type);
				xfree((yyvsp[0].string));
			}
#line 10744 "parser_bison.c"
    break;

  case 477: /* reject_opts: "with" "tcp" "reset"  */
#line 3259 "parser_bison.y"
                        {
				(yyvsp[-3].stmt)->reject.type = NFT_REJECT_TCP_RST;
			}
#line 10752 "parser_bison.c"
    break;

  case 479: /* nat_stmt_alloc: "snat"  */
#line 3267 "parser_bison.y"
                                        { (yyval.stmt) = nat_stmt_alloc(&(yyloc), NFT_NAT_SNAT); }
#line 10758 "parser_bison.c"
    break;

  case 480: /* nat_stmt_alloc: "dnat"  */
#line 3268 "parser_bison.y"
                                        { (yyval.stmt) = nat_stmt_alloc(&(yyloc), NFT_NAT_DNAT); }
#line 10764 "parser_bison.c"
    break;

  case 481: /* tproxy_stmt: "tproxy" "to" stmt_expr  */
#line 3272 "parser_bison.y"
                        {
				(yyval.stmt) = tproxy_stmt_alloc(&(yyloc));
				(yyval.stmt)->tproxy.family = NFPROTO_UNSPEC;
				(yyval.stmt)->tproxy.addr = (yyvsp[0].expr);
			}
#line 10774 "parser_bison.c"
    break;

  case 482: /* tproxy_stmt: "tproxy" nf_key_proto "to" stmt_expr  */
#line 3278 "parser_bison.y"
                        {
				(yyval.stmt) = tproxy_stmt_alloc(&(yyloc));
				(yyval.stmt)->tproxy.family = (yyvsp[-2].val);
				(yyval.stmt)->tproxy.addr = (yyvsp[0].expr);
			}
#line 10784 "parser_bison.c"
    break;

  case 483: /* tproxy_stmt: "tproxy" "to" "colon" stmt_expr  */
#line 3284 "parser_bison.y"
                        {
				(yyval.stmt) = tproxy_stmt_alloc(&(yyloc));
				(yyval.stmt)->tproxy.family = NFPROTO_UNSPEC;
				(yyval.stmt)->tproxy.port = (yyvsp[0].expr);
			}
#line 10794 "parser_bison.c"
    break;

  case 484: /* tproxy_stmt: "tproxy" "to" stmt_expr "colon" stmt_expr  */
#line 3290 "parser_bison.y"
                        {
				(yyval.stmt) = tproxy_stmt_alloc(&(yyloc));
				(yyval.stmt)->tproxy.family = NFPROTO_UNSPEC;
				(yyval.stmt)->tproxy.addr = (yyvsp[-2].expr);
				(yyval.stmt)->tproxy.port = (yyvsp[0].expr);
			}
#line 10805 "parser_bison.c"
    break;

  case 485: /* tproxy_stmt: "tproxy" nf_key_proto "to" stmt_expr "colon" stmt_expr  */
#line 3297 "parser_bison.y"
                        {
				(yyval.stmt) = tproxy_stmt_alloc(&(yyloc));
				(yyval.stmt)->tproxy.family = (yyvsp[-4].val);
				(yyval.stmt)->tproxy.addr = (yyvsp[-2].expr);
				(yyval.stmt)->tproxy.port = (yyvsp[0].expr);
			}
#line 10816 "parser_bison.c"
    break;

  case 486: /* tproxy_stmt: "tproxy" nf_key_proto "to" "colon" stmt_expr  */
#line 3304 "parser_bison.y"
                        {
				(yyval.stmt) = tproxy_stmt_alloc(&(yyloc));
				(yyval.stmt)->tproxy.family = (yyvsp[-3].val);
				(yyval.stmt)->tproxy.port = (yyvsp[0].expr);
			}
#line 10826 "parser_bison.c"
    break;

  case 489: /* synproxy_stmt_alloc: "synproxy"  */
#line 3316 "parser_bison.y"
                        {
				(yyval.stmt) = synproxy_stmt_alloc(&(yyloc));
			}
#line 10834 "parser_bison.c"
    break;

  case 490: /* synproxy_stmt_alloc: "synproxy" "name" stmt_expr  */
#line 3320 "parser_bison.y"
                        {
				(yyval.stmt) = objref_stmt_alloc(&(yyloc));
				(yyval.stmt)->objref.type = NFT_OBJECT_SYNPROXY;
				(yyval.stmt)->objref.expr = (yyvsp[0].expr);
			}
#line 10844 "parser_bison.c"
    break;

  case 491: /* synproxy_args: synproxy_arg  */
#line 3328 "parser_bison.y"
                        {
				(yyval.stmt)	= (yyvsp[-1].stmt);
			}
#line 10852 "parser_bison.c"
    break;

  case 493: /* synproxy_arg: "mss" "number"  */
#line 3335 "parser_bison.y"
                        {
				(yyvsp[-2].stmt)->synproxy.mss = (yyvsp[0].val);
				(yyvsp[-2].stmt)->synproxy.flags |= NF_SYNPROXY_OPT_MSS;
			}
#line 10861 "parser_bison.c"
    break;

  case 494: /* synproxy_arg: "wscale" "number"  */
#line 3340 "parser_bison.y"
                        {
				(yyvsp[-2].stmt)->synproxy.wscale = (yyvsp[0].val);
				(yyvsp[-2].stmt)->synproxy.flags |= NF_SYNPROXY_OPT_WSCALE;
			}
#line 10870 "parser_bison.c"
    break;

  case 495: /* synproxy_arg: "timestamp"  */
#line 3345 "parser_bison.y"
                        {
				(yyvsp[-1].stmt)->synproxy.flags |= NF_SYNPROXY_OPT_TIMESTAMP;
			}
#line 10878 "parser_bison.c"
    break;

  case 496: /* synproxy_arg: "sack-permitted"  */
#line 3349 "parser_bison.y"
                        {
				(yyvsp[-1].stmt)->synproxy.flags |= NF_SYNPROXY_OPT_SACK_PERM;
			}
#line 10886 "parser_bison.c"
    break;

  case 497: /* synproxy_config: "mss" "number" "wscale" "number" synproxy_ts synproxy_sack  */
#line 3355 "parser_bison.y"
                        {
				struct synproxy *synproxy;
				uint32_t flags = 0;

				synproxy = &(yyvsp[-6].obj)->synproxy;
				synproxy->mss = (yyvsp[-4].val);
				flags |= NF_SYNPROXY_OPT_MSS;
				synproxy->wscale = (yyvsp[-2].val);
				flags |= NF_SYNPROXY_OPT_WSCALE;
				if ((yyvsp[-1].val))
					flags |= (yyvsp[-1].val);
				if ((yyvsp[0].val))
					flags |= (yyvsp[0].val);
				synproxy->flags = flags;
			}
#line 10906 "parser_bison.c"
    break;

  case 498: /* synproxy_config: "mss" "number" stmt_separator "wscale" "number" stmt_separator synproxy_ts synproxy_sack  */
#line 3371 "parser_bison.y"
                        {
				struct synproxy *synproxy;
				uint32_t flags = 0;

				synproxy = &(yyvsp[-8].obj)->synproxy;
				synproxy->mss = (yyvsp[-6].val);
				flags |= NF_SYNPROXY_OPT_MSS;
				synproxy->wscale = (yyvsp[-3].val);
				flags |= NF_SYNPROXY_OPT_WSCALE;
				if ((yyvsp[-1].val))
					flags |= (yyvsp[-1].val);
				if ((yyvsp[0].val))
					flags |= (yyvsp[0].val);
				synproxy->flags = flags;
			}
#line 10926 "parser_bison.c"
    break;

  case 499: /* synproxy_obj: %empty  */
#line 3389 "parser_bison.y"
                        {
				(yyval.obj) = obj_alloc(&(yyloc));
				(yyval.obj)->type = NFT_OBJECT_SYNPROXY;
			}
#line 10935 "parser_bison.c"
    break;

  case 500: /* synproxy_ts: %empty  */
#line 3395 "parser_bison.y"
                                                { (yyval.val) = 0; }
#line 10941 "parser_bison.c"
    break;

  case 501: /* synproxy_ts: "timestamp"  */
#line 3397 "parser_bison.y"
                        {
				(yyval.val) = NF_SYNPROXY_OPT_TIMESTAMP;
			}
#line 10949 "parser_bison.c"
    break;

  case 502: /* synproxy_sack: %empty  */
#line 3402 "parser_bison.y"
                                                { (yyval.val) = 0; }
#line 10955 "parser_bison.c"
    break;

  case 503: /* synproxy_sack: "sack-permitted"  */
#line 3404 "parser_bison.y"
                        {
				(yyval.val) = NF_SYNPROXY_OPT_SACK_PERM;
			}
#line 10963 "parser_bison.c"
    break;

  case 504: /* primary_stmt_expr: symbol_expr  */
#line 3409 "parser_bison.y"
                                                                { (yyval.expr) = (yyvsp[0].expr); }
#line 10969 "parser_bison.c"
    break;

  case 505: /* primary_stmt_expr: integer_expr  */
#line 3410 "parser_bison.y"
                                                                { (yyval.expr) = (yyvsp[0].expr); }
#line 10975 "parser_bison.c"
    break;

  case 506: /* primary_stmt_expr: boolean_expr  */
#line 3411 "parser_bison.y"
                                                                { (yyval.expr) = (yyvsp[0].expr); }
#line 10981 "parser_bison.c"
    break;

  case 507: /* primary_stmt_expr: meta_expr  */
#line 3412 "parser_bison.y"
                                                                { (yyval.expr) = (yyvsp[0].expr); }
#line 10987 "parser_bison.c"
    break;

  case 508: /* primary_stmt_expr: rt_expr  */
#line 3413 "parser_bison.y"
                                                                { (yyval.expr) = (yyvsp[0].expr); }
#line 10993 "parser_bison.c"
    break;

  case 509: /* primary_stmt_expr: ct_expr  */
#line 3414 "parser_bison.y"
                                                                { (yyval.expr) = (yyvsp[0].expr); }
#line 10999 "parser_bison.c"
    break;

  case 510: /* primary_stmt_expr: numgen_expr  */
#line 3415 "parser_bison.y"
                                                                { (yyval.expr) = (yyvsp[0].expr); }
#line 11005 "parser_bison.c"
    break;

  case 511: /* primary_stmt_expr: hash_expr  */
#line 3416 "parser_bison.y"
                                                                { (yyval.expr) = (yyvsp[0].expr); }
#line 11011 "parser_bison.c"
    break;

  case 512: /* primary_stmt_expr: payload_expr  */
#line 3417 "parser_bison.y"
                                                                { (yyval.expr) = (yyvsp[0].expr); }
#line 11017 "parser_bison.c"
    break;

  case 513: /* primary_stmt_expr: keyword_expr  */
#line 3418 "parser_bison.y"
                                                                { (yyval.expr) = (yyvsp[0].expr); }
#line 11023 "parser_bison.c"
    break;

  case 514: /* primary_stmt_expr: socket_expr  */
#line 3419 "parser_bison.y"
                                                                { (yyval.expr) = (yyvsp[0].expr); }
#line 11029 "parser_bison.c"
    break;

  case 515: /* primary_stmt_expr: osf_expr  */
#line 3420 "parser_bison.y"
                                                                { (yyval.expr) = (yyvsp[0].expr); }
#line 11035 "parser_bison.c"
    break;

  case 516: /* primary_stmt_expr: '(' basic_stmt_expr ')'  */
#line 3421 "parser_bison.y"
                                                                { (yyval.expr) = (yyvsp[-1].expr); }
#line 11041 "parser_bison.c"
    break;

  case 518: /* shift_stmt_expr: shift_stmt_expr "<<" primary_stmt_expr  */
#line 3426 "parser_bison.y"
                        {
				(yyval.expr) = binop_expr_alloc(&(yyloc), OP_LSHIFT, (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 11049 "parser_bison.c"
    break;

  case 519: /* shift_stmt_expr: shift_stmt_expr ">>" primary_stmt_expr  */
#line 3430 "parser_bison.y"
                        {
				(yyval.expr) = binop_expr_alloc(&(yyloc), OP_RSHIFT, (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 11057 "parser_bison.c"
    break;

  case 521: /* and_stmt_expr: and_stmt_expr "&" shift_stmt_expr  */
#line 3437 "parser_bison.y"
                        {
				(yyval.expr) = binop_expr_alloc(&(yyloc), OP_AND, (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 11065 "parser_bison.c"
    break;

  case 523: /* exclusive_or_stmt_expr: exclusive_or_stmt_expr "^" and_stmt_expr  */
#line 3444 "parser_bison.y"
                        {
				(yyval.expr) = binop_expr_alloc(&(yyloc), OP_XOR, (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 11073 "parser_bison.c"
    break;

  case 525: /* inclusive_or_stmt_expr: inclusive_or_stmt_expr '|' exclusive_or_stmt_expr  */
#line 3451 "parser_bison.y"
                        {
				(yyval.expr) = binop_expr_alloc(&(yyloc), OP_OR, (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 11081 "parser_bison.c"
    break;

  case 528: /* concat_stmt_expr: concat_stmt_expr "." primary_stmt_expr  */
#line 3461 "parser_bison.y"
                        {
				struct location rhs[] = {
					[1]	= (yylsp[-1]),
					[2]	= (yylsp[0]),
				};

				(yyval.expr) = handle_concat_expr(&(yyloc), (yyval.expr), (yyvsp[-2].expr), (yyvsp[0].expr), rhs);
			}
#line 11094 "parser_bison.c"
    break;

  case 531: /* map_stmt_expr: concat_stmt_expr "map" map_stmt_expr_set  */
#line 3476 "parser_bison.y"
                        {
				(yyval.expr) = map_expr_alloc(&(yyloc), (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 11102 "parser_bison.c"
    break;

  case 532: /* map_stmt_expr: concat_stmt_expr  */
#line 3479 "parser_bison.y"
                                                        { (yyval.expr) = (yyvsp[0].expr); }
#line 11108 "parser_bison.c"
    break;

  case 533: /* prefix_stmt_expr: basic_stmt_expr "/" "number"  */
#line 3483 "parser_bison.y"
                        {
				(yyval.expr) = prefix_expr_alloc(&(yyloc), (yyvsp[-2].expr), (yyvsp[0].val));
			}
#line 11116 "parser_bison.c"
    break;

  case 534: /* range_stmt_expr: basic_stmt_expr "-" basic_stmt_expr  */
#line 3489 "parser_bison.y"
                        {
				(yyval.expr) = range_expr_alloc(&(yyloc), (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 11124 "parser_bison.c"
    break;

  case 535: /* wildcard_expr: "*"  */
#line 3495 "parser_bison.y"
                        {
				struct expr *expr;

				expr = constant_expr_alloc(&(yyloc), &integer_type,
							   BYTEORDER_HOST_ENDIAN,
							   0, NULL);
				(yyval.expr) = prefix_expr_alloc(&(yyloc), expr, 0);
			}
#line 11137 "parser_bison.c"
    break;

  case 542: /* nat_stmt_args: stmt_expr  */
#line 3516 "parser_bison.y"
                        {
				(yyvsp[-1].stmt)->nat.addr = (yyvsp[0].expr);
			}
#line 11145 "parser_bison.c"
    break;

  case 543: /* nat_stmt_args: "to" stmt_expr  */
#line 3520 "parser_bison.y"
                        {
				(yyvsp[-2].stmt)->nat.addr = (yyvsp[0].expr);
			}
#line 11153 "parser_bison.c"
    break;

  case 544: /* nat_stmt_args: nf_key_proto "to" stmt_expr  */
#line 3524 "parser_bison.y"
                        {
				(yyvsp[-3].stmt)->nat.family = (yyvsp[-2].val);
				(yyvsp[-3].stmt)->nat.addr = (yyvsp[0].expr);
			}
#line 11162 "parser_bison.c"
    break;

  case 545: /* nat_stmt_args: stmt_expr "colon" stmt_expr  */
#line 3529 "parser_bison.y"
                        {
				(yyvsp[-3].stmt)->nat.addr = (yyvsp[-2].expr);
				(yyvsp[-3].stmt)->nat.proto = (yyvsp[0].expr);
			}
#line 11171 "parser_bison.c"
    break;

  case 546: /* nat_stmt_args: "to" stmt_expr "colon" stmt_expr  */
#line 3534 "parser_bison.y"
                        {
				(yyvsp[-4].stmt)->nat.addr = (yyvsp[-2].expr);
				(yyvsp[-4].stmt)->nat.proto = (yyvsp[0].expr);
			}
#line 11180 "parser_bison.c"
    break;

  case 547: /* nat_stmt_args: nf_key_proto "to" stmt_expr "colon" stmt_expr  */
#line 3539 "parser_bison.y"
                        {
				(yyvsp[-5].stmt)->nat.family = (yyvsp[-4].val);
				(yyvsp[-5].stmt)->nat.addr = (yyvsp[-2].expr);
				(yyvsp[-5].stmt)->nat.proto = (yyvsp[0].expr);
			}
#line 11190 "parser_bison.c"
    break;

  case 548: /* nat_stmt_args: "colon" stmt_expr  */
#line 3545 "parser_bison.y"
                        {
				(yyvsp[-2].stmt)->nat.proto = (yyvsp[0].expr);
			}
#line 11198 "parser_bison.c"
    break;

  case 549: /* nat_stmt_args: "to" "colon" stmt_expr  */
#line 3549 "parser_bison.y"
                        {
				(yyvsp[-3].stmt)->nat.proto = (yyvsp[0].expr);
			}
#line 11206 "parser_bison.c"
    break;

  case 550: /* nat_stmt_args: nat_stmt_args nf_nat_flags  */
#line 3553 "parser_bison.y"
                        {
				(yyvsp[-2].stmt)->nat.flags = (yyvsp[0].val);
			}
#line 11214 "parser_bison.c"
    break;

  case 551: /* nat_stmt_args: nf_key_proto "addr" "." "port" "to" stmt_expr  */
#line 3557 "parser_bison.y"
                        {
				(yyvsp[-6].stmt)->nat.family = (yyvsp[-5].val);
				(yyvsp[-6].stmt)->nat.addr = (yyvsp[0].expr);
				(yyvsp[-6].stmt)->nat.type_flags = STMT_NAT_F_CONCAT;
			}
#line 11224 "parser_bison.c"
    break;

  case 552: /* nat_stmt_args: nf_key_proto "interval" "to" stmt_expr  */
#line 3563 "parser_bison.y"
                        {
				(yyvsp[-4].stmt)->nat.family = (yyvsp[-3].val);
				(yyvsp[-4].stmt)->nat.addr = (yyvsp[0].expr);
				(yyvsp[-4].stmt)->nat.type_flags = STMT_NAT_F_INTERVAL;
			}
#line 11234 "parser_bison.c"
    break;

  case 553: /* nat_stmt_args: "interval" "to" stmt_expr  */
#line 3569 "parser_bison.y"
                        {
				(yyvsp[-3].stmt)->nat.addr = (yyvsp[0].expr);
				(yyvsp[-3].stmt)->nat.type_flags = STMT_NAT_F_INTERVAL;
			}
#line 11243 "parser_bison.c"
    break;

  case 554: /* nat_stmt_args: nf_key_proto "prefix" "to" stmt_expr  */
#line 3574 "parser_bison.y"
                        {
				(yyvsp[-4].stmt)->nat.family = (yyvsp[-3].val);
				(yyvsp[-4].stmt)->nat.addr = (yyvsp[0].expr);
				(yyvsp[-4].stmt)->nat.type_flags =
						STMT_NAT_F_PREFIX |
						STMT_NAT_F_INTERVAL;
				(yyvsp[-4].stmt)->nat.flags |= NF_NAT_RANGE_NETMAP;
			}
#line 11256 "parser_bison.c"
    break;

  case 555: /* nat_stmt_args: "prefix" "to" stmt_expr  */
#line 3583 "parser_bison.y"
                        {
				(yyvsp[-3].stmt)->nat.addr = (yyvsp[0].expr);
				(yyvsp[-3].stmt)->nat.type_flags =
						STMT_NAT_F_PREFIX |
						STMT_NAT_F_INTERVAL;
				(yyvsp[-3].stmt)->nat.flags |= NF_NAT_RANGE_NETMAP;
			}
#line 11268 "parser_bison.c"
    break;

  case 558: /* masq_stmt_alloc: "masquerade"  */
#line 3596 "parser_bison.y"
                                                { (yyval.stmt) = nat_stmt_alloc(&(yyloc), NFT_NAT_MASQ); }
#line 11274 "parser_bison.c"
    break;

  case 559: /* masq_stmt_args: "to" "colon" stmt_expr  */
#line 3600 "parser_bison.y"
                        {
				(yyvsp[-3].stmt)->nat.proto = (yyvsp[0].expr);
			}
#line 11282 "parser_bison.c"
    break;

  case 560: /* masq_stmt_args: "to" "colon" stmt_expr nf_nat_flags  */
#line 3604 "parser_bison.y"
                        {
				(yyvsp[-4].stmt)->nat.proto = (yyvsp[-1].expr);
				(yyvsp[-4].stmt)->nat.flags = (yyvsp[0].val);
			}
#line 11291 "parser_bison.c"
    break;

  case 561: /* masq_stmt_args: nf_nat_flags  */
#line 3609 "parser_bison.y"
                        {
				(yyvsp[-1].stmt)->nat.flags = (yyvsp[0].val);
			}
#line 11299 "parser_bison.c"
    break;

  case 564: /* redir_stmt_alloc: "redirect"  */
#line 3618 "parser_bison.y"
                                                { (yyval.stmt) = nat_stmt_alloc(&(yyloc), NFT_NAT_REDIR); }
#line 11305 "parser_bison.c"
    break;

  case 565: /* redir_stmt_arg: "to" stmt_expr  */
#line 3622 "parser_bison.y"
                        {
				(yyvsp[-2].stmt)->nat.proto = (yyvsp[0].expr);
			}
#line 11313 "parser_bison.c"
    break;

  case 566: /* redir_stmt_arg: "to" "colon" stmt_expr  */
#line 3626 "parser_bison.y"
                        {
				(yyvsp[-3].stmt)->nat.proto = (yyvsp[0].expr);
			}
#line 11321 "parser_bison.c"
    break;

  case 567: /* redir_stmt_arg: nf_nat_flags  */
#line 3630 "parser_bison.y"
                        {
				(yyvsp[-1].stmt)->nat.flags = (yyvsp[0].val);
			}
#line 11329 "parser_bison.c"
    break;

  case 568: /* redir_stmt_arg: "to" stmt_expr nf_nat_flags  */
#line 3634 "parser_bison.y"
                        {
				(yyvsp[-3].stmt)->nat.proto = (yyvsp[-1].expr);
				(yyvsp[-3].stmt)->nat.flags = (yyvsp[0].val);
			}
#line 11338 "parser_bison.c"
    break;

  case 569: /* redir_stmt_arg: "to" "colon" stmt_expr nf_nat_flags  */
#line 3639 "parser_bison.y"
                        {
				(yyvsp[-4].stmt)->nat.proto = (yyvsp[-1].expr);
				(yyvsp[-4].stmt)->nat.flags = (yyvsp[0].val);
			}
#line 11347 "parser_bison.c"
    break;

  case 570: /* dup_stmt: "dup" "to" stmt_expr  */
#line 3646 "parser_bison.y"
                        {
				(yyval.stmt) = dup_stmt_alloc(&(yyloc));
				(yyval.stmt)->dup.to = (yyvsp[0].expr);
			}
#line 11356 "parser_bison.c"
    break;

  case 571: /* dup_stmt: "dup" "to" stmt_expr "device" stmt_expr  */
#line 3651 "parser_bison.y"
                        {
				(yyval.stmt) = dup_stmt_alloc(&(yyloc));
				(yyval.stmt)->dup.to = (yyvsp[-2].expr);
				(yyval.stmt)->dup.dev = (yyvsp[0].expr);
			}
#line 11366 "parser_bison.c"
    break;

  case 572: /* fwd_stmt: "fwd" "to" stmt_expr  */
#line 3659 "parser_bison.y"
                        {
				(yyval.stmt) = fwd_stmt_alloc(&(yyloc));
				(yyval.stmt)->fwd.dev = (yyvsp[0].expr);
			}
#line 11375 "parser_bison.c"
    break;

  case 573: /* fwd_stmt: "fwd" nf_key_proto "to" stmt_expr "device" stmt_expr  */
#line 3664 "parser_bison.y"
                        {
				(yyval.stmt) = fwd_stmt_alloc(&(yyloc));
				(yyval.stmt)->fwd.family = (yyvsp[-4].val);
				(yyval.stmt)->fwd.addr = (yyvsp[-2].expr);
				(yyval.stmt)->fwd.dev = (yyvsp[0].expr);
			}
#line 11386 "parser_bison.c"
    break;

  case 575: /* nf_nat_flags: nf_nat_flags "comma" nf_nat_flag  */
#line 3674 "parser_bison.y"
                        {
				(yyval.val) = (yyvsp[-2].val) | (yyvsp[0].val);
			}
#line 11394 "parser_bison.c"
    break;

  case 576: /* nf_nat_flag: "random"  */
#line 3679 "parser_bison.y"
                                                { (yyval.val) = NF_NAT_RANGE_PROTO_RANDOM; }
#line 11400 "parser_bison.c"
    break;

  case 577: /* nf_nat_flag: "fully-random"  */
#line 3680 "parser_bison.y"
                                                { (yyval.val) = NF_NAT_RANGE_PROTO_RANDOM_FULLY; }
#line 11406 "parser_bison.c"
    break;

  case 578: /* nf_nat_flag: "persistent"  */
#line 3681 "parser_bison.y"
                                                { (yyval.val) = NF_NAT_RANGE_PERSISTENT; }
#line 11412 "parser_bison.c"
    break;

  case 581: /* queue_stmt_alloc: "queue"  */
#line 3689 "parser_bison.y"
                        {
				(yyval.stmt) = queue_stmt_alloc(&(yyloc));
			}
#line 11420 "parser_bison.c"
    break;

  case 582: /* queue_stmt_args: queue_stmt_arg  */
#line 3695 "parser_bison.y"
                        {
				(yyval.stmt)	= (yyvsp[-1].stmt);
			}
#line 11428 "parser_bison.c"
    break;

  case 584: /* queue_stmt_arg: "num" stmt_expr  */
#line 3702 "parser_bison.y"
                        {
				(yyvsp[-2].stmt)->queue.queue = (yyvsp[0].expr);
				(yyvsp[-2].stmt)->queue.queue->location = (yyloc);
			}
#line 11437 "parser_bison.c"
    break;

  case 585: /* queue_stmt_arg: queue_stmt_flags  */
#line 3707 "parser_bison.y"
                        {
				(yyvsp[-1].stmt)->queue.flags |= (yyvsp[0].val);
			}
#line 11445 "parser_bison.c"
    break;

  case 587: /* queue_stmt_flags: queue_stmt_flags "comma" queue_stmt_flag  */
#line 3714 "parser_bison.y"
                        {
				(yyval.val) = (yyvsp[-2].val) | (yyvsp[0].val);
			}
#line 11453 "parser_bison.c"
    break;

  case 588: /* queue_stmt_flag: "bypass"  */
#line 3719 "parser_bison.y"
                                        { (yyval.val) = NFT_QUEUE_FLAG_BYPASS; }
#line 11459 "parser_bison.c"
    break;

  case 589: /* queue_stmt_flag: "fanout"  */
#line 3720 "parser_bison.y"
                                        { (yyval.val) = NFT_QUEUE_FLAG_CPU_FANOUT; }
#line 11465 "parser_bison.c"
    break;

  case 592: /* set_elem_expr_stmt_alloc: concat_expr  */
#line 3728 "parser_bison.y"
                        {
				(yyval.expr) = set_elem_expr_alloc(&(yylsp[0]), (yyvsp[0].expr));
			}
#line 11473 "parser_bison.c"
    break;

  case 593: /* set_stmt: "set" set_stmt_op set_elem_expr_stmt set_ref_expr  */
#line 3734 "parser_bison.y"
                        {
				(yyval.stmt) = set_stmt_alloc(&(yyloc));
				(yyval.stmt)->set.op  = (yyvsp[-2].val);
				(yyval.stmt)->set.key = (yyvsp[-1].expr);
				(yyval.stmt)->set.set = (yyvsp[0].expr);
			}
#line 11484 "parser_bison.c"
    break;

  case 594: /* set_stmt: set_stmt_op set_ref_expr '{' set_elem_expr_stmt '}'  */
#line 3741 "parser_bison.y"
                        {
				(yyval.stmt) = set_stmt_alloc(&(yyloc));
				(yyval.stmt)->set.op  = (yyvsp[-4].val);
				(yyval.stmt)->set.key = (yyvsp[-1].expr);
				(yyval.stmt)->set.set = (yyvsp[-3].expr);
			}
#line 11495 "parser_bison.c"
    break;

  case 595: /* set_stmt: set_stmt_op set_ref_expr '{' set_elem_expr_stmt stateful_stmt_list '}'  */
#line 3748 "parser_bison.y"
                        {
				(yyval.stmt) = set_stmt_alloc(&(yyloc));
				(yyval.stmt)->set.op  = (yyvsp[-5].val);
				(yyval.stmt)->set.key = (yyvsp[-2].expr);
				(yyval.stmt)->set.set = (yyvsp[-4].expr);
				list_splice_tail((yyvsp[-1].list), &(yyval.stmt)->set.stmt_list);
				free((yyvsp[-1].list));
			}
#line 11508 "parser_bison.c"
    break;

  case 596: /* set_stmt_op: "add"  */
#line 3758 "parser_bison.y"
                                        { (yyval.val) = NFT_DYNSET_OP_ADD; }
#line 11514 "parser_bison.c"
    break;

  case 597: /* set_stmt_op: "update"  */
#line 3759 "parser_bison.y"
                                        { (yyval.val) = NFT_DYNSET_OP_UPDATE; }
#line 11520 "parser_bison.c"
    break;

  case 598: /* set_stmt_op: "delete"  */
#line 3760 "parser_bison.y"
                                        { (yyval.val) = NFT_DYNSET_OP_DELETE; }
#line 11526 "parser_bison.c"
    break;

  case 599: /* map_stmt: set_stmt_op set_ref_expr '{' set_elem_expr_stmt "colon" set_elem_expr_stmt '}'  */
#line 3764 "parser_bison.y"
                        {
				(yyval.stmt) = map_stmt_alloc(&(yyloc));
				(yyval.stmt)->map.op  = (yyvsp[-6].val);
				(yyval.stmt)->map.key = (yyvsp[-3].expr);
				(yyval.stmt)->map.data = (yyvsp[-1].expr);
				(yyval.stmt)->map.set = (yyvsp[-5].expr);
			}
#line 11538 "parser_bison.c"
    break;

  case 600: /* map_stmt: set_stmt_op set_ref_expr '{' set_elem_expr_stmt stateful_stmt_list "colon" set_elem_expr_stmt '}'  */
#line 3772 "parser_bison.y"
                        {
				(yyval.stmt) = map_stmt_alloc(&(yyloc));
				(yyval.stmt)->map.op  = (yyvsp[-7].val);
				(yyval.stmt)->map.key = (yyvsp[-4].expr);
				(yyval.stmt)->map.data = (yyvsp[-1].expr);
				(yyval.stmt)->map.set = (yyvsp[-6].expr);
				list_splice_tail((yyvsp[-3].list), &(yyval.stmt)->map.stmt_list);
				free((yyvsp[-3].list));
			}
#line 11552 "parser_bison.c"
    break;

  case 601: /* meter_stmt: flow_stmt_legacy_alloc flow_stmt_opts '{' meter_key_expr stmt '}'  */
#line 3784 "parser_bison.y"
                        {
				(yyvsp[-5].stmt)->meter.key  = (yyvsp[-2].expr);
				(yyvsp[-5].stmt)->meter.stmt = (yyvsp[-1].stmt);
				(yyval.stmt)->location  = (yyloc);
				(yyval.stmt) = (yyvsp[-5].stmt);
			}
#line 11563 "parser_bison.c"
    break;

  case 602: /* meter_stmt: meter_stmt_alloc  */
#line 3790 "parser_bison.y"
                                                                { (yyval.stmt) = (yyvsp[0].stmt); }
#line 11569 "parser_bison.c"
    break;

  case 603: /* flow_stmt_legacy_alloc: "flow"  */
#line 3794 "parser_bison.y"
                        {
				(yyval.stmt) = meter_stmt_alloc(&(yyloc));
			}
#line 11577 "parser_bison.c"
    break;

  case 604: /* flow_stmt_opts: flow_stmt_opt  */
#line 3800 "parser_bison.y"
                        {
				(yyval.stmt)	= (yyvsp[-1].stmt);
			}
#line 11585 "parser_bison.c"
    break;

  case 606: /* flow_stmt_opt: "table" identifier  */
#line 3807 "parser_bison.y"
                        {
				(yyvsp[-2].stmt)->meter.name = (yyvsp[0].string);
			}
#line 11593 "parser_bison.c"
    break;

  case 607: /* meter_stmt_alloc: "meter" identifier '{' meter_key_expr stmt '}'  */
#line 3813 "parser_bison.y"
                        {
				(yyval.stmt) = meter_stmt_alloc(&(yyloc));
				(yyval.stmt)->meter.name = (yyvsp[-4].string);
				(yyval.stmt)->meter.size = 0;
				(yyval.stmt)->meter.key  = (yyvsp[-2].expr);
				(yyval.stmt)->meter.stmt = (yyvsp[-1].stmt);
				(yyval.stmt)->location  = (yyloc);
			}
#line 11606 "parser_bison.c"
    break;

  case 608: /* meter_stmt_alloc: "meter" identifier "size" "number" '{' meter_key_expr stmt '}'  */
#line 3822 "parser_bison.y"
                        {
				(yyval.stmt) = meter_stmt_alloc(&(yyloc));
				(yyval.stmt)->meter.name = (yyvsp[-6].string);
				(yyval.stmt)->meter.size = (yyvsp[-4].val);
				(yyval.stmt)->meter.key  = (yyvsp[-2].expr);
				(yyval.stmt)->meter.stmt = (yyvsp[-1].stmt);
				(yyval.stmt)->location  = (yyloc);
			}
#line 11619 "parser_bison.c"
    break;

  case 609: /* match_stmt: relational_expr  */
#line 3833 "parser_bison.y"
                        {
				(yyval.stmt) = expr_stmt_alloc(&(yyloc), (yyvsp[0].expr));
			}
#line 11627 "parser_bison.c"
    break;

  case 610: /* variable_expr: '$' identifier  */
#line 3839 "parser_bison.y"
                        {
				struct scope *scope = current_scope(state);
				struct symbol *sym;

				sym = symbol_get(scope, (yyvsp[0].string));
				if (!sym) {
					sym = symbol_lookup_fuzzy(scope, (yyvsp[0].string));
					if (sym) {
						erec_queue(error(&(yylsp[0]), "unknown identifier '%s'; "
								      "did you mean identifier ‘%s’?",
								      (yyvsp[0].string), sym->identifier),
							   state->msgs);
					} else {
						erec_queue(error(&(yylsp[0]), "unknown identifier '%s'", (yyvsp[0].string)),
							   state->msgs);
					}
					xfree((yyvsp[0].string));
					YYERROR;
				}

				(yyval.expr) = variable_expr_alloc(&(yyloc), scope, sym);
				xfree((yyvsp[0].string));
			}
#line 11655 "parser_bison.c"
    break;

  case 612: /* symbol_expr: string  */
#line 3866 "parser_bison.y"
                        {
				(yyval.expr) = symbol_expr_alloc(&(yyloc), SYMBOL_VALUE,
						       current_scope(state),
						       (yyvsp[0].string));
				xfree((yyvsp[0].string));
			}
#line 11666 "parser_bison.c"
    break;

  case 615: /* set_ref_symbol_expr: "@" identifier  */
#line 3879 "parser_bison.y"
                        {
				(yyval.expr) = symbol_expr_alloc(&(yyloc), SYMBOL_SET,
						       current_scope(state),
						       (yyvsp[0].string));
				xfree((yyvsp[0].string));
			}
#line 11677 "parser_bison.c"
    break;

  case 616: /* integer_expr: "number"  */
#line 3888 "parser_bison.y"
                        {
				char str[64];

				snprintf(str, sizeof(str), "%" PRIu64, (yyvsp[0].val));
				(yyval.expr) = symbol_expr_alloc(&(yyloc), SYMBOL_VALUE,
						       current_scope(state),
						       str);
			}
#line 11690 "parser_bison.c"
    break;

  case 617: /* primary_expr: symbol_expr  */
#line 3898 "parser_bison.y"
                                                                { (yyval.expr) = (yyvsp[0].expr); }
#line 11696 "parser_bison.c"
    break;

  case 618: /* primary_expr: integer_expr  */
#line 3899 "parser_bison.y"
                                                                { (yyval.expr) = (yyvsp[0].expr); }
#line 11702 "parser_bison.c"
    break;

  case 619: /* primary_expr: payload_expr  */
#line 3900 "parser_bison.y"
                                                                { (yyval.expr) = (yyvsp[0].expr); }
#line 11708 "parser_bison.c"
    break;

  case 620: /* primary_expr: exthdr_expr  */
#line 3901 "parser_bison.y"
                                                                { (yyval.expr) = (yyvsp[0].expr); }
#line 11714 "parser_bison.c"
    break;

  case 621: /* primary_expr: exthdr_exists_expr  */
#line 3902 "parser_bison.y"
                                                                { (yyval.expr) = (yyvsp[0].expr); }
#line 11720 "parser_bison.c"
    break;

  case 622: /* primary_expr: meta_expr  */
#line 3903 "parser_bison.y"
                                                                { (yyval.expr) = (yyvsp[0].expr); }
#line 11726 "parser_bison.c"
    break;

  case 623: /* primary_expr: socket_expr  */
#line 3904 "parser_bison.y"
                                                                { (yyval.expr) = (yyvsp[0].expr); }
#line 11732 "parser_bison.c"
    break;

  case 624: /* primary_expr: rt_expr  */
#line 3905 "parser_bison.y"
                                                                { (yyval.expr) = (yyvsp[0].expr); }
#line 11738 "parser_bison.c"
    break;

  case 625: /* primary_expr: ct_expr  */
#line 3906 "parser_bison.y"
                                                                { (yyval.expr) = (yyvsp[0].expr); }
#line 11744 "parser_bison.c"
    break;

  case 626: /* primary_expr: numgen_expr  */
#line 3907 "parser_bison.y"
                                                                { (yyval.expr) = (yyvsp[0].expr); }
#line 11750 "parser_bison.c"
    break;

  case 627: /* primary_expr: hash_expr  */
#line 3908 "parser_bison.y"
                                                                { (yyval.expr) = (yyvsp[0].expr); }
#line 11756 "parser_bison.c"
    break;

  case 628: /* primary_expr: fib_expr  */
#line 3909 "parser_bison.y"
                                                                { (yyval.expr) = (yyvsp[0].expr); }
#line 11762 "parser_bison.c"
    break;

  case 629: /* primary_expr: osf_expr  */
#line 3910 "parser_bison.y"
                                                                { (yyval.expr) = (yyvsp[0].expr); }
#line 11768 "parser_bison.c"
    break;

  case 630: /* primary_expr: xfrm_expr  */
#line 3911 "parser_bison.y"
                                                                { (yyval.expr) = (yyvsp[0].expr); }
#line 11774 "parser_bison.c"
    break;

  case 631: /* primary_expr: '(' basic_expr ')'  */
#line 3912 "parser_bison.y"
                                                                { (yyval.expr) = (yyvsp[-1].expr); }
#line 11780 "parser_bison.c"
    break;

  case 632: /* fib_expr: "fib" fib_tuple fib_result  */
#line 3916 "parser_bison.y"
                        {
				if (((yyvsp[-1].val) & (NFTA_FIB_F_SADDR|NFTA_FIB_F_DADDR)) == 0) {
					erec_queue(error(&(yylsp[-1]), "fib: need either saddr or daddr"), state->msgs);
					YYERROR;
				}

				if (((yyvsp[-1].val) & (NFTA_FIB_F_SADDR|NFTA_FIB_F_DADDR)) ==
					  (NFTA_FIB_F_SADDR|NFTA_FIB_F_DADDR)) {
					erec_queue(error(&(yylsp[-1]), "fib: saddr and daddr are mutually exclusive"), state->msgs);
					YYERROR;
				}

				if (((yyvsp[-1].val) & (NFTA_FIB_F_IIF|NFTA_FIB_F_OIF)) ==
					  (NFTA_FIB_F_IIF|NFTA_FIB_F_OIF)) {
					erec_queue(error(&(yylsp[-1]), "fib: iif and oif are mutually exclusive"), state->msgs);
					YYERROR;
				}

				(yyval.expr) = fib_expr_alloc(&(yyloc), (yyvsp[-1].val), (yyvsp[0].val));
			}
#line 11805 "parser_bison.c"
    break;

  case 633: /* fib_result: "oif"  */
#line 3938 "parser_bison.y"
                                        { (yyval.val) =NFT_FIB_RESULT_OIF; }
#line 11811 "parser_bison.c"
    break;

  case 634: /* fib_result: "oifname"  */
#line 3939 "parser_bison.y"
                                        { (yyval.val) =NFT_FIB_RESULT_OIFNAME; }
#line 11817 "parser_bison.c"
    break;

  case 635: /* fib_result: "type"  */
#line 3940 "parser_bison.y"
                                        { (yyval.val) =NFT_FIB_RESULT_ADDRTYPE; }
#line 11823 "parser_bison.c"
    break;

  case 636: /* fib_flag: "saddr"  */
#line 3943 "parser_bison.y"
                                        { (yyval.val) = NFTA_FIB_F_SADDR; }
#line 11829 "parser_bison.c"
    break;

  case 637: /* fib_flag: "daddr"  */
#line 3944 "parser_bison.y"
                                        { (yyval.val) = NFTA_FIB_F_DADDR; }
#line 11835 "parser_bison.c"
    break;

  case 638: /* fib_flag: "mark"  */
#line 3945 "parser_bison.y"
                                        { (yyval.val) = NFTA_FIB_F_MARK; }
#line 11841 "parser_bison.c"
    break;

  case 639: /* fib_flag: "iif"  */
#line 3946 "parser_bison.y"
                                        { (yyval.val) = NFTA_FIB_F_IIF; }
#line 11847 "parser_bison.c"
    break;

  case 640: /* fib_flag: "oif"  */
#line 3947 "parser_bison.y"
                                        { (yyval.val) = NFTA_FIB_F_OIF; }
#line 11853 "parser_bison.c"
    break;

  case 641: /* fib_tuple: fib_flag "." fib_tuple  */
#line 3951 "parser_bison.y"
                        {
				(yyval.val) = (yyvsp[-2].val) | (yyvsp[0].val);
			}
#line 11861 "parser_bison.c"
    break;

  case 643: /* osf_expr: "osf" osf_ttl "version"  */
#line 3958 "parser_bison.y"
                        {
				(yyval.expr) = osf_expr_alloc(&(yyloc), (yyvsp[-1].val), NFT_OSF_F_VERSION);
			}
#line 11869 "parser_bison.c"
    break;

  case 644: /* osf_expr: "osf" osf_ttl "name"  */
#line 3962 "parser_bison.y"
                        {
				(yyval.expr) = osf_expr_alloc(&(yyloc), (yyvsp[-1].val), 0);
			}
#line 11877 "parser_bison.c"
    break;

  case 645: /* osf_ttl: %empty  */
#line 3968 "parser_bison.y"
                        {
				(yyval.val) = NF_OSF_TTL_TRUE;
			}
#line 11885 "parser_bison.c"
    break;

  case 646: /* osf_ttl: "ttl" "string"  */
#line 3972 "parser_bison.y"
                        {
				if (!strcmp((yyvsp[0].string), "loose"))
					(yyval.val) = NF_OSF_TTL_LESS;
				else if (!strcmp((yyvsp[0].string), "skip"))
					(yyval.val) = NF_OSF_TTL_NOCHECK;
				else {
					erec_queue(error(&(yylsp[0]), "invalid ttl option"),
						   state->msgs);
					YYERROR;
				}
			}
#line 11901 "parser_bison.c"
    break;

  case 648: /* shift_expr: shift_expr "<<" primary_rhs_expr  */
#line 3987 "parser_bison.y"
                        {
				(yyval.expr) = binop_expr_alloc(&(yyloc), OP_LSHIFT, (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 11909 "parser_bison.c"
    break;

  case 649: /* shift_expr: shift_expr ">>" primary_rhs_expr  */
#line 3991 "parser_bison.y"
                        {
				(yyval.expr) = binop_expr_alloc(&(yyloc), OP_RSHIFT, (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 11917 "parser_bison.c"
    break;

  case 651: /* and_expr: and_expr "&" shift_rhs_expr  */
#line 3998 "parser_bison.y"
                        {
				(yyval.expr) = binop_expr_alloc(&(yyloc), OP_AND, (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 11925 "parser_bison.c"
    break;

  case 653: /* exclusive_or_expr: exclusive_or_expr "^" and_rhs_expr  */
#line 4005 "parser_bison.y"
                        {
				(yyval.expr) = binop_expr_alloc(&(yyloc), OP_XOR, (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 11933 "parser_bison.c"
    break;

  case 655: /* inclusive_or_expr: inclusive_or_expr '|' exclusive_or_rhs_expr  */
#line 4012 "parser_bison.y"
                        {
				(yyval.expr) = binop_expr_alloc(&(yyloc), OP_OR, (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 11941 "parser_bison.c"
    break;

  case 658: /* concat_expr: concat_expr "." basic_expr  */
#line 4022 "parser_bison.y"
                        {
				struct location rhs[] = {
					[1]	= (yylsp[-1]),
					[2]	= (yylsp[0]),
				};

				(yyval.expr) = handle_concat_expr(&(yyloc), (yyval.expr), (yyvsp[-2].expr), (yyvsp[0].expr), rhs);
			}
#line 11954 "parser_bison.c"
    break;

  case 659: /* prefix_rhs_expr: basic_rhs_expr "/" "number"  */
#line 4033 "parser_bison.y"
                        {
				(yyval.expr) = prefix_expr_alloc(&(yyloc), (yyvsp[-2].expr), (yyvsp[0].val));
			}
#line 11962 "parser_bison.c"
    break;

  case 660: /* range_rhs_expr: basic_rhs_expr "-" basic_rhs_expr  */
#line 4039 "parser_bison.y"
                        {
				(yyval.expr) = range_expr_alloc(&(yyloc), (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 11970 "parser_bison.c"
    break;

  case 663: /* map_expr: concat_expr "map" rhs_expr  */
#line 4049 "parser_bison.y"
                        {
				(yyval.expr) = map_expr_alloc(&(yyloc), (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 11978 "parser_bison.c"
    break;

  case 667: /* set_expr: '{' set_list_expr '}'  */
#line 4060 "parser_bison.y"
                        {
				(yyvsp[-1].expr)->location = (yyloc);
				(yyval.expr) = (yyvsp[-1].expr);
			}
#line 11987 "parser_bison.c"
    break;

  case 668: /* set_list_expr: set_list_member_expr  */
#line 4067 "parser_bison.y"
                        {
				(yyval.expr) = set_expr_alloc(&(yyloc), NULL);
				compound_expr_add((yyval.expr), (yyvsp[0].expr));
			}
#line 11996 "parser_bison.c"
    break;

  case 669: /* set_list_expr: set_list_expr "comma" set_list_member_expr  */
#line 4072 "parser_bison.y"
                        {
				compound_expr_add((yyvsp[-2].expr), (yyvsp[0].expr));
				(yyval.expr) = (yyvsp[-2].expr);
			}
#line 12005 "parser_bison.c"
    break;

  case 671: /* set_list_member_expr: opt_newline set_expr opt_newline  */
#line 4080 "parser_bison.y"
                        {
				(yyval.expr) = (yyvsp[-1].expr);
			}
#line 12013 "parser_bison.c"
    break;

  case 672: /* set_list_member_expr: opt_newline set_elem_expr opt_newline  */
#line 4084 "parser_bison.y"
                        {
				(yyval.expr) = (yyvsp[-1].expr);
			}
#line 12021 "parser_bison.c"
    break;

  case 673: /* set_list_member_expr: opt_newline set_elem_expr "colon" set_rhs_expr opt_newline  */
#line 4088 "parser_bison.y"
                        {
				(yyval.expr) = mapping_expr_alloc(&(yyloc), (yyvsp[-3].expr), (yyvsp[-1].expr));
			}
#line 12029 "parser_bison.c"
    break;

  case 675: /* meter_key_expr: meter_key_expr_alloc set_elem_options  */
#line 4095 "parser_bison.y"
                        {
				(yyval.expr)->location = (yyloc);
				(yyval.expr) = (yyvsp[-1].expr);
			}
#line 12038 "parser_bison.c"
    break;

  case 676: /* meter_key_expr_alloc: concat_expr  */
#line 4102 "parser_bison.y"
                        {
				(yyval.expr) = set_elem_expr_alloc(&(yylsp[0]), (yyvsp[0].expr));
			}
#line 12046 "parser_bison.c"
    break;

  case 679: /* set_elem_expr_alloc: set_lhs_expr set_elem_stmt_list  */
#line 4112 "parser_bison.y"
                        {
				(yyval.expr) = set_elem_expr_alloc(&(yylsp[-1]), (yyvsp[-1].expr));
				list_splice_tail((yyvsp[0].list), &(yyval.expr)->stmt_list);
				xfree((yyvsp[0].list));
			}
#line 12056 "parser_bison.c"
    break;

  case 680: /* set_elem_expr_alloc: set_lhs_expr  */
#line 4118 "parser_bison.y"
                        {
				(yyval.expr) = set_elem_expr_alloc(&(yylsp[0]), (yyvsp[0].expr));
			}
#line 12064 "parser_bison.c"
    break;

  case 681: /* set_elem_options: set_elem_option  */
#line 4124 "parser_bison.y"
                        {
				(yyval.expr)	= (yyvsp[-1].expr);
			}
#line 12072 "parser_bison.c"
    break;

  case 683: /* set_elem_option: "timeout" time_spec  */
#line 4131 "parser_bison.y"
                        {
				(yyvsp[-2].expr)->timeout = (yyvsp[0].val);
			}
#line 12080 "parser_bison.c"
    break;

  case 684: /* set_elem_option: "expires" time_spec  */
#line 4135 "parser_bison.y"
                        {
				(yyvsp[-2].expr)->expiration = (yyvsp[0].val);
			}
#line 12088 "parser_bison.c"
    break;

  case 685: /* set_elem_option: comment_spec  */
#line 4139 "parser_bison.y"
                        {
				if (already_set((yyvsp[-1].expr)->comment, &(yylsp[0]), state)) {
					xfree((yyvsp[0].string));
					YYERROR;
				}
				(yyvsp[-1].expr)->comment = (yyvsp[0].string);
			}
#line 12100 "parser_bison.c"
    break;

  case 686: /* set_elem_expr_options: set_elem_expr_option  */
#line 4149 "parser_bison.y"
                        {
				(yyval.expr)	= (yyvsp[-1].expr);
			}
#line 12108 "parser_bison.c"
    break;

  case 688: /* set_elem_stmt_list: set_elem_stmt  */
#line 4156 "parser_bison.y"
                        {
				(yyval.list) = xmalloc(sizeof(*(yyval.list)));
				init_list_head((yyval.list));
				list_add_tail(&(yyvsp[0].stmt)->list, (yyval.list));
			}
#line 12118 "parser_bison.c"
    break;

  case 689: /* set_elem_stmt_list: set_elem_stmt_list set_elem_stmt  */
#line 4162 "parser_bison.y"
                        {
				(yyval.list) = (yyvsp[-1].list);
				list_add_tail(&(yyvsp[0].stmt)->list, (yyvsp[-1].list));
			}
#line 12127 "parser_bison.c"
    break;

  case 690: /* set_elem_stmt: "counter"  */
#line 4169 "parser_bison.y"
                        {
				(yyval.stmt) = counter_stmt_alloc(&(yyloc));
			}
#line 12135 "parser_bison.c"
    break;

  case 691: /* set_elem_stmt: "counter" "packets" "number" "bytes" "number"  */
#line 4173 "parser_bison.y"
                        {
				(yyval.stmt) = counter_stmt_alloc(&(yyloc));
				(yyval.stmt)->counter.packets = (yyvsp[-2].val);
				(yyval.stmt)->counter.bytes = (yyvsp[0].val);
			}
#line 12145 "parser_bison.c"
    break;

  case 692: /* set_elem_stmt: "limit" "rate" limit_mode "number" "/" time_unit limit_burst_pkts  */
#line 4179 "parser_bison.y"
                        {
				if ((yyvsp[0].val) == 0) {
					erec_queue(error(&(yylsp[0]), "limit burst must be > 0"),
						   state->msgs);
					YYERROR;
				}
				(yyval.stmt) = limit_stmt_alloc(&(yyloc));
				(yyval.stmt)->limit.rate  = (yyvsp[-3].val);
				(yyval.stmt)->limit.unit  = (yyvsp[-1].val);
				(yyval.stmt)->limit.burst = (yyvsp[0].val);
				(yyval.stmt)->limit.type  = NFT_LIMIT_PKTS;
				(yyval.stmt)->limit.flags = (yyvsp[-4].val);
			}
#line 12163 "parser_bison.c"
    break;

  case 693: /* set_elem_stmt: "limit" "rate" limit_mode "number" "string" limit_burst_bytes  */
#line 4193 "parser_bison.y"
                        {
				struct error_record *erec;
				uint64_t rate, unit;

				if ((yyvsp[0].val) == 0) {
					erec_queue(error(&(yylsp[0]), "limit burst must be > 0"),
						   state->msgs);
					YYERROR;
				}
				erec = rate_parse(&(yyloc), (yyvsp[-1].string), &rate, &unit);
				xfree((yyvsp[-1].string));
				if (erec != NULL) {
					erec_queue(erec, state->msgs);
					YYERROR;
				}

				(yyval.stmt) = limit_stmt_alloc(&(yyloc));
				(yyval.stmt)->limit.rate  = rate * (yyvsp[-2].val);
				(yyval.stmt)->limit.unit  = unit;
				(yyval.stmt)->limit.burst = (yyvsp[0].val);
				(yyval.stmt)->limit.type  = NFT_LIMIT_PKT_BYTES;
				(yyval.stmt)->limit.flags = (yyvsp[-3].val);
                        }
#line 12191 "parser_bison.c"
    break;

  case 694: /* set_elem_expr_option: "timeout" time_spec  */
#line 4219 "parser_bison.y"
                        {
				(yyvsp[-2].expr)->timeout = (yyvsp[0].val);
			}
#line 12199 "parser_bison.c"
    break;

  case 695: /* set_elem_expr_option: "expires" time_spec  */
#line 4223 "parser_bison.y"
                        {
				(yyvsp[-2].expr)->expiration = (yyvsp[0].val);
			}
#line 12207 "parser_bison.c"
    break;

  case 696: /* set_elem_expr_option: comment_spec  */
#line 4227 "parser_bison.y"
                        {
				if (already_set((yyvsp[-1].expr)->comment, &(yylsp[0]), state)) {
					xfree((yyvsp[0].string));
					YYERROR;
				}
				(yyvsp[-1].expr)->comment = (yyvsp[0].string);
			}
#line 12219 "parser_bison.c"
    break;

  case 703: /* initializer_expr: '{' '}'  */
#line 4246 "parser_bison.y"
                                                { (yyval.expr) = compound_expr_alloc(&(yyloc), EXPR_SET); }
#line 12225 "parser_bison.c"
    break;

  case 704: /* initializer_expr: "-" "number"  */
#line 4248 "parser_bison.y"
                        {
				int32_t num = -(yyvsp[0].val);

				(yyval.expr) = constant_expr_alloc(&(yyloc), &integer_type,
							 BYTEORDER_HOST_ENDIAN,
							 sizeof(num) * BITS_PER_BYTE,
							 &num);
			}
#line 12238 "parser_bison.c"
    break;

  case 705: /* counter_config: "packets" "number" "bytes" "number"  */
#line 4259 "parser_bison.y"
                        {
				struct counter *counter;

				counter = &(yyvsp[-4].obj)->counter;
				counter->packets = (yyvsp[-2].val);
				counter->bytes = (yyvsp[0].val);
			}
#line 12250 "parser_bison.c"
    break;

  case 706: /* counter_obj: %empty  */
#line 4269 "parser_bison.y"
                        {
				(yyval.obj) = obj_alloc(&(yyloc));
				(yyval.obj)->type = NFT_OBJECT_COUNTER;
			}
#line 12259 "parser_bison.c"
    break;

  case 707: /* quota_config: quota_mode "number" quota_unit quota_used  */
#line 4276 "parser_bison.y"
                        {
				struct error_record *erec;
				struct quota *quota;
				uint64_t rate;

				erec = data_unit_parse(&(yyloc), (yyvsp[-1].string), &rate);
				xfree((yyvsp[-1].string));
				if (erec != NULL) {
					erec_queue(erec, state->msgs);
					YYERROR;
				}

				quota = &(yyvsp[-4].obj)->quota;
				quota->bytes	= (yyvsp[-2].val) * rate;
				quota->used	= (yyvsp[0].val);
				quota->flags	= (yyvsp[-3].val);
			}
#line 12281 "parser_bison.c"
    break;

  case 708: /* quota_obj: %empty  */
#line 4296 "parser_bison.y"
                        {
				(yyval.obj) = obj_alloc(&(yyloc));
				(yyval.obj)->type = NFT_OBJECT_QUOTA;
			}
#line 12290 "parser_bison.c"
    break;

  case 709: /* secmark_config: string  */
#line 4303 "parser_bison.y"
                        {
				int ret;
				struct secmark *secmark;

				secmark = &(yyvsp[-1].obj)->secmark;
				ret = snprintf(secmark->ctx, sizeof(secmark->ctx), "%s", (yyvsp[0].string));
				if (ret <= 0 || ret >= (int)sizeof(secmark->ctx)) {
					erec_queue(error(&(yylsp[0]), "invalid context '%s', max length is %u\n", (yyvsp[0].string), (int)sizeof(secmark->ctx)), state->msgs);
					xfree((yyvsp[0].string));
					YYERROR;
				}
				xfree((yyvsp[0].string));
			}
#line 12308 "parser_bison.c"
    break;

  case 710: /* secmark_obj: %empty  */
#line 4319 "parser_bison.y"
                        {
				(yyval.obj) = obj_alloc(&(yyloc));
				(yyval.obj)->type = NFT_OBJECT_SECMARK;
			}
#line 12317 "parser_bison.c"
    break;

  case 711: /* ct_obj_type: "helper"  */
#line 4325 "parser_bison.y"
                                                { (yyval.val) = NFT_OBJECT_CT_HELPER; }
#line 12323 "parser_bison.c"
    break;

  case 712: /* ct_obj_type: "timeout"  */
#line 4326 "parser_bison.y"
                                                { (yyval.val) = NFT_OBJECT_CT_TIMEOUT; }
#line 12329 "parser_bison.c"
    break;

  case 713: /* ct_obj_type: "expectation"  */
#line 4327 "parser_bison.y"
                                                { (yyval.val) = NFT_OBJECT_CT_EXPECT; }
#line 12335 "parser_bison.c"
    break;

  case 714: /* ct_l4protoname: "tcp"  */
#line 4330 "parser_bison.y"
                                        { (yyval.val) = IPPROTO_TCP; }
#line 12341 "parser_bison.c"
    break;

  case 715: /* ct_l4protoname: "udp"  */
#line 4331 "parser_bison.y"
                                        { (yyval.val) = IPPROTO_UDP; }
#line 12347 "parser_bison.c"
    break;

  case 716: /* ct_helper_config: "type" "quoted string" "protocol" ct_l4protoname stmt_separator  */
#line 4335 "parser_bison.y"
                        {
				struct ct_helper *ct;
				int ret;

				ct = &(yyvsp[-5].obj)->ct_helper;

				ret = snprintf(ct->name, sizeof(ct->name), "%s", (yyvsp[-3].string));
				if (ret <= 0 || ret >= (int)sizeof(ct->name)) {
					erec_queue(error(&(yylsp[-3]), "invalid name '%s', max length is %u\n", (yyvsp[-3].string), (int)sizeof(ct->name)), state->msgs);
					YYERROR;
				}
				xfree((yyvsp[-3].string));

				ct->l4proto = (yyvsp[-1].val);
			}
#line 12367 "parser_bison.c"
    break;

  case 717: /* ct_helper_config: "l3proto" family_spec_explicit stmt_separator  */
#line 4351 "parser_bison.y"
                        {
				(yyvsp[-3].obj)->ct_helper.l3proto = (yyvsp[-1].val);
			}
#line 12375 "parser_bison.c"
    break;

  case 718: /* timeout_states: timeout_state  */
#line 4357 "parser_bison.y"
                        {
				(yyval.list) = xmalloc(sizeof(*(yyval.list)));
				init_list_head((yyval.list));
				list_add_tail((yyvsp[0].list), (yyval.list));
			}
#line 12385 "parser_bison.c"
    break;

  case 719: /* timeout_states: timeout_states "comma" timeout_state  */
#line 4363 "parser_bison.y"
                        {
				list_add_tail((yyvsp[0].list), (yyvsp[-2].list));
				(yyval.list) = (yyvsp[-2].list);
			}
#line 12394 "parser_bison.c"
    break;

  case 720: /* timeout_state: "string" "colon" "number"  */
#line 4371 "parser_bison.y"
                        {
				struct timeout_state *ts;

				ts = xzalloc(sizeof(*ts));
				ts->timeout_str = (yyvsp[-2].string);
				ts->timeout_value = (yyvsp[0].val);
				ts->location = (yylsp[-2]);
				init_list_head(&ts->head);
				(yyval.list) = &ts->head;
			}
#line 12409 "parser_bison.c"
    break;

  case 721: /* ct_timeout_config: "protocol" ct_l4protoname stmt_separator  */
#line 4384 "parser_bison.y"
                        {
				struct ct_timeout *ct;
				int l4proto = (yyvsp[-1].val);

				ct = &(yyvsp[-3].obj)->ct_timeout;
				ct->l4proto = l4proto;
			}
#line 12421 "parser_bison.c"
    break;

  case 722: /* ct_timeout_config: "policy" '=' '{' timeout_states '}' stmt_separator  */
#line 4392 "parser_bison.y"
                        {
				struct ct_timeout *ct;

				ct = &(yyvsp[-6].obj)->ct_timeout;
				list_splice_tail((yyvsp[-2].list), &ct->timeout_list);
				xfree((yyvsp[-2].list));
			}
#line 12433 "parser_bison.c"
    break;

  case 723: /* ct_timeout_config: "l3proto" family_spec_explicit stmt_separator  */
#line 4400 "parser_bison.y"
                        {
				(yyvsp[-3].obj)->ct_timeout.l3proto = (yyvsp[-1].val);
			}
#line 12441 "parser_bison.c"
    break;

  case 724: /* ct_expect_config: "protocol" ct_l4protoname stmt_separator  */
#line 4406 "parser_bison.y"
                        {
				(yyvsp[-3].obj)->ct_expect.l4proto = (yyvsp[-1].val);
			}
#line 12449 "parser_bison.c"
    break;

  case 725: /* ct_expect_config: "dport" "number" stmt_separator  */
#line 4410 "parser_bison.y"
                        {
				(yyvsp[-3].obj)->ct_expect.dport = (yyvsp[-1].val);
			}
#line 12457 "parser_bison.c"
    break;

  case 726: /* ct_expect_config: "timeout" time_spec stmt_separator  */
#line 4414 "parser_bison.y"
                        {
				(yyvsp[-3].obj)->ct_expect.timeout = (yyvsp[-1].val);
			}
#line 12465 "parser_bison.c"
    break;

  case 727: /* ct_expect_config: "size" "number" stmt_separator  */
#line 4418 "parser_bison.y"
                        {
				(yyvsp[-3].obj)->ct_expect.size = (yyvsp[-1].val);
			}
#line 12473 "parser_bison.c"
    break;

  case 728: /* ct_expect_config: "l3proto" family_spec_explicit stmt_separator  */
#line 4422 "parser_bison.y"
                        {
				(yyvsp[-3].obj)->ct_expect.l3proto = (yyvsp[-1].val);
			}
#line 12481 "parser_bison.c"
    break;

  case 729: /* ct_obj_alloc: %empty  */
#line 4428 "parser_bison.y"
                        {
				(yyval.obj) = obj_alloc(&(yyloc));
			}
#line 12489 "parser_bison.c"
    break;

  case 730: /* limit_config: "rate" limit_mode "number" "/" time_unit limit_burst_pkts  */
#line 4434 "parser_bison.y"
                        {
				struct limit *limit;

				limit = &(yyvsp[-6].obj)->limit;
				limit->rate	= (yyvsp[-3].val);
				limit->unit	= (yyvsp[-1].val);
				limit->burst	= (yyvsp[0].val);
				limit->type	= NFT_LIMIT_PKTS;
				limit->flags	= (yyvsp[-4].val);
			}
#line 12504 "parser_bison.c"
    break;

  case 731: /* limit_config: "rate" limit_mode "number" "string" limit_burst_bytes  */
#line 4445 "parser_bison.y"
                        {
				struct limit *limit;
				struct error_record *erec;
				uint64_t rate, unit;

				erec = rate_parse(&(yyloc), (yyvsp[-1].string), &rate, &unit);
				if (erec != NULL) {
					erec_queue(erec, state->msgs);
					YYERROR;
				}

				limit = &(yyvsp[-5].obj)->limit;
				limit->rate	= rate * (yyvsp[-2].val);
				limit->unit	= unit;
				limit->burst	= (yyvsp[0].val);
				limit->type	= NFT_LIMIT_PKT_BYTES;
				limit->flags	= (yyvsp[-3].val);
			}
#line 12527 "parser_bison.c"
    break;

  case 732: /* limit_obj: %empty  */
#line 4466 "parser_bison.y"
                        {
				(yyval.obj) = obj_alloc(&(yyloc));
				(yyval.obj)->type = NFT_OBJECT_LIMIT;
			}
#line 12536 "parser_bison.c"
    break;

  case 733: /* relational_expr: expr rhs_expr  */
#line 4473 "parser_bison.y"
                        {
				(yyval.expr) = relational_expr_alloc(&(yyloc), OP_IMPLICIT, (yyvsp[-1].expr), (yyvsp[0].expr));
			}
#line 12544 "parser_bison.c"
    break;

  case 734: /* relational_expr: expr list_rhs_expr  */
#line 4477 "parser_bison.y"
                        {
				(yyval.expr) = relational_expr_alloc(&(yyloc), OP_IMPLICIT, (yyvsp[-1].expr), (yyvsp[0].expr));
			}
#line 12552 "parser_bison.c"
    break;

  case 735: /* relational_expr: expr relational_op rhs_expr  */
#line 4481 "parser_bison.y"
                        {
				(yyval.expr) = relational_expr_alloc(&(yylsp[-1]), (yyvsp[-1].val), (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 12560 "parser_bison.c"
    break;

  case 736: /* list_rhs_expr: basic_rhs_expr "comma" basic_rhs_expr  */
#line 4487 "parser_bison.y"
                        {
				(yyval.expr) = list_expr_alloc(&(yyloc));
				compound_expr_add((yyval.expr), (yyvsp[-2].expr));
				compound_expr_add((yyval.expr), (yyvsp[0].expr));
			}
#line 12570 "parser_bison.c"
    break;

  case 737: /* list_rhs_expr: list_rhs_expr "comma" basic_rhs_expr  */
#line 4493 "parser_bison.y"
                        {
				(yyvsp[-2].expr)->location = (yyloc);
				compound_expr_add((yyvsp[-2].expr), (yyvsp[0].expr));
				(yyval.expr) = (yyvsp[-2].expr);
			}
#line 12580 "parser_bison.c"
    break;

  case 738: /* rhs_expr: concat_rhs_expr  */
#line 4500 "parser_bison.y"
                                                        { (yyval.expr) = (yyvsp[0].expr); }
#line 12586 "parser_bison.c"
    break;

  case 739: /* rhs_expr: wildcard_expr  */
#line 4501 "parser_bison.y"
                                                        { (yyval.expr) = (yyvsp[0].expr); }
#line 12592 "parser_bison.c"
    break;

  case 740: /* rhs_expr: set_expr  */
#line 4502 "parser_bison.y"
                                                        { (yyval.expr) = (yyvsp[0].expr); }
#line 12598 "parser_bison.c"
    break;

  case 741: /* rhs_expr: set_ref_symbol_expr  */
#line 4503 "parser_bison.y"
                                                        { (yyval.expr) = (yyvsp[0].expr); }
#line 12604 "parser_bison.c"
    break;

  case 743: /* shift_rhs_expr: shift_rhs_expr "<<" primary_rhs_expr  */
#line 4508 "parser_bison.y"
                        {
				(yyval.expr) = binop_expr_alloc(&(yyloc), OP_LSHIFT, (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 12612 "parser_bison.c"
    break;

  case 744: /* shift_rhs_expr: shift_rhs_expr ">>" primary_rhs_expr  */
#line 4512 "parser_bison.y"
                        {
				(yyval.expr) = binop_expr_alloc(&(yyloc), OP_RSHIFT, (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 12620 "parser_bison.c"
    break;

  case 746: /* and_rhs_expr: and_rhs_expr "&" shift_rhs_expr  */
#line 4519 "parser_bison.y"
                        {
				(yyval.expr) = binop_expr_alloc(&(yyloc), OP_AND, (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 12628 "parser_bison.c"
    break;

  case 748: /* exclusive_or_rhs_expr: exclusive_or_rhs_expr "^" and_rhs_expr  */
#line 4526 "parser_bison.y"
                        {
				(yyval.expr) = binop_expr_alloc(&(yyloc), OP_XOR, (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 12636 "parser_bison.c"
    break;

  case 750: /* inclusive_or_rhs_expr: inclusive_or_rhs_expr '|' exclusive_or_rhs_expr  */
#line 4533 "parser_bison.y"
                        {
				(yyval.expr) = binop_expr_alloc(&(yyloc), OP_OR, (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 12644 "parser_bison.c"
    break;

  case 754: /* concat_rhs_expr: concat_rhs_expr "." multiton_rhs_expr  */
#line 4544 "parser_bison.y"
                        {
				struct location rhs[] = {
					[1]	= (yylsp[-1]),
					[2]	= (yylsp[0]),
				};

				(yyval.expr) = handle_concat_expr(&(yyloc), (yyval.expr), (yyvsp[-2].expr), (yyvsp[0].expr), rhs);
			}
#line 12657 "parser_bison.c"
    break;

  case 755: /* concat_rhs_expr: concat_rhs_expr "." basic_rhs_expr  */
#line 4553 "parser_bison.y"
                        {
				struct location rhs[] = {
					[1]	= (yylsp[-1]),
					[2]	= (yylsp[0]),
				};

				(yyval.expr) = handle_concat_expr(&(yyloc), (yyval.expr), (yyvsp[-2].expr), (yyvsp[0].expr), rhs);
			}
#line 12670 "parser_bison.c"
    break;

  case 756: /* boolean_keys: "exists"  */
#line 4563 "parser_bison.y"
                                                { (yyval.val8) = true; }
#line 12676 "parser_bison.c"
    break;

  case 757: /* boolean_keys: "missing"  */
#line 4564 "parser_bison.y"
                                                { (yyval.val8) = false; }
#line 12682 "parser_bison.c"
    break;

  case 758: /* boolean_expr: boolean_keys  */
#line 4568 "parser_bison.y"
                        {
				(yyval.expr) = constant_expr_alloc(&(yyloc), &boolean_type,
							 BYTEORDER_HOST_ENDIAN,
							 sizeof((yyvsp[0].val8)) * BITS_PER_BYTE, &(yyvsp[0].val8));
			}
#line 12692 "parser_bison.c"
    break;

  case 759: /* keyword_expr: "ether"  */
#line 4575 "parser_bison.y"
                                                        { (yyval.expr) = symbol_value(&(yyloc), "ether"); }
#line 12698 "parser_bison.c"
    break;

  case 760: /* keyword_expr: "ip"  */
#line 4576 "parser_bison.y"
                                                        { (yyval.expr) = symbol_value(&(yyloc), "ip"); }
#line 12704 "parser_bison.c"
    break;

  case 761: /* keyword_expr: "ip6"  */
#line 4577 "parser_bison.y"
                                                        { (yyval.expr) = symbol_value(&(yyloc), "ip6"); }
#line 12710 "parser_bison.c"
    break;

  case 762: /* keyword_expr: "vlan"  */
#line 4578 "parser_bison.y"
                                                        { (yyval.expr) = symbol_value(&(yyloc), "vlan"); }
#line 12716 "parser_bison.c"
    break;

  case 763: /* keyword_expr: "arp"  */
#line 4579 "parser_bison.y"
                                                        { (yyval.expr) = symbol_value(&(yyloc), "arp"); }
#line 12722 "parser_bison.c"
    break;

  case 764: /* keyword_expr: "dnat"  */
#line 4580 "parser_bison.y"
                                                        { (yyval.expr) = symbol_value(&(yyloc), "dnat"); }
#line 12728 "parser_bison.c"
    break;

  case 765: /* keyword_expr: "snat"  */
#line 4581 "parser_bison.y"
                                                        { (yyval.expr) = symbol_value(&(yyloc), "snat"); }
#line 12734 "parser_bison.c"
    break;

  case 766: /* keyword_expr: "ecn"  */
#line 4582 "parser_bison.y"
                                                        { (yyval.expr) = symbol_value(&(yyloc), "ecn"); }
#line 12740 "parser_bison.c"
    break;

  case 767: /* keyword_expr: "reset"  */
#line 4583 "parser_bison.y"
                                                        { (yyval.expr) = symbol_value(&(yyloc), "reset"); }
#line 12746 "parser_bison.c"
    break;

  case 768: /* keyword_expr: "original"  */
#line 4584 "parser_bison.y"
                                                        { (yyval.expr) = symbol_value(&(yyloc), "original"); }
#line 12752 "parser_bison.c"
    break;

  case 769: /* keyword_expr: "reply"  */
#line 4585 "parser_bison.y"
                                                        { (yyval.expr) = symbol_value(&(yyloc), "reply"); }
#line 12758 "parser_bison.c"
    break;

  case 770: /* keyword_expr: "label"  */
#line 4586 "parser_bison.y"
                                                        { (yyval.expr) = symbol_value(&(yyloc), "label"); }
#line 12764 "parser_bison.c"
    break;

  case 771: /* primary_rhs_expr: symbol_expr  */
#line 4589 "parser_bison.y"
                                                        { (yyval.expr) = (yyvsp[0].expr); }
#line 12770 "parser_bison.c"
    break;

  case 772: /* primary_rhs_expr: integer_expr  */
#line 4590 "parser_bison.y"
                                                        { (yyval.expr) = (yyvsp[0].expr); }
#line 12776 "parser_bison.c"
    break;

  case 773: /* primary_rhs_expr: boolean_expr  */
#line 4591 "parser_bison.y"
                                                        { (yyval.expr) = (yyvsp[0].expr); }
#line 12782 "parser_bison.c"
    break;

  case 774: /* primary_rhs_expr: keyword_expr  */
#line 4592 "parser_bison.y"
                                                        { (yyval.expr) = (yyvsp[0].expr); }
#line 12788 "parser_bison.c"
    break;

  case 775: /* primary_rhs_expr: "tcp"  */
#line 4594 "parser_bison.y"
                        {
				uint8_t data = IPPROTO_TCP;
				(yyval.expr) = constant_expr_alloc(&(yyloc), &inet_protocol_type,
							 BYTEORDER_HOST_ENDIAN,
							 sizeof(data) * BITS_PER_BYTE, &data);
			}
#line 12799 "parser_bison.c"
    break;

  case 776: /* primary_rhs_expr: "udp"  */
#line 4601 "parser_bison.y"
                        {
				uint8_t data = IPPROTO_UDP;
				(yyval.expr) = constant_expr_alloc(&(yyloc), &inet_protocol_type,
							 BYTEORDER_HOST_ENDIAN,
							 sizeof(data) * BITS_PER_BYTE, &data);
			}
#line 12810 "parser_bison.c"
    break;

  case 777: /* primary_rhs_expr: "udplite"  */
#line 4608 "parser_bison.y"
                        {
				uint8_t data = IPPROTO_UDPLITE;
				(yyval.expr) = constant_expr_alloc(&(yyloc), &inet_protocol_type,
							 BYTEORDER_HOST_ENDIAN,
							 sizeof(data) * BITS_PER_BYTE, &data);
			}
#line 12821 "parser_bison.c"
    break;

  case 778: /* primary_rhs_expr: "esp"  */
#line 4615 "parser_bison.y"
                        {
				uint8_t data = IPPROTO_ESP;
				(yyval.expr) = constant_expr_alloc(&(yyloc), &inet_protocol_type,
							 BYTEORDER_HOST_ENDIAN,
							 sizeof(data) * BITS_PER_BYTE, &data);
			}
#line 12832 "parser_bison.c"
    break;

  case 779: /* primary_rhs_expr: "ah"  */
#line 4622 "parser_bison.y"
                        {
				uint8_t data = IPPROTO_AH;
				(yyval.expr) = constant_expr_alloc(&(yyloc), &inet_protocol_type,
							 BYTEORDER_HOST_ENDIAN,
							 sizeof(data) * BITS_PER_BYTE, &data);
			}
#line 12843 "parser_bison.c"
    break;

  case 780: /* primary_rhs_expr: "icmp"  */
#line 4629 "parser_bison.y"
                        {
				uint8_t data = IPPROTO_ICMP;
				(yyval.expr) = constant_expr_alloc(&(yyloc), &inet_protocol_type,
							 BYTEORDER_HOST_ENDIAN,
							 sizeof(data) * BITS_PER_BYTE, &data);
			}
#line 12854 "parser_bison.c"
    break;

  case 781: /* primary_rhs_expr: "igmp"  */
#line 4636 "parser_bison.y"
                        {
				uint8_t data = IPPROTO_IGMP;
				(yyval.expr) = constant_expr_alloc(&(yyloc), &inet_protocol_type,
							 BYTEORDER_HOST_ENDIAN,
							 sizeof(data) * BITS_PER_BYTE, &data);
			}
#line 12865 "parser_bison.c"
    break;

  case 782: /* primary_rhs_expr: "icmpv6"  */
#line 4643 "parser_bison.y"
                        {
				uint8_t data = IPPROTO_ICMPV6;
				(yyval.expr) = constant_expr_alloc(&(yyloc), &inet_protocol_type,
							 BYTEORDER_HOST_ENDIAN,
							 sizeof(data) * BITS_PER_BYTE, &data);
			}
#line 12876 "parser_bison.c"
    break;

  case 783: /* primary_rhs_expr: "comp"  */
#line 4650 "parser_bison.y"
                        {
				uint8_t data = IPPROTO_COMP;
				(yyval.expr) = constant_expr_alloc(&(yyloc), &inet_protocol_type,
							 BYTEORDER_HOST_ENDIAN,
							 sizeof(data) * BITS_PER_BYTE, &data);
			}
#line 12887 "parser_bison.c"
    break;

  case 784: /* primary_rhs_expr: "dccp"  */
#line 4657 "parser_bison.y"
                        {
				uint8_t data = IPPROTO_DCCP;
				(yyval.expr) = constant_expr_alloc(&(yyloc), &inet_protocol_type,
							 BYTEORDER_HOST_ENDIAN,
							 sizeof(data) * BITS_PER_BYTE, &data);
			}
#line 12898 "parser_bison.c"
    break;

  case 785: /* primary_rhs_expr: "sctp" close_scope_sctp  */
#line 4664 "parser_bison.y"
                        {
				uint8_t data = IPPROTO_SCTP;
				(yyval.expr) = constant_expr_alloc(&(yyloc), &inet_protocol_type,
							 BYTEORDER_HOST_ENDIAN,
							 sizeof(data) * BITS_PER_BYTE, &data);
			}
#line 12909 "parser_bison.c"
    break;

  case 786: /* primary_rhs_expr: "redirect"  */
#line 4671 "parser_bison.y"
                        {
				uint8_t data = ICMP_REDIRECT;
				(yyval.expr) = constant_expr_alloc(&(yyloc), &icmp_type_type,
							 BYTEORDER_HOST_ENDIAN,
							 sizeof(data) * BITS_PER_BYTE, &data);
			}
#line 12920 "parser_bison.c"
    break;

  case 787: /* primary_rhs_expr: '(' basic_rhs_expr ')'  */
#line 4677 "parser_bison.y"
                                                                { (yyval.expr) = (yyvsp[-1].expr); }
#line 12926 "parser_bison.c"
    break;

  case 788: /* relational_op: "=="  */
#line 4680 "parser_bison.y"
                                                { (yyval.val) = OP_EQ; }
#line 12932 "parser_bison.c"
    break;

  case 789: /* relational_op: "!="  */
#line 4681 "parser_bison.y"
                                                { (yyval.val) = OP_NEQ; }
#line 12938 "parser_bison.c"
    break;

  case 790: /* relational_op: "<"  */
#line 4682 "parser_bison.y"
                                                { (yyval.val) = OP_LT; }
#line 12944 "parser_bison.c"
    break;

  case 791: /* relational_op: ">"  */
#line 4683 "parser_bison.y"
                                                { (yyval.val) = OP_GT; }
#line 12950 "parser_bison.c"
    break;

  case 792: /* relational_op: ">="  */
#line 4684 "parser_bison.y"
                                                { (yyval.val) = OP_GTE; }
#line 12956 "parser_bison.c"
    break;

  case 793: /* relational_op: "<="  */
#line 4685 "parser_bison.y"
                                                { (yyval.val) = OP_LTE; }
#line 12962 "parser_bison.c"
    break;

  case 794: /* verdict_expr: "accept"  */
#line 4689 "parser_bison.y"
                        {
				(yyval.expr) = verdict_expr_alloc(&(yyloc), NF_ACCEPT, NULL);
			}
#line 12970 "parser_bison.c"
    break;

  case 795: /* verdict_expr: "drop"  */
#line 4693 "parser_bison.y"
                        {
				(yyval.expr) = verdict_expr_alloc(&(yyloc), NF_DROP, NULL);
			}
#line 12978 "parser_bison.c"
    break;

  case 796: /* verdict_expr: "continue"  */
#line 4697 "parser_bison.y"
                        {
				(yyval.expr) = verdict_expr_alloc(&(yyloc), NFT_CONTINUE, NULL);
			}
#line 12986 "parser_bison.c"
    break;

  case 797: /* verdict_expr: "jump" chain_expr  */
#line 4701 "parser_bison.y"
                        {
				(yyval.expr) = verdict_expr_alloc(&(yyloc), NFT_JUMP, (yyvsp[0].expr));
			}
#line 12994 "parser_bison.c"
    break;

  case 798: /* verdict_expr: "goto" chain_expr  */
#line 4705 "parser_bison.y"
                        {
				(yyval.expr) = verdict_expr_alloc(&(yyloc), NFT_GOTO, (yyvsp[0].expr));
			}
#line 13002 "parser_bison.c"
    break;

  case 799: /* verdict_expr: "return"  */
#line 4709 "parser_bison.y"
                        {
				(yyval.expr) = verdict_expr_alloc(&(yyloc), NFT_RETURN, NULL);
			}
#line 13010 "parser_bison.c"
    break;

  case 801: /* chain_expr: identifier  */
#line 4716 "parser_bison.y"
                        {
				(yyval.expr) = constant_expr_alloc(&(yyloc), &string_type,
							 BYTEORDER_HOST_ENDIAN,
							 strlen((yyvsp[0].string)) * BITS_PER_BYTE,
							 (yyvsp[0].string));
				xfree((yyvsp[0].string));
			}
#line 13022 "parser_bison.c"
    break;

  case 802: /* meta_expr: "meta" meta_key  */
#line 4726 "parser_bison.y"
                        {
				(yyval.expr) = meta_expr_alloc(&(yyloc), (yyvsp[0].val));
			}
#line 13030 "parser_bison.c"
    break;

  case 803: /* meta_expr: meta_key_unqualified  */
#line 4730 "parser_bison.y"
                        {
				(yyval.expr) = meta_expr_alloc(&(yyloc), (yyvsp[0].val));
			}
#line 13038 "parser_bison.c"
    break;

  case 804: /* meta_expr: "meta" "string"  */
#line 4734 "parser_bison.y"
                        {
				struct error_record *erec;
				unsigned int key;

				erec = meta_key_parse(&(yyloc), (yyvsp[0].string), &key);
				xfree((yyvsp[0].string));
				if (erec != NULL) {
					erec_queue(erec, state->msgs);
					YYERROR;
				}

				(yyval.expr) = meta_expr_alloc(&(yyloc), key);
			}
#line 13056 "parser_bison.c"
    break;

  case 807: /* meta_key_qualified: "length"  */
#line 4753 "parser_bison.y"
                                                { (yyval.val) = NFT_META_LEN; }
#line 13062 "parser_bison.c"
    break;

  case 808: /* meta_key_qualified: "protocol"  */
#line 4754 "parser_bison.y"
                                                { (yyval.val) = NFT_META_PROTOCOL; }
#line 13068 "parser_bison.c"
    break;

  case 809: /* meta_key_qualified: "priority"  */
#line 4755 "parser_bison.y"
                                                { (yyval.val) = NFT_META_PRIORITY; }
#line 13074 "parser_bison.c"
    break;

  case 810: /* meta_key_qualified: "random"  */
#line 4756 "parser_bison.y"
                                                { (yyval.val) = NFT_META_PRANDOM; }
#line 13080 "parser_bison.c"
    break;

  case 811: /* meta_key_qualified: "secmark"  */
#line 4757 "parser_bison.y"
                                                { (yyval.val) = NFT_META_SECMARK; }
#line 13086 "parser_bison.c"
    break;

  case 812: /* meta_key_unqualified: "mark"  */
#line 4760 "parser_bison.y"
                                                { (yyval.val) = NFT_META_MARK; }
#line 13092 "parser_bison.c"
    break;

  case 813: /* meta_key_unqualified: "iif"  */
#line 4761 "parser_bison.y"
                                                { (yyval.val) = NFT_META_IIF; }
#line 13098 "parser_bison.c"
    break;

  case 814: /* meta_key_unqualified: "iifname"  */
#line 4762 "parser_bison.y"
                                                { (yyval.val) = NFT_META_IIFNAME; }
#line 13104 "parser_bison.c"
    break;

  case 815: /* meta_key_unqualified: "iiftype"  */
#line 4763 "parser_bison.y"
                                                { (yyval.val) = NFT_META_IIFTYPE; }
#line 13110 "parser_bison.c"
    break;

  case 816: /* meta_key_unqualified: "oif"  */
#line 4764 "parser_bison.y"
                                                { (yyval.val) = NFT_META_OIF; }
#line 13116 "parser_bison.c"
    break;

  case 817: /* meta_key_unqualified: "oifname"  */
#line 4765 "parser_bison.y"
                                                { (yyval.val) = NFT_META_OIFNAME; }
#line 13122 "parser_bison.c"
    break;

  case 818: /* meta_key_unqualified: "oiftype"  */
#line 4766 "parser_bison.y"
                                                { (yyval.val) = NFT_META_OIFTYPE; }
#line 13128 "parser_bison.c"
    break;

  case 819: /* meta_key_unqualified: "skuid"  */
#line 4767 "parser_bison.y"
                                                { (yyval.val) = NFT_META_SKUID; }
#line 13134 "parser_bison.c"
    break;

  case 820: /* meta_key_unqualified: "skgid"  */
#line 4768 "parser_bison.y"
                                                { (yyval.val) = NFT_META_SKGID; }
#line 13140 "parser_bison.c"
    break;

  case 821: /* meta_key_unqualified: "nftrace"  */
#line 4769 "parser_bison.y"
                                                { (yyval.val) = NFT_META_NFTRACE; }
#line 13146 "parser_bison.c"
    break;

  case 822: /* meta_key_unqualified: "rtclassid"  */
#line 4770 "parser_bison.y"
                                                { (yyval.val) = NFT_META_RTCLASSID; }
#line 13152 "parser_bison.c"
    break;

  case 823: /* meta_key_unqualified: "ibriport"  */
#line 4771 "parser_bison.y"
                                                { (yyval.val) = NFT_META_BRI_IIFNAME; }
#line 13158 "parser_bison.c"
    break;

  case 824: /* meta_key_unqualified: "obriport"  */
#line 4772 "parser_bison.y"
                                                { (yyval.val) = NFT_META_BRI_OIFNAME; }
#line 13164 "parser_bison.c"
    break;

  case 825: /* meta_key_unqualified: "ibrname"  */
#line 4773 "parser_bison.y"
                                                { (yyval.val) = NFT_META_BRI_IIFNAME; }
#line 13170 "parser_bison.c"
    break;

  case 826: /* meta_key_unqualified: "obrname"  */
#line 4774 "parser_bison.y"
                                                { (yyval.val) = NFT_META_BRI_OIFNAME; }
#line 13176 "parser_bison.c"
    break;

  case 827: /* meta_key_unqualified: "pkttype"  */
#line 4775 "parser_bison.y"
                                                { (yyval.val) = NFT_META_PKTTYPE; }
#line 13182 "parser_bison.c"
    break;

  case 828: /* meta_key_unqualified: "cpu"  */
#line 4776 "parser_bison.y"
                                                { (yyval.val) = NFT_META_CPU; }
#line 13188 "parser_bison.c"
    break;

  case 829: /* meta_key_unqualified: "iifgroup"  */
#line 4777 "parser_bison.y"
                                                { (yyval.val) = NFT_META_IIFGROUP; }
#line 13194 "parser_bison.c"
    break;

  case 830: /* meta_key_unqualified: "oifgroup"  */
#line 4778 "parser_bison.y"
                                                { (yyval.val) = NFT_META_OIFGROUP; }
#line 13200 "parser_bison.c"
    break;

  case 831: /* meta_key_unqualified: "cgroup"  */
#line 4779 "parser_bison.y"
                                                { (yyval.val) = NFT_META_CGROUP; }
#line 13206 "parser_bison.c"
    break;

  case 832: /* meta_key_unqualified: "ipsec"  */
#line 4780 "parser_bison.y"
                                                { (yyval.val) = NFT_META_SECPATH; }
#line 13212 "parser_bison.c"
    break;

  case 833: /* meta_key_unqualified: "time"  */
#line 4781 "parser_bison.y"
                                                { (yyval.val) = NFT_META_TIME_NS; }
#line 13218 "parser_bison.c"
    break;

  case 834: /* meta_key_unqualified: "day"  */
#line 4782 "parser_bison.y"
                                                { (yyval.val) = NFT_META_TIME_DAY; }
#line 13224 "parser_bison.c"
    break;

  case 835: /* meta_key_unqualified: "hour"  */
#line 4783 "parser_bison.y"
                                                { (yyval.val) = NFT_META_TIME_HOUR; }
#line 13230 "parser_bison.c"
    break;

  case 836: /* meta_stmt: "meta" meta_key "set" stmt_expr  */
#line 4787 "parser_bison.y"
                        {
				switch ((yyvsp[-2].val)) {
				case NFT_META_SECMARK:
					switch ((yyvsp[0].expr)->etype) {
					case EXPR_CT:
						(yyval.stmt) = meta_stmt_alloc(&(yyloc), (yyvsp[-2].val), (yyvsp[0].expr));
						break;
					default:
						(yyval.stmt) = objref_stmt_alloc(&(yyloc));
						(yyval.stmt)->objref.type = NFT_OBJECT_SECMARK;
						(yyval.stmt)->objref.expr = (yyvsp[0].expr);
						break;
					}
					break;
				default:
					(yyval.stmt) = meta_stmt_alloc(&(yyloc), (yyvsp[-2].val), (yyvsp[0].expr));
					break;
				}
			}
#line 13254 "parser_bison.c"
    break;

  case 837: /* meta_stmt: meta_key_unqualified "set" stmt_expr  */
#line 4807 "parser_bison.y"
                        {
				(yyval.stmt) = meta_stmt_alloc(&(yyloc), (yyvsp[-2].val), (yyvsp[0].expr));
			}
#line 13262 "parser_bison.c"
    break;

  case 838: /* meta_stmt: "meta" "string" "set" stmt_expr  */
#line 4811 "parser_bison.y"
                        {
				struct error_record *erec;
				unsigned int key;

				erec = meta_key_parse(&(yyloc), (yyvsp[-2].string), &key);
				xfree((yyvsp[-2].string));
				if (erec != NULL) {
					erec_queue(erec, state->msgs);
					YYERROR;
				}

				(yyval.stmt) = meta_stmt_alloc(&(yyloc), key, (yyvsp[0].expr));
			}
#line 13280 "parser_bison.c"
    break;

  case 839: /* meta_stmt: "notrack"  */
#line 4825 "parser_bison.y"
                        {
				(yyval.stmt) = notrack_stmt_alloc(&(yyloc));
			}
#line 13288 "parser_bison.c"
    break;

  case 840: /* meta_stmt: "flow" "offload" "@" string  */
#line 4829 "parser_bison.y"
                        {
				(yyval.stmt) = flow_offload_stmt_alloc(&(yyloc), (yyvsp[0].string));
			}
#line 13296 "parser_bison.c"
    break;

  case 841: /* meta_stmt: "flow" "add" "@" string  */
#line 4833 "parser_bison.y"
                        {
				(yyval.stmt) = flow_offload_stmt_alloc(&(yyloc), (yyvsp[0].string));
			}
#line 13304 "parser_bison.c"
    break;

  case 842: /* socket_expr: "socket" socket_key  */
#line 4839 "parser_bison.y"
                        {
				(yyval.expr) = socket_expr_alloc(&(yyloc), (yyvsp[0].val));
			}
#line 13312 "parser_bison.c"
    break;

  case 843: /* socket_key: "transparent"  */
#line 4844 "parser_bison.y"
                                                { (yyval.val) = NFT_SOCKET_TRANSPARENT; }
#line 13318 "parser_bison.c"
    break;

  case 844: /* socket_key: "mark"  */
#line 4845 "parser_bison.y"
                                                { (yyval.val) = NFT_SOCKET_MARK; }
#line 13324 "parser_bison.c"
    break;

  case 845: /* socket_key: "wildcard"  */
#line 4846 "parser_bison.y"
                                                { (yyval.val) = NFT_SOCKET_WILDCARD; }
#line 13330 "parser_bison.c"
    break;

  case 846: /* offset_opt: %empty  */
#line 4849 "parser_bison.y"
                                                { (yyval.val) = 0; }
#line 13336 "parser_bison.c"
    break;

  case 847: /* offset_opt: "offset" "number"  */
#line 4850 "parser_bison.y"
                                                { (yyval.val) = (yyvsp[0].val); }
#line 13342 "parser_bison.c"
    break;

  case 848: /* numgen_type: "inc"  */
#line 4853 "parser_bison.y"
                                                { (yyval.val) = NFT_NG_INCREMENTAL; }
#line 13348 "parser_bison.c"
    break;

  case 849: /* numgen_type: "random"  */
#line 4854 "parser_bison.y"
                                                { (yyval.val) = NFT_NG_RANDOM; }
#line 13354 "parser_bison.c"
    break;

  case 850: /* numgen_expr: "numgen" numgen_type "mod" "number" offset_opt close_scope_numgen  */
#line 4858 "parser_bison.y"
                        {
				(yyval.expr) = numgen_expr_alloc(&(yyloc), (yyvsp[-4].val), (yyvsp[-2].val), (yyvsp[-1].val));
			}
#line 13362 "parser_bison.c"
    break;

  case 851: /* xfrm_spnum: "spnum" "number"  */
#line 4863 "parser_bison.y"
                                            { (yyval.val) = (yyvsp[0].val); }
#line 13368 "parser_bison.c"
    break;

  case 852: /* xfrm_spnum: %empty  */
#line 4864 "parser_bison.y"
                                            { (yyval.val) = 0; }
#line 13374 "parser_bison.c"
    break;

  case 853: /* xfrm_dir: "in"  */
#line 4867 "parser_bison.y"
                                        { (yyval.val) = XFRM_POLICY_IN; }
#line 13380 "parser_bison.c"
    break;

  case 854: /* xfrm_dir: "out"  */
#line 4868 "parser_bison.y"
                                        { (yyval.val) = XFRM_POLICY_OUT; }
#line 13386 "parser_bison.c"
    break;

  case 855: /* xfrm_state_key: "spi"  */
#line 4871 "parser_bison.y"
                                    { (yyval.val) = NFT_XFRM_KEY_SPI; }
#line 13392 "parser_bison.c"
    break;

  case 856: /* xfrm_state_key: "reqid"  */
#line 4872 "parser_bison.y"
                                      { (yyval.val) = NFT_XFRM_KEY_REQID; }
#line 13398 "parser_bison.c"
    break;

  case 857: /* xfrm_state_proto_key: "daddr"  */
#line 4875 "parser_bison.y"
                                                { (yyval.val) = NFT_XFRM_KEY_DADDR_IP4; }
#line 13404 "parser_bison.c"
    break;

  case 858: /* xfrm_state_proto_key: "saddr"  */
#line 4876 "parser_bison.y"
                                                { (yyval.val) = NFT_XFRM_KEY_SADDR_IP4; }
#line 13410 "parser_bison.c"
    break;

  case 859: /* xfrm_expr: "ipsec" xfrm_dir xfrm_spnum xfrm_state_key  */
#line 4880 "parser_bison.y"
                        {
				if ((yyvsp[-1].val) > 255) {
					erec_queue(error(&(yylsp[-1]), "value too large"), state->msgs);
					YYERROR;
				}
				(yyval.expr) = xfrm_expr_alloc(&(yyloc), (yyvsp[-2].val), (yyvsp[-1].val), (yyvsp[0].val));
			}
#line 13422 "parser_bison.c"
    break;

  case 860: /* xfrm_expr: "ipsec" xfrm_dir xfrm_spnum nf_key_proto xfrm_state_proto_key  */
#line 4888 "parser_bison.y"
                        {
				enum nft_xfrm_keys xfrmk = (yyvsp[0].val);

				switch ((yyvsp[-1].val)) {
				case NFPROTO_IPV4:
					break;
				case NFPROTO_IPV6:
					if ((yyvsp[0].val) == NFT_XFRM_KEY_SADDR_IP4)
						xfrmk = NFT_XFRM_KEY_SADDR_IP6;
					else if ((yyvsp[0].val) == NFT_XFRM_KEY_DADDR_IP4)
						xfrmk = NFT_XFRM_KEY_DADDR_IP6;
					break;
				default:
					YYERROR;
					break;
				}

				if ((yyvsp[-2].val) > 255) {
					erec_queue(error(&(yylsp[-2]), "value too large"), state->msgs);
					YYERROR;
				}

				(yyval.expr) = xfrm_expr_alloc(&(yyloc), (yyvsp[-3].val), (yyvsp[-2].val), xfrmk);
			}
#line 13451 "parser_bison.c"
    break;

  case 861: /* hash_expr: "jhash" expr "mod" "number" "seed" "number" offset_opt close_scope_hash  */
#line 4915 "parser_bison.y"
                        {
				(yyval.expr) = hash_expr_alloc(&(yyloc), (yyvsp[-4].val), true, (yyvsp[-2].val), (yyvsp[-1].val), NFT_HASH_JENKINS);
				(yyval.expr)->hash.expr = (yyvsp[-6].expr);
			}
#line 13460 "parser_bison.c"
    break;

  case 862: /* hash_expr: "jhash" expr "mod" "number" offset_opt close_scope_hash  */
#line 4920 "parser_bison.y"
                        {
				(yyval.expr) = hash_expr_alloc(&(yyloc), (yyvsp[-2].val), false, 0, (yyvsp[-1].val), NFT_HASH_JENKINS);
				(yyval.expr)->hash.expr = (yyvsp[-4].expr);
			}
#line 13469 "parser_bison.c"
    break;

  case 863: /* hash_expr: "symhash" "mod" "number" offset_opt close_scope_hash  */
#line 4925 "parser_bison.y"
                        {
				(yyval.expr) = hash_expr_alloc(&(yyloc), (yyvsp[-2].val), false, 0, (yyvsp[-1].val), NFT_HASH_SYM);
			}
#line 13477 "parser_bison.c"
    break;

  case 864: /* nf_key_proto: "ip"  */
#line 4930 "parser_bison.y"
                                                { (yyval.val) = NFPROTO_IPV4; }
#line 13483 "parser_bison.c"
    break;

  case 865: /* nf_key_proto: "ip6"  */
#line 4931 "parser_bison.y"
                                                { (yyval.val) = NFPROTO_IPV6; }
#line 13489 "parser_bison.c"
    break;

  case 866: /* rt_expr: "rt" rt_key  */
#line 4935 "parser_bison.y"
                        {
				(yyval.expr) = rt_expr_alloc(&(yyloc), (yyvsp[0].val), true);
			}
#line 13497 "parser_bison.c"
    break;

  case 867: /* rt_expr: "rt" nf_key_proto rt_key  */
#line 4939 "parser_bison.y"
                        {
				enum nft_rt_keys rtk = (yyvsp[0].val);

				switch ((yyvsp[-1].val)) {
				case NFPROTO_IPV4:
					break;
				case NFPROTO_IPV6:
					if ((yyvsp[0].val) == NFT_RT_NEXTHOP4)
						rtk = NFT_RT_NEXTHOP6;
					break;
				default:
					YYERROR;
					break;
				}

				(yyval.expr) = rt_expr_alloc(&(yyloc), rtk, false);
			}
#line 13519 "parser_bison.c"
    break;

  case 868: /* rt_key: "classid"  */
#line 4958 "parser_bison.y"
                                                { (yyval.val) = NFT_RT_CLASSID; }
#line 13525 "parser_bison.c"
    break;

  case 869: /* rt_key: "nexthop"  */
#line 4959 "parser_bison.y"
                                                { (yyval.val) = NFT_RT_NEXTHOP4; }
#line 13531 "parser_bison.c"
    break;

  case 870: /* rt_key: "mtu"  */
#line 4960 "parser_bison.y"
                                                { (yyval.val) = NFT_RT_TCPMSS; }
#line 13537 "parser_bison.c"
    break;

  case 871: /* rt_key: "ipsec"  */
#line 4961 "parser_bison.y"
                                                { (yyval.val) = NFT_RT_XFRM; }
#line 13543 "parser_bison.c"
    break;

  case 872: /* ct_expr: "ct" ct_key  */
#line 4965 "parser_bison.y"
                        {
				(yyval.expr) = ct_expr_alloc(&(yyloc), (yyvsp[0].val), -1);
			}
#line 13551 "parser_bison.c"
    break;

  case 873: /* ct_expr: "ct" ct_dir ct_key_dir  */
#line 4969 "parser_bison.y"
                        {
				(yyval.expr) = ct_expr_alloc(&(yyloc), (yyvsp[0].val), (yyvsp[-1].val));
			}
#line 13559 "parser_bison.c"
    break;

  case 874: /* ct_expr: "ct" ct_dir ct_key_proto_field  */
#line 4973 "parser_bison.y"
                        {
				(yyval.expr) = ct_expr_alloc(&(yyloc), (yyvsp[0].val), (yyvsp[-1].val));
			}
#line 13567 "parser_bison.c"
    break;

  case 875: /* ct_dir: "original"  */
#line 4978 "parser_bison.y"
                                                { (yyval.val) = IP_CT_DIR_ORIGINAL; }
#line 13573 "parser_bison.c"
    break;

  case 876: /* ct_dir: "reply"  */
#line 4979 "parser_bison.y"
                                                { (yyval.val) = IP_CT_DIR_REPLY; }
#line 13579 "parser_bison.c"
    break;

  case 877: /* ct_key: "l3proto"  */
#line 4982 "parser_bison.y"
                                                { (yyval.val) = NFT_CT_L3PROTOCOL; }
#line 13585 "parser_bison.c"
    break;

  case 878: /* ct_key: "protocol"  */
#line 4983 "parser_bison.y"
                                                { (yyval.val) = NFT_CT_PROTOCOL; }
#line 13591 "parser_bison.c"
    break;

  case 879: /* ct_key: "mark"  */
#line 4984 "parser_bison.y"
                                                { (yyval.val) = NFT_CT_MARK; }
#line 13597 "parser_bison.c"
    break;

  case 880: /* ct_key: "state"  */
#line 4985 "parser_bison.y"
                                                { (yyval.val) = NFT_CT_STATE; }
#line 13603 "parser_bison.c"
    break;

  case 881: /* ct_key: "direction"  */
#line 4986 "parser_bison.y"
                                                { (yyval.val) = NFT_CT_DIRECTION; }
#line 13609 "parser_bison.c"
    break;

  case 882: /* ct_key: "status"  */
#line 4987 "parser_bison.y"
                                                { (yyval.val) = NFT_CT_STATUS; }
#line 13615 "parser_bison.c"
    break;

  case 883: /* ct_key: "expiration"  */
#line 4988 "parser_bison.y"
                                                { (yyval.val) = NFT_CT_EXPIRATION; }
#line 13621 "parser_bison.c"
    break;

  case 884: /* ct_key: "helper"  */
#line 4989 "parser_bison.y"
                                                { (yyval.val) = NFT_CT_HELPER; }
#line 13627 "parser_bison.c"
    break;

  case 885: /* ct_key: "saddr"  */
#line 4990 "parser_bison.y"
                                                { (yyval.val) = NFT_CT_SRC; }
#line 13633 "parser_bison.c"
    break;

  case 886: /* ct_key: "daddr"  */
#line 4991 "parser_bison.y"
                                                { (yyval.val) = NFT_CT_DST; }
#line 13639 "parser_bison.c"
    break;

  case 887: /* ct_key: "proto-src"  */
#line 4992 "parser_bison.y"
                                                { (yyval.val) = NFT_CT_PROTO_SRC; }
#line 13645 "parser_bison.c"
    break;

  case 888: /* ct_key: "proto-dst"  */
#line 4993 "parser_bison.y"
                                                { (yyval.val) = NFT_CT_PROTO_DST; }
#line 13651 "parser_bison.c"
    break;

  case 889: /* ct_key: "label"  */
#line 4994 "parser_bison.y"
                                                { (yyval.val) = NFT_CT_LABELS; }
#line 13657 "parser_bison.c"
    break;

  case 890: /* ct_key: "event"  */
#line 4995 "parser_bison.y"
                                                { (yyval.val) = NFT_CT_EVENTMASK; }
#line 13663 "parser_bison.c"
    break;

  case 891: /* ct_key: "secmark"  */
#line 4996 "parser_bison.y"
                                                { (yyval.val) = NFT_CT_SECMARK; }
#line 13669 "parser_bison.c"
    break;

  case 892: /* ct_key: "id"  */
#line 4997 "parser_bison.y"
                                                { (yyval.val) = NFT_CT_ID; }
#line 13675 "parser_bison.c"
    break;

  case 894: /* ct_key_dir: "saddr"  */
#line 5001 "parser_bison.y"
                                                { (yyval.val) = NFT_CT_SRC; }
#line 13681 "parser_bison.c"
    break;

  case 895: /* ct_key_dir: "daddr"  */
#line 5002 "parser_bison.y"
                                                { (yyval.val) = NFT_CT_DST; }
#line 13687 "parser_bison.c"
    break;

  case 896: /* ct_key_dir: "l3proto"  */
#line 5003 "parser_bison.y"
                                                { (yyval.val) = NFT_CT_L3PROTOCOL; }
#line 13693 "parser_bison.c"
    break;

  case 897: /* ct_key_dir: "protocol"  */
#line 5004 "parser_bison.y"
                                                { (yyval.val) = NFT_CT_PROTOCOL; }
#line 13699 "parser_bison.c"
    break;

  case 898: /* ct_key_dir: "proto-src"  */
#line 5005 "parser_bison.y"
                                                { (yyval.val) = NFT_CT_PROTO_SRC; }
#line 13705 "parser_bison.c"
    break;

  case 899: /* ct_key_dir: "proto-dst"  */
#line 5006 "parser_bison.y"
                                                { (yyval.val) = NFT_CT_PROTO_DST; }
#line 13711 "parser_bison.c"
    break;

  case 901: /* ct_key_proto_field: "ip" "saddr"  */
#line 5010 "parser_bison.y"
                                                { (yyval.val) = NFT_CT_SRC_IP; }
#line 13717 "parser_bison.c"
    break;

  case 902: /* ct_key_proto_field: "ip" "daddr"  */
#line 5011 "parser_bison.y"
                                                { (yyval.val) = NFT_CT_DST_IP; }
#line 13723 "parser_bison.c"
    break;

  case 903: /* ct_key_proto_field: "ip6" "saddr"  */
#line 5012 "parser_bison.y"
                                                { (yyval.val) = NFT_CT_SRC_IP6; }
#line 13729 "parser_bison.c"
    break;

  case 904: /* ct_key_proto_field: "ip6" "daddr"  */
#line 5013 "parser_bison.y"
                                                { (yyval.val) = NFT_CT_DST_IP6; }
#line 13735 "parser_bison.c"
    break;

  case 905: /* ct_key_dir_optional: "bytes"  */
#line 5016 "parser_bison.y"
                                                { (yyval.val) = NFT_CT_BYTES; }
#line 13741 "parser_bison.c"
    break;

  case 906: /* ct_key_dir_optional: "packets"  */
#line 5017 "parser_bison.y"
                                                { (yyval.val) = NFT_CT_PKTS; }
#line 13747 "parser_bison.c"
    break;

  case 907: /* ct_key_dir_optional: "avgpkt"  */
#line 5018 "parser_bison.y"
                                                { (yyval.val) = NFT_CT_AVGPKT; }
#line 13753 "parser_bison.c"
    break;

  case 908: /* ct_key_dir_optional: "zone"  */
#line 5019 "parser_bison.y"
                                                { (yyval.val) = NFT_CT_ZONE; }
#line 13759 "parser_bison.c"
    break;

  case 911: /* list_stmt_expr: symbol_stmt_expr "comma" symbol_stmt_expr  */
#line 5027 "parser_bison.y"
                        {
				(yyval.expr) = list_expr_alloc(&(yyloc));
				compound_expr_add((yyval.expr), (yyvsp[-2].expr));
				compound_expr_add((yyval.expr), (yyvsp[0].expr));
			}
#line 13769 "parser_bison.c"
    break;

  case 912: /* list_stmt_expr: list_stmt_expr "comma" symbol_stmt_expr  */
#line 5033 "parser_bison.y"
                        {
				(yyvsp[-2].expr)->location = (yyloc);
				compound_expr_add((yyvsp[-2].expr), (yyvsp[0].expr));
				(yyval.expr) = (yyvsp[-2].expr);
			}
#line 13779 "parser_bison.c"
    break;

  case 913: /* ct_stmt: "ct" ct_key "set" stmt_expr  */
#line 5041 "parser_bison.y"
                        {
				switch ((yyvsp[-2].val)) {
				case NFT_CT_HELPER:
					(yyval.stmt) = objref_stmt_alloc(&(yyloc));
					(yyval.stmt)->objref.type = NFT_OBJECT_CT_HELPER;
					(yyval.stmt)->objref.expr = (yyvsp[0].expr);
					break;
				default:
					(yyval.stmt) = ct_stmt_alloc(&(yyloc), (yyvsp[-2].val), -1, (yyvsp[0].expr));
					break;
				}
			}
#line 13796 "parser_bison.c"
    break;

  case 914: /* ct_stmt: "ct" "timeout" "set" stmt_expr  */
#line 5054 "parser_bison.y"
                        {
				(yyval.stmt) = objref_stmt_alloc(&(yyloc));
				(yyval.stmt)->objref.type = NFT_OBJECT_CT_TIMEOUT;
				(yyval.stmt)->objref.expr = (yyvsp[0].expr);

			}
#line 13807 "parser_bison.c"
    break;

  case 915: /* ct_stmt: "ct" "expectation" "set" stmt_expr  */
#line 5061 "parser_bison.y"
                        {
				(yyval.stmt) = objref_stmt_alloc(&(yyloc));
				(yyval.stmt)->objref.type = NFT_OBJECT_CT_EXPECT;
				(yyval.stmt)->objref.expr = (yyvsp[0].expr);
			}
#line 13817 "parser_bison.c"
    break;

  case 916: /* ct_stmt: "ct" ct_dir ct_key_dir_optional "set" stmt_expr  */
#line 5067 "parser_bison.y"
                        {
				(yyval.stmt) = ct_stmt_alloc(&(yyloc), (yyvsp[-2].val), (yyvsp[-3].val), (yyvsp[0].expr));
			}
#line 13825 "parser_bison.c"
    break;

  case 917: /* payload_stmt: payload_expr "set" stmt_expr  */
#line 5073 "parser_bison.y"
                        {
				if ((yyvsp[-2].expr)->etype == EXPR_EXTHDR)
					(yyval.stmt) = exthdr_stmt_alloc(&(yyloc), (yyvsp[-2].expr), (yyvsp[0].expr));
				else
					(yyval.stmt) = payload_stmt_alloc(&(yyloc), (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 13836 "parser_bison.c"
    break;

  case 936: /* payload_raw_expr: "@" payload_base_spec "comma" "number" "comma" "number"  */
#line 5102 "parser_bison.y"
                        {
				(yyval.expr) = payload_expr_alloc(&(yyloc), NULL, 0);
				payload_init_raw((yyval.expr), (yyvsp[-4].val), (yyvsp[-2].val), (yyvsp[0].val));
				(yyval.expr)->byteorder		= BYTEORDER_BIG_ENDIAN;
				(yyval.expr)->payload.is_raw	= true;
			}
#line 13847 "parser_bison.c"
    break;

  case 937: /* payload_base_spec: "ll"  */
#line 5110 "parser_bison.y"
                                                { (yyval.val) = PROTO_BASE_LL_HDR; }
#line 13853 "parser_bison.c"
    break;

  case 938: /* payload_base_spec: "nh"  */
#line 5111 "parser_bison.y"
                                                { (yyval.val) = PROTO_BASE_NETWORK_HDR; }
#line 13859 "parser_bison.c"
    break;

  case 939: /* payload_base_spec: "th"  */
#line 5112 "parser_bison.y"
                                                { (yyval.val) = PROTO_BASE_TRANSPORT_HDR; }
#line 13865 "parser_bison.c"
    break;

  case 940: /* eth_hdr_expr: "ether" eth_hdr_field  */
#line 5116 "parser_bison.y"
                        {
				(yyval.expr) = payload_expr_alloc(&(yyloc), &proto_eth, (yyvsp[0].val));
			}
#line 13873 "parser_bison.c"
    break;

  case 941: /* eth_hdr_field: "saddr"  */
#line 5121 "parser_bison.y"
                                                { (yyval.val) = ETHHDR_SADDR; }
#line 13879 "parser_bison.c"
    break;

  case 942: /* eth_hdr_field: "daddr"  */
#line 5122 "parser_bison.y"
                                                { (yyval.val) = ETHHDR_DADDR; }
#line 13885 "parser_bison.c"
    break;

  case 943: /* eth_hdr_field: "type"  */
#line 5123 "parser_bison.y"
                                                { (yyval.val) = ETHHDR_TYPE; }
#line 13891 "parser_bison.c"
    break;

  case 944: /* vlan_hdr_expr: "vlan" vlan_hdr_field  */
#line 5127 "parser_bison.y"
                        {
				(yyval.expr) = payload_expr_alloc(&(yyloc), &proto_vlan, (yyvsp[0].val));
			}
#line 13899 "parser_bison.c"
    break;

  case 945: /* vlan_hdr_field: "id"  */
#line 5132 "parser_bison.y"
                                                { (yyval.val) = VLANHDR_VID; }
#line 13905 "parser_bison.c"
    break;

  case 946: /* vlan_hdr_field: "cfi"  */
#line 5133 "parser_bison.y"
                                                { (yyval.val) = VLANHDR_CFI; }
#line 13911 "parser_bison.c"
    break;

  case 947: /* vlan_hdr_field: "pcp"  */
#line 5134 "parser_bison.y"
                                                { (yyval.val) = VLANHDR_PCP; }
#line 13917 "parser_bison.c"
    break;

  case 948: /* vlan_hdr_field: "type"  */
#line 5135 "parser_bison.y"
                                                { (yyval.val) = VLANHDR_TYPE; }
#line 13923 "parser_bison.c"
    break;

  case 949: /* arp_hdr_expr: "arp" arp_hdr_field  */
#line 5139 "parser_bison.y"
                        {
				(yyval.expr) = payload_expr_alloc(&(yyloc), &proto_arp, (yyvsp[0].val));
			}
#line 13931 "parser_bison.c"
    break;

  case 950: /* arp_hdr_field: "htype"  */
#line 5144 "parser_bison.y"
                                                { (yyval.val) = ARPHDR_HRD; }
#line 13937 "parser_bison.c"
    break;

  case 951: /* arp_hdr_field: "ptype"  */
#line 5145 "parser_bison.y"
                                                { (yyval.val) = ARPHDR_PRO; }
#line 13943 "parser_bison.c"
    break;

  case 952: /* arp_hdr_field: "hlen"  */
#line 5146 "parser_bison.y"
                                                { (yyval.val) = ARPHDR_HLN; }
#line 13949 "parser_bison.c"
    break;

  case 953: /* arp_hdr_field: "plen"  */
#line 5147 "parser_bison.y"
                                                { (yyval.val) = ARPHDR_PLN; }
#line 13955 "parser_bison.c"
    break;

  case 954: /* arp_hdr_field: "operation"  */
#line 5148 "parser_bison.y"
                                                { (yyval.val) = ARPHDR_OP; }
#line 13961 "parser_bison.c"
    break;

  case 955: /* arp_hdr_field: "saddr" "ether"  */
#line 5149 "parser_bison.y"
                                                { (yyval.val) = ARPHDR_SADDR_ETHER; }
#line 13967 "parser_bison.c"
    break;

  case 956: /* arp_hdr_field: "daddr" "ether"  */
#line 5150 "parser_bison.y"
                                                { (yyval.val) = ARPHDR_DADDR_ETHER; }
#line 13973 "parser_bison.c"
    break;

  case 957: /* arp_hdr_field: "saddr" "ip"  */
#line 5151 "parser_bison.y"
                                                { (yyval.val) = ARPHDR_SADDR_IP; }
#line 13979 "parser_bison.c"
    break;

  case 958: /* arp_hdr_field: "daddr" "ip"  */
#line 5152 "parser_bison.y"
                                                { (yyval.val) = ARPHDR_DADDR_IP; }
#line 13985 "parser_bison.c"
    break;

  case 959: /* ip_hdr_expr: "ip" ip_hdr_field  */
#line 5156 "parser_bison.y"
                        {
				(yyval.expr) = payload_expr_alloc(&(yyloc), &proto_ip, (yyvsp[0].val));
			}
#line 13993 "parser_bison.c"
    break;

  case 960: /* ip_hdr_expr: "ip" "option" ip_option_type ip_option_field  */
#line 5160 "parser_bison.y"
                        {
				(yyval.expr) = ipopt_expr_alloc(&(yyloc), (yyvsp[-1].val), (yyvsp[0].val), 0);
			}
#line 14001 "parser_bison.c"
    break;

  case 961: /* ip_hdr_expr: "ip" "option" ip_option_type  */
#line 5164 "parser_bison.y"
                        {
				(yyval.expr) = ipopt_expr_alloc(&(yyloc), (yyvsp[0].val), IPOPT_FIELD_TYPE, 0);
				(yyval.expr)->exthdr.flags = NFT_EXTHDR_F_PRESENT;
			}
#line 14010 "parser_bison.c"
    break;

  case 962: /* ip_hdr_field: "version"  */
#line 5170 "parser_bison.y"
                                                { (yyval.val) = IPHDR_VERSION; }
#line 14016 "parser_bison.c"
    break;

  case 963: /* ip_hdr_field: "hdrlength"  */
#line 5171 "parser_bison.y"
                                                { (yyval.val) = IPHDR_HDRLENGTH; }
#line 14022 "parser_bison.c"
    break;

  case 964: /* ip_hdr_field: "dscp"  */
#line 5172 "parser_bison.y"
                                                { (yyval.val) = IPHDR_DSCP; }
#line 14028 "parser_bison.c"
    break;

  case 965: /* ip_hdr_field: "ecn"  */
#line 5173 "parser_bison.y"
                                                { (yyval.val) = IPHDR_ECN; }
#line 14034 "parser_bison.c"
    break;

  case 966: /* ip_hdr_field: "length"  */
#line 5174 "parser_bison.y"
                                                { (yyval.val) = IPHDR_LENGTH; }
#line 14040 "parser_bison.c"
    break;

  case 967: /* ip_hdr_field: "id"  */
#line 5175 "parser_bison.y"
                                                { (yyval.val) = IPHDR_ID; }
#line 14046 "parser_bison.c"
    break;

  case 968: /* ip_hdr_field: "frag-off"  */
#line 5176 "parser_bison.y"
                                                { (yyval.val) = IPHDR_FRAG_OFF; }
#line 14052 "parser_bison.c"
    break;

  case 969: /* ip_hdr_field: "ttl"  */
#line 5177 "parser_bison.y"
                                                { (yyval.val) = IPHDR_TTL; }
#line 14058 "parser_bison.c"
    break;

  case 970: /* ip_hdr_field: "protocol"  */
#line 5178 "parser_bison.y"
                                                { (yyval.val) = IPHDR_PROTOCOL; }
#line 14064 "parser_bison.c"
    break;

  case 971: /* ip_hdr_field: "checksum"  */
#line 5179 "parser_bison.y"
                                                { (yyval.val) = IPHDR_CHECKSUM; }
#line 14070 "parser_bison.c"
    break;

  case 972: /* ip_hdr_field: "saddr"  */
#line 5180 "parser_bison.y"
                                                { (yyval.val) = IPHDR_SADDR; }
#line 14076 "parser_bison.c"
    break;

  case 973: /* ip_hdr_field: "daddr"  */
#line 5181 "parser_bison.y"
                                                { (yyval.val) = IPHDR_DADDR; }
#line 14082 "parser_bison.c"
    break;

  case 974: /* ip_option_type: "lsrr"  */
#line 5184 "parser_bison.y"
                                                { (yyval.val) = IPOPT_LSRR; }
#line 14088 "parser_bison.c"
    break;

  case 975: /* ip_option_type: "rr"  */
#line 5185 "parser_bison.y"
                                                { (yyval.val) = IPOPT_RR; }
#line 14094 "parser_bison.c"
    break;

  case 976: /* ip_option_type: "ssrr"  */
#line 5186 "parser_bison.y"
                                                { (yyval.val) = IPOPT_SSRR; }
#line 14100 "parser_bison.c"
    break;

  case 977: /* ip_option_type: "ra"  */
#line 5187 "parser_bison.y"
                                                { (yyval.val) = IPOPT_RA; }
#line 14106 "parser_bison.c"
    break;

  case 978: /* ip_option_field: "type"  */
#line 5190 "parser_bison.y"
                                                { (yyval.val) = IPOPT_FIELD_TYPE; }
#line 14112 "parser_bison.c"
    break;

  case 979: /* ip_option_field: "length"  */
#line 5191 "parser_bison.y"
                                                { (yyval.val) = IPOPT_FIELD_LENGTH; }
#line 14118 "parser_bison.c"
    break;

  case 980: /* ip_option_field: "value"  */
#line 5192 "parser_bison.y"
                                                { (yyval.val) = IPOPT_FIELD_VALUE; }
#line 14124 "parser_bison.c"
    break;

  case 981: /* ip_option_field: "ptr"  */
#line 5193 "parser_bison.y"
                                                { (yyval.val) = IPOPT_FIELD_PTR; }
#line 14130 "parser_bison.c"
    break;

  case 982: /* ip_option_field: "addr"  */
#line 5194 "parser_bison.y"
                                                { (yyval.val) = IPOPT_FIELD_ADDR_0; }
#line 14136 "parser_bison.c"
    break;

  case 983: /* icmp_hdr_expr: "icmp" icmp_hdr_field  */
#line 5198 "parser_bison.y"
                        {
				(yyval.expr) = payload_expr_alloc(&(yyloc), &proto_icmp, (yyvsp[0].val));
			}
#line 14144 "parser_bison.c"
    break;

  case 984: /* icmp_hdr_field: "type"  */
#line 5203 "parser_bison.y"
                                                { (yyval.val) = ICMPHDR_TYPE; }
#line 14150 "parser_bison.c"
    break;

  case 985: /* icmp_hdr_field: "code"  */
#line 5204 "parser_bison.y"
                                                { (yyval.val) = ICMPHDR_CODE; }
#line 14156 "parser_bison.c"
    break;

  case 986: /* icmp_hdr_field: "checksum"  */
#line 5205 "parser_bison.y"
                                                { (yyval.val) = ICMPHDR_CHECKSUM; }
#line 14162 "parser_bison.c"
    break;

  case 987: /* icmp_hdr_field: "id"  */
#line 5206 "parser_bison.y"
                                                { (yyval.val) = ICMPHDR_ID; }
#line 14168 "parser_bison.c"
    break;

  case 988: /* icmp_hdr_field: "seq"  */
#line 5207 "parser_bison.y"
                                                { (yyval.val) = ICMPHDR_SEQ; }
#line 14174 "parser_bison.c"
    break;

  case 989: /* icmp_hdr_field: "gateway"  */
#line 5208 "parser_bison.y"
                                                { (yyval.val) = ICMPHDR_GATEWAY; }
#line 14180 "parser_bison.c"
    break;

  case 990: /* icmp_hdr_field: "mtu"  */
#line 5209 "parser_bison.y"
                                                { (yyval.val) = ICMPHDR_MTU; }
#line 14186 "parser_bison.c"
    break;

  case 991: /* igmp_hdr_expr: "igmp" igmp_hdr_field  */
#line 5213 "parser_bison.y"
                        {
				(yyval.expr) = payload_expr_alloc(&(yyloc), &proto_igmp, (yyvsp[0].val));
			}
#line 14194 "parser_bison.c"
    break;

  case 992: /* igmp_hdr_field: "type"  */
#line 5218 "parser_bison.y"
                                                { (yyval.val) = IGMPHDR_TYPE; }
#line 14200 "parser_bison.c"
    break;

  case 993: /* igmp_hdr_field: "checksum"  */
#line 5219 "parser_bison.y"
                                                { (yyval.val) = IGMPHDR_CHECKSUM; }
#line 14206 "parser_bison.c"
    break;

  case 994: /* igmp_hdr_field: "mrt"  */
#line 5220 "parser_bison.y"
                                                { (yyval.val) = IGMPHDR_MRT; }
#line 14212 "parser_bison.c"
    break;

  case 995: /* igmp_hdr_field: "group"  */
#line 5221 "parser_bison.y"
                                                { (yyval.val) = IGMPHDR_GROUP; }
#line 14218 "parser_bison.c"
    break;

  case 996: /* ip6_hdr_expr: "ip6" ip6_hdr_field  */
#line 5225 "parser_bison.y"
                        {
				(yyval.expr) = payload_expr_alloc(&(yyloc), &proto_ip6, (yyvsp[0].val));
			}
#line 14226 "parser_bison.c"
    break;

  case 997: /* ip6_hdr_field: "version"  */
#line 5230 "parser_bison.y"
                                                { (yyval.val) = IP6HDR_VERSION; }
#line 14232 "parser_bison.c"
    break;

  case 998: /* ip6_hdr_field: "dscp"  */
#line 5231 "parser_bison.y"
                                                { (yyval.val) = IP6HDR_DSCP; }
#line 14238 "parser_bison.c"
    break;

  case 999: /* ip6_hdr_field: "ecn"  */
#line 5232 "parser_bison.y"
                                                { (yyval.val) = IP6HDR_ECN; }
#line 14244 "parser_bison.c"
    break;

  case 1000: /* ip6_hdr_field: "flowlabel"  */
#line 5233 "parser_bison.y"
                                                { (yyval.val) = IP6HDR_FLOWLABEL; }
#line 14250 "parser_bison.c"
    break;

  case 1001: /* ip6_hdr_field: "length"  */
#line 5234 "parser_bison.y"
                                                { (yyval.val) = IP6HDR_LENGTH; }
#line 14256 "parser_bison.c"
    break;

  case 1002: /* ip6_hdr_field: "nexthdr"  */
#line 5235 "parser_bison.y"
                                                { (yyval.val) = IP6HDR_NEXTHDR; }
#line 14262 "parser_bison.c"
    break;

  case 1003: /* ip6_hdr_field: "hoplimit"  */
#line 5236 "parser_bison.y"
                                                { (yyval.val) = IP6HDR_HOPLIMIT; }
#line 14268 "parser_bison.c"
    break;

  case 1004: /* ip6_hdr_field: "saddr"  */
#line 5237 "parser_bison.y"
                                                { (yyval.val) = IP6HDR_SADDR; }
#line 14274 "parser_bison.c"
    break;

  case 1005: /* ip6_hdr_field: "daddr"  */
#line 5238 "parser_bison.y"
                                                { (yyval.val) = IP6HDR_DADDR; }
#line 14280 "parser_bison.c"
    break;

  case 1006: /* icmp6_hdr_expr: "icmpv6" icmp6_hdr_field  */
#line 5241 "parser_bison.y"
                        {
				(yyval.expr) = payload_expr_alloc(&(yyloc), &proto_icmp6, (yyvsp[0].val));
			}
#line 14288 "parser_bison.c"
    break;

  case 1007: /* icmp6_hdr_field: "type"  */
#line 5246 "parser_bison.y"
                                                { (yyval.val) = ICMP6HDR_TYPE; }
#line 14294 "parser_bison.c"
    break;

  case 1008: /* icmp6_hdr_field: "code"  */
#line 5247 "parser_bison.y"
                                                { (yyval.val) = ICMP6HDR_CODE; }
#line 14300 "parser_bison.c"
    break;

  case 1009: /* icmp6_hdr_field: "checksum"  */
#line 5248 "parser_bison.y"
                                                { (yyval.val) = ICMP6HDR_CHECKSUM; }
#line 14306 "parser_bison.c"
    break;

  case 1010: /* icmp6_hdr_field: "param-problem"  */
#line 5249 "parser_bison.y"
                                                { (yyval.val) = ICMP6HDR_PPTR; }
#line 14312 "parser_bison.c"
    break;

  case 1011: /* icmp6_hdr_field: "mtu"  */
#line 5250 "parser_bison.y"
                                                { (yyval.val) = ICMP6HDR_MTU; }
#line 14318 "parser_bison.c"
    break;

  case 1012: /* icmp6_hdr_field: "id"  */
#line 5251 "parser_bison.y"
                                                { (yyval.val) = ICMP6HDR_ID; }
#line 14324 "parser_bison.c"
    break;

  case 1013: /* icmp6_hdr_field: "seq"  */
#line 5252 "parser_bison.y"
                                                { (yyval.val) = ICMP6HDR_SEQ; }
#line 14330 "parser_bison.c"
    break;

  case 1014: /* icmp6_hdr_field: "max-delay"  */
#line 5253 "parser_bison.y"
                                                { (yyval.val) = ICMP6HDR_MAXDELAY; }
#line 14336 "parser_bison.c"
    break;

  case 1015: /* auth_hdr_expr: "ah" auth_hdr_field  */
#line 5257 "parser_bison.y"
                        {
				(yyval.expr) = payload_expr_alloc(&(yyloc), &proto_ah, (yyvsp[0].val));
			}
#line 14344 "parser_bison.c"
    break;

  case 1016: /* auth_hdr_field: "nexthdr"  */
#line 5262 "parser_bison.y"
                                                { (yyval.val) = AHHDR_NEXTHDR; }
#line 14350 "parser_bison.c"
    break;

  case 1017: /* auth_hdr_field: "hdrlength"  */
#line 5263 "parser_bison.y"
                                                { (yyval.val) = AHHDR_HDRLENGTH; }
#line 14356 "parser_bison.c"
    break;

  case 1018: /* auth_hdr_field: "reserved"  */
#line 5264 "parser_bison.y"
                                                { (yyval.val) = AHHDR_RESERVED; }
#line 14362 "parser_bison.c"
    break;

  case 1019: /* auth_hdr_field: "spi"  */
#line 5265 "parser_bison.y"
                                                { (yyval.val) = AHHDR_SPI; }
#line 14368 "parser_bison.c"
    break;

  case 1020: /* auth_hdr_field: "seq"  */
#line 5266 "parser_bison.y"
                                                { (yyval.val) = AHHDR_SEQUENCE; }
#line 14374 "parser_bison.c"
    break;

  case 1021: /* esp_hdr_expr: "esp" esp_hdr_field  */
#line 5270 "parser_bison.y"
                        {
				(yyval.expr) = payload_expr_alloc(&(yyloc), &proto_esp, (yyvsp[0].val));
			}
#line 14382 "parser_bison.c"
    break;

  case 1022: /* esp_hdr_field: "spi"  */
#line 5275 "parser_bison.y"
                                                { (yyval.val) = ESPHDR_SPI; }
#line 14388 "parser_bison.c"
    break;

  case 1023: /* esp_hdr_field: "seq"  */
#line 5276 "parser_bison.y"
                                                { (yyval.val) = ESPHDR_SEQUENCE; }
#line 14394 "parser_bison.c"
    break;

  case 1024: /* comp_hdr_expr: "comp" comp_hdr_field  */
#line 5280 "parser_bison.y"
                        {
				(yyval.expr) = payload_expr_alloc(&(yyloc), &proto_comp, (yyvsp[0].val));
			}
#line 14402 "parser_bison.c"
    break;

  case 1025: /* comp_hdr_field: "nexthdr"  */
#line 5285 "parser_bison.y"
                                                { (yyval.val) = COMPHDR_NEXTHDR; }
#line 14408 "parser_bison.c"
    break;

  case 1026: /* comp_hdr_field: "flags"  */
#line 5286 "parser_bison.y"
                                                { (yyval.val) = COMPHDR_FLAGS; }
#line 14414 "parser_bison.c"
    break;

  case 1027: /* comp_hdr_field: "cpi"  */
#line 5287 "parser_bison.y"
                                                { (yyval.val) = COMPHDR_CPI; }
#line 14420 "parser_bison.c"
    break;

  case 1028: /* udp_hdr_expr: "udp" udp_hdr_field  */
#line 5291 "parser_bison.y"
                        {
				(yyval.expr) = payload_expr_alloc(&(yyloc), &proto_udp, (yyvsp[0].val));
			}
#line 14428 "parser_bison.c"
    break;

  case 1029: /* udp_hdr_field: "sport"  */
#line 5296 "parser_bison.y"
                                                { (yyval.val) = UDPHDR_SPORT; }
#line 14434 "parser_bison.c"
    break;

  case 1030: /* udp_hdr_field: "dport"  */
#line 5297 "parser_bison.y"
                                                { (yyval.val) = UDPHDR_DPORT; }
#line 14440 "parser_bison.c"
    break;

  case 1031: /* udp_hdr_field: "length"  */
#line 5298 "parser_bison.y"
                                                { (yyval.val) = UDPHDR_LENGTH; }
#line 14446 "parser_bison.c"
    break;

  case 1032: /* udp_hdr_field: "checksum"  */
#line 5299 "parser_bison.y"
                                                { (yyval.val) = UDPHDR_CHECKSUM; }
#line 14452 "parser_bison.c"
    break;

  case 1033: /* udplite_hdr_expr: "udplite" udplite_hdr_field  */
#line 5303 "parser_bison.y"
                        {
				(yyval.expr) = payload_expr_alloc(&(yyloc), &proto_udplite, (yyvsp[0].val));
			}
#line 14460 "parser_bison.c"
    break;

  case 1034: /* udplite_hdr_field: "sport"  */
#line 5308 "parser_bison.y"
                                                { (yyval.val) = UDPHDR_SPORT; }
#line 14466 "parser_bison.c"
    break;

  case 1035: /* udplite_hdr_field: "dport"  */
#line 5309 "parser_bison.y"
                                                { (yyval.val) = UDPHDR_DPORT; }
#line 14472 "parser_bison.c"
    break;

  case 1036: /* udplite_hdr_field: "csumcov"  */
#line 5310 "parser_bison.y"
                                                { (yyval.val) = UDPHDR_LENGTH; }
#line 14478 "parser_bison.c"
    break;

  case 1037: /* udplite_hdr_field: "checksum"  */
#line 5311 "parser_bison.y"
                                                { (yyval.val) = UDPHDR_CHECKSUM; }
#line 14484 "parser_bison.c"
    break;

  case 1038: /* tcp_hdr_expr: "tcp" tcp_hdr_field  */
#line 5315 "parser_bison.y"
                        {
				(yyval.expr) = payload_expr_alloc(&(yyloc), &proto_tcp, (yyvsp[0].val));
			}
#line 14492 "parser_bison.c"
    break;

  case 1039: /* tcp_hdr_expr: "tcp" "option" tcp_hdr_option_type tcp_hdr_option_field  */
#line 5319 "parser_bison.y"
                        {
				(yyval.expr) = tcpopt_expr_alloc(&(yyloc), (yyvsp[-1].val), (yyvsp[0].val));
			}
#line 14500 "parser_bison.c"
    break;

  case 1040: /* tcp_hdr_expr: "tcp" "option" tcp_hdr_option_type  */
#line 5323 "parser_bison.y"
                        {
				(yyval.expr) = tcpopt_expr_alloc(&(yyloc), (yyvsp[0].val), TCPOPT_COMMON_KIND);
				(yyval.expr)->exthdr.flags = NFT_EXTHDR_F_PRESENT;
			}
#line 14509 "parser_bison.c"
    break;

  case 1041: /* tcp_hdr_expr: "tcp" "option" "@" tcp_hdr_option_type "comma" "number" "comma" "number"  */
#line 5328 "parser_bison.y"
                        {
				(yyval.expr) = tcpopt_expr_alloc(&(yyloc), (yyvsp[-4].val), 0);
				tcpopt_init_raw((yyval.expr), (yyvsp[-4].val), (yyvsp[-2].val), (yyvsp[0].val), 0);
			}
#line 14518 "parser_bison.c"
    break;

  case 1042: /* tcp_hdr_field: "sport"  */
#line 5334 "parser_bison.y"
                                                { (yyval.val) = TCPHDR_SPORT; }
#line 14524 "parser_bison.c"
    break;

  case 1043: /* tcp_hdr_field: "dport"  */
#line 5335 "parser_bison.y"
                                                { (yyval.val) = TCPHDR_DPORT; }
#line 14530 "parser_bison.c"
    break;

  case 1044: /* tcp_hdr_field: "seq"  */
#line 5336 "parser_bison.y"
                                                { (yyval.val) = TCPHDR_SEQ; }
#line 14536 "parser_bison.c"
    break;

  case 1045: /* tcp_hdr_field: "ackseq"  */
#line 5337 "parser_bison.y"
                                                { (yyval.val) = TCPHDR_ACKSEQ; }
#line 14542 "parser_bison.c"
    break;

  case 1046: /* tcp_hdr_field: "doff"  */
#line 5338 "parser_bison.y"
                                                { (yyval.val) = TCPHDR_DOFF; }
#line 14548 "parser_bison.c"
    break;

  case 1047: /* tcp_hdr_field: "reserved"  */
#line 5339 "parser_bison.y"
                                                { (yyval.val) = TCPHDR_RESERVED; }
#line 14554 "parser_bison.c"
    break;

  case 1048: /* tcp_hdr_field: "flags"  */
#line 5340 "parser_bison.y"
                                                { (yyval.val) = TCPHDR_FLAGS; }
#line 14560 "parser_bison.c"
    break;

  case 1049: /* tcp_hdr_field: "window"  */
#line 5341 "parser_bison.y"
                                                { (yyval.val) = TCPHDR_WINDOW; }
#line 14566 "parser_bison.c"
    break;

  case 1050: /* tcp_hdr_field: "checksum"  */
#line 5342 "parser_bison.y"
                                                { (yyval.val) = TCPHDR_CHECKSUM; }
#line 14572 "parser_bison.c"
    break;

  case 1051: /* tcp_hdr_field: "urgptr"  */
#line 5343 "parser_bison.y"
                                                { (yyval.val) = TCPHDR_URGPTR; }
#line 14578 "parser_bison.c"
    break;

  case 1052: /* tcp_hdr_option_type: "eol"  */
#line 5346 "parser_bison.y"
                                                { (yyval.val) = TCPOPT_KIND_EOL; }
#line 14584 "parser_bison.c"
    break;

  case 1053: /* tcp_hdr_option_type: "nop"  */
#line 5347 "parser_bison.y"
                                                { (yyval.val) = TCPOPT_KIND_NOP; }
#line 14590 "parser_bison.c"
    break;

  case 1054: /* tcp_hdr_option_type: "mss"  */
#line 5348 "parser_bison.y"
                                                { (yyval.val) = TCPOPT_KIND_MAXSEG; }
#line 14596 "parser_bison.c"
    break;

  case 1055: /* tcp_hdr_option_type: "window"  */
#line 5349 "parser_bison.y"
                                                { (yyval.val) = TCPOPT_KIND_WINDOW; }
#line 14602 "parser_bison.c"
    break;

  case 1056: /* tcp_hdr_option_type: "sack-permitted"  */
#line 5350 "parser_bison.y"
                                                { (yyval.val) = TCPOPT_KIND_SACK_PERMITTED; }
#line 14608 "parser_bison.c"
    break;

  case 1057: /* tcp_hdr_option_type: "sack"  */
#line 5351 "parser_bison.y"
                                                { (yyval.val) = TCPOPT_KIND_SACK; }
#line 14614 "parser_bison.c"
    break;

  case 1058: /* tcp_hdr_option_type: "sack0"  */
#line 5352 "parser_bison.y"
                                                { (yyval.val) = TCPOPT_KIND_SACK; }
#line 14620 "parser_bison.c"
    break;

  case 1059: /* tcp_hdr_option_type: "sack1"  */
#line 5353 "parser_bison.y"
                                                { (yyval.val) = TCPOPT_KIND_SACK1; }
#line 14626 "parser_bison.c"
    break;

  case 1060: /* tcp_hdr_option_type: "sack2"  */
#line 5354 "parser_bison.y"
                                                { (yyval.val) = TCPOPT_KIND_SACK2; }
#line 14632 "parser_bison.c"
    break;

  case 1061: /* tcp_hdr_option_type: "sack3"  */
#line 5355 "parser_bison.y"
                                                { (yyval.val) = TCPOPT_KIND_SACK3; }
#line 14638 "parser_bison.c"
    break;

  case 1062: /* tcp_hdr_option_type: "echo"  */
#line 5356 "parser_bison.y"
                                                { (yyval.val) = TCPOPT_KIND_ECHO; }
#line 14644 "parser_bison.c"
    break;

  case 1063: /* tcp_hdr_option_type: "timestamp"  */
#line 5357 "parser_bison.y"
                                                { (yyval.val) = TCPOPT_KIND_TIMESTAMP; }
#line 14650 "parser_bison.c"
    break;

  case 1064: /* tcp_hdr_option_type: "number"  */
#line 5358 "parser_bison.y"
                                                {
				if ((yyvsp[0].val) > 255) {
					erec_queue(error(&(yylsp[0]), "value too large"), state->msgs);
					YYERROR;
				}
				(yyval.val) = (yyvsp[0].val);
			}
#line 14662 "parser_bison.c"
    break;

  case 1065: /* tcp_hdr_option_field: "kind"  */
#line 5367 "parser_bison.y"
                                                { (yyval.val) = TCPOPT_COMMON_KIND; }
#line 14668 "parser_bison.c"
    break;

  case 1066: /* tcp_hdr_option_field: "length"  */
#line 5368 "parser_bison.y"
                                                { (yyval.val) = TCPOPT_COMMON_LENGTH; }
#line 14674 "parser_bison.c"
    break;

  case 1067: /* tcp_hdr_option_field: "size"  */
#line 5369 "parser_bison.y"
                                                { (yyval.val) = TCPOPT_MAXSEG_SIZE; }
#line 14680 "parser_bison.c"
    break;

  case 1068: /* tcp_hdr_option_field: "count"  */
#line 5370 "parser_bison.y"
                                                { (yyval.val) = TCPOPT_WINDOW_COUNT; }
#line 14686 "parser_bison.c"
    break;

  case 1069: /* tcp_hdr_option_field: "left"  */
#line 5371 "parser_bison.y"
                                                { (yyval.val) = TCPOPT_SACK_LEFT; }
#line 14692 "parser_bison.c"
    break;

  case 1070: /* tcp_hdr_option_field: "right"  */
#line 5372 "parser_bison.y"
                                                { (yyval.val) = TCPOPT_SACK_RIGHT; }
#line 14698 "parser_bison.c"
    break;

  case 1071: /* tcp_hdr_option_field: "tsval"  */
#line 5373 "parser_bison.y"
                                                { (yyval.val) = TCPOPT_TS_TSVAL; }
#line 14704 "parser_bison.c"
    break;

  case 1072: /* tcp_hdr_option_field: "tsecr"  */
#line 5374 "parser_bison.y"
                                                { (yyval.val) = TCPOPT_TS_TSECR; }
#line 14710 "parser_bison.c"
    break;

  case 1073: /* dccp_hdr_expr: "dccp" dccp_hdr_field  */
#line 5378 "parser_bison.y"
                        {
				(yyval.expr) = payload_expr_alloc(&(yyloc), &proto_dccp, (yyvsp[0].val));
			}
#line 14718 "parser_bison.c"
    break;

  case 1074: /* dccp_hdr_field: "sport"  */
#line 5383 "parser_bison.y"
                                                { (yyval.val) = DCCPHDR_SPORT; }
#line 14724 "parser_bison.c"
    break;

  case 1075: /* dccp_hdr_field: "dport"  */
#line 5384 "parser_bison.y"
                                                { (yyval.val) = DCCPHDR_DPORT; }
#line 14730 "parser_bison.c"
    break;

  case 1076: /* dccp_hdr_field: "type"  */
#line 5385 "parser_bison.y"
                                                { (yyval.val) = DCCPHDR_TYPE; }
#line 14736 "parser_bison.c"
    break;

  case 1077: /* sctp_chunk_type: "data"  */
#line 5388 "parser_bison.y"
                                                { (yyval.val) = SCTP_CHUNK_TYPE_DATA; }
#line 14742 "parser_bison.c"
    break;

  case 1078: /* sctp_chunk_type: "init"  */
#line 5389 "parser_bison.y"
                                                { (yyval.val) = SCTP_CHUNK_TYPE_INIT; }
#line 14748 "parser_bison.c"
    break;

  case 1079: /* sctp_chunk_type: "init-ack"  */
#line 5390 "parser_bison.y"
                                                { (yyval.val) = SCTP_CHUNK_TYPE_INIT_ACK; }
#line 14754 "parser_bison.c"
    break;

  case 1080: /* sctp_chunk_type: "sack"  */
#line 5391 "parser_bison.y"
                                                { (yyval.val) = SCTP_CHUNK_TYPE_SACK; }
#line 14760 "parser_bison.c"
    break;

  case 1081: /* sctp_chunk_type: "heartbeat"  */
#line 5392 "parser_bison.y"
                                                { (yyval.val) = SCTP_CHUNK_TYPE_HEARTBEAT; }
#line 14766 "parser_bison.c"
    break;

  case 1082: /* sctp_chunk_type: "heartbeat-ack"  */
#line 5393 "parser_bison.y"
                                                { (yyval.val) = SCTP_CHUNK_TYPE_HEARTBEAT_ACK; }
#line 14772 "parser_bison.c"
    break;

  case 1083: /* sctp_chunk_type: "abort"  */
#line 5394 "parser_bison.y"
                                                { (yyval.val) = SCTP_CHUNK_TYPE_ABORT; }
#line 14778 "parser_bison.c"
    break;

  case 1084: /* sctp_chunk_type: "shutdown"  */
#line 5395 "parser_bison.y"
                                                { (yyval.val) = SCTP_CHUNK_TYPE_SHUTDOWN; }
#line 14784 "parser_bison.c"
    break;

  case 1085: /* sctp_chunk_type: "shutdown-ack"  */
#line 5396 "parser_bison.y"
                                                { (yyval.val) = SCTP_CHUNK_TYPE_SHUTDOWN_ACK; }
#line 14790 "parser_bison.c"
    break;

  case 1086: /* sctp_chunk_type: "error"  */
#line 5397 "parser_bison.y"
                                                { (yyval.val) = SCTP_CHUNK_TYPE_ERROR; }
#line 14796 "parser_bison.c"
    break;

  case 1087: /* sctp_chunk_type: "cookie-echo"  */
#line 5398 "parser_bison.y"
                                                { (yyval.val) = SCTP_CHUNK_TYPE_COOKIE_ECHO; }
#line 14802 "parser_bison.c"
    break;

  case 1088: /* sctp_chunk_type: "cookie-ack"  */
#line 5399 "parser_bison.y"
                                                { (yyval.val) = SCTP_CHUNK_TYPE_COOKIE_ACK; }
#line 14808 "parser_bison.c"
    break;

  case 1089: /* sctp_chunk_type: "ecne"  */
#line 5400 "parser_bison.y"
                                                { (yyval.val) = SCTP_CHUNK_TYPE_ECNE; }
#line 14814 "parser_bison.c"
    break;

  case 1090: /* sctp_chunk_type: "cwr"  */
#line 5401 "parser_bison.y"
                                                { (yyval.val) = SCTP_CHUNK_TYPE_CWR; }
#line 14820 "parser_bison.c"
    break;

  case 1091: /* sctp_chunk_type: "shutdown-complete"  */
#line 5402 "parser_bison.y"
                                                  { (yyval.val) = SCTP_CHUNK_TYPE_SHUTDOWN_COMPLETE; }
#line 14826 "parser_bison.c"
    break;

  case 1092: /* sctp_chunk_type: "asconf-ack"  */
#line 5403 "parser_bison.y"
                                                { (yyval.val) = SCTP_CHUNK_TYPE_ASCONF_ACK; }
#line 14832 "parser_bison.c"
    break;

  case 1093: /* sctp_chunk_type: "forward-tsn"  */
#line 5404 "parser_bison.y"
                                                { (yyval.val) = SCTP_CHUNK_TYPE_FORWARD_TSN; }
#line 14838 "parser_bison.c"
    break;

  case 1094: /* sctp_chunk_type: "asconf"  */
#line 5405 "parser_bison.y"
                                                { (yyval.val) = SCTP_CHUNK_TYPE_ASCONF; }
#line 14844 "parser_bison.c"
    break;

  case 1095: /* sctp_chunk_common_field: "type"  */
#line 5408 "parser_bison.y"
                                        { (yyval.val) = SCTP_CHUNK_COMMON_TYPE; }
#line 14850 "parser_bison.c"
    break;

  case 1096: /* sctp_chunk_common_field: "flags"  */
#line 5409 "parser_bison.y"
                                        { (yyval.val) = SCTP_CHUNK_COMMON_FLAGS; }
#line 14856 "parser_bison.c"
    break;

  case 1097: /* sctp_chunk_common_field: "length"  */
#line 5410 "parser_bison.y"
                                        { (yyval.val) = SCTP_CHUNK_COMMON_LENGTH; }
#line 14862 "parser_bison.c"
    break;

  case 1098: /* sctp_chunk_data_field: "tsn"  */
#line 5413 "parser_bison.y"
                                        { (yyval.val) = SCTP_CHUNK_DATA_TSN; }
#line 14868 "parser_bison.c"
    break;

  case 1099: /* sctp_chunk_data_field: "stream"  */
#line 5414 "parser_bison.y"
                                        { (yyval.val) = SCTP_CHUNK_DATA_STREAM; }
#line 14874 "parser_bison.c"
    break;

  case 1100: /* sctp_chunk_data_field: "ssn"  */
#line 5415 "parser_bison.y"
                                        { (yyval.val) = SCTP_CHUNK_DATA_SSN; }
#line 14880 "parser_bison.c"
    break;

  case 1101: /* sctp_chunk_data_field: "ppid"  */
#line 5416 "parser_bison.y"
                                        { (yyval.val) = SCTP_CHUNK_DATA_PPID; }
#line 14886 "parser_bison.c"
    break;

  case 1102: /* sctp_chunk_init_field: "init-tag"  */
#line 5419 "parser_bison.y"
                                                { (yyval.val) = SCTP_CHUNK_INIT_TAG; }
#line 14892 "parser_bison.c"
    break;

  case 1103: /* sctp_chunk_init_field: "a-rwnd"  */
#line 5420 "parser_bison.y"
                                                { (yyval.val) = SCTP_CHUNK_INIT_RWND; }
#line 14898 "parser_bison.c"
    break;

  case 1104: /* sctp_chunk_init_field: "num-outbound-streams"  */
#line 5421 "parser_bison.y"
                                                { (yyval.val) = SCTP_CHUNK_INIT_OSTREAMS; }
#line 14904 "parser_bison.c"
    break;

  case 1105: /* sctp_chunk_init_field: "num-inbound-streams"  */
#line 5422 "parser_bison.y"
                                                { (yyval.val) = SCTP_CHUNK_INIT_ISTREAMS; }
#line 14910 "parser_bison.c"
    break;

  case 1106: /* sctp_chunk_init_field: "initial-tsn"  */
#line 5423 "parser_bison.y"
                                                { (yyval.val) = SCTP_CHUNK_INIT_TSN; }
#line 14916 "parser_bison.c"
    break;

  case 1107: /* sctp_chunk_sack_field: "cum-tsn-ack"  */
#line 5426 "parser_bison.y"
                                                { (yyval.val) = SCTP_CHUNK_SACK_CTSN_ACK; }
#line 14922 "parser_bison.c"
    break;

  case 1108: /* sctp_chunk_sack_field: "a-rwnd"  */
#line 5427 "parser_bison.y"
                                                { (yyval.val) = SCTP_CHUNK_SACK_RWND; }
#line 14928 "parser_bison.c"
    break;

  case 1109: /* sctp_chunk_sack_field: "num-gap-ack-blocks"  */
#line 5428 "parser_bison.y"
                                                { (yyval.val) = SCTP_CHUNK_SACK_GACK_BLOCKS; }
#line 14934 "parser_bison.c"
    break;

  case 1110: /* sctp_chunk_sack_field: "num-dup-tsns"  */
#line 5429 "parser_bison.y"
                                                { (yyval.val) = SCTP_CHUNK_SACK_DUP_TSNS; }
#line 14940 "parser_bison.c"
    break;

  case 1111: /* sctp_chunk_alloc: sctp_chunk_type  */
#line 5433 "parser_bison.y"
                        {
				(yyval.expr) = sctp_chunk_expr_alloc(&(yyloc), (yyvsp[0].val), SCTP_CHUNK_COMMON_TYPE);
				(yyval.expr)->exthdr.flags = NFT_EXTHDR_F_PRESENT;
			}
#line 14949 "parser_bison.c"
    break;

  case 1112: /* sctp_chunk_alloc: sctp_chunk_type sctp_chunk_common_field  */
#line 5438 "parser_bison.y"
                        {
				(yyval.expr) = sctp_chunk_expr_alloc(&(yyloc), (yyvsp[-1].val), (yyvsp[0].val));
			}
#line 14957 "parser_bison.c"
    break;

  case 1113: /* sctp_chunk_alloc: "data" sctp_chunk_data_field  */
#line 5442 "parser_bison.y"
                        {
				(yyval.expr) = sctp_chunk_expr_alloc(&(yyloc), SCTP_CHUNK_TYPE_DATA, (yyvsp[0].val));
			}
#line 14965 "parser_bison.c"
    break;

  case 1114: /* sctp_chunk_alloc: "init" sctp_chunk_init_field  */
#line 5446 "parser_bison.y"
                        {
				(yyval.expr) = sctp_chunk_expr_alloc(&(yyloc), SCTP_CHUNK_TYPE_INIT, (yyvsp[0].val));
			}
#line 14973 "parser_bison.c"
    break;

  case 1115: /* sctp_chunk_alloc: "init-ack" sctp_chunk_init_field  */
#line 5450 "parser_bison.y"
                        {
				(yyval.expr) = sctp_chunk_expr_alloc(&(yyloc), SCTP_CHUNK_TYPE_INIT_ACK, (yyvsp[0].val));
			}
#line 14981 "parser_bison.c"
    break;

  case 1116: /* sctp_chunk_alloc: "sack" sctp_chunk_sack_field  */
#line 5454 "parser_bison.y"
                        {
				(yyval.expr) = sctp_chunk_expr_alloc(&(yyloc), SCTP_CHUNK_TYPE_SACK, (yyvsp[0].val));
			}
#line 14989 "parser_bison.c"
    break;

  case 1117: /* sctp_chunk_alloc: "shutdown" "cum-tsn-ack"  */
#line 5458 "parser_bison.y"
                        {
				(yyval.expr) = sctp_chunk_expr_alloc(&(yyloc), SCTP_CHUNK_TYPE_SHUTDOWN,
							   SCTP_CHUNK_SHUTDOWN_CTSN_ACK);
			}
#line 14998 "parser_bison.c"
    break;

  case 1118: /* sctp_chunk_alloc: "ecne" "lowest-tsn"  */
#line 5463 "parser_bison.y"
                        {
				(yyval.expr) = sctp_chunk_expr_alloc(&(yyloc), SCTP_CHUNK_TYPE_ECNE,
							   SCTP_CHUNK_ECNE_CWR_MIN_TSN);
			}
#line 15007 "parser_bison.c"
    break;

  case 1119: /* sctp_chunk_alloc: "cwr" "lowest-tsn"  */
#line 5468 "parser_bison.y"
                        {
				(yyval.expr) = sctp_chunk_expr_alloc(&(yyloc), SCTP_CHUNK_TYPE_CWR,
							   SCTP_CHUNK_ECNE_CWR_MIN_TSN);
			}
#line 15016 "parser_bison.c"
    break;

  case 1120: /* sctp_chunk_alloc: "asconf-ack" "seqno"  */
#line 5473 "parser_bison.y"
                        {
				(yyval.expr) = sctp_chunk_expr_alloc(&(yyloc), SCTP_CHUNK_TYPE_ASCONF_ACK,
							   SCTP_CHUNK_ASCONF_SEQNO);
			}
#line 15025 "parser_bison.c"
    break;

  case 1121: /* sctp_chunk_alloc: "forward-tsn" "new-cum-tsn"  */
#line 5478 "parser_bison.y"
                        {
				(yyval.expr) = sctp_chunk_expr_alloc(&(yyloc), SCTP_CHUNK_TYPE_FORWARD_TSN,
							   SCTP_CHUNK_FORWARD_TSN_NCTSN);
			}
#line 15034 "parser_bison.c"
    break;

  case 1122: /* sctp_chunk_alloc: "asconf" "seqno"  */
#line 5483 "parser_bison.y"
                        {
				(yyval.expr) = sctp_chunk_expr_alloc(&(yyloc), SCTP_CHUNK_TYPE_ASCONF,
							   SCTP_CHUNK_ASCONF_SEQNO);
			}
#line 15043 "parser_bison.c"
    break;

  case 1123: /* sctp_hdr_expr: "sctp" sctp_hdr_field close_scope_sctp  */
#line 5490 "parser_bison.y"
                        {
				(yyval.expr) = payload_expr_alloc(&(yyloc), &proto_sctp, (yyvsp[-1].val));
			}
#line 15051 "parser_bison.c"
    break;

  case 1124: /* sctp_hdr_expr: "sctp" "chunk" sctp_chunk_alloc close_scope_sctp_chunk close_scope_sctp  */
#line 5494 "parser_bison.y"
                        {
				(yyval.expr) = (yyvsp[-2].expr);
			}
#line 15059 "parser_bison.c"
    break;

  case 1125: /* sctp_hdr_field: "sport"  */
#line 5499 "parser_bison.y"
                                                { (yyval.val) = SCTPHDR_SPORT; }
#line 15065 "parser_bison.c"
    break;

  case 1126: /* sctp_hdr_field: "dport"  */
#line 5500 "parser_bison.y"
                                                { (yyval.val) = SCTPHDR_DPORT; }
#line 15071 "parser_bison.c"
    break;

  case 1127: /* sctp_hdr_field: "vtag"  */
#line 5501 "parser_bison.y"
                                                { (yyval.val) = SCTPHDR_VTAG; }
#line 15077 "parser_bison.c"
    break;

  case 1128: /* sctp_hdr_field: "checksum"  */
#line 5502 "parser_bison.y"
                                                { (yyval.val) = SCTPHDR_CHECKSUM; }
#line 15083 "parser_bison.c"
    break;

  case 1129: /* th_hdr_expr: "th" th_hdr_field  */
#line 5506 "parser_bison.y"
                        {
				(yyval.expr) = payload_expr_alloc(&(yyloc), &proto_th, (yyvsp[0].val));
				if ((yyval.expr))
					(yyval.expr)->payload.is_raw = true;
			}
#line 15093 "parser_bison.c"
    break;

  case 1130: /* th_hdr_field: "sport"  */
#line 5513 "parser_bison.y"
                                                { (yyval.val) = THDR_SPORT; }
#line 15099 "parser_bison.c"
    break;

  case 1131: /* th_hdr_field: "dport"  */
#line 5514 "parser_bison.y"
                                                { (yyval.val) = THDR_DPORT; }
#line 15105 "parser_bison.c"
    break;

  case 1140: /* hbh_hdr_expr: "hbh" hbh_hdr_field  */
#line 5528 "parser_bison.y"
                        {
				(yyval.expr) = exthdr_expr_alloc(&(yyloc), &exthdr_hbh, (yyvsp[0].val));
			}
#line 15113 "parser_bison.c"
    break;

  case 1141: /* hbh_hdr_field: "nexthdr"  */
#line 5533 "parser_bison.y"
                                                { (yyval.val) = HBHHDR_NEXTHDR; }
#line 15119 "parser_bison.c"
    break;

  case 1142: /* hbh_hdr_field: "hdrlength"  */
#line 5534 "parser_bison.y"
                                                { (yyval.val) = HBHHDR_HDRLENGTH; }
#line 15125 "parser_bison.c"
    break;

  case 1143: /* rt_hdr_expr: "rt" rt_hdr_field  */
#line 5538 "parser_bison.y"
                        {
				(yyval.expr) = exthdr_expr_alloc(&(yyloc), &exthdr_rt, (yyvsp[0].val));
			}
#line 15133 "parser_bison.c"
    break;

  case 1144: /* rt_hdr_field: "nexthdr"  */
#line 5543 "parser_bison.y"
                                                { (yyval.val) = RTHDR_NEXTHDR; }
#line 15139 "parser_bison.c"
    break;

  case 1145: /* rt_hdr_field: "hdrlength"  */
#line 5544 "parser_bison.y"
                                                { (yyval.val) = RTHDR_HDRLENGTH; }
#line 15145 "parser_bison.c"
    break;

  case 1146: /* rt_hdr_field: "type"  */
#line 5545 "parser_bison.y"
                                                { (yyval.val) = RTHDR_TYPE; }
#line 15151 "parser_bison.c"
    break;

  case 1147: /* rt_hdr_field: "seg-left"  */
#line 5546 "parser_bison.y"
                                                { (yyval.val) = RTHDR_SEG_LEFT; }
#line 15157 "parser_bison.c"
    break;

  case 1148: /* rt0_hdr_expr: "rt0" rt0_hdr_field  */
#line 5550 "parser_bison.y"
                        {
				(yyval.expr) = exthdr_expr_alloc(&(yyloc), &exthdr_rt0, (yyvsp[0].val));
			}
#line 15165 "parser_bison.c"
    break;

  case 1149: /* rt0_hdr_field: "addr" '[' "number" ']'  */
#line 5556 "parser_bison.y"
                        {
				(yyval.val) = RT0HDR_ADDR_1 + (yyvsp[-1].val) - 1;
			}
#line 15173 "parser_bison.c"
    break;

  case 1150: /* rt2_hdr_expr: "rt2" rt2_hdr_field  */
#line 5562 "parser_bison.y"
                        {
				(yyval.expr) = exthdr_expr_alloc(&(yyloc), &exthdr_rt2, (yyvsp[0].val));
			}
#line 15181 "parser_bison.c"
    break;

  case 1151: /* rt2_hdr_field: "addr"  */
#line 5567 "parser_bison.y"
                                                { (yyval.val) = RT2HDR_ADDR; }
#line 15187 "parser_bison.c"
    break;

  case 1152: /* rt4_hdr_expr: "srh" rt4_hdr_field  */
#line 5571 "parser_bison.y"
                        {
				(yyval.expr) = exthdr_expr_alloc(&(yyloc), &exthdr_rt4, (yyvsp[0].val));
			}
#line 15195 "parser_bison.c"
    break;

  case 1153: /* rt4_hdr_field: "last-entry"  */
#line 5576 "parser_bison.y"
                                                { (yyval.val) = RT4HDR_LASTENT; }
#line 15201 "parser_bison.c"
    break;

  case 1154: /* rt4_hdr_field: "flags"  */
#line 5577 "parser_bison.y"
                                                { (yyval.val) = RT4HDR_FLAGS; }
#line 15207 "parser_bison.c"
    break;

  case 1155: /* rt4_hdr_field: "tag"  */
#line 5578 "parser_bison.y"
                                                { (yyval.val) = RT4HDR_TAG; }
#line 15213 "parser_bison.c"
    break;

  case 1156: /* rt4_hdr_field: "sid" '[' "number" ']'  */
#line 5580 "parser_bison.y"
                        {
				(yyval.val) = RT4HDR_SID_1 + (yyvsp[-1].val) - 1;
			}
#line 15221 "parser_bison.c"
    break;

  case 1157: /* frag_hdr_expr: "frag" frag_hdr_field  */
#line 5586 "parser_bison.y"
                        {
				(yyval.expr) = exthdr_expr_alloc(&(yyloc), &exthdr_frag, (yyvsp[0].val));
			}
#line 15229 "parser_bison.c"
    break;

  case 1158: /* frag_hdr_field: "nexthdr"  */
#line 5591 "parser_bison.y"
                                                { (yyval.val) = FRAGHDR_NEXTHDR; }
#line 15235 "parser_bison.c"
    break;

  case 1159: /* frag_hdr_field: "reserved"  */
#line 5592 "parser_bison.y"
                                                { (yyval.val) = FRAGHDR_RESERVED; }
#line 15241 "parser_bison.c"
    break;

  case 1160: /* frag_hdr_field: "frag-off"  */
#line 5593 "parser_bison.y"
                                                { (yyval.val) = FRAGHDR_FRAG_OFF; }
#line 15247 "parser_bison.c"
    break;

  case 1161: /* frag_hdr_field: "reserved2"  */
#line 5594 "parser_bison.y"
                                                { (yyval.val) = FRAGHDR_RESERVED2; }
#line 15253 "parser_bison.c"
    break;

  case 1162: /* frag_hdr_field: "more-fragments"  */
#line 5595 "parser_bison.y"
                                                { (yyval.val) = FRAGHDR_MFRAGS; }
#line 15259 "parser_bison.c"
    break;

  case 1163: /* frag_hdr_field: "id"  */
#line 5596 "parser_bison.y"
                                                { (yyval.val) = FRAGHDR_ID; }
#line 15265 "parser_bison.c"
    break;

  case 1164: /* dst_hdr_expr: "dst" dst_hdr_field  */
#line 5600 "parser_bison.y"
                        {
				(yyval.expr) = exthdr_expr_alloc(&(yyloc), &exthdr_dst, (yyvsp[0].val));
			}
#line 15273 "parser_bison.c"
    break;

  case 1165: /* dst_hdr_field: "nexthdr"  */
#line 5605 "parser_bison.y"
                                                { (yyval.val) = DSTHDR_NEXTHDR; }
#line 15279 "parser_bison.c"
    break;

  case 1166: /* dst_hdr_field: "hdrlength"  */
#line 5606 "parser_bison.y"
                                                { (yyval.val) = DSTHDR_HDRLENGTH; }
#line 15285 "parser_bison.c"
    break;

  case 1167: /* mh_hdr_expr: "mh" mh_hdr_field  */
#line 5610 "parser_bison.y"
                        {
				(yyval.expr) = exthdr_expr_alloc(&(yyloc), &exthdr_mh, (yyvsp[0].val));
			}
#line 15293 "parser_bison.c"
    break;

  case 1168: /* mh_hdr_field: "nexthdr"  */
#line 5615 "parser_bison.y"
                                                { (yyval.val) = MHHDR_NEXTHDR; }
#line 15299 "parser_bison.c"
    break;

  case 1169: /* mh_hdr_field: "hdrlength"  */
#line 5616 "parser_bison.y"
                                                { (yyval.val) = MHHDR_HDRLENGTH; }
#line 15305 "parser_bison.c"
    break;

  case 1170: /* mh_hdr_field: "type"  */
#line 5617 "parser_bison.y"
                                                { (yyval.val) = MHHDR_TYPE; }
#line 15311 "parser_bison.c"
    break;

  case 1171: /* mh_hdr_field: "reserved"  */
#line 5618 "parser_bison.y"
                                                { (yyval.val) = MHHDR_RESERVED; }
#line 15317 "parser_bison.c"
    break;

  case 1172: /* mh_hdr_field: "checksum"  */
#line 5619 "parser_bison.y"
                                                { (yyval.val) = MHHDR_CHECKSUM; }
#line 15323 "parser_bison.c"
    break;

  case 1173: /* exthdr_exists_expr: "exthdr" exthdr_key  */
#line 5623 "parser_bison.y"
                        {
				const struct exthdr_desc *desc;

				desc = exthdr_find_proto((yyvsp[0].val));

				/* Assume that NEXTHDR template is always
				 * the fist one in list of templates.
				 */
				(yyval.expr) = exthdr_expr_alloc(&(yyloc), desc, 1);
				(yyval.expr)->exthdr.flags = NFT_EXTHDR_F_PRESENT;
			}
#line 15339 "parser_bison.c"
    break;

  case 1174: /* exthdr_key: "hbh"  */
#line 5636 "parser_bison.y"
                                        { (yyval.val) = IPPROTO_HOPOPTS; }
#line 15345 "parser_bison.c"
    break;

  case 1175: /* exthdr_key: "rt"  */
#line 5637 "parser_bison.y"
                                        { (yyval.val) = IPPROTO_ROUTING; }
#line 15351 "parser_bison.c"
    break;

  case 1176: /* exthdr_key: "frag"  */
#line 5638 "parser_bison.y"
                                        { (yyval.val) = IPPROTO_FRAGMENT; }
#line 15357 "parser_bison.c"
    break;

  case 1177: /* exthdr_key: "dst"  */
#line 5639 "parser_bison.y"
                                        { (yyval.val) = IPPROTO_DSTOPTS; }
#line 15363 "parser_bison.c"
    break;

  case 1178: /* exthdr_key: "mh"  */
#line 5640 "parser_bison.y"
                                        { (yyval.val) = IPPROTO_MH; }
#line 15369 "parser_bison.c"
    break;


#line 15373 "parser_bison.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      {
        yypcontext_t yyctx
          = {yyssp, yytoken, &yylloc};
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == -1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = YY_CAST (char *,
                             YYSTACK_ALLOC (YY_CAST (YYSIZE_T, yymsg_alloc)));
            if (yymsg)
              {
                yysyntax_error_status
                  = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
                yymsgp = yymsg;
              }
            else
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = YYENOMEM;
              }
          }
        yyerror (&yylloc, nft, scanner, state, yymsgp);
        if (yysyntax_error_status == YYENOMEM)
          goto yyexhaustedlab;
      }
    }

  yyerror_range[1] = yylloc;
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= TOKEN_EOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == TOKEN_EOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc, nft, scanner, state);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp, yylsp, nft, scanner, state);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  ++yylsp;
  YYLLOC_DEFAULT (*yylsp, yyerror_range, 2);

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;


#if 1
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (&yylloc, nft, scanner, state, YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturn;
#endif


/*-------------------------------------------------------.
| yyreturn -- parsing is finished, clean up and return.  |
`-------------------------------------------------------*/
yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc, nft, scanner, state);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp, yylsp, nft, scanner, state);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
  return yyresult;
}

#line 5643 "parser_bison.y"

